$!	concatenate_sixel_example.com
$!
$!
$!	This procedure shows the basics of using concatenate_sixel.
$!	Parameters are specified using logical names:
$!
$!		ci$input	- the "left-hand" graph file.
$!		ci$input_2	- the "right-hand" graph file.
$!		ci$output	- the new graph file to be created.
$!		ci$sixel_offset	- the number of "dots" to leave between the
$!				  two input graphs.
$!
$!
$!	This example will indent a sixel graph by concatenating it
$!	with an "empty" (almost) sixel graph (included in this submission):
$!
$	define	ci$input	empty.sixel
$	define	ci$input_2	old_left_hand_graph.sixel
$	define	ci$output	new_left_hand_graph.sixel
$	define	ci$sixel_offset	80
$	run	concatenate_sixel
$!
$!
$!	This example will concatenate the "indented" sixel graph (from the
$!	previous example) to another graph:
$!
$	define	ci$input	new_left_hand_graph.sixel
$	define	ci$input_2	old_right_hand_graph.sixel
$	define	ci$output	new_concatenated_graph.sixel
$	define	ci$sixel_offset	880
$	run	concatenate_sixel
$!
$!
$!	end of concatenate_sixel_example.com
