$!
$! COMMAND FILE TO CREATE THE ROUTE DATABASE USERS GUIDE RUNOFF DOCUMENT
$!
$ SET NOON
$!
$ TYPE SYS$INPUT

	This command file creates the RD_USERS GUIDE document.

$!
$!
$! Create main document output RD_USER.MEM
$!
$RUNOFF RD_USER.RNO/DEBUG=CONTENTS/NOSIMULATE
$! 
$! Create intermediate binary file for index and table of contents 
$!	RD_USER.brn
$!
$RUNOFF/INTERMEDIATE RD_USER.RNO
$!
$! Create table of contents RD_USER.RNT 
$!	and then RD_USER.MEC for appending and print
$!
$RUNOFF/CONTENTS RD_USER.BRN
$RUNOFF RD_USER.RNT/NOSIMULATE
$!
$! Create index, binary file: RD_USER.brn, 
$!	then RD_USER.rnx, and then RD_USER.mex
$!
$RUNOFF/INDEX RD_USER.BRN
$RUNOFF RD_USER.RNX/NOSIMULATE
$!
$! CREATE TITLE PAGE
$!
$ TODAY = F$TIME()
$ TODAY = F$CVTIME(TODAY,"ABSOLUTE","DATE")
$ DELETE RD_USER_TITLE.RNO;*
$ OPEN TITLE/WRITE RD_USER_TITLE.RNO
$ WRITE TITLE ".PS 60,80"
$ WRITE TITLE ".RM 80"
$ WRITE TITLE ".LITERAL"
$ WRITE TITLE ""
$ WRITE TITLE " "
$ WRITE TITLE " "
$ WRITE TITLE " "
$ WRITE TITLE " "
$ WRITE TITLE " "
$ WRITE TITLE " "
$ WRITE TITLE " "
$ WRITE TITLE " "
$ WRITE TITLE " "
$ WRITE TITLE " "
$ WRITE TITLE " "
$ WRITE TITLE " "
$ WRITE TITLE " "
$ WRITE TITLE " "
$ WRITE TITLE " "
$ WRITE TITLE " "
$ WRITE TITLE " "
$ WRITE TITLE ".END LITERAL
$ WRITE TITLE ".CENTER;ROUTE DATABASE MAINTANENCE
$ WRITE TITLE ".CENTER;USER'S GUIDE"
$ WRITE TITLE " "
$ WRITE TITLE ".CENTER;Revision: 1.0"
$ WRITE TITLE " "
$ WRITE TITLE ".CENTER;",TODAY
$ WRITE TITLE ".LITERAL"
$ WRITE TITLE " "
$ WRITE TITLE " "
$ WRITE TITLE " "
$ WRITE TITLE " "
$ WRITE TITLE " "
$ WRITE TITLE " "
$ WRITE TITLE " "
$ WRITE TITLE " "
$ WRITE TITLE " "
$ WRITE TITLE " "
$ WRITE TITLE " "
$ WRITE TITLE " "
$ WRITE TITLE " "
$ WRITE TITLE " "
$ WRITE TITLE " "
$ WRITE TITLE " "
$ WRITE TITLE " "
$ WRITE TITLE ".END LITERAL"
$ WRITE TITLE ".NOFILL"
$ WRITE TITLE "By: Phil Levin
$ WRITE TITLE "    Contract Programmer"
$ WRITE TITLE " "
$ WRITE TITLE " "
$ WRITE TITLE " "
$ WRITE TITLE " "
$ WRITE TITLE "    Process Automation Department"
$ WRITE TITLE "    Inland Steel Company"
$ WRITE TITLE "    3210 Watling St.  MS 2-465"
$ WRITE TITLE "    East Chicago, IN  46342"
$ WRITE TITLE " "
$ WRITE TITLE " "
$ WRITE TITLE "File: RD_USER.RNO "
$ WRITE TITLE "Command: @RD_USER.COM "
$ WRITE TITLE ".FILL"
$ WRITE TITLE ".PAGE"
$ CLOSE TITLE
$ RUNOFF RD_USER_TITLE.RNO
$!
$! CREATE A FILE THAT IS OF THE SAME FORMAT AS RUNOFF OUTPUTS
$! THAT SIMPLY HAS A PAGE EJECT IN IT.
$!
$ OPEN PAGE/WRITE PAGE.RNO
$ WRITE PAGE ".PAGE"
$ CLOSE PAGE
$ RUNOFF PAGE
$!
$! NOW CREATE THE ACTUAL RUNOFF DOCUMENT
$!
$COPY RD_USER_TITLE.MEM,-
	RD_USER.MEC,-
	PAGE.MEM,-
	RD_USER.MEM,-
	PAGE.MEM,-
	RD_USER.MEX -
	RD_USER.LIS
$!
$! CLEAN UP
$!
$DELETE RD_USER.MEC;*,-
	RD_USER.MEM;*,-
	RD_USER.MEX;*,-
	RD_USER.BRN;*,-
	RD_USER.RNX;*,-
	PAGE.*;*
$!
$PURGE RD_USER.*
$!
$type sys$input
	RD_USER.LIS IS READY FOR WHAT EVER.
