C
C THIS INCLUDE FILE DEFINES THE COMMMON INFORMATION NEEDED
C BY THE MA_ROUTER PROCESS.
C
C DATE OF LAST UPDATE:  3/16/87
C
C NOTE: CHANGES TO THIS COMMON MUST ALSO BE REFLECTED IN
C 	MACRO VERSION OF THE COMMON (IE: MA_ROUTER_COMMON.MAR)
C	AND REPLACED IN THE MA_ROUTER.MLB LIBRARY.
C
	INTEGER*4 VERSION	! CURRENT VERSION NUMBER (used
				! to verify compatible releases of the
				! software. (see ROUTEMAC.MAR)
	PARAMETER (VERSION='20001'X)	! CURRENT VERSION NUMBER 2.0
				! UPPER WORD=RELEASE, LOWER= VERSION
C
	INTEGER*4 ROUTE_DBS(8)	! ROUTING DATABASE 
				! 1=START V.A.
				! 2= END VIRTUAL ADDRESS, 
				! 3= SIZE IN DISK BOCKS,
				! 4= CHANNEL NUMBER,
				! 5= LOGICAL UNIT NUMBER
				! 6,7= SECTION NAME DESCRIPTOR
				! 8= SYSTEM SERVICE OR RMS ERROR FROM OPENS
C
	STRUCTURE/IOSTATUS/
	 UNION
	   MAP
	     INTEGER*4 LW(2)
           END MAP
C
	   MAP
	     INTEGER*2 COND	! CONDITION VALUE
	     INTEGER*2 TRANS	! TRANSFER BYTE COUNT
	     INTEGER*4 SPEC	! DEVICE SPECIFIC
	   END MAP
	 END UNION
	END STRUCTURE
	    
C
	CHARACTER*8 OUR_NODE	! EXECUTOR NODE NAME
	INTEGER*4 MA_ROUTE_MBX	! MA_ROUTE PROCESS MAILBOX CHANNEL
	INTEGER*4 MBX_CNT		! NUMBER OF LETTER IN OUR MBX
	INTEGER*4 MBX_SIZE		! SIZE OF EACH LETTER
	RECORD/IOSTATUS/MBX_STATUS	! MAILBOX I/O STATUS
	RECORD/IOSTATUS/IOSTATUS	! I/O STATUS FOR QIOW's
	CHARACTER*12 MA_ROUTE_MBX_NAME
	PARAMETER (MA_ROUTE_MBX_NAME='MA_ROUTE_MBX')
	PARAMETER (MBX_CNT=2)	! MAXIMUM NUMBER OF LETTERS
	PARAMETER (MBX_SIZE=32) ! NUMBER OF BYTES EACH LETTER
	BYTE MA_MBX_LETTER(MBX_SIZE)  ! SINGLE LETTER BUFFER
C
	INTEGER*4 WAKE_EFN	! EVENT FLAG TO WAKE PROCESS UP WHEN EVENT
				! OCCURRS.
	INTEGER*4 MESG_EFN	! EVENT FLAG TO WAKE PROCESS WHEN NEW MESG.
C
	INTEGER*4 MSGDESC(2)	! MESSAGE DESCRIPTOR FOR GET MESSAGE
	BYTE MSGBUF(512)	! MESSAGE BUFFER
C
	CHARACTER*14 ROUTE_DBS_SECT	! ROUTE DATABASE SECTION NAME
	PARAMETER (ROUTE_DBS_SECT= 'ROUTE_DBS_SECT')
c
c AST ROUTINE ADDRESSES (PROBLEM WITH FORTRAN IN USEING OWN SUBROTINE
C		NAME AS AN EXTERNAL ALSO)
C
	INTEGER*4 NET_AST_ADD	! NETWORK AST ADDRESS
	INTEGER*4 MA_MBX_AST_ADD ! ROUTING  MAILBOX AST ADDRESS
	INTEGER*4 CONNECT_NODE_AST_ADD  ! NETWORK CONNECT AST 
	INTEGER*4 READ_NET_AST_ADD	! NETWORK READ QIO AST
	INTEGER*4 WRITE_NET_AST_ADD	! NETWORK WRITE QIO AST
	INTEGER*4 CON_TIMER_AST_ADD	! CONNECT TIMER AST
	INTEGER*4 NET_READ_RESP_AST_ADD	! RESPONSE TO A READ AST
	INTEGER*4 UNFULL_AST_ADD	! REMOTE NOT FULL AST
C
	CHARACTER*23 TIME_DELAY	! TIME TO WAIT BEFORE TRYING TO
	PARAMETER (TIME_DELAY='0 :15:00') ! ESTABLISH LINK AGAIN (15 MINUTES)
C
C 	STRUCTURE FOR THE QUEUE SUBROUTINES
C
	INTEGER*4 Q_BLOCK(2)	! QBLOCK 
	INTEGER*4 NETMSGINDEX	! NET_STATUS Message id index into queue
c
c buffers shared for all nodes
c
	INTEGER*4 RESP_COUNT	! NUMBER OF RESPONSE BUFFERS
	INTEGER*4 RESP_ADD_LST ! ADDRESS OF LIST OF ADDRESS OF RESP. BUFRS.
	INTEGER*4 RESP_INUSE	! ADDRESS OF LIST OF IN USE FLAGS
	INTEGER*4 LAST_RESP	! LAST USED RESPONSE POINTER
	INTEGER*4 BUF_COUNT	! NUMBER OF OUTPUT BUFFERS
	INTEGER*4 BUF_AVAIL	! NUMBER OF OUTPUT BUFFER AVAILABLE 
				! MAINTAINED BY ALLOCATE/DEALLOCATE ROUTINES
	INTEGER*4 BUF_ADD_LST	! ADDRESS OF LIST OF ADDRESSES OF OUTPUT BUFRS.
	INTEGER*4 BUF_INUSE	! ADDRESS OF LIST OF IN USER FLAGS
	INTEGER*4 LAST_BUF	! LAST USED BUFFER POINTER
	INTEGER*4 BUF_SIZE	! SIZE OF THE OUTPUT BUFFERS
c
c Last NRB scanned for output and count of the number of NRBs
c
	INTEGER*4 LAST_NRB	! LAST NODE NRB THAT BUFFER WAS ALLOCATED FOR
	INTEGER*4 NRB_COUNT	! NUMBER OF NRBS (SEE NEW_ROUTING_MAP)
C
	LOGICAL*4 QNA_TMO	! FOR REMOTE QUEUES THAT ARE FULL, AST ACTIVE
C
C INFORMATION NEEDED TO BID THE FIND SERVICE PROCESS
C
	CHARACTER*15 PROC_NAME	! PROCESS NAME FOR FIND SERVICE
	CHARACTER*26  IMAGE_NAME ! IMAGE NAME FOR FIND_SERVICE
	CHARACTER*26 SYSERROR	! ERROR FILE NAME (SYS$ERROR)
	CHARACTER*26 SYSINPUT	! INPUT FILE NAME (SYS$INPUT)
	CHARACTER*26 SYSOUTPUT	! OUTPUT FILE NAME (SYS$OUTPUT)
C
	INTEGER*4 PRILOG_COUNT	! NUMBER OF NODES THAT ARE FLAGED
				! AS PRIMARY LOGICAL NODE NAME AS A 
				! LOGICAL NODE NAME
C
C
C NOTE: ROUTE_DBS MUST BE FIRST IN COMMON AS WE WERE TOO LAZY
C 	TO MAINTAIN A MACRO AND A FORTRAN INCLUDE FILE.   SOME
C	MACRO SUBROUTINES MAKE ASSUMPTIONS ABOUT THIS ORDER.
C
	COMMON/MA_ROUTE_COMMON/ROUTE_DBS,MA_ROUTE_MBX,MA_MBX_LETTER,
	1	MBX_STATUS,WAKE_EFN,MESG_EFN,IOSTATUS,
	1	MSGDESC,MSGBUF,NET_AST_ADD,MA_MBX_AST_ADD,
	1	CONNECT_NODE_AST_ADD,READ_NET_AST_ADD,
	1	WRITE_NET_AST_ADD,CON_TIMER_AST_ADD,
	1	NET_READ_RESP_AST_ADD,UNFULL_AST_ADD,Q_BLOCK,NETMSGINDEX,
	1	RESP_COUNT,RESP_ADD_LST,RESP_INUSE,
	1	LAST_RESP,BUF_COUNT,BUF_AVAIL,BUF_ADD_LST,
	1	BUF_INUSE,LAST_BUF,BUF_SIZE,OUR_NODE,LAST_NRB,NRB_COUNT,
	1	QNA_TMO,PROC_NAME,IMAGE_NAME,SYSERROR,SYSINPUT,
	1	SYSOUTPUT,PRILOG_COUNT
