	PROGRAM MONITOR
	IMPLICIT NONE
C.begin.doc ************************** begin.doc
C  
C Source:monitor
C Original Designer     :PAUL VESTUTO, EARL LAKIA
C Stealer		:Neal Schmidt
C             Inland Steel
C             Process Automation Department
C             3210 Watling St.  MS 2-465
C             East Chicago, IN  46312
C  
C Date of last update: 17-JAN-88
C Revision level     :2.5
C  
C This code was stolen from the menu.for program and modified to
C monitor the queues.
C 
C end.doc ****************************** end.doc  
C

	INCLUDE '($SSDEF)'
c
c Define the QUEUEING specific values
c
	INCLUDE 'MA_Q$DEF:QUEUE.TLB(QUECONST)/LIST'
	INCLUDE 'MA_Q$DEF:QUEUE.TLB(HDRDEF)/LIST'
	INCLUDE 'MA_Q$DEF:QUEUE.TLB(PEXDEF)/LIST'
	INCLUDE 'MA_Q$DEF:QUEUE.TLB(QHDDEF)/LIST'
	INCLUDE 'MA_Q$DEF:QUEUE.TLB(MIDDEF)/LIST'
	INCLUDE 'MA_Q$DEF:QUEUE.TLB(QUEMSG)/LIST'

	RECORD /PEXDEF/ EXPANDED_REGION
	RECORD /QHDDEF/ QUEUE_HEAD
	RECORD /MIDDEF/ M_ID_BLOCK
	STRUCTURE /ID_REC/
	  CHARACTER*16 MSG_ID  ! MESSAGE ID
	  INTEGER*4 MAX_COUNT  ! MAXIMUM NUMBER TO BE ALLOWED IN QUEUE
	END STRUCTURE
C
	RECORD/ID_REC/ID_REC
C
C PCB DEFINITION MACRO
C extracted from sys$library:lib.mlb ($PCBDEF) and converted 
c to fortran
c
	INTEGER*4 PCB$K_LENGTH
	PARAMETER(PCB$K_LENGTH=288)
	STRUCTURE/PCBDEF/
	 UNION
	 MAP
	    BYTE DUMMY(PCB$K_LENGTH)
	 END MAP
	 MAP
	    INTEGER*4 PCBDUMP(PCB$K_LENGTH/4)
	 ENDMAP
	 MAP
		INTEGER*4 PCB$L_SQFL
		INTEGER*4 PCB$L_SQBL
		INTEGER*2 PCB$W_SIZE
		BYTE PCB$B_TYPE	
		BYTE PCB$B_PRI	
		BYTE PCB$B_ASTACT
		BYTE PCB$B_ASTEN
		INTEGER*2 PCB$W_MTXCNT
		INTEGER*4 PCB$L_ASTQFL
		INTEGER*4 PCB$L_ASTQBL
		INTEGER*4 PCB$L_PHYPCB
		INTEGER*4 PCB$L_OWNER
		INTEGER*4 PCB$L_WSSWP
		INTEGER*4 PCB$L_STS
		UNION
		MAP
			INTEGER*4 PCB$L_WTIME
		END MAP
		MAP
			BYTE PCB$B_PRISAV
			BYTE PCB$B_PRIBSAV
			BYTE PCB$B_DPC
			BYTE PCB$B_AUTHPRI
		END MAP
		END UNION
		INTEGER*2 PCB$W_STATE
		BYTE PCB$B_WEFC	
		BYTE PCB$B_PRIB	
		INTEGER*2 PCB$W_APTCNT
		INTEGER*2 PCB$W_TMBU
		INTEGER*2 PCB$W_GPGCNT
		INTEGER*2 PCB$W_PPGCNT
		INTEGER*2 PCB$W_ASTCNT
		INTEGER*2 PCB$W_BIOCNT
		INTEGER*2 PCB$W_BIOLM
		INTEGER*2 PCB$W_DIOCNT
		INTEGER*2 PCB$W_DIOLM
		INTEGER*2 PCB$W_PRCCNT
		BYTE C1
		CHARACTER*7 PCB$T_TERMINAL
		INTEGER*4 PCB$L_EFWM
		INTEGER*4 PCB$L_EFCS
		INTEGER*4 PCB$L_EFCU
		INTEGER*4 PCB$L_EFC2P
		INTEGER*4 PCB$L_EFC3P
		INTEGER*4 PCB$L_PID
		INTEGER*4 PCB$L_EPID
		INTEGER*4 PCB$L_EOWNER	
		INTEGER*4 PCB$L_PHD
		BYTE C2
		CHARACTER*15 PCB$T_LNAME
		INTEGER*4 PCB$L_JIB
		INTEGER*4 PCB$Q_PRIV(2)
		INTEGER*4 PCB$L_ARB(12)
		UNION
		MAP
			INTEGER*4 PCB$L_UIC
		END MAP
		MAP
			INTEGER*2 PCB$W_MEM	
			INTEGER*2 PCB$W_GRP	
		END MAP
		END UNION
		INTEGER*4 PCB$L_XXXX(15)  ! UNKNOWN FILLER
		INTEGER*4 PCB$L_ACLFL	
		INTEGER*4 PCB$L_ACLBL	
		INTEGER*4 PCB$L_LOCKQFL	
		INTEGER*4 PCB$L_LOCKQBL	
		INTEGER*4 PCB$L_DLCKPRI	
		INTEGER*4 PCB$L_IPAST	
		INTEGER*4 PCB$L_DEFPROT	
		INTEGER*4 PCB$L_WAITIME	
		INTEGER*4 PCB$L_PMB
	 END MAP
	 END UNION
	 END STRUCTURE
C
	INTEGER*4 PCBNUM
	PARAMETER (PCBNUM=25)	! NUMBER OF PCB TO GET BACK
	RECORD /PCBDEF/PCB(PCBNUM)	! SOME PLACE TO STORE THE 
	INTEGER*4 FNDCNT		! NUMBER OF PCBS FOUND
c
c Define the message header  and the rest of the read message packet
c
	STRUCTURE /MESBUF/
	  UNION
	    MAP
		CHARACTER MESSAGE_ALL*(9212) ! 18 BLOCKS MAX 
	    END MAP
	    MAP
		RECORD /HDRDEF/ MESBUFHDR
		CHARACTER MESSAGE_BUF*(4608) ! 9 BLOCKS MAX 
					! USER TEXT + 8 BLOCKS PAD 
	    END MAP
	  END UNION
	END STRUCTURE

	RECORD /mesbuf/ MESSAGE
c
c Define local parameters
c
	INTEGER*2 QUEUE_TIME(4)	! USED FOR CALCULATIONS OF ON QUEUE TIME
	INTEGER*2 CUR_TIME(4)	! CURRENT TIME FOR ON QUEUE TIME CALCS.
	INTEGER*4 DAYS		! NUMBER OF DAYS
	INTEGER*4 STATUS
	INTEGER*4 C1,C2	! BYTE COUNTS FOR CHARACTER STRINGS
	INTEGER*4 CHOICE
	INTEGER*4 LIB$ADDX	! QUAD WORD ADD
	INTEGER*4 LIB$SUBX	! QUAD WORD SUB
	INTEGER*4 LIB$DAY	! NUMBER OF DAYS
	INTEGER*4 SYS$GETMSG
	INTEGER*4 SYS$GETTIM
	INTEGER*4 SYS$CLREF
	INTEGER*4 SYS$ASCTIM
	INTEGER*4 Q_BLOCK(2)
	INTEGER*4 RNA_POINTER
	INTEGER*4 TMP_RNA_POINTER
	INTEGER*2 efn
	INTEGER*2 NUM_MESSAGE
	INTEGER*2 MSGLEN
	INTEGER*2 MIDX
	INTEGER*2 BOGUS_Q_BLOCK
	INTEGER*2 MESSAGE_LENGTH
	INTEGER*2 TEMPLEN
	INTEGER*2 TYPES
	INTEGER*2 POINTER
	INTEGER*2 REPEAT
	INTEGER*2 RTR_FLAG
	INTEGER*2 I		! LOOP  VARIABLE
	INTEGER*2 IC		! NUMBER OF BYTES IN RESPONSE
	CHARACTER MSGBUF*256
	CHARACTER MESSAGE_ID*16
	CHARACTER Q_NAME*(*)
	CHARACTER ASCII_TIME*23
	INTEGER*4 IOSTAT	! RMS FILE OPEN STATUS
	INTEGER*4 ID_LUN	! Lun of the keyed message id file
	PARAMETER(ID_LUN=7)
C
C Initialize section ...
C
	PARAMETER (Q_NAME = 'MA_Q_NAME')  ! FOR DIFFERENT QUEUE NAMES
	STATUS = 1
	EFN = 0
C
C Attach the queue sections
C
100	CONTINUE
	STATUS = ATTACH_Q(Q_BLOCK)
	msgbuf = ' The queue global section has been attached '
200	if (.not. status) THEN
		STATUS=SYS$GETMSG( %val(STATUS), MSGLEN, MSGBUF,,)
		type *,MsgBUF(1:msglen)	! Display the last message
	else
		type *,msgbuf(1:78)
	END IF

C
C Scan the queue and print summary of the message ids.
c We will do this by opening the message id file and
c asking for status for each message id.  Note, if
c the user has not modified the QUEUE_IDS.DAT file, 
c then obviously this won't work.
c
2000 	CONTINUE
	OPEN(UNIT=ID_LUN,
	1	TYPE='OLD',
	1	READONLY,
	1	IOSTAT=IOSTAT,
	1	NAME='MA_Q$PROD:QUEUE_IDS.DAT;',
	1	ERR=2100,
	1	INITIALSIZE=15,
	1	RECL=5,
	1	ORGANIZATION='INDEXED',
	1	RECORDTYPE='FIXED',
	1	KEY=(1:16:CHARACTER),
	1	FORM='UNFORMATTED',
	1	ACCESS='KEYED')
C
	TYPE 10010
	READ (*,10011,END=10000,ERR=10000) CHOICE
	TYPE *,'Queue name        current/  total'
	TYPE *,'----------        ---------------'
C
C Loop here reading the keyed file in ASCII ascending order until
c we get an end of file
c
2010	READ(UNIT=ID_LUN,END=2025)ID_REC
	STATUS = DISPLAY_MESSAGE_ID (q_block, ID_REC.MSG_ID, m_id_block)
	IF (( STATUS .EQ. %LOC(QUE_MIDNOTFOUND) ))THEN
		TYPE *,' Message id: ',ID_REC.MSG_ID
		TYPE *,' Was not found in the installed queue'
		TYPE *,' The queue message id file is not consistant with'
		TYPE *,' with the installed queue.  You should update '
		TYPE *,' the valid message ids with Q_UTL. '
		GO TO 2010  ! go get next message id
	ENDIF
	IF (M_ID_BLOCK.MID$W_CNT .LT. CHOICE) GO TO 2010
	IF (.NOT. STATUS) GOTO 2025
	TYPE 10013, m_id_block.mid$c_mid, m_id_block.mid$w_cnt,
	1		m_id_block.mid$w_max
	IF((M_ID_BLOCK.MID$L_STAT .AND. MID$M_RQF) .NE. 0)
	1	TYPE *,' Remote queue is full for this message id'
	IF((M_ID_BLOCK.MID$L_STAT .AND. MID$M_DEL) .NE. 0)
	1	TYPE *,' Message id is marked as being deleted'
	IF((M_ID_BLOCK.MID$L_STAT .AND. MID$M_IOPND) .NE. 0)
	1	TYPE *,' Router has an outstanding write to remote node this id'
	IF((M_ID_BLOCK.MID$L_STAT .AND. MID$M_ACKPND) .NE. 0)
	1	TYPE *,' Router waiting on a ACK from remote node this id'
	IF((M_ID_BLOCK.MID$L_STAT .AND. MID$M_NOROUTE) .NE. 0)
	1	TYPE *,' Message id is not routeable (not known at remote)'
	IF((M_ID_BLOCK.MID$L_STAT .AND. MID$M_QUERDERR) .NE. 0)
	1	TYPE *,' Message id was unreadaable from the queue ',
	1	       ' because of an error'
	GO TO 2010
C
2025	CLOSE(UNIT=ID_LUN)
	GO TO 10000
c
2100	TYPE *,' Unable to open the message id keyed file'
	GO TO 2025
C
C Exit
C
10000	CONTINUE
	TYPE *,'Exiting... will attempt to deatach the queue'
	STATUS= DETACH_Q(Q_BLOCK)	! DEALLOCATE FROM THE QUEUE
	CALL SYS$EXIT(%VAL(STATUS))
C
C Format statements
C
10010	format ('$ Display queues with current messages greater than ')
10011	format (i4)
10013	format ('  ',a16,' ',i,'/',i)
	END
