$ SET NOON
$ SET NOVERIFY
$ TYPE SYS$INPUT

     COMMAND FILE TO BUILD THE PROGRAM "MA_ROUTER"
     SOURCE DIRECTORY IS: [.MA_Q.ROUTER]

$ IF P1 .NES. "" THEN GOTO GOTP1
$ TYPE SYS$INPUT

 FIND OUT WHAT OPTIONS THE USER WANTED
 	D= DEBUG 
	T= COMPILE FORTRAN D_LINES IN SOURCE CODE
	M= COMPILE MESSAGE FILE
	L= LISTING
	C= COMPILE
	A= ASSEMBLE
	B= LINK AND BUILD
 	P= MOVE TO PRODUCTION ACCOUNT
	R= LINKER MAP
	X= CROSS REFERENCE
	S= SHORT LIST (NO CROSS REFERENCE)
	V= NO TRACE BACK OPTION (FOR RELEASE VERSION)
	*= OPTIONS=MLCABPRS

 ENTER YOUR OPTIONS SUCH AS:  CABP
 
 THERE ARE NO DEFAULT VALUES ALLOWED, IF YOU ENTER CARRIAGE RETURN, 
 COMMAND FILE WILL EXIT
  
$ INQUIRE P1  "Enter options"
$ IF P1 .EQS. "" THEN EXIT
$!
$!
$ GOTP1:
$!
$ C_ERR=""
$ D=0
$ T=0
$ N=0
$ M=0
$ L=0
$ C=0 
$ A=0
$ B=0
$ P=0
$ R=0
$ S=0
$ X=0
$ V=0
$!
$! SCAN P1 FOR THE OPTIONS DESIRED
$!
$ IF P1 .EQS. "*" THEN P1="MLCABPRS"
$ P1L=F$LENGTH(P1)
$ I=0
$ SWCHK:
$ IF I .EQ. P1L THEN GOTO GOTSWCH
$ WRITE SYS$OUTPUT F$EXTRACT(I,1,P1)
$ IF F$EXTRACT(I,1,P1) .EQS. "D" THEN D=1
$ IF F$EXTRACT(I,1,P1) .EQS. "T" THEN T=1
$ IF F$EXTRACT(I,1,P1) .EQS. "N" THEN N=1
$ IF F$EXTRACT(I,1,P1) .EQS. "M" THEN M=1
$ IF F$EXTRACT(I,1,P1) .EQS. "L" THEN L=1
$ IF F$EXTRACT(I,1,P1) .EQS. "C" THEN C=1
$ IF F$EXTRACT(I,1,P1) .EQS. "A" THEN A=1
$ IF F$EXTRACT(I,1,P1) .EQS. "B" THEN B=1
$ IF F$EXTRACT(I,1,P1) .EQS. "P" THEN P=1
$ IF F$EXTRACT(I,1,P1) .EQS. "R" THEN R=1
$ IF F$EXTRACT(I,1,P1) .EQS. "S" THEN S=1
$ IF F$EXTRACT(I,1,P1) .EQS. "X" THEN X=1
$ IF F$EXTRACT(I,1,P1) .EQS. "V" THEN V=1
$ I=I+1
$ GOTO SWCHK
$!
$! NOW SELECT THE CORRECT TYPE OF OPTIMIZATION AND LISTING SELECTION
$! AS REQUIRED BY THE SWITCH SETTINGS
$!
$ GOTSWCH:
$ LIST=""	! FORTRAN LISTINGS
$ MLIST=""	! MACRO LISTINGS
$ LINKLIST= ""	! LINKER OPTIONS
$!
$ IF L .EQ. 1 THEN LIST=LIST+"/LIST"
$ IF L .EQ. 1 THEN MLIST=MLIST+"/LIST"
$ IF V .EQ. 1 THEN LIST=LIST+"/DEBUG=NONE"
$ IF S .EQ. 1 THEN MLIST=MLIST-
	+ "/NOSHOW=(CONDITIONALS,EXPANSION,DEFINITIONS,BINARY)"-
	+ "/NOCROSS_REFERENCE"
$ IF S .EQ. 1 THEN LIST=LIST + "/NOCROSS_REFERENCE"-
	+"/SHOW=(NOINCLUDE,NOMAP,NOPREPROCESSOR,NOSINGLE)"
$ IF D .EQ. 1 THEN LIST=LIST+"/DEBUG/NOOPTIMIZE"
$ IF D .EQ. 1 THEN LINKLIST=LINKLIST+"/DEBUG"
$ IF T .EQ. 1 THEN LIST=LIST+"/D_LINES"
$ IF R .EQ. 1 THEN LINKLIST=LINKLIST+"/MAP"
$ IF X .EQ. 1 THEN LINKLIST=LINKLIST+"/CROSS_REFERENCE"
$!
$!
$ SET VERIFY
$!
$! COMPILE
$!
$ IF C .EQ. 0 THEN GOTO ASSEM
$FOR ACK_LAST_WRITE'LIST'
$ IF .NOT. $STATUS THEN C_ERR=C_ERR+",ACK_LAST_WRITE"
$FOR ALC_RESP_BUF'LIST'
$ IF .NOT. $STATUS THEN C_ERR=C_ERR+",ALC_RESP_BUF"
$FOR ALC_OUT_BUF'LIST'
$ IF .NOT. $STATUS THEN C_ERR=C_ERR+",ALC_OUT_BUF" 
$FOR BUILD_REMOTE_CONNECT_NCB'LIST'
$ IF .NOT. $STATUS THEN C_ERR=C_ERR+",BUILD_REMOTE_CONNECT_NCB"
$FOR BUILD_RESP'LIST'
$ IF .NOT. $STATUS THEN C_ERR=C_ERR+",BUILD_RESP"
$FOR BUILD_ROUTE_TABLE'LIST'
$ IF .NOT. $STATUS THEN C_ERR=C_ERR+",BUILD_ROUTE_TABLE"
$FOR CHK_LNK_SEQ'LIST'
$ IF .NOT. $STATUS THEN C_ERR=C_ERR+",CHK_LNK_SEQ"
$FOR CMP_NAME'LIST'
$ IF .NOT. $STATUS THEN C_ERR=C_ERR+",CMP_NAME"
$FOR CONNECT_NODE'LIST'
$ IF .NOT. $STATUS THEN C_ERR=C_ERR+",CONNECT_NODE"
$FOR CONNECT_NODE_AST'LIST'
$ IF .NOT. $STATUS THEN C_ERR=C_ERR+",CONNECT_NODE_AST"
$FOR CON_TIMER_AST'LIST'
$ IF .NOT. $STATUS THEN C_ERR=C_ERR+",CON_TIMER_AST"
$FOR DEA_OUT_BUF'LIST'
$ IF .NOT. $STATUS THEN C_ERR=C_ERR+",DEA_OUT_BUF"
$FOR DEA_RESP_BUF'LIST'
$ IF .NOT. $STATUS THEN C_ERR=C_ERR+",DEA_RESP_BUF"
$FOR DISCONNECT_NODE'LIST'
$ IF .NOT. $STATUS THEN C_ERR=C_ERR+",DISCONNECT_NODE"
$FOR GET_OUT_MESG'LIST'
$ IF .NOT. $STATUS THEN C_ERR=C_ERR+",GET_OUT_MESG"
$FOR GET_Q_EVENT'LIST'
$ IF .NOT. $STATUS THEN C_ERR=C_ERR+",GET_Q_EVENT"
$FOR MAP_IDS'LIST'
$ IF .NOT. $STATUS THEN C_ERR=C_ERR+",MAP_IDS"
$FOR MA_MBX_AST'LIST'
$ IF .NOT. $STATUS THEN C_ERR=C_ERR+",MA_MBX_AST"
$FOR MA_ROUTER'LIST'
$ IF .NOT. $STATUS THEN C_ERR=C_ERR+",MA_ROUTER"
$FOR MA_ROUTER_EXIT_HAN'LIST'
$ IF .NOT. $STATUS THEN C_ERR=C_ERR+",MA_ROUTER_EXIT_HAN"
$FOR MA_R_INIT'LIST'
$ IF .NOT. $STATUS THEN C_ERR=C_ERR+",MA_R_INIT"
$FOR NET_AST'LIST'
$ IF .NOT. $STATUS THEN C_ERR=C_ERR+",NET_AST"
$FOR NET_READ'LIST'
$ IF .NOT. $STATUS THEN C_ERR=C_ERR+",NET_READ"
$FOR NET_READ_RESP_AST'LIST'
$ IF .NOT. $STATUS THEN C_ERR=C_ERR+",NET_READ_RESP_AST"
$FOR NEW_ROUTING_MAP'LIST'
$ IF .NOT. $STATUS THEN C_ERR=C_ERR+",NEW_ROUTING_MAP"
$FOR NODE_TO_NRB'LIST'
$ IF .NOT. $STATUS THEN C_ERR=C_ERR+",NODE_TO_NRB"
$FOR OUTPUT_NET'LIST'
$ IF .NOT. $STATUS THEN C_ERR=C_ERR+",OUTPUT_NET"
$FOR PUT_BACK'LIST'
$ IF .NOT. $STATUS THEN C_ERR=C_ERR+",PUT_BACK"
$FOR READ_MBX_NW'LIST'
$ IF .NOT. $STATUS THEN C_ERR=C_ERR+",READ_MBX_NW"
$FOR READ_NET_AST'LIST'
$ IF .NOT. $STATUS THEN C_ERR=C_ERR+",READ_NET_AST"
$FOR REM_NODE_CON'LIST'
$ IF .NOT. $STATUS THEN C_ERR=C_ERR+",REM_NODE_CON"
$FOR WRITE_NET_AST'LIST'
$ IF .NOT. $STATUS THEN C_ERR=C_ERR+",WRITE_NET_AST"
$!
$! ASSEMBLE
$!
$ ASSEM:
$ IF A .EQ. 0 THEN GOTO MESG
$!
$ LIBR MA_ROUTER.MLB/REPLACE MA_ROUTER_COMMON.MAR
$!
$ MAC FIND_ROUTE_MSG'MLIST'
$ IF .NOT. $STATUS THEN C_ERR=C_ERR+",FIND_ROUTE_MSG"
$ MAC GET_NODE_NAME'MLIST'
$ IF .NOT. $STATUS THEN C_ERR=C_ERR+",GET_NODE_NAME"
$ MAC LHD_ADD'MLIST'
$ IF .NOT. $STATUS THEN C_ERR=C_ERR+",LHD_ADD"
$ MAC MARK_AVAIL'MLIST'
$ IF .NOT. $STATUS THEN C_ERR=C_ERR+",MARK_AVAIL"
$ MAC MARK_FULL'MLIST'
$ IF .NOT. $STATUS THEN C_ERR=C_ERR+",MARK_FULL"
$ MAC ROUTE_SECTION_OPEN'MLIST'
$ IF .NOT. $STATUS THEN C_ERR=C_ERR+",ROUTE_SECTION_OPEN"
$ MAC UNFULL_AST'MLIST'
$ IF .NOT. $STATUS THEN C_ERR=C_ERR+",UNFULL_AST"
$!
$! MESSAGE ASSEMBLE
$!
$ MESG:
$ IF M .EQ. 0 THEN GOTO LINKIT
$ OPEN/WRITE PPP MA_ROUTER_MSG.PRE
$ WRITE PPP "	.TITLE	MA_ROUTER MESSAGE FILE"
$ WRITE PPP "	.IDENT	/2.0/"
$ WRITE PPP ".FACILITY MA_ROUTER,1/PREFIX=RTR_"
$ CLOSE PPP
$ MESSAGE MA_ROUTER_MSG.PRE,MA_ROUTER_MSG.MSG
$ IF .NOT. $STATUS THEN C_ERR=C_ERR+",MA_ROUTER_MSG"
$!
$! LINK SECTION
$!
$ LINKIT:
$ SET NOVERIFY
$ IF (C_ERR .EQS. "")THEN GOTO NOERR
$ WRITE SYS$OUTPUT " COMPILE or ASSEMBLY  ERRORS IN MODULES: "
$ N=0
$ ERRLUP:
$ NAME=F$ELEMENT(N,",",C_ERR)
$ WRITE SYS$OUTPUT NAME
$!
$ IF ( NAME .EQS. "," )THEN GOTO DONE
$ N=N+1
$ GOTO ERRLUP
$ DONE:
$ WRITE SYS$OUTPUT " NO LINK WILL BE DONE "
$ EXIT
$!
$!
$ NOERR:
$ IF B .EQ. 0 THEN GOTO PROD
$!
$ LINK'LINKLIST' MA_ROUTER,SYS$INPUT/OPTION
	MA_ROUTER_MSG,-
	ACK_LAST_WRITE,-
	ALC_OUT_BUF,-
	ALC_RESP_BUF,-
	BUILD_REMOTE_CONNECT_NCB,-
	BUILD_RESP,-
	BUILD_ROUTE_TABLE,-
	CHK_LNK_SEQ,-
	CMP_NAME,-
	CONNECT_NODE,-
	CONNECT_NODE_AST,-
	CON_TIMER_AST,-
	DEA_OUT_BUF,-
	DEA_RESP_BUF,-
	DISCONNECT_NODE,-
	FIND_ROUTE_MSG,-
	GET_NODE_NAME,-
	GET_OUT_MESG,-
	GET_Q_EVENT,-
	LHD_ADD,-
	MAP_IDS,-
	MARK_AVAIL,-
	MARK_FULL,-
	MA_MBX_AST,-
	MA_ROUTER_EXIT_HAN,-
	MA_R_INIT,-
	NET_AST,-
	NET_READ,-
	NET_READ_RESP_AST,-
	NEW_ROUTING_MAP,-
	NODE_TO_NRB,-
	OUTPUT_NET,-
	PUT_BACK,-
	READ_MBX_NW,-
	READ_NET_AST,-
	REM_NODE_CON,-
	ROUTE_SECTION_OPEN,-
	UNFULL_AST,-
	WRITE_NET_AST,-
	MA_Q$SSDISP/SHAREABLE,-
	MA_Q$LIB:QUEUE.OLB/LIBRARY,-
	MA_Q$LIB:INLAND.OLB/LIBRARY,-
	SYS$SYSTEM:SYS.STB/SELECTIVE_SEARCH
$EOD
$!
$! MOVE TO PRODUCTION AND CLEAN UP PRODUCTION ACCOUNT
$!
$ PROD:
$!
$ IF P .EQ. 0 THEN GOTO CLEANUP
$
$ COPY MA_ROUTER.EXE [-]*.*
$ PURGE [-]MA_ROUTER.EXE/KEEP=3
$ SET NOVERIFY
$ SET PROTECTION=(W:RWED,G:RWED,O:RWED) [-]MA_ROUTER.EXE
$!
$! CLEAN UP
$!
$ CLEANUP:
$ PURGE *.*/KEEP=2
