	PROGRAM RTIN
C.begin.doc ************************** begin.doc
C  
C .c ;MODULE
C .c ;^&RTIN\&
C .nf
C .x RTIN>Defined
C Source:RTIN.MOD
C Designer           :EARL LAKIA
C Author             :
C             Inland Steel
C             Process Automation Department
C             3210 Watling St.  MS 2-465
C             East Chicago, IN  46312
C  
C Date of last update:22-JUL-86
C Revision level     :1.1
C  
C .C ;Formal Parameter List
C Receives:
C  
C Returns:
C  
C Accesses common(s):
C  
C Accesses file(s):
C  
C Other modules referenced:
C .SK
C .fill
C .SK
C Description:
C 
C
C THIS IS A TEST PROGRAM WHICH TRIES TO MAKE A CONNECTION
C THE MA _ROUTER.  IT THEN WRITES A MESSAGE PROMPTED BY USER AND
C GETS THE RESPONSE FROM THE ROUTER.  IT KINDA WORKS LIKE
C A ROUTER IN WHICH MESSAGES ARE BEING SEND TO THE ROUTER ONLY.
C
C  THIS PROGRAM IS RUN WITH A SIMPLE DCL "RUN" COMMAND.
C .sk    
C end.doc ****************************** end.doc  

	character*1 iyes
	integer*4 SYS_STATUS
	INTEGER*4 CHANNEL
	INTEGER*4 SYS$QIOW
	INTEGER*4 SYS$ASSIGN
	INTEGER*4 SYS$EXIT
	INTEGER*4 Q_IOSB(2)
	INTEGER*2 Q_IOSBW(4)
	INTEGER*4 BUFFER(25)
	EQUIVALENCE (Q_IOSB,Q_IOSBW)
	INCLUDE '($IODEF)'
C
	INCLUDE 'MA_ROUTER_COMMON.INC/LIST'
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(HDRDEF)/LIST'
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(MGHDEF)/LIST'
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(NRBDEF)/LIST'
	INCLUDE 'MA_Q:[DEF]QUEUE.TLB(RSPDEF)/LIST'
	INCLUDE 'MA_ROUTER_MSG.INC/NOLIST'
	RECORD/NRBDEF/NRB	! AST PARAMETER IS THE NRB OR DUMMY FOR 
				! UNSOLICITED CONNECTS
	RECORD/RSPDEF/RESP_BUF
C
	STRUCTURE/TEST/
		RECORD/MGHDEF/MGH
		CHARACTER*25 MSG
	END STRUCTURE
C
	RECORD/TEST/REC
C
C
C
	TYPE *,' TRYING TO CONNECT'
C
	SYS_STATUS=SYS$ASSIGN('B4750A::"TASK=MA_ROUTER"',
	1	CHANNEL,,)
C
	TYPE *,' CONNECT COMPLETE'
C
	IF (.NOT. SYS_STATUS)SYS_STATUS=SYS$EXIT(%VAL(SYS_STATUS))
C

	ISEQ=0
1000	CONTINUE
	TYPE *,' ENTER A MESSAGE ID (16 BYTES OR LESS) '
	READ (*,100)REC.MGH.MGH$C_MID
100	FORMAT(A16)
	TYPE *,' ENTER TEST MESSAGE: '
	READ(*,110)REC.MSG
110	FORMAT(A25)
C
	REC.MGH.MGH$W_LSQ=ISEQ	! LINK SEQUENCE NUMBER
	REC.MGH.MGH$L_IDX=ISEQ*2	! ROUTER INDEX
	REC.MGH.HDR.HDR$W_QSEQ=ISEQ*4	! QUEUE SEQUNCE NUMBER
	REC.MGH.HDR.HDR$W_TYPE=1		! MESSAGE TYPE
	REC.MGH.HDR.HDR$C_SNM='B4750A'	! SOURCE
	REC.MGH.HDR.HDR$C_DNM='B4750A'	! DEST.
	REC.MGH.HDR.HDR$W_LEN=25	! SIZE OF MESSAGE PART OF MESSAGE
C
C NOW WRITE THE MESSAGE TO THE MA_ROUTER
C 
	SYS_STATUS = SYS$QIOW(,
	1		%VAL(CHANNEL),
	1		%VAL(IO$_WRITEVBLK),
	1		Q_IOSB,		! STATUS BLOCK
	1		,,
	1		%REF(REC), ! BUFFER ADDRESS
	1		%VAL(25+HDR$K_SIZ+22),	! BYTE COUNT TO WRITE 
	1		,,,)
C
	TYPE *, 'NET WORK WRITE COMPLETE '
	IF(.NOT. SYS_STATUS)THEN
		TYPE *,' SYSTEM SERVICE ERROR ON WRITE QIO'
		SYS_STATUS=SYS$EXIT(%VAL(SYS_STATUS))
	ENDIF
	IF(.NOT. Q_IOSBW(1))THEN
		 TYPE *,' I/O STATUS ERORR: ',Q_IOSBW
		 SYS_STATUS=SYS$EXIT(%VAL(Q_IOSBW(1)))
	ENDIF

C
C NOW SET UP A READ TO GET THE RESPONSE
C
	SYS_STATUS = SYS$QIOW(,
	1		%VAL(CHANNEL),
	1		%VAL(IO$_READVBLK),
	1		Q_IOSB,		! STATUS BLOCK
	1		,,
	1		%REF(REC), ! BUFFER ADDRESS
	1		%VAL(22+HDR$K_SIZ+8),	! BYTE COUNT OF RESPONSE
	1		,,,)
C
	TYPE *,' LINK SEQ: ',REC.MGH.MGH$W_LSQ
	TYPE *,'    INDEX: ',REC.MGH.MGH$L_IDX
	TYPE *,'QUEUE SEQ: ',REC.MGH.HDR.HDR$W_QSEQ
	TYPE *,'     TYPE: ',REC.MGH.HDR.HDR$W_TYPE
	TYPE *,'   SOURCE: ',REC.MGH.HDR.HDR$C_SNM
C
	TYPE *, 'NET WORK WRITE COMPLETE '
	IF(.NOT. SYS_STATUS)THEN
		TYPE *,' SYSTEM SERVICE ERROR ON WRITE QIO'
		SYS_STATUS=SYS$EXIT(%VAL(SYS_STATUS))
	ENDIF
	IF(.NOT. Q_IOSBW(1))THEN
		 TYPE *,' I/O STATUS ERORR: ',Q_IOSBW
		 SYS_STATUS=SYS$EXIT(%VAL(Q_IOSBW(1)))
	ENDIF
C	
	ISEQ=ISEQ+1	! INCREMENT LINK SEQ. NUMBER
	TYPE *,' DONE SUCCESSFULLY'
	TYPE *,' DO YOU WANT TO TRY ANOTHER?'
	READ(*,300)IYES
300	FORMAT(A1)
	IF(IYES .EQ. 'Y' .OR. IYES .EQ. 'y')go to 1000
	SYS_STATUS=SYS$EXIT(%VAL(SYS_STATUS))
	END
