C.begin.doc ************************** begin.doc
C  
C .c ;MODULE
C .c ;^&FORCE_EXIT\&
C .nf
C .x FORCE_EXIT>Defined
C Source:FORCE_EXIT1.MOD
C Designer           :EARL LAKIA,SUZANNE GELATKA
C Author             :SUZANNE GELATKA
C Date of last update:12-MAR-1986
C Revision level     :1.0
C  
C .C ;Formal Parameter List
C Receives:
C  
C Returns:
C  
C Accesses common(s):
C  
C Accesses file(s):
C  
C Other modules referenced:
C .SK
C .fill
C .SK
C Description:
C .sk    
C THIS PROGRAM FORCES A PROCESS TO EXIT. THEN THE PROCESS EXECUTES
C ITS EXIT HANDLERS.
C CALLING SEQUENCE:
C      RUN FORCE_EXIT
C end.doc ****************************** end.doc  

	PROGRAM FORCE_EXIT

	IMPLICIT NONE
	INTEGER*4 ILTH
	CHARACTER*80 NAME
	INTEGER*4 STATUS
	INTEGER*4 SYS$FORCEX
	INTEGER*4 PRC_NAME_DESCR(2)
	INTEGER*4 SYS_STATUS
	INTEGER*4 SYS$GETMSG
	CHARACTER*256 MSG_BUF
	INTEGER*2 MSG_LEN
	INCLUDE '($SSDEF)'

C
C	GET THE PROCESS NAME FROM THE COMMAND FILE
C
	OPEN(UNIT=1,NAME='SYS$INPUT',TYPE='OLD')
	OPEN(UNIT=2,NAME='SYS$OUTPUT',TYPE='OLD')
C
	WRITE(2,100)
  100   FORMAT('$ENTER PROCESS NAME: ')
	READ(1,200,END=250) ILTH,NAME(1:ILTH)
  200   FORMAT(Q,A<ILTH>)
	GOTO 260

  250   WRITE(2,255)
  255	FORMAT(1X,'UNABLE TO READ PROCESS NAME')
	CALL SYS$EXIT(%VAL(STATUS))

  260   CONTINUE

C
C	BUILD THE PROCESS NAME CHARACTER DESCRIPTOR
C
	PRC_NAME_DESCR(1) = ILTH
	PRC_NAME_DESCR(2) = %LOC(NAME(1:ILTH))

C
C	FORCE THE PROCESS TO EXIT
C
	STATUS = SYS$FORCEX(,PRC_NAME_DESCR,%VAL(SS$_ABORT))
	IF(.NOT. STATUS) THEN
	  SYS_STATUS = SYS$GETMSG(%VAL(STATUS),MSG_LEN,MSG_BUF,,)
	  IF(.NOT. SYS_STATUS) CALL SYS$EXIT(%VAL(SYS_STATUS))
	  WRITE(2,300)
  300     FORMAT(1X,'BAD STATUS ON SYS$FORCEX')
	  CALL SYS$EXIT(%VAL(STATUS))
	ENDIF
	CALL SYS$EXIT(%VAL(STATUS))
	END	
