	SUBROUTINE FTN_IOSTAT
	IMPLICIT NONE
C.begin.doc ************************** begin.doc
C  
C .c ;MODULE
C .c ;^&FTN_IOSTAT\&
C .nf
C .x FTN_IOSTAT>Defined
C Source:FTN_IOSTAT.MOD
C TO BECOME PART OF LIBRARY:INLAND
C Designer           :EARL LAKIA
C Author             :EARL LAKIA
C             Inland Steel
C             Process Automation Department
C             3210 Watling St.  MS 2-465
C             East Chicago, IN  46312
C  
C Date of last update: 7-AUG-1986 09:15:26.36
C Revision level     :1.0
C  
C .C ;Formal Parameter List
C Receives:
C  
C Returns:
C  
C Accesses common(s):
C  
C Accesses file(s):
C  
C Other modules referenced:
C .SK
C .fill
C .SK
C Description:
C .sk    
C 	This is a simple subroutine that will print to the
C sys$input device the current RMS and Fortran error codes.
C The following is a typical useage.
C .LITERAL
C 
C 	INTEGER*4 IOSTAT
C 	READ(UNIT=1,IOSTAT=IOSTAT)RECORD
C 	IF(IOSTAT .NE. 0)
C 	      CALL FTN_IOSTAT
C 	      ( What ever corrective action )
C 	ENDIF
C .END LITERAL
C end.doc ****************************** end.doc  

	INTEGER*4 FNUM,RMSSTS,RMSSTV,IUNIT,CONDVAL
	INTEGER*4 SYS$GETMSG	! TRANSLATE VMS ERROR CODE MESSAGE
	INTEGER*4 SYS_STATUS	! SYSTEM STATUS
	INTEGER*4 I,KSIZE
	CHARACTER*256 MESG
C
	CALL ERRSNS(FNUM,RMSSTS,RMSSTV,IUNIT,CONDVAL)
C
	TYPE *,' Fortran error number: ',FNUM
	TYPE *,' RMS last I/O error status: ',RMSSTS
	TYPE *,' RMS last I/O extended error status: ',RMSSTV
	TYPE *,' Unit number that error occurred on: ',IUNIT
	TYPE *,' VAX condition value: ',CONDVAL
	SYS_STATUS=SYS$GETMSG(%VAL(CONDVAL),KSIZE,
	1	MESG,,)
	TYPE *,MESG(1:KSIZE)	! TRANSLATED MESSAGE
	RETURN
	END
