/* This header file was created by Joe Meadows, and is not copyrighted
   in any way. This header file was last modified on Sep. 8th, 1987.

   This include file contains the strings that describe the command line
   for the FIND utility */
char *t_rtype = "Type";
char *ta_rtype[] = {
  "Undefined",
  "Fixed",
  "Variable",
  "VFC",
  "Stream",
  "LFStream",
  "CRStream"
};
char *t_fileorg = "Organization";
char *ta_fileorg[] = {
  "Sequential",
  "Relative",
  "Indexed",
  "Direct"
};
char *t_attr = "Attributes";
  char *t_fortrancc = "FortranCC";
  char *t_impliedcc = "ImpliedCC";
  char *t_printcc = "PrintCC";
  char *t_nospan = "Span";
char *t_char = "Characteristics";
  char *t_badacl = "ACL_Corrupt";
  char *t_nobackup = "Backup";
  char *t_contigb = "Best_Try_Contiguous";
  char *t_nocharge = "Charge";
  char *t_contig = "Contiguous";
  char *t_directory = "Directory";
  char *t_erase = "Erase_On_Delete";
  char *t_badblock = "File_Corrupt";
  char *t_locked = "Locked";
  char *t_markdel = "Marked_For_Delete";
  char *t_spool = "Spool";
  char *t_readcheck = "Read_Verify";
  char *t_writeback = "Write_Back";
  char *t_writcheck = "Write_Verify";
char *t_journal = "Journal";
  char *t_journal_file = "Journal";
  char *t_aijnl = "AIJnl";
  char *t_atjnl = "ATJnl";
  char *t_bijnl = "BIJnl";
  char *t_rujnl = "RUJnl";
  char *t_never_ru = "Never_RU";
  char *t_only_ru = "Only_RU";
char *t_access = "Access_Mode";
char *ta_access[] = {
  "USER",
  "SUPERVISOR",
  "EXECUTIVE",
  "KERNEL"
};

char *t_placement = "Placement";
  char *t_place_exact = "Exact";
  char *t_place_oncyl = "On_Cylinder";
  char *t_place_rvn = "Relative_Volume_Number";
  char *t_place_lbn = "LBN_Specified";

char *t_prot = "Protection";
char *t_protset = "Protection.set";
char *t_protclr = "Protection.clear";
char *ta_prot[] = {"SYSTEM", "OWNER", "GROUP", "WORLD"};
char *t_fileprot[] = {
  "RWED", "WED", "RED", "ED", "RWD", "WD", "RD",
  "D", "RWE", "WE", "RE", "E", "RW", "W", "R", ""
};
char *t_credate = "Creation_Date";
char *t_revdate = "Revision_Date";
char *t_expdate = "Expiration_Date";
char *t_bakdate = "Backup_Date";
char *t_revisions = "Number_Of_Revisions";
char *t_vfcsize = "VFC_Size";
char *t_rsize = "Record_Size";
char *t_maxrec = "Maximum_Record_Size";
char *t_efblk = "Used";
char *t_ffbyte = "First_Free_Byte";
char *t_hiblk = "Allocated";
char *t_defext = "Default_Extend_Quantity";
char *t_bktsize = "Bucket_Size";
char *t_gbc = "Global_Buffer_Count";
char *t_versions = "Version_Limit";
char *t_extents = "Extents";
char *t_header = "Headers";
char *t_lbn = "LBN";
char *t_owner = "Owner_UIC";
char *t_fid = "File_ID";
char *t_backlink = "Directory_File_ID";
char *t_highwater = "Highwater_Mark";
char *t_ru_active = "Active_Recovery_Units";
char *t_wasted = "Wasted_Blocks";
char *t_filename = "Name";
char *t_fullname = "Fullname";

char *t_display = "Display";
char *t_aclexists = "ACL";
char *t_aclcontains = "ACE";
