/*
 * this file was made by hand, and has NOT been tested yet.
 */

/**** MODULE $UCBDEF ****/
#define UCB$M_TIM  1
#define UCB$M_INT  2
#define UCB$M_ERLOGIP  4
#define UCB$M_CANCEL  8
#define UCB$M_ONLINE  16
#define UCB$M_POWER  32
#define UCB$M_TIMOUT  64
#define UCB$M_INTTYPE  128
#define UCB$M_BSY  256
#define UCB$M_MOUNTING  512
#define UCB$M_DEADMO  1024
#define UCB$M_VALID  2048
#define UCB$M_UNLOAD  4096
#define UCB$M_TEMPLATE  8192
#define UCB$M_MNTVERIP  16384
#define UCB$M_WRONGVOL  32768
#define UCB$M_DELETEUCB  65536
#define UCB$M_LCL_VALID  131072
#define UCB$M_SUPMVMSG  262144
#define UCB$M_MNTVERPND  524288
#define UCB$M_DISMOUNT  1048576
#define UCB$M_CLUTRAN  2097152
#define UCB$M_WRTLOCKMV  4194304
#define UCB$M_SVPN_END  8388608
#define UCB$M_JOB  1
#define UCB$M_TEMPL_BSY  64
#define UCB$M_PRMMBX  1
#define UCB$M_DELMBX  2
#define UCB$M_SHMMBX  8
#define UCB$M_TT_TIMO  2
#define UCB$M_TT_NOTIF  4
#define UCB$M_TT_HANGUP  8
#define UCB$M_TT_NOLOGINS  32768
#define UCB$M_NT_BFROVF  4
#define UCB$M_NT_NAME  16
#define UCB$M_NT_BREAK  32
#define UCB$M_ECC  1
#define UCB$M_DIAGBUF  2
#define UCB$M_NOCNVRT  4
#define UCB$M_DX_WRITE  8
#define UCB$M_DATACACHE  16
#define UCB$M_MSCP_MNTVERIP  256
#define UCB$M_MSCP_INITING  512
#define UCB$M_MSCP_WAITBMP  1024
#define UCB$M_MSCP_FLOVR  2048
#define UCB$M_MSCP_PKACK  4096
#define UCB$M_MSCP_WRTP  8192
#define UCB$M_DU_SHMV_STRTD  8
#define UCB$M_TU_OVRSQCHK  1
#define UCB$M_TU_TRACEACT  2
#define UCB$M_TU_SEQNOP  4
#define UCB$M_TU_1DENS  8
#define UCB$K_LENGTH  144             /* LENGTH OF STANDARD UCB */
#define UCB$C_LENGTH  144             /* LENGTH OF STANDARD UCB */
#define UCB$S_UCBDEF  144
#define UCB$S_DEVCHAR  8              /*  Device characteristic bits quadword*/
#define UCB$S_DEVDEPEND  8            /* Device dependent quadword*/
#define UCB$S_DEVDEPEND_Q_BLOCK  8
#define UCB$S_DISK_DEVDEPEND  4       /*     Disk fields*/
#define UCB$S_TERM_DEVDEPEND  4       /*     Terminal fields*/
#define UCB$S_NET_DEVDEPEND  4        /*     Network fields*/
#define UCB$S_MEDIA_ID_NN  7          /*  MEDIA NAME NUMBER*/
#define UCB$S_MEDIA_ID_N2  5          /*  MEDIA NAME CHAR 2*/
#define UCB$S_MEDIA_ID_N1  5          /*  MEDIA NAME CHAR 1*/
#define UCB$S_MEDIA_ID_N0  5          /*  MEDIA NAME CHAR 0*/
#define UCB$S_MEDIA_ID_T1  5          /*  MEDIA TYPE CHAR 1*/
#define UCB$S_MEDIA_ID_T0  5          /*  MEDIA TYPE CHAR 0*/
#define UCB$S_TT_DEVSTS_FILL  11      /*    fill to the end the word*/
#define UCB$K_MB_LENGTH  172          /* SIZE OF MAILBOX UCB */
#define UCB$C_MB_LENGTH  172          /* SIZE OF MAILBOX UCB */
#define UCB$S_UCBDEF3  172
#define UCB$K_ERL_LENGTH  160         /* SIZE OF ERROR LOG UCB*/
#define UCB$C_ERL_LENGTH  160         /* SIZE OF ERROR LOG UCB*/
#define UCB$S_UCBDEF4  160
#define UCB$K_DP_LENGTH  172          /*  Size of dual path UCB*/
#define UCB$C_DP_LENGTH  172          /*  size of dual path UCB*/
#define UCB$K_2P_LENGTH  172          /*  Size of dual path UCB*/
#define UCB$C_2P_LENGTH  172          /*  size of dual path UCB*/
#define UCB$S_DUALPATH_EXTENSION  172
#define UCB$M_AST_ARMED  32768
#define UCB$K_LCL_TAPE_LENGTH  180    /*  Size of local tape UCB*/
#define UCB$C_LCL_TAPE_LENGTH  180    /*  Size of local tape UCB*/
#define UCB$S_DISKTAPE_UCB_EXTENSION  188
#define UCB$K_LCL_DISK_LENGTH  204    /*  Size of local disk UCB*/
#define UCB$C_LCL_DISK_LENGTH  204    /*  Size of local disk UCB*/
#define UCB$S_LCL_DISK_UCB_EXTENSION  220
#define UCB$K_MSCP_DISK_LENGTH  236   /*  Size of MSCP disk UCB*/
#define UCB$K_MSCP_TAPE_LENGTH  236   /*  Size of MSCP tape UCB*/
#define UCB$S_MSCP_UCB_EXTENSION  236
#define UCB$S_UNIT_ID  8              /*  Unique MSCP unit identifier*/
#define UCB$M_BACKP  32
#define UCB$C_LOGLNK  1               /*  CONNECT IS FOR LOGICAL LINK (NOT SINGLE MSG) */
#define UCB$S_UCBDEF7  156
#define UCB$S_LTYPE  2                /*  LINK TYPE BITS */
#define UCB$S_LNKPRI  2               /*  LINK PRIORITY (IGNORED) */
#define UCB$K_NI_LENGTH  152          /* SIZE OF NI DEVICE UCB */
#define UCB$C_NI_LENGTH  152          /* SIZE OF NI DEVICE UCB */
#define UCB$S_UCBDEF9  152

struct ucbdef {
  variant_union {
    long int ucb$l_fqfl;	/* FORK QUEUE FORWARD LINK */
    short int ucb$w_unit_seed;	/*  UNIT NUMBER SEED */
    short int ucb$w_mb_seed;	/*  MB -- UNIT NUMBER SEED */
    long int ucb$l_rqfl;	/*  NET -- RCV QUEUE FORWARD LINK */
  } ucb$overlay_1;
  variant_union {
    long int ucb$l_fqbl;	/* FORK QUEUE BACKWARD LINK */
    long int ucb$l_rqbl;	/*  NET -- RCV QUEUE BACKWARD LINK */
  } ucb$overlay_2;
  short int ucb$w_size;	/* SIZE OF UCB IN BYTES */
  unsigned char ucb$b_type;	/* STRUCTURE TYPE FOR UCB */
  unsigned char ucb$b_fipl;	/* FORK INTERRUPT PRIORITY LEVEL */
  variant_union {
    long int ucb$l_fpc;	/* FORK PC */
    long int ucb$l_astqfl;	/*  MB -- AST QUEUE LISTHEAD FORWARD LINK */
    char *ucb$t_partner;	/*  NET -- PARTNER'S NODENAME */
  } ucb$overlay_3;
  variant_union {
    long int ucb$l_fr3;	/* FORK R3 */
    long int ucb$l_astqbl;	/*  MB -- AST QUEUE LISTHEAD BACKWARD LINK */
  } ucb$overlay_4;
  variant_union {
    long int ucb$l_fr4;	/* FORK R4 */
    long int ucb$l_first;	/*  NET -- ADDR OF 1ST SEG OF CHAINED MSG */
    variant_struct {
      short int ucb$w_msgmax;	/*  MB -- MAXIMUM MESSAGES ALLOWED */
      short int ucb$w_msgcnt;	/*  MB -- CURRENT NUMBER OF MESSAGES */
    } ucb$fields_1;
  } ucb$overlay_5;
  variant_union {
    short int ucb$w_bufquo;	/*  BUFFERED I/O QUOTA CHARGED FOR THIS UCB*/
    short int ucb$w_dstaddr;	/*  NET -- REMOTE CONNECT NO. */
  } ucb$overlay_6;
  variant_union {
    short int ucb$w_iniquo;	/*  INITIAL BUFFERED I/O QUOTA FOR THIS UCB*/
    short int ucb$w_srcaddr;	/*  NET -- LOCAL CONNECT NO. */
  } ucb$overlay_7;
  long int ucb$l_orb;	/*  OBJECT'S RIGHTS BLOCK ADDRESS*/
  variant_union {
    long int ucb$l_lockid;	/* DEVICE LOCK ID*/
    long int ucb$l_cpid;	/* PID CHARGED FOR BUFQUO BY UCBCREDEL*/
  } ucb$overlay_8;
  long int ucb$l_crb;	/* ADDRESS OF PRIMARY CHANNEL REQUEST BLOCK */
  long int ucb$l_ddb;	/* BACKPOINTER TO DEVICE DATA BLOCK */
  long int ucb$l_pid;	/* PROCESS ID OF OWNER PROCESS */
  long int ucb$l_link;	/* ADDRESS OF NEXT UCB FOR RESPECTIVE DDB */
  long int ucb$l_vcb;	/* ADDRESS OF VOLUME CONTROL BLOCK */
  variant_union {
    long int ucb$q_devchar[2];	/*  Device characteristic bits quadword*/
    variant_struct {
      long int ucb$l_devchar;	/*   Original device characteristic bits*/
      long int ucb$l_devchar2;	/*   Extended device characteristic bits*/
    } ucb$fields_2;
  } ucb$overlay_9;
  unsigned char ucb$b_devclass;	/* DEVICE CLASS */
  unsigned char ucb$b_devtype;	/* DEVICE TYPE */
  short int ucb$w_devbufsiz;	/* DEVICE DEFAULT BUFFER SIZE */
  variant_union {
    long int ucb$q_devdepend[2];	/* Device dependent quadword*/
    long int ucb$r_devdepend_q_block[2];	
    long int ucb$l_devdepend;	/*   First device dependent longword*/
    variant_struct {
      unsigned char ucb$b_sectors;	/* 	Sectors per track*/
      unsigned char ucb$b_tracks;	/* 	Track per cylinder*/
      short int ucb$w_cylinders;	/* 	Cylinders per disk*/
    } ucb$r_disk_devdepend;	/*     Disk fields*/
    variant_struct {
      char ucb$fill_2[3];
      unsigned char ucb$b_vertsz;	/* 	Vertical page size (lines per page)*/
      variant_union {
        long int ucb$l_devdepnd2;	/*   Second device dependent long word */
        long int ucb$l_tt_devdp1;	/*     Terminal -- Device dependent long word */
      } ucb$overlay_10;
    } ucb$r_term_devdepend;	/*     Terminal fields*/
    variant_struct {
      unsigned char ucb$b_locsrv;	/* 	Local link services */
      unsigned char ucb$b_remsrv;	/* 	Remote link services*/
      short int ucb$w_bytestogo;	/* 	No. of bytes left in rcv bfr*/
    } ucb$r_net_devdepend;	/*     Network fields*/
  } ucb$overlay_11;
  long int ucb$l_ioqfl;	/* I/O QUEUE LISTHEAD FORWARD LINK */
  long int ucb$l_ioqbl;	/* I/O QUEUE LISTHEAD BACKWARD LINK */
  short int ucb$w_unit;	/* PHYSICAL DEVICE UNIT NUMBER */
  variant_union {
    short int ucb$w_charge;	/* MAILBOX BYTE COUNT QUOTA CHARGE */
    short int ucb$w_rwaitcnt;	/*  CLASS DRIVERS -- THREADS WAITING RESOURCES */
    variant_struct {
      unsigned char ucb$b_cm1;	/*  LEVEL 1 CONTROLLER ALLOCATION MASK */
      unsigned char ucb$b_cm2;	/*  LEVEL 2 CONTROLLER ALLOCATION MASK */
    } ucb$fields_6;
  } ucb$overlay_12;
  long int ucb$l_irp;	/* CURRENT I/O REQUEST PACKET ADDRESS */
  short int ucb$w_refc;	/* REFERENCE COUNT OF PROCESSES */
  variant_union {
    unsigned char ucb$b_dipl;	/* DEVICE INTERRUPT PRIORITY LEVEL */
    unsigned char ucb$b_state;	/*  NET -- LINK STATE FOR NETWORK TRANSITIONS */
  } ucb$overlay_13;
  unsigned char ucb$b_amod;	/* ALLOCATION ACCESS MODE */
  long int ucb$l_amb;	/* ASSOCIATED UNIT CONTROL BLOCK POINTER */
  variant_union {
    long int ucb$l_sts;	/* DEVICE UNIT STATUS */
    short int ucb$w_sts;	
    variant_struct {
      unsigned ucb$v_tim:1;		/*  TIME OUT ENABLED (1YES) */
      unsigned ucb$v_int:1;		/*  INTERRUPT EXPECTED (1YES) */
      unsigned ucb$v_erlogip:1;		/*  ERROR LOG IN PROGRESS ON UNIT (1YES) */
      unsigned ucb$v_cancel:1;		/*  CANCEL I/O ON UNIT (1YES) */
      unsigned ucb$v_online:1;		/*  UNIT ONLINE (1YES) */
      unsigned ucb$v_power:1;		/*  POWER FAILED WHILE UNIT BUSY (1YES) */
      unsigned ucb$v_timout:1;		/*  UNIT TIMED OUT (1YES) */
      unsigned ucb$v_inttype:1;		/*  RECEIVER INTERRUPT IF SET */
      unsigned ucb$v_bsy:1;		/*  UNIT IS BUSY (1YES) */
      unsigned ucb$v_mounting:1;	/*  DEVICE IS BEING MOUNTED */
      unsigned ucb$v_deadmo:1;		/*  DEALLOCATE AT DISMOUNT */
      unsigned ucb$v_valid:1;		/*  VOLUME IS SOFTWARE VALID */
      unsigned ucb$v_unload:1;		/*  UNLOAD VOLUME AT DISMOUNT */
      unsigned ucb$v_template:1;	/*  SET IF THIS IS TEMPLATE UCB*/
      unsigned ucb$v_mntverip:1;	/*  MOUNT VERIFICATION IN PROGRESS */
      unsigned ucb$v_wrongvol:1;	/*  WRONG VOLUME DETECTED DURING MOUNT VERIFICATION */
      unsigned ucb$v_deleteucb:1;	/*  DELETE THIS UCB WHEN REFC REACHES ZERO*/
      unsigned ucb$v_lcl_valid:1;	/*  VOLUME IS VALID ON THE LOCAL NODE*/
      unsigned ucb$v_supmvmsg:1;	/*  IF SET, SUPPRESS SUCCESS TYPE MOUNT VER. MSGS.*/
      unsigned ucb$v_mntverpnd:1;	/*  MOUNT VERIFICATION IS PENDING ON BUSY DEVICE.*/
      unsigned ucb$v_dismount:1;	/*  DISMOUNT IN PROGRESS*/
      unsigned ucb$v_clutran:1;		/*  VAXcluster STATE TRANSITION IN PROGRESS*/
      unsigned ucb$v_wrtlockmv:1;	/*  Write-locked mount verification in progress*/
      unsigned ucb$v_svpn_end:1;	/*  Last byte used from page mapped by SVPN*/
    } ucb$fields_8;
  } ucb$overlay_14;
  variant_union {
    short int ucb$w_devsts;	/* DEVICE DEPENDENT STATUS */
    variant_struct {
      unsigned ucb$v_job:1;	/*    Job Controller notified */
      unsigned : 5;
      unsigned ucb$v_templ_bsy:1;	/*    Template UCB is busy */
    } ucb$fields_9;
    variant_struct {
      unsigned ucb$v_prmmbx:1;	/*    Permanent mailbox */
      unsigned ucb$v_delmbx:1;	/*    Mailbox marked for delete */
      unsigned :1;
      unsigned ucb$v_shmmbx:1;	/*    Shared memory mailbox */
    } ucb$fields_10;
    variant_struct {
      unsigned : 1;
      unsigned ucb$v_tt_timo:1;		/*    Terminal read timeout in progress */
      unsigned ucb$v_tt_notif:1;	/*    Terminal user notified of unsolicted data */
      unsigned ucb$v_tt_hangup:1;	/*    Process hang up*/
      unsigned ucb$v_tt_devsts_fill:11;	
      unsigned ucb$v_tt_nologins:1;	/*  NOLOGINS ALLOWED*/
    } ucb$fields_11;
    variant_struct {
      unsigned :2;
      unsigned ucb$v_nt_bfrovf:1;	/*    Too many bytes rcvd */
      unsigned : 2;
      unsigned ucb$v_nt_name:1;	/*    Link has declared a connect name */
      unsigned ucb$v_nt_break:1;	/*    Link is being broken */
    } ucb$fields_12;
    variant_struct {
      unsigned ucb$v_ecc:1;		/*    ECC correction was made*/
      unsigned ucb$v_diagbuf:1;		/*    Diagnostic buffer specified*/
      unsigned ucb$v_nocnvrt:1;		/*    No LBN to media address conversion*/
      unsigned ucb$v_dx_write:1;	/*    Console floppy write operation*/
      unsigned ucb$v_datacache:1;	/*    Data blocks being cached*/
    } ucb$fields_13;
    variant_struct {                
      unsigned :8;
      unsigned ucb$v_mscp_mntverip:1;	/*    Mount verification in progress*/
      unsigned ucb$v_mscp_initing:1;	/*    UCB is being initialized*/
      unsigned ucb$v_mscp_waitbmp:1;	/*    RWAITCNT has been bumped*/
      unsigned ucb$v_mscp_flovr:1;	/*    Bit toggled everytime a failover succeeds.*/
      unsigned ucb$v_mscp_pkack:1;	/*    Set when a IO$_PACKACK is in progress.*/
      unsigned ucb$v_mscp_wrtp:1;	/*    Unit MSCP write protected in some way.*/
    } ucb$fields_14;
    variant_struct {
      unsigned :3;
      unsigned ucb$v_du_shmv_strtd:1;	/*    Shadowing mount verification started*/
    } ucb$fields_15;
    variant_struct {
      unsigned ucb$v_tu_ovrsqchk:1;	/*    Override sequence checking*/
      unsigned ucb$v_tu_traceact:1;	/*    IRP trace table active*/
      unsigned ucb$v_tu_seqnop:1;	/*    Sequential NOP tape operation in progress*/
      unsigned ucb$v_tu_1dens:1;	/*    Single density device*/
    } ucb$fields_16;
  } ucb$overlay_15;
  short int ucb$w_qlen;	/*  Device queue length*/
  long int ucb$l_duetim;	/* DUE TIME FOR I/O COMPLETION */
  long int ucb$l_opcnt;	/* COUNT OF OPERATIONS COMPLETED */
  variant_union {
    long int ucb$l_svpn;	/* SYSTEM VIRTUAL PAGE/MAP REGISTER NUMBER */
    long int ucb$l_logadr;	/*  MB -- LOGICAL NAME BLOCK ADDRESS */
  } ucb$overlay_16;
  long int ucb$l_svapte;	/* SYSTEM VIRTUAL ADDRESS OF PTE */
  short int ucb$w_boff;	/* BYTE OFFSET IN FIRST PAGE */
  short int ucb$w_bcnt;	/* BYTE COUNT OF TRANSFER */
  unsigned char ucb$b_ertcnt;	/* ERROR LOG DEVICE CURRENT ERROR RETRY COUNT */
  unsigned char ucb$b_ertmax;	/* ERROR LOG DEVICE MAXIMUM ERROR RETRY COUNT */
  short int ucb$w_errcnt;	/* DEVICE ERROR COUNT */
  long int ucb$l_pdt;	/* ADDR OF PORT DESCRIPTOR TABLE*/
  long int ucb$l_ddt;	/* ADDR OF DDT (OPTIONAL BUT PREFERRED) */
  variant_union {
    long int ucb$l_media_id;	/* BIT ENCODED MEDIA IDENTIFICATION */
    variant_struct {
      unsigned ucb$v_media_id_nn:7;	
      unsigned ucb$v_media_id_n2:5;	
      unsigned ucb$v_media_id_n1:5;	
      unsigned ucb$v_media_id_n0:5;	
      unsigned ucb$v_media_id_t1:5;	
      unsigned ucb$v_media_id_t0:5;	
    } ucb$fields_17;
  } ucb$overlay_17;
  variant_union {
    variant_struct /* byte 144 */ {
      long int ucb$l_mb_wast;	/* WRITE ATTENTION AST BLOCK ADDR */
      long int ucb$l_mb_rast;	/* READ ATTENTION AST BLOCK ADDR */
      long int ucb$l_mb_mbx;	/* MAILBOX CONTROL BLOCK ADDR */
      long int ucb$l_mb_shb;	/* SHARED MEM. CONTROL BLOCK ADDR */
      long int ucb$l_mb_wioqfl;	/* WRITE I/O QUEUE FORWARD LINK */
      long int ucb$l_mb_wioqbl;	/* WRITE I/O QUEUE BACKWARD LINK */
      long int ucb$l_mb_port;	/* SHARED MEM. PORT NUMBER */
    } ucb$fields_18;	/*  MAILBOX*/
    variant_struct /* byte 144 */ {
      unsigned char ucb$b_slave;	/* SLAVE CONTROLLER NUMBER */
      unsigned char ucb$b_spr;	/* SPARE UNUSED BYTE */
      unsigned char ucb$b_fex;	/* FUNCTION DISPATCH TABLE INDEX */
      unsigned char ucb$b_cex;	/* CASE TABLE FUNCTION EXECUTION INDEX */
      long int ucb$l_emb;	/* ADDRESS OF ERROR MESSAGE BUFFER */
      short int ucb$fill_3;
      short int ucb$w_func;	/* I/O FUNCTION MODIFIERS */
      long int ucb$l_dpc;	/* SAVED DRIVER SUBROUTINE RETURN ADDRESS*/
    } ucb$fields_19;	/*  ERROR LOG DEVICES (ALL)*/
    variant_struct /* byte 144 */ {
      unsigned char ucb$fill_4[16];
      long int ucb$l_dp_ddb;	/*  Pointer to alternate DDB*/
      long int ucb$l_dp_link;	/*  Address of next UCB for this DDB */
      long int ucb$l_dp_altucb;	/*  Addr of alternate UCB for this unit*/
      long int ucb$l_2p_ddb;	/*  Pointer to alternate DDB*/
      long int ucb$l_2p_link;	/*  Address of next UCB for this DDB */
      long int ucb$l_2p_altucb;	/*  Addr of alternate UCB for this unit*/
      /*  ALL DISKS AND TAPES*/
      short int ucb$w_dirseq;	/*  Directory sequence number*/
      unsigned ucb$v_ast_armed;	/*   Blocking AST armed flag*/
      unsigned char ucb$b_onlcnt;	/*  Online count*/
      long int ucb$l_maxblock;	/*  Random access device highest block*/
      long int ucb$l_record;	/*  Current tape position or frame counter*/
      long int ucb$l_maxbcnt;	/*  Maximum transfer BCNT*/
      long int ucb$l_dccb;	/*  Pointer to data cache control block*/
      variant_union {
        variant_struct {
          long int ucb$l_media;	/*  Media address (longword)*/
          short int ucb$w_da;	/*  Saved desired sector/track address register*/
          short int ucb$w_dc;	/*  Saved desired cylinder address register*/
          long int ucb$l_bcr;	/*  Byte count register*/
          short int ucb$w_bcr;	
          short int ucb$w_ec1;	/*  ECC position register*/
          short int ucb$w_ec2;	/*  ECC pattern register*/
          short int ucb$w_offset;	/*  Current offset register contents*/
          unsigned char ucb$b_offndx;	/*  Current offset table index*/
          unsigned char ucb$b_offrtc;	/*  Current offset retry count*/
          /*  FLOPPY DEPENDENT BIT DEFINITIONS*/
          long int ucb$l_dx_buf;	/* ADDRESS OF SECTOR BUFFER */
          long int ucb$l_dx_bfpnt;	/* CURRENT SECTOR BUFFER POINTER */
          long int ucb$l_dx_rxdb;	/* SAVED RECEIVER DATA BUFFER */
          short int ucb$w_dx_bcr;	/* CURRENT FLOPPY BYTE COUNT */
          unsigned char ucb$b_dx_sctcnt;	/* CURRENT SECTOR BYTE COUNT */
        } ucb$fields_20;
        variant_struct {
          long int ucb$l_cddb;	/*  Pointer to active CDDB*/
          long int ucb$l_2p_cddb;	/*  Pointer to alternate CDDB*/
          long int ucb$l_cddb_link;	/*  Pointer to next UCB in CDDB chain*/
          long int ucb$l_cdt;	/*  Pointer to active CDT*/
          long int ucb$q_unit_id[2];	/*  Unique MSCP unit identifier*/
          short int ucb$w_mscpunit;	/*  Primary path MSCP unit number */
          short int ucb$w_2p_mscpunit;	/*  Secondary path MSCP unit number*/
          long int ucb$l_mscpdevparam;	/*  MSCP device-dependent parameters*/
          long int ucb$l_wait_cddb;	/*  Address of the CDDB waiting for mnt. ver.*/
          short int ucb$w_unit_flags;	/*  MSCP unit flags*/
          long int ucb$l_mscp_resv;	/*  Reserved for MSCP enhancements*/
          long int ucb$l_pref_cddb;	/*  CDDB address for preferred path*/
        } ucb$fields_20;
      } ucb$overlay_18;
    } ucb$overlay_19;
    variant_struct /* byte 144 */ {
      /*  NETWORK LOGICAL LINK (NETWORK MAILBOX) EXTENSION*/
      long int ucb$l_nt_datssb;	/*  ADDRESS OF DATA SUBCHANNEL STATUS BLOCK */
      long int ucb$l_nt_intssb;	/*  ADDRESS OF INT/LS SSB */
      short int ucb$w_nt_chan;	/*  DDCMP CHANNEL NO. */
      variant_struct {
        unsigned ucb$v_ltype:2;
        unsigned ucb$v_segflo:1;	/*  SEGMENT REQUEST COUNTS */
        unsigned ucb$v_msgflo:1;	/*  MESSAGE REQUEST COUNTS */
        unsigned ucb$v_msgack:1;	/*  MESSAGE ACK/NAK */
        unsigned ucb$v_backp:1;		/*  BACKPRESSURE (1> NO FLOW) */
        unsigned ucb$v_lnkpri:2;	
      } ucb$fields_21;
    } ucb$fields_22;
    variant_struct /* byte 144 */ {
      /*  NI DEVICE EXTENSION*/
      long int ucb$l_ni_hwaptr;	/* ADDRESS OF NI DEVICE HARDWARE ADDRESS*/
      long int ucb$l_ni_mltptr;	/* ADDRESS OF PROTOCOL MULTICAST TABLE*/
    } ucb$fields_23;
  } ucb$overlay_20;
};
