/*
 * this file was made by hand, and has NOT been tested yet.
 */
/**** MODULE $VCBDEF ****/
#define VCB$K_MRKLEN 11              /*  Mark length */
#define VCB$C_MRKLEN 11              /*  Mark length */
#define VCB$M_WRITE_IF 1
#define VCB$M_WRITE_SM 2
#define VCB$M_HOMBLKBAD 4
#define VCB$M_IDXHDRBAD 8
#define VCB$M_NOALLOC 16
#define VCB$M_EXTFID 32
#define VCB$M_GROUP 64
#define VCB$M_SYSTEM 128
#define VCB$M_PARTFILE 1
#define VCB$M_LOGICEOVS 2
#define VCB$M_WAIMOUVOL 4
#define VCB$M_WAIREWIND 8
#define VCB$M_WAIUSRLBL 16
#define VCB$M_CANCELIO 32
#define VCB$M_MUSTCLOSE 64
#define VCB$M_NOWRITE 128
#define VCB$M_SHADMAST 1
#define VCB$M_FAILED 2
#define VCB$M_REBLDNG 8
#define VCB$M_BLKASTREC 16
#define VCB$M_MVBEGUN 32
#define VCB$M_ADDING 64
#define VCB$K_COMLEN 36              /*  LENGTH OF COMMON AREA  */
#define VCB$S_VCBDEF_COMMON 36
#define VCB$S_VOLNAME 12             /*  VOLUME LABEL BLANK FILLED  */
#define VCB$C_COMLEN 36              /*  LENGTH OF COMMON AREA  */
#define VCB$K_LENGTH 236             /*  LENGTH OF STANDARD VCB  */
#define VCB$C_LENGTH 236             /*  LENGTH OF STANDARD VCB  */
#define VCB$S_VCBDEF_DISKS 236
#define VCB$S_RETAINMIN 8            /*  MINIMUM FILE RETENTION PERIOD  */
#define VCB$S_RETAINMAX 8            /*  MAXIMUM FILE RETENTION PERIOD  */
#define VCB$S_LOCKNAM 12
#define VCB$S_MOUNTTIME 8            /*  VOLUME MOUNT TIME */
#define VCB$S_ACB 28                 /*  ACB FOR BLOCKING AST. */
#define VCB$S_MIN_CLASS 20           /*  MINIMUM CLASSIFICATION */
#define VCB$S_MAX_CLASS 20           /*  MAXIMUM CLASSIFICATION */
#define VCB$K_SHAD_LEN 68            /*  Shadow set member VCB length */
#define VCB$S_VCBDEF_SHADOW 68
#define VCB$S_WORK 8                 /*  Per-member workspace */
#define VCB$S_SHDM_RESV 8            /*  Reserved for future enhancements */
#define VCB$S_VCBDEF2 73
#define VCB$S_VCBDEF3 32
#define VCB$S_QNAME 20               /*  ASCII NAME OF QUEUE FOR THIS DEVICE  */

struct vcbdef {
  variant_union {
    long int vcb$l_fcbfl;	/*  FCB listhead forward link */
    long int vcb$l_blockfl;	/*   or - Blocked request listhead forward link */
    long int vcb$l_memqfl;	/*   or - Shadow set members queue forward link */
  } vcb_overlay_1;
  variant_union {
    long int vcb$l_fcbbl;	/*  FCB listhead backward link */
    long int vcb$l_blockbl;	/*   or - Blocked request listhead backward link */
    long int vcb$l_memqbl;	/*   or - Shadow set members queue backward link */
  } vcb_overlay_1;
  short int vcb$w_size;	/*  Size of VCB in bytes */
  unsigned char vcb$b_type;	/*  structure type of VCB  */
  /*  Second mark point */
  variant_union {
    unsigned char vcb$b_status;	/*  Volume status: */
    variant_struct {
      unsigned vcb$v_write_if:1;	/*     Index file is write accessed */
      unsigned vcb$v_write_sm:1;	/*     Storage map is write accessed */
      unsigned vcb$v_homblkbad:1;	/*     Primary home block is bad */
      unsigned vcb$v_idxhdrbad:1;	/*     Primary index file header is bad */
      unsigned vcb$v_noalloc:1;	/*     Allocation/deallocation inhibited (bad bitmaps) */
      unsigned vcb$v_extfid:1;	/*     Volume has 24 bit file numbers */
      unsigned vcb$v_group:1;	/*     Volume is mounted /group */
      unsigned vcb$v_system:1;	/*     Volume is mounted /system */
    } vcb_fields_1;
    variant_struct {
      unsigned vcb$v_partfile:1;	/*     Partial file exists on tape */
      unsigned vcb$v_logiceovs:1;	/*     Positioned at logical end of volume set */
      unsigned vcb$v_waimouvol:1;	/*     Wait for volume mount */
      unsigned vcb$v_wairewind:1;	/*     Wait for rewind completion */
      unsigned vcb$v_waiusrlbl:1;	/*     Wait for user label */
      unsigned vcb$v_cancelio:1;	/*     Cancel I/O  */
      unsigned vcb$v_mustclose:1;	/*     Must close file */
      unsigned vcb$v_nowrite:1;	/*     Don't write trailers */
    } vcb_fields_2;
    variant_struct {
      unsigned vcb$v_shadmast:1;	/*     This VCB is for shadow set master */
      unsigned vcb$v_failed:1;	/*     Member failed out of shadow set */
      unsigned vcb$v_rebldng:1;	/*     Mount verfication rebuilding shadow set */
      unsigned vcb$v_blkastrec:1;	/*     Shadowing lock blocking AST received */
      unsigned vcb$v_mvbegun:1;	/*     Mount verification initiated */
      unsigned vcb$v_adding:1;	/*     Adding member to shadow set */
    } vcb_fields_3;
    unsigned char vcb$b_qnamecnt;	/*  BYTE COUNT OF QUEUE NAME  */
  } vcb_overlay_2;
  variant_union {
    unsigned char vcb$t_qname[VCB$S_QNAME];	/*  JOURNAL ACP VOLUME CONTROL BLOCK FIELDS */
    variant_struct {
      short int vcb$w_trans;	/*  VOLUME TRANSACTION COUNT  */
      short int vcb$w_rvn;	/*  RELATIVE VOLUME NUMBER  */
      long int vcb$l_aqb;	/*  ADDRESS OF AQB  */
      unsigned char vcb$t_volname[VCB$S_VOLNAME];
    } vcb_fields_4;
  } vcb_overlay_3;
  long int vcb$l_rvt;	/*  ADDRESS OF UCB OR RELATIVE VOLUME TABLE  */
  /*  THIRD MARK POINT */
  variant_union {
    variant_struct {
      /*  SHADOW SET MEMBER VOLUME CONTROL BLOCK FIELDS */
      long int vcb$l_mem_ucb;	/*  Shadow set member UCB address */
      long int vcb$l_mast_ucb;	/*  Shadow set master UCB address */
      long int vcb$l_mast_vcb;	/*  Shadow set master VCB address */
      short int vcb$w_copy_type;	/*  Member's MSCP copy type */
      short int vcb$w_cpyseqnum;	/*  IO$_COPYSHAD sequence number */
      long int vcb$q_work[2];	
      long int vcb$q_shdm_resv[2];	
    } vcb_fields_5;
    variant_struct {
      long int vcb$l_homelbn;	/*  LBN OF VOLUME HOME BLOCK  */
      long int vcb$l_home2lbn;	/*  LBN OF ALTERNATE VOLUME HOME BLOCK  */
      long int vcb$l_ixhdr2lbn;	/*  LBN OF ALTERNATE INDEX FILE HEADER  */
      long int vcb$l_ibmaplbn;	/*  LBN OF INDEX FILE BITMAP  */
      long int vcb$l_sbmaplbn;	/*  LBN OF STORAGE BITMAP  */
      unsigned char vcb$b_ibmapsize;	/*  SIZE OF INDEX FILE BITMAP  */
      unsigned char vcb$b_sbmapsize;	/*  SIZE OF STORAGE BITMAP  */
      unsigned char vcb$b_ibmapvbn;	/*  CURRENT VBN IN INDEX FILE BIT MAP  */
      unsigned char vcb$b_sbmapvbn;	/*  CURRENT VBN IN STORAGE MAP  */
      short int vcb$w_cluster;	/*  VOLUME CLUSTER SIZE  */
      short int vcb$w_extend;	/*  VOLUME DEFAULT FILE EXTENSION LENGTH  */
      long int vcb$l_free;	/*  NUMBER OF FREE BLOCKS ON VOLUME  */
      long int vcb$l_maxfiles;	/*  MAXIMUM NUMBER OF FILES ALLOWED ON VOLUME  */
      unsigned char vcb$b_window;	/*  VOLUME DEFAULT WINDOW SIZE  */
    } vcb_fields_6;
    variant_struct {
      /*  MTAACP VOLUME CONTROL BLOCK FIELDS */
      variant_union {
        long int vcb$l_cur_fid;	/*  CURRENT FILE IDENTIFICATION  */
        variant_struct {
          short int vcb$w_cur_num;	/*  CURRENT FILE SECTION NUMBER  */
          short int vcb$w_cur_seq;	/*  CURRENT FILE SEQUENCE NUMBER  */
        } vcb_fields_7;
      } vcb_overlay_6;
      variant_union {
        long int vcb$l_start_fid;	/*  FILE IDENTIFICATION AT START OF SEARCH  */
        variant_struct {
          short int vcb$w_start_num;	/*  FILE SECTION NUMBER AT START OF SEARCH  */
          short int vcb$w_start_seq;	/*  FILE SEQUENCE NUMBER AT START OF SEARCH  */
        } vcb_fields_8;
      } vcb_overlay_7;
      variant_union {
        short int vcb$w_mode;	/*  MODE OF OPERATION  */
        variant_struct {
          unsigned vcb$v_ovrexp:1;	/*  OVERRIDE EXPIRATION  */
          unsigned vcb$v_ovracc:1;	/*  OVERRIDE ACCESS  */
          unsigned vcb$v_ovrlbl:1;	/*  OVERRIDE LABELS  */
          unsigned vcb$v_ovrsetid:1;	/*  OVERRIDE SET IDENTIFIER  */
          unsigned vcb$v_intchg:1;	/*  INTERCHANGE TAPE  */
          unsigned vcb$v_ebcdic:1;	/*  EBCDIC CODE SET  */
          unsigned vcb$v_novol2:1;	/*  DO NOT WRITE A VOL2 LABEL */
          unsigned vcb$v_nohdr3:1;	/*  DO NOT WRITE HDR3 LABELS  */
          unsigned vcb$v_starfile:1;	/*  CURRENT FILE IS A STARLET PRODUCED FILE  */
          unsigned vcb$v_enusereot:1;	/*  SET WHEN USER HANDLING OF EOT IS ENABLED */
          unsigned vcb$v_blank:1;	/*  SET FOR AVL WHEN NO READ SHOULD HAPPEN FIRST */
          unsigned vcb$v_init:1;	/*  SET FOR AVL WHEN NEXT VOL MOUNTED SHOULD BE INITED */
          unsigned vcb$v_noauto:1;	/*  MTAACP NOT RUNNING IN AVL AND AVR MODE */
          unsigned vcb$v_ovrvolo:1;	/*  OVERRIDE THEVOL1 OWNER IDENT FIELD */
          unsigned vcb$v_fil_access:1;	/*  SET IF ACCESS ROUTINE ALLOWS CHECK OF VMS PROTECTION ON FILE */
        } vcb_field_9;
      } vcb_overlay_8;
      unsigned char vcb$b_tm;	/*  NUMBER OF TM'S INTO FILE  */
      unsigned char vcb$b_cur_rvn;	/*  CURRENT RELATIVE VOLUME  */
      long int vcb$l_st_record;	/*  NUMBER OF RECORDS UP TO AND INCLUDING LAST TAPE MARK  */
      long int vcb$l_mvl;	/*  ADDRESS OF MAGNETIC TAPE VOLUME LIST  */
      long int vcb$l_wcb;	/*  ADDRESS OF WINDOW FOR THIS VOLUME  */
      long int vcb$l_vpfl;	/*  VIRTUAL PAGE LIST HEAD  */
      long int vcb$l_vpbl;	/*  VIRTUAL PAGE LIST TAIL  */
      long int vcb$l_usrlblast;	/*  ADDRESS OF USER LABEL AST CONTROL BLOCK  */
      unsigned char vcb$b_lblcnt;	/*  Count of HDRn labels read on file open */
      /*  NOTE THAT FCP AND MTAACP SHARE VCB$W_MCOUNT(DISPLACEMENT 76) */
    } vcb_fields_7;
  } vcb_overlay_5;
  unsigned char vcb$b_lru_lim;	/*  VOLUME DIRECTORY LRU SIZE LIMIT  */
  short int vcb$w_fileprot;	/*  VOLUME DEFAULT FILE PROTECTION  */
  short int vcb$w_mcount;	/*  MOUNT COUNT  */
  unsigned char vcb$b_eofdelta;	/*  INDEX FILE EOF UPDATE COUNT  */
  unsigned char vcb$b_resfiles;	/*  NUMBER OF RESERVED FILES ON VOLUME  */
  short int vcb$w_recordsz;	/*  NUMBER OF BYTES IN A RECORD  */
  unsigned char vcb$b_blockfact;	/*  VOLUME BLOCKING FACTOR  */
  variant_union {
    unsigned char vcb$b_status2;	/*  SECOND STATUS BYTE  */
    variant_struct {
      unsigned vcb$v_writethru:1;	/*  VOLUME IS TO BE WRITE-THROUGH CACHED  */
      unsigned vcb$v_nocache:1;	/*  ALL CACHEING IS DISABLED ON VOLUME  */
      unsigned vcb$v_mountver:1;	/*  VOLUME CAN UNDERGO MOUNT VERIFICATION  */
      unsigned vcb$v_erase:1;	/*  ERASE DATA WHEN BLOCKS REMOVED FROM FILE */
      unsigned vcb$v_nohighwater:1;	/*  TURN OFF HIGH-WATER MARKING (D ON) */
      unsigned vcb$v_noshare:1;	/*  non-shared mount */
      unsigned vcb$v_cluslock:1;	/*  CLUSTER WIDE LOCKING NECESSARY */
      unsigned vcb$v_subset0:1;	/*  ODS-2 SUBSET 0 VOLUME */
    } vcb_fields_4;
  } vcb_overlay_5;
  long int vcb$l_quotafcb;	/*  ADDRESS OF FCB OF DISK QUOTA FILE  */
  long int vcb$l_cache;	/*  ADDRESS OF VOLUME CACHE BLOCK  */
  long int vcb$l_quocache;	/*  ADDRESS OF VOLUME QUOTA CACHE  */
  short int vcb$w_quosize;	/*  LENGTH OF QUOTA CACHE TO ALLOCATE  */
  short int vcb$w_penderr;	/*  COUNT OF PENDING WRITE ERRORS  */
  long int vcb$l_serialnum;	/*  VOLUME SERIAL NUMBER (DISKS ONLY)  */
  long int vcb$l_jnliocnt;	/*  JOURNALING IO COUNT (obsolete CJF field) */
  /*  NOTE: the above field is obsolete however, it is being temporarily used my MONITOR for V4.4, since */
  /*  new VCB fields cannot be added until a new exec. */
  long int vcb$q_retainmin[2];	
  long int vcb$q_retainmax[2];	
  long int vcb$l_vollkid;	/*  VOLUME LOCK ID */
  unsigned char vcb$t_volcknam[VCB$S_LOCKNAM];
  long int vcb$l_blockid;	/*  VOLUME BLOCKING LOCK. */
  long int vcb$q_mounttime[2];	
  long int vcb$l_memhdfl;	/*  SHADOW SET MEMBERS QUEUE HEADER FL */
  long int vcb$l_memhdbl;	/*  SHADOW SET MEMBERS QUEUE HEADER BL */
  short int vcb$w_activity;	/*  ACTIVITY COUNT/FLAG */
  char vcb_fill_1;
  unsigned char vcb$b_shad_sts;	/*  STATUS BYTE RELATIVE TO MEMHDFL */
  long int vcb$l_shad_lkid;	/*  Shadowing lock lock-id */
  unsigned char vcb$b_acb[VCB$S_ACB];
  unsigned char vcb$r_min_class[VCB$S_MIN_CLASS];
  unsigned char vcb$r_max_class[VCB$S_MAX_CLASS];
};
