/* Created by SDL V3.0-2     */
/* Source:  8-AUG-1988 09:44:43 EMULEX$DISK:[MEADOWS.UNSDL.VMS4-7_H]STARDEFAE.S */
#ifndef $ACLDEF_H
#define $ACLDEF_H
 
/*** MODULE $ACLDEF ***/
#define ACL$K_LENGTH 12 /* Length of the overhead area                        */
#define ACL$C_LENGTH 12 /* Length of the overhead area                        */
#define ACL$C_FILE 1    /* Files                                              */
#define ACL$C_DEVICE 2  /* MBX, MT, TT, etc.                                  */
#define ACL$C_JOBCTL_QUEUE 3    /* Job controller queue                       */
#define ACL$C_COMMON_EF_CLUSTER 4       /* Common event flag clusters         */
#define ACL$C_LOGICAL_NAME_TABLE 5      /* Logical name tables                */
#define ACL$C_PROCESS 6 /* Process                                            */
#define ACL$C_GROUP_GLOBAL_SECTION 7    /* Group global sections              */
#define ACL$C_SYSTEM_GLOBAL_SECTION 8   /* System global sections             */
/* Action codes                                                               */
#define ACL$C_ADDACLENT 1       /* Add an ACL entry                           */
#define ACL$C_DELACLENT 2       /* Delete an ACL entry                        */
#define ACL$C_MODACLENT 3       /* Modify an ACL entry                        */
#define ACL$C_FNDACLENT 4       /* Locate an ACL entry                        */
#define ACL$C_FNDACETYP 5       /* Locate specific ACE type                   */
#define ACL$C_DELETEACL 6       /* Delete entire ACL                          */
#define ACL$C_READACL 7 /* Read the ACL                                       */
#define ACL$C_ACLLENGTH 8       /* Get the ACL's length                       */
#define ACL$C_READACE 9 /* Read a single ACE                                  */
#define ACL$C_RLOCK_ACL 10      /* Read lock on ACL                           */
#define ACL$C_WLOCK_ACL 11      /* Write lock on ACL                          */
#define ACL$C_UNLOCK_ACL 12     /* Release exclusive lock                     */
#define ACL$S_ADDACLENT 255     /* Add an ACL entry                           */
#define ACL$S_DELACLENT 255     /* Delete an ACL entry                        */
#define ACL$S_MODACLENT 255     /* Modify an ACL entry                        */
#define ACL$S_FNDACLENT 255     /* Locate an ACL entry                        */
#define ACL$S_FNDACETYP 255     /* Locate specific ACE type                   */
#define ACL$S_DELETEACL 255     /* Delete entire ACL                          */
#define ACL$S_READACL 512       /* Read the ACL                               */
#define ACL$S_ACLLENGTH 4       /* Get the ACL's length                       */
#define ACL$S_READACE 255       /* Read a single ACE                          */
#define ACL$S_RLOCK_ACL 4       /* Read lock on ACL                           */
#define ACL$S_WLOCK_ACL 4       /* Write lock on ACL                          */
#define ACL$S_UNLOCK_ACL 4      /* Remove lock on ACL                         */
struct acldef {
    unsigned long int acl$l_flink;      /* Forward link to next list in the queue     */
    unsigned long int acl$l_blink;      /* Back link to previous list in queue        */
    unsigned short int acl$w_size;      /* Total size of the list             */
    unsigned char acl$b_type;   /* Structure type code                        */
    char acldef$$_fill_1;       /* Spare unused byte                          */
    unsigned long int acl$l_list;       /* Start of the Access Control Entries        */
/* Object types                                                               */
} ;
#endif
