/* Created by SDL V3.0-2     */
/* Source:  8-AUG-1988 09:44:43 EMULEX$DISK:[MEADOWS.UNSDL.VMS4-7_H]STARDEFAE.S */
#ifndef $DMPDEF_H
#define $DMPDEF_H
 
/*** MODULE $DMPDEF ***/
/*                                                                            */
/* LAYOUT OF THE HEADER BLOCK OF THE SYSTEM DUMP FILE                         */
/* (WHICH IS THE FIRST DISK BLOCK OF SYS$SYSTEM:SYSDUMP.DMP)                  */
/*                                                                            */
#define DMP$C_MEMDSCSIZ 8       /* NEW FORMAT DUMP: SIZE OF ONE MEMORY DESCRPTR       */
#define DMP$C_NMEMDSC 8 /* NEW FORMAT DUMP: NUMBER OF MEMORY DESCRIPTORS      */
struct dmpdef {
    unsigned long int dmp$l_errseq;     /* LAST ERROR LOG SEQ. NUMBER         */
    union {
        unsigned long int dmp$l_flags;  /* DUMP FILE FLAGS                    */
        struct {
            union {
                unsigned short int dmp$w_flags; /* NEW FORMAT DUMP: DUMP FILE FLAGS   */
                struct {
                    unsigned dmp$v_olddump : 1; /* SET IF DUMP ALREADY ANALYZED       */
                    unsigned dmp$v_empty : 1;   /* SET IF DUMP HAS NO DATA BLOCKS     */
                    unsigned dmp$v_fill_22 : 6;
                    } dmp$r_flags_bits;
                } dmp$r_flags_overlay1;
            unsigned short int dmp$w_dumpver;   /* NEW FORMAT DUMP: DUMP FILE VERSION NUMBER  */
/* NEW FORMAT DUMP:    0 = PRE-RELEASE 2 FORMAT                               */
/* NEW FORMAT DUMP:    1 = RELEASE 2.0 FORMAT                                 */
            } dmp$r_flags_fields;
        } dmp$r_flags_overlay;
    unsigned long int dmp$l_sbr;        /* SYSTEM BASE REGISTER               */
    unsigned long int dmp$l_slr;        /* SYSTEM LENGTH REGISTER             */
    unsigned long int dmp$l_ksp;        /* KERNEL STACK POINTER               */
    unsigned long int dmp$l_esp;        /* EXECUTIVE STACK POINTER            */
    unsigned long int dmp$l_ssp;        /* SUPERVISOR STACK POINTER           */
    unsigned long int dmp$l_usp;        /* USER STACK POINTER                 */
    unsigned long int dmp$l_isp;        /* INTERRUPT STACK POINTER            */
    union {
        unsigned long int dmp$l_regs [14];      /* OLD FORMAT DUMP: R0 - R13  */
        union {
            unsigned long int dmp$l_memdsc;     /* NEW FORMAT DUMP: 8 MEMORY DESCRIPTORS      */
            struct {
                unsigned dmp$v_pagcnt : 24;     /* NEW FORMAT DUMP: ! OF PAGES IN MEMORY      */
                unsigned dmp$v_tr : 8;  /* NEW FORMAT DUMP: TR ! FOR MEMORY   */
                unsigned dmp$v_basepfn : 32;    /* NEW FORMAT DUMP: BASE PFN FOR MEMORY       */
                } dmp$r_memdsc_bits;
            } dmp$r_memdsc_overlay;
        } dmp$r_regs_overlay;
} ;
#define DMP$K_LENGTH 108        /* LENGTH OF FILE HEADER                      */
#define DMP$C_LENGTH 108        /* LENGTH OF FILE HEADER                      */
struct dmpdef1 {
    char dmpdef$$_fill_1 [92];
    unsigned long int dmp$l_sp; /* OLD FORMAT DUMP: STACK POINTER             */
    unsigned long int dmp$l_pc; /* OLD FORMAT DUMP: PROGRAM COUNTER           */
    union {
        unsigned long int dmp$l_sysver; /* NEW FORMAT DUMP: SYSTEM VERSION NUMBER     */
        unsigned long int dmp$l_psl;    /* OLD FORMAT DUMP: PROGRAM STATUS LONGWORD   */
        } dmp$r_sysver_overlay;
    unsigned long int dmp$l_check;      /* NEW FORMAT DUMP: ONES COMPLEMENT OF SYSVER */
    unsigned long int dmp$l_crasherl;   /* NEW FORMAT DUMP: SYSTEM CRASH ERR LOG ENTRY        */
} ;
#endif
