/* Created by SDL V3.0-2     */
/* Source:  8-AUG-1988 09:45:49 EMULEX$DISK:[MEADOWS.UNSDL.VMS4-7_H]STARDEFFL.S */
#ifndef $IACDEF_H
#define $IACDEF_H
 
/*** MODULE $IACDEF ***/
/*+                                                                           */
/* IMAGE ACTIVATION CONTROL FLAGS                                             */
/*-                                                                           */
#define IAC$M_NOACT 0x00000001
#define IAC$M_WRITABLE 0x00000002
#define IAC$M_SHAREABLE 0x00000004
#define IAC$M_PRIVILEGE 0x00000008
#define IAC$M_MERGE 0x00000010
#define IAC$M_EXPREG 0x00000020
#define IAC$M_P1MERGE 0x00000040
#define IAC$M_LASTCLU 0x00000100
#define IAC$M_LIM 0x00000200
#define IAC$M_RETRY 0x00000400
#define IAC$M_NOCMKRNL 0x00000800
#define IAC$M_SEQDEVLOD 0x00001000
#define IAC$M_XLINKER 0x00002000
#define IAC$M_KP_RESHDR 0x00004000
#define IAC$M_IS_RESHDR 0x00008000
#define IAC$M_NOTSHARED 0x00010000
#define IAC$M_GBLCLUSTR 0x00020000
#define IAC$M_SHMIDENT 0x00040000
#define IAC$M_NOCOPY 0x00080000
#define IAC$M_P1MERG_P0 0x00100000
#define IAC$M_SETVECTOR 0x00200000
#define IAC$C_LARGEST 6 /*LARGEST FLAG CALLER MAY SPECIFY                     */
union iacdef {
    struct {
        unsigned iac$v_noact : 1;       /*DO NOT ACTIVATE THE IMAGE (FOR INSTALL)     */
        unsigned iac$v_writable : 1;    /*MAKE IMAGE FILE WRITABLE            */
        unsigned iac$v_shareable : 1;   /*ACT. SHAREABLE IMAGE FOR EXECUTABLE IMG     */
        unsigned iac$v_privilege : 1;   /*ACT. SHARE. IMG FOR PRIV EXECUTABLE IMG     */
        unsigned iac$v_merge : 1;       /*ACT 2ND EXECUTABLE IMG INTO ADR SPACE       */
        unsigned iac$v_expreg : 1;      /*MAP IMAGE INTO NEXT FREE VA SPACE   */
        unsigned iac$v_p1merge : 1;     /*P1 MERGED ACTIVATION (LEGAL INPUT FLAG)     */
        unsigned iacdef$$_fill_1 : 1;   /*SPARE                               */
        unsigned iac$v_lastclu : 1;     /*LAST CLUSTER FLAG                   */
        unsigned iac$v_lim : 1; /*LINKABLE IMAGE                              */
        unsigned iac$v_retry : 1;       /*RETRY IMAGE ACTIVATION              */
        unsigned iac$v_nocmkrnl : 1;    /*SHUT OFF CMKRNL,CMEXEC-SYSVER DIFF  */
        unsigned iac$v_seqdevlod : 1;   /*LOADING FROM SEQUENTIAL DEVICE (NET)        */
        unsigned iac$v_xlinker : 1;     /*CROSS LINKER FORMAT                 */
        unsigned iac$v_kp_reshdr : 1;   /*MAKE IMAGE HEADER RESIDENT          */
        unsigned iac$v_is_reshdr : 1;   /*IMAGE HEADER IS RESIDENT            */
        unsigned iac$v_notshared : 1;   /*DO NOT SET IS_SHARED IN KFI ENTRY   */
        unsigned iac$v_gblclustr : 1;   /*CURRENTLY PROCESSING GBL ISD CLUSTER        */
        unsigned iac$v_shmident : 1;    /*SHARED MEMORY IDENT USED FOR GBL SEC        */
        unsigned iac$v_nocopy : 1;      /*NO PRIVATE COPY OF SECTION IN EXEC IMG      */
        unsigned iac$v_p1merg_p0 : 1;   /*P1 MERGED ACTIVATION WITH P0 ADDRESS        */
/* RANGE (INTERNAL FLAG ONLY)                                                 */
        unsigned iac$v_setvector : 1;   /*SIGNAL ATLERNATE ENTRY TO SET VECTORS       */
        unsigned iac$v_fill_5 : 2;
        } iac$r_iacdef_bits;
} ;
#endif
