/* Created by SDL V3.0-2     */
/* Source:  8-AUG-1988 09:46:33 EMULEX$DISK:[MEADOWS.UNSDL.VMS4-7_H]STARDEFMP.S */
#ifndef $PSLDEF_H
#define $PSLDEF_H
 
/*** MODULE $PSLDEF ***/
/*+                                                                           */
/* PROCESSOR STATUS LONGWORD MASK AND FIELD DEFINITIONS                       */
/*-                                                                           */
#define PSL$M_C 0x00000001
#define PSL$M_V 0x00000002
#define PSL$M_Z 0x00000004
#define PSL$M_N 0x00000008
#define PSL$M_TBIT 0x00000010
#define PSL$M_IV 0x00000020
#define PSL$M_FU 0x00000040
#define PSL$M_DV 0x00000080
#define PSL$M_IPL 0x001F0000
#define PSL$M_PRVMOD 0x00C00000
#define PSL$M_CURMOD 0x03000000
#define PSL$M_IS 0x04000000
#define PSL$M_FPD 0x08000000
#define PSL$M_TP 0x40000000
#define PSL$M_CM 0x80000000
#define PSL$C_KERNEL 0  /* KERNEL MODE                                        */
#define PSL$C_EXEC 1    /* EXEC MODE                                          */
#define PSL$C_SUPER 2   /* SUPERVISOR MODE                                    */
#define PSL$C_USER 3    /* USER MODE                                          */
#define PSL$M_SAFBITS 14335
union psldef {
    struct {
        unsigned psl$v_c : 1;   /* Carry                                      */
        unsigned psl$v_v : 1;   /* oVerflow                                   */
        unsigned psl$v_z : 1;   /* Zero                                       */
        unsigned psl$v_n : 1;   /* Negative                                   */
        unsigned psl$v_tbit : 1;        /* TBIT ENABLE                        */
        unsigned psl$v_iv : 1;  /* INTEGER OVERFLOW                           */
        unsigned psl$v_fu : 1;  /* FLOATING UNDEFINED                         */
        unsigned psl$v_dv : 1;  /* DIVIDE BY ZERO                             */
        unsigned psldef$$_fill_1 : 8;   /*                                    */
        unsigned psl$v_ipl : 5; /* INTERRUPT PRIORITY LEVEL                   */
        unsigned psldef$$_fill_2 : 1;   /*                                    */
        unsigned psl$v_prvmod : 2;      /* PREVIOUS PROCESSOR MODE            */
        unsigned psl$v_curmod : 2;      /* CURRENT PROCESSOR MODE             */
        unsigned psl$v_is : 1;  /* INTERRUPT STACK BIT                        */
        unsigned psl$v_fpd : 1; /* FIRST PART DONE                            */
        unsigned psldef$$_fill_3 : 2;   /* MUST BE ZERO                       */
        unsigned psl$v_tp : 1;  /* TRACE TRAP PENDING                         */
        unsigned psl$v_cm : 1;  /* COMPATIBILITY MODE BIT AND MASK            */
        } psl$r_psldef_bits;
/*                                                                            */
/* MODE SYMBOL DEFINITIONS                                                    */
/*                                                                            */
} ;
#endif
