/* Created by SDL V3.0-2     */
/* Source:  8-AUG-1988 09:47:35 EMULEX$DISK:[MEADOWS.UNSDL.VMS4-7_H]STARDEFQZ.S */
#ifndef $SBKDEF_H
#define $SBKDEF_H
 
/*** MODULE $SBKDEF ***/
/*+                                                                           */
/*                                                                            */
/* Statistics block. This block is used to report various data regarding      */
/* an open file to the requesting program.                                    */
/*                                                                            */
/*-                                                                           */
/*                                                                            */
/* The first two longwords are presented in inverted form for compatibility   */
/* with the old RSX-11 statistics block.                                      */
/*                                                                            */
#define SBK$K_LENGTH 32
#define SBK$C_LENGTH 32
struct sbkdef {
    union {
        unsigned long int sbk$l_stlbn;  /* starting LBN if contiguous         */
        struct {
            unsigned short int sbk$w_stlbnh;    /* high order word            */
            unsigned short int sbk$w_stlbnl;    /* low order word             */
            } sbk$r_stlbn_fields;
        } sbk$r_stlbn_overlay;
    union {
        unsigned long int sbk$l_filesize;       /* file size                  */
        struct {
            unsigned short int sbk$w_filesizh;  /* high order word            */
            unsigned short int sbk$w_filesizl;  /* low order word             */
/*                                                                            */
/* The following two fields are for RSX-11 compatibility                      */
/*                                                                            */
            } sbk$r_filesize_fields;
        } sbk$r_filesize_overlay;
    unsigned char sbk$b_acnt;   /* low byte of access count                   */
    unsigned char sbk$b_lcnt;   /* low byte of lock count                     */
    unsigned long int sbk$l_fcb;        /* address of file control block      */
    short int sbkdef$$_fill_1;  /* spare                                      */
    unsigned short int sbk$w_acnt;      /* access count                       */
    unsigned short int sbk$w_lcnt;      /* lock count (against writers)       */
    unsigned short int sbk$w_wcnt;      /* writer count                       */
    unsigned short int sbk$w_tcnt;      /* truncate lock count                */
    unsigned long int sbk$l_reads;      /* count of reads executed on channel */
    unsigned long int sbk$l_writes;     /* count of writes executed on channel        */
} ;
#endif
