/* Created by SDL V3.0-2     */
/* Source:  8-AUG-1988 09:47:35 EMULEX$DISK:[MEADOWS.UNSDL.VMS4-7_H]STARDEFQZ.S */
#ifndef $XFDEF_H
#define $XFDEF_H
 
/*** MODULE $XFDEF ***/
/*+                                                                           */
/*                                                                            */
/* DR32 DEFINITIONS FOR COMMAND TABLE, PACKETS, AND CHARACTERISTICS           */
/*                                                                            */
/*-                                                                           */
/*                                                                            */
/* QIO COMMAND TABLE OFFSETS                                                  */
/*                                                                            */
#define XF$M_IOS_SUCCES 0x00000001
#define XF$M_IOS_CMDSTD 0x00000002
#define XF$M_IOS_INVPTE 0x00000004
#define XF$M_IOS_FREQPK 0x00000008
#define XF$M_IOS_DDIDIS 0x00000010
#define XF$M_IOS_SLFTST 0x00000020
#define XF$M_IOS_RNGERR 0x00000040
#define XF$M_IOS_UNQERR 0x00000080
#define XF$M_IOS_INVPKT 0x00000100
#define XF$M_IOS_FREQMT 0x00000200
#define XF$M_IOS_RNDENB 0x00000400
#define XF$M_IOS_INVDDI 0x00000800
#define XF$M_IOS_LENERR 0x00001000
#define XF$M_IOS_DRVABT 0x00002000
#define XF$M_IOS_PARERR 0x00004000
#define XF$M_IOS_BUSERR 0x08000000
#define XF$M_IOS_RDSERR 0x10000000
#define XF$M_IOS_WCSPE 0x20000000
#define XF$M_IOS_CIPE 0x40000000
#define XF$M_IOS_DIPE 0x80000000
#define XF$M_IOS_NEXREG 0x00000020
#define XF$M_IOS_LOG 0x00000040
#define XF$M_IOS_DDIERR 0x00000080
union xfdef {
    struct {
        unsigned xf$v_ios_succes : 1;   /* SUCCESS                            */
        unsigned xf$v_ios_cmdstd : 1;   /* COMMAND STARTED                    */
        unsigned xf$v_ios_invpte : 1;   /* INVALID PTE                        */
        unsigned xf$v_ios_freqpk : 1;   /* FREE QUEUE PACKET                  */
        unsigned xf$v_ios_ddidis : 1;   /* DDI DISABLE                        */
        unsigned xf$v_ios_slftst : 1;   /* SELF TEST                          */
        unsigned xf$v_ios_rngerr : 1;   /* RANGE ERROR                        */
        unsigned xf$v_ios_unqerr : 1;   /* UNALIGNED QUEUE ERROR              */
        unsigned xf$v_ios_invpkt : 1;   /* INVALID COMMAND PACKET             */
        unsigned xf$v_ios_freqmt : 1;   /* FREE QUEUE EMPTY                   */
        unsigned xf$v_ios_rndenb : 1;   /* RANDOM ENABLE                      */
        unsigned xf$v_ios_invddi : 1;   /* INVALID DDI COMMAND                */
        unsigned xf$v_ios_lenerr : 1;   /* LENGTH ERROR                       */
        unsigned xf$v_ios_drvabt : 1;   /* DRIVER ABORT                       */
        unsigned xf$v_ios_parerr : 1;   /* PARITY ERROR (CI OR DI)            */
        unsigned xfdef$$_fill_7 : 1;    /* RESERVED                           */
        unsigned xf$v_ios_ddists : 8;   /* DDI STATUS                         */
        unsigned xfdef$$_fill_8 : 3;    /* RESERVED                           */
        unsigned xf$v_ios_buserr : 1;   /* BUS ERROR                          */
        unsigned xf$v_ios_rdserr : 1;   /* READ DATA SUBSTITUTE ERROR         */
        unsigned xf$v_ios_wcspe : 1;    /* WCS PARITY ERROR                   */
        unsigned xf$v_ios_cipe : 1;     /* CONTROL INTERCONNECT PARITY ERROR  */
        unsigned xf$v_ios_dipe : 1;     /* DATA INTERCONNECT PARITY ERROR     */
        } xf$r_xfdef_bits0;
    struct {
        unsigned xfdef$$_fill_9 : 5;    /* SKIP OVER 5 BITS                   */
        unsigned xf$v_ios_nexreg : 1;   /* NON-EXISTENT REGISTER              */
        unsigned xf$v_ios_log : 1;      /* LOG                                */
        unsigned xf$v_ios_ddierr : 1;   /* ERROR ON FAR-END DEVICE            */
        } xf$r_xfdef_bits1;
} ;
#define XF$M_CMT_SETRTE 0x00000001
#define XF$M_CMT_DIPEAB 0x00000002
#define XF$K_CMT_LENGTH 32      /* LENGTH OF COMMAND TABLE                    */
#define XF$C_CMT_LENGTH 32      /* LENGTH OF COMMAND TABLE                    */
/*                                                                            */
struct xfdef1 {
    unsigned long int xf$l_cmt_cblksz;  /* COMMAND BLOCK SIZE                 */
    unsigned long int xf$l_cmt_cblkad;  /* COMMAND BLOCK ADDRESS              */
    unsigned long int xf$l_cmt_bblksz;  /* BUFFER BLOCK SIZE                  */
    unsigned long int xf$l_cmt_bblkad;  /* BUFFER BLOCK ADDRESS               */
    unsigned long int xf$l_cmt_pastad;  /* PACKET AST ADDRESS                 */
    unsigned long int xf$l_cmt_pastpm;  /* PACKET AST ADDRESS                 */
    unsigned char xf$b_cmt_rate;        /* DATA RATE                          */
    union {
        unsigned char xf$b_cmt_flags;   /* FLAGS                              */
        struct {
            unsigned xf$v_cmt_setrte : 1;       /* SET DATA RATE              */
            unsigned xf$v_cmt_dipeab : 1;       /* DISABLE PARITY ERROR ABORT */
            unsigned xf$v_fill_9 : 6;
            } xf$r_cmt_flags_bits;
        } xf$r_cmt_flags_overlay;
    short int xfdef$$_fill_1;   /* SPARE                                      */
    unsigned long int xf$l_cmt_gbitad;  /* GO BIT ADDRESS                     */
/* COMMAND PACKET OFFSETS                                                     */
/*                                                                            */
} ;
#define XF$K_PKT_RD 0   /* READ                                               */
#define XF$K_PKT_RDCHN 1        /* READ CHAINED                               */
#define XF$K_PKT_WRT 2  /* WRITE                                              */
#define XF$K_PKT_WRTCHN 3       /* WRITE CHAINED                              */
#define XF$K_PKT_WRTCM 4        /* WRITE CONTROL MESSAGE                      */
/*  VALUE 5 IS RESERVED                                                       */
#define XF$K_PKT_SETTST 6       /* SET SELF TEST                              */
#define XF$K_PKT_CLRTST 7       /* CLEAR SELF TEST                            */
#define XF$K_PKT_NOP 8  /* NOP                                                */
#define XF$K_PKT_DIAGRI 9       /* DIAGNOSTIC READ INTERNAL                   */
#define XF$K_PKT_DIAGWI 10      /* DIAGNOSTIC WRITE INTERNAL                  */
#define XF$K_PKT_DIAGRD 11      /* DIAGNOSTIC READ DDI                        */
#define XF$K_PKT_DIAGWC 12      /* WRITE CONTROL MESSAGE                      */
#define XF$K_PKT_SETRND 13      /* SET RANDOM ENABLE                          */
#define XF$K_PKT_CLRRND 14      /* CLEAR RANDOM ENABLE                        */
#define XF$K_PKT_HALT 15        /* HALT                                       */
#define XF$M_PKT_SLNERR 0x00000020
#define XF$K_PKT_NOTRAN 0       /* NO TRANSMISSION                            */
#define XF$K_PKT_CB 1   /* COMMAND BYTE ONLY                                  */
#define XF$K_PKT_CBDM 2 /* COMMAND BYTE AND DEVICE MESSAGE                    */
#define XF$K_PKT_CBDMBC 3       /* CMD. BYTE, DEV. MSG, AND BYTE COUNT        */
/* VALUES FOR INTERRUPT CONTOL                                                */
#define XF$K_PKT_UNCOND 0       /* UNCONDITIONAL INTERRUPT                    */
#define XF$K_PKT_TMQMT 1        /* INTERRUPT ON TERM. QUEUE EMPTY             */
#define XF$K_PKT_NOINT 2        /* NO INTERRUPT                               */
#define XF$M_PKT_SUCCES 0x00000001
#define XF$M_PKT_CMDSTD 0x00000002
#define XF$M_PKT_INVPTE 0x00000004
#define XF$M_PKT_FREQPK 0x00000008
#define XF$M_PKT_DDIDIS 0x00000010
#define XF$M_PKT_SLFTST 0x00000020
#define XF$M_PKT_RNGERR 0x00000040
#define XF$M_PKT_UNQERR 0x00000080
#define XF$M_PKT_INVPKT 0x00000100
#define XF$M_PKT_FREQMT 0x00000200
#define XF$M_PKT_RNDENB 0x00000400
#define XF$M_PKT_INVDDI 0x00000800
#define XF$M_PKT_LENERR 0x00001000
#define XF$M_PKT_DRVABT 0x00002000
#define XF$M_PKT_PARERR 0x00004000
#define XF$M_PKT_NEXREG 0x00000020
#define XF$M_PKT_LOG 0x00000040
#define XF$M_PKT_DDIERR 0x00000080
struct xfdef2 {
    unsigned long int xf$l_pkt_flink;   /* FORWARD LINK                       */
    unsigned long int xf$l_pkt_blink;   /* BACKWARD LINK                      */
    unsigned char xf$b_pkt_msglen;      /* LENGTH OF DEVICE MESSAGE AREA      */
    unsigned char xf$b_pkt_loglen;      /* LENGTH OF LOG AREA                 */
    union {
        unsigned char xf$b_pkt_cmdctl;  /* COMMAND CONTROL                    */
        struct {
            unsigned xf$v_pkt_func : 4; /* FUNCTION CODE                      */
            unsigned xfdef$$_fill_2 : 4;        /* MUST BE ZERO               */
            } xf$r_pkt_cmdctl_bits;
/* FUNCTION CODE VALUES                                                       */
        } xf$r_pkt_cmdctl_overlay;
    union {
        unsigned char xf$b_pkt_pktctl;  /* PACKET CONTROL                     */
        struct {
            unsigned xfdef$$_fill_3 : 3;        /* UNUSED                     */
            unsigned xf$v_pkt_cisel : 2;        /* CONTROL INTERCONNECT SELECT        */
            unsigned xf$v_pkt_slnerr : 1;       /* SUPPRESS LENGTH ERROR      */
            unsigned xf$v_pkt_intctl : 2;       /* INTERRUPT CONTROL          */
            } xf$r_pkt_pktctl_bits;
/* VALUES FOR CONTROL INTERCONNECT SELECT                                     */
        } xf$r_pkt_pktctl_overlay;
    unsigned long int xf$l_pkt_bfrsiz;  /* BUFFER SIZE                        */
    unsigned long int xf$l_pkt_bfradr;  /* BUFFER ADDRESS                     */
    unsigned long int xf$l_pkt_rmbcnt;  /* RESIDUAL MEMORY BYTE COUNT         */
    unsigned long int xf$l_pkt_rdbcnt;  /* RESIDUAL DDI BYTE COUNT            */
    union {
        unsigned long int xf$l_pkt_dsl; /* DR32 STATUS LONGWORD               */
        struct {
            unsigned xf$v_pkt_succes : 1;       /* SUCCESS                    */
            unsigned xf$v_pkt_cmdstd : 1;       /* COMMAND STARTED            */
            unsigned xf$v_pkt_invpte : 1;       /* INVALID PTE                */
            unsigned xf$v_pkt_freqpk : 1;       /* FREE QUEUE PACKET          */
            unsigned xf$v_pkt_ddidis : 1;       /* DDI DISABLE                */
            unsigned xf$v_pkt_slftst : 1;       /* SELF TEST                  */
            unsigned xf$v_pkt_rngerr : 1;       /* RANGE ERROR                */
            unsigned xf$v_pkt_unqerr : 1;       /* UNALIGNED QUEUE ERROR      */
            unsigned xf$v_pkt_invpkt : 1;       /* INVALID COMMAND PACKET     */
            unsigned xf$v_pkt_freqmt : 1;       /* FREE QUEUE EMPTY           */
            unsigned xf$v_pkt_rndenb : 1;       /* RANDOM ENABLE              */
            unsigned xf$v_pkt_invddi : 1;       /* INVALID DDI COMMAND        */
            unsigned xf$v_pkt_lenerr : 1;       /* LENGTH ERROR               */
            unsigned xf$v_pkt_drvabt : 1;       /* DRIVER ABORT               */
            unsigned xf$v_pkt_parerr : 1;       /* PARITY ERROR               */
            unsigned xfdef$$_fill_4 : 1;        /* RESERVED                   */
            unsigned xf$v_pkt_ddists : 8;       /* DDI STATUS                 */
            unsigned xfdef$$_fill_5 : 8;        /* RESERVED                   */
            } xf$r_pkt_dsl_bits0;
        struct {
            unsigned xfdef$$_fill_6 : 5;        /* SKIP OVER 5 BITS           */
            unsigned xf$v_pkt_nexreg : 1;       /* NON-EXISTENT REGISTER      */
            unsigned xf$v_pkt_log : 1;  /* LOG                                */
            unsigned xf$v_pkt_ddierr : 1;       /* ERROR ON FAR-END DEVICE    */
            } xf$r_pkt_dsl_bits1;
        } xf$r_pkt_dsl_overlay;
    unsigned char xf$b_pkt_devmsg;      /* START OF DEVICE MESSAGE            */
/*                                                                            */
/* SECOND LONGWORD OF I/O STATUS BLOCK DEFINITIONS                            */
/*                                                                            */
} ;
#endif
