/* Created by SDL V3.0-2     */
/* Source:  8-AUG-1988 09:47:35 EMULEX$DISK:[MEADOWS.UNSDL.VMS4-7_H]STARDEFQZ.S */
#ifndef $XKSTSDEF_H
#define $XKSTSDEF_H
 
/*** MODULE $XKSTSDEF ***/
/*                                                                            */
/* DEFINITIONS FOR 3271 LINE STATUS BLOCK (RETURNED BY IO$_RDSTATS)           */
/*                                                                            */
#define XKSTS$K_LSTR 0  /* OFFSET OF BEGINNING OF DATA AREA                   */
#define XKSTS$C_LSTR 0  /* OFFSET OF BEGINNING OF DATA AREA                   */
#define XKSTS$M_ACT 0x00000001
#define XKSTS$M_DGN 0x00000002
#define XKSTS$K_DSTR 45 /* LENGTH OF THE LINE STATUS BLOCK                    */
#define XKSTS$C_DSTR 45 /* LENGTH OF THE LINE STATUS BLOCK                    */
struct xkstsdef {
    unsigned char xksts$b_cuad; /* CONTROL UNIT ADDRESS (HEX EBCDIC)          */
    union {
        unsigned short int xksts$w_lsts;        /* LINE STATUS                */
        struct {
            unsigned xksts$v_act : 1;   /* IF SET, LINE IS 'ON' (ACTIVE IN 3271 MODE) */
            unsigned xksts$v_dgn : 1;   /* IF SET, LINE IS EXECUTING A DIAGNOSTIC QIO */
            unsigned xksts$v_fill_10 : 6;
            } xksts$r_lsts_bits;
        } xksts$r_lsts_overlay;
    unsigned char xksts$b_plsz; /* POOL SIZE                                  */
    unsigned short int xksts$w_bsiz;    /* MAXIMUM BLOCK TO BE RECEIVED FROM IBM      */
    unsigned char xksts$b_ecnt; /* ENQ THRESHOLD                              */
    unsigned short int xksts$w_tnak;    /* NUMBER OF NAKS TRANSMITTED         */
    unsigned short int xksts$w_rnak;    /* NUMBER OF NAKS RECEIVED            */
    unsigned short int xksts$w_tenq;    /* NUMBER OF ENQS SENT                */
    unsigned short int xksts$w_renq;    /* NUMBER OF ENQS RECEIVED            */
    unsigned short int xksts$w_trvi;    /* NUMBER OF RVIS TRANSMITTED         */
    unsigned short int xksts$w_rrvi;    /* NUMBER OF RVIS RECEIVED            */
    unsigned short int xksts$w_rcnv;    /* NUMBER OF CONVERSATIONAL MODE RESPONSES    */
/*  RECEIVED                                                                  */
    unsigned short int xksts$w_chai;    /* NUMBER OF CHAINED WRITES RECEIVED  */
    unsigned short int xksts$w_gpol;    /* NUMBER OF GENERAL POLLS RECEIVED   */
    unsigned short int xksts$w_xack;    /* NUMBER OF INVALID ACKS RECEIVED    */
    unsigned short int xksts$w_habo;    /* NUMBER OF HOST ABORTS ENCOUNTERED  */
    unsigned short int xksts$w_dabo;    /* NUMBER OF DRIVER ABORTS ENCOUNTERED        */
    unsigned short int xksts$w_rtim;    /* NUMBER OF ACK RESPONSE TIMEOUTS    */
    unsigned short int xksts$w_disc;    /* NUMBER OF DISCONNECTS ENCOUNTERED  */
    unsigned short int xksts$w_hard;    /* NUMBER OF HARDWARE FAILURES (INCLUDING     */
/*  DISCONNECTS) ENCOUNTERED                                                  */
    unsigned short int xksts$w_tblk;    /* NUMBER OF BLOCKS TRANSMITTED       */
    unsigned short int xksts$w_rblk;    /* NUMBER OF BLOCKS RECEIVED          */
    unsigned short int xksts$w_habx;    /* NUMBER OF DUBIOUS ACK OUTS         */
    unsigned short int xksts$w_ieot;    /* NUMBER OF EOTS IMPLYING ACK        */
} ;
#endif
