/* Created by SDL V3.0-2     */
/* Source:  8-AUG-1988 09:47:35 EMULEX$DISK:[MEADOWS.UNSDL.VMS4-7_H]STARDEFQZ.S */
#ifndef $XMDEF_H
#define $XMDEF_H
 
/*** MODULE $XMDEF ***/
/*                                                                            */
/* DEFINITIONS FOR STATUS, CHARACTERISTICS AND ERRORS FOR DMC-11/DMR-11/DMP-11*/
/*                                                                            */
struct xmdev {
    unsigned char xmdev$b_p1_class;     /* Device Class                       */
    unsigned char xmdev$b_p1_type;      /* Device type                        */
    unsigned short int xmdev$w_p1_mms;  /* Maximum message size               */
    unsigned char xmdev$b_p1_char;      /* Unit characteristics               */
    unsigned char xmdev$b_p1_sts;       /* Unit Status                        */
    unsigned char xmdev$b_p1_esum;      /* Error Summary                      */
    unsigned char xmdev$b_p1_tpi;       /* Transmit Pipeline no.              */
} ;
#define XM$M_CHR_MOP 0x00000001
#define XM$M_CHR_LOOPB 0x00000002
#define XM$M_CHR_HDPLX 0x00000004
#define XM$M_CHR_SLAVE 0x00000008
#define XM$M_CHR_MBX 0x00000010
#define XM$M_CHR_DMC 0x00000020
#define XM$M_CHR_CTRL 0x00000040
#define XM$M_CHR_TRIB 0x00000080
#define XM$M_STS_DCHK 0x00000100
#define XM$M_STS_TIMO 0x00000200
#define XM$M_STS_ORUN 0x00000400
#define XM$M_STS_ACTIVE 0x00000800
#define XM$M_STS_BUFFAIL 0x00001000
#define XM$M_STS_RUNNING 0x00002000
#define XM$M_STS_DISC 0x00004000
#define XM$M_ERR_FATAL 0x00010000
#define XM$M_ERR_MAINT 0x00080000
#define XM$M_ERR_LOST 0x00100000
#define XM$M_ERR_THRESH 0x00200000
#define XM$M_ERR_TRIB 0x00400000
#define XM$M_ERR_START 0x00800000
#define XM$M_MDM_RTSHLD 0x00000001
#define XM$M_MDM_STNDBY 0x00000002
#define XM$M_MDM_MAINT2 0x00000004
#define XM$M_MDM_MAINT1 0x00000008
#define XM$M_MDM_FREQ 0x00000020
#define XM$M_MDM_RDY 0x00000040
#define XM$M_MDM_POLL 0x00000080
#define XM$M_MDM_SELM 0x00000100
#define XM$M_MDM_INT 0x00000800
#define XM$M_MDM_V35 0x00001000
#define XM$M_MDM_RS232 0x00004000
#define XM$M_MDM_RS422 0x00008000
#define XM$M_MDM_CARRDET 0x00000001
#define XM$M_MDM_MSTNDBY 0x00000002
#define XM$M_MDM_CTS 0x00000004
#define XM$M_MDM_DSR 0x00000008
#define XM$M_MDM_HDX 0x00000010
#define XM$M_MDM_RTS 0x00000020
#define XM$M_MDM_DTR 0x00000040
#define XM$M_MDM_RING 0x00000080
#define XM$M_MDM_CHRMOD 0x00000100
#define XM$M_MDM_MCLOCK 0x00000200
#define XM$M_MDM_MODTEST 0x00000400
#define XM$M_MDM_SIGQUAL 0x00004000
#define XM$M_MDM_SIGRATE 0x00008000
union xmdef {
    struct {
        unsigned xm$v_chr_mop : 1;      /* MOP MODE                           */
        unsigned xm$v_chr_loopb : 1;    /* LOOP BACK                          */
        unsigned xm$v_chr_hdplx : 1;    /* HALF DUPLEX                        */
        unsigned xm$v_chr_slave : 1;    /* HALF DUPLEX SLAVE STATION          */
        unsigned xm$v_chr_mbx : 1;      /* MAILBOX IS ENABLED                 */
        unsigned xm$v_chr_dmc : 1;      /* DMC-11 COMPATABILITY MODE          */
        unsigned xm$v_chr_ctrl : 1;     /* CONTROL STATION                    */
        unsigned xm$v_chr_trib : 1;     /* TRIBUTARY STATION                  */
        unsigned xm$v_sts_dchk : 1;     /* DATA CHECK OCCURED                 */
        unsigned xm$v_sts_timo : 1;     /* TIMEOUT OCCURED                    */
        unsigned xm$v_sts_orun : 1;     /* DATA OVER RUN OCCURED              */
        unsigned xm$v_sts_active : 1;   /* ACTIVE UNIT                        */
        unsigned xm$v_sts_buffail : 1;  /* BUFFER ALLOCATION FAILURE OCCURED  */
        unsigned xm$v_sts_running : 1;  /* PROTOCOL RUNNING                   */
        unsigned xm$v_sts_disc : 1;     /* LINE DISCONNECT OCCURED            */
        unsigned xmdef$$_fill_1 : 1;    /* SPARE                              */
        unsigned xm$v_err_fatal : 1;    /* HARDWARE ERROR                     */
        unsigned xmdef$$_fill_2 : 2;
        unsigned xm$v_err_maint : 1;    /* DDCMP MAINT MESSAGE RECEIVED       */
        unsigned xm$v_err_lost : 1;     /* DATA LOST BECAUSE OF BUFFER SIZE MISMATCH  */
        unsigned xm$v_err_thresh : 1;   /* THRESHOLD ERRORS                   */
        unsigned xm$v_err_trib : 1;     /* TRIBUTARY MALFUNCTIONING           */
        unsigned xm$v_err_start : 1;    /* DDCMP START MESSAGE RECEIVED       */
        } xm$r_xmdef_bits0;
    struct {
        unsigned xm$v_mdm_rtshld : 1;   /* RTS HOLD                           */
        unsigned xm$v_mdm_stndby : 1;   /* SELECT STANDBY                     */
        unsigned xm$v_mdm_maint2 : 1;   /* MAINTENANCE MODE 2                 */
        unsigned xm$v_mdm_maint1 : 1;   /* MAINTENANCE MODE 1                 */
        unsigned xmdef$$_fill_3 : 1;    /* HALF-DUPLEX                        */
        unsigned xm$v_mdm_freq : 1;     /* SELECT FREQUENCY                   */
        unsigned xm$v_mdm_rdy : 1;      /* DATA TERMINAL READY                */
        unsigned xm$v_mdm_poll : 1;     /* SELECT POLLING MODEM MODE          */
        unsigned xm$v_mdm_selm : 1;     /* MODEM INTERFACE PROGRAM SELECTED   */
        unsigned xmdef$$_fill_4 : 2;    /* UNUSED                             */
        unsigned xm$v_mdm_int : 1;      /* INTEGRAL MODEM                     */
        unsigned xm$v_mdm_v35 : 1;      /* V.35                               */
        unsigned xmdef$$_fill_5 : 1;    /* UNUSED                             */
        unsigned xm$v_mdm_rs232 : 1;    /* RS-232-C OR RS423                  */
        unsigned xm$v_mdm_rs422 : 1;    /* RS-422                             */
        } xm$r_xmdef_bits1;
    struct {
        unsigned xm$v_mdm_carrdet : 1;  /* CARRIER DETECT                     */
        unsigned xm$v_mdm_mstndby : 1;  /* MODEM STANDBY                      */
        unsigned xm$v_mdm_cts : 1;      /* CLEAR TO SEND                      */
        unsigned xm$v_mdm_dsr : 1;      /* DATA SET READY                     */
        unsigned xm$v_mdm_hdx : 1;      /* HALF-DUPLEX                        */
        unsigned xm$v_mdm_rts : 1;      /* REQUEST TO SEND                    */
        unsigned xm$v_mdm_dtr : 1;      /* DATA TERMINAL READY                */
        unsigned xm$v_mdm_ring : 1;     /* RING                               */
        unsigned xm$v_mdm_chrmod : 1;   /* CHARACTER OR BIT PROTOCOL MODE     */
        unsigned xm$v_mdm_mclock : 1;   /* MAINTENANCE CLOCK                  */
        unsigned xm$v_mdm_modtest : 1;  /* MODEM TEST MODE                    */
        unsigned xmdef$$_fill_6 : 3;    /* UNUSED                             */
        unsigned xm$v_mdm_sigqual : 1;  /* SIGNAL QUALITY                     */
        unsigned xm$v_mdm_sigrate : 1;  /* SIGNAL RATE                        */
        } xm$r_xmdef_bits2;
} ;
#endif
