/* Created by SDL V3.0-2     */
/* Source:  8-AUG-1988 09:30:14 EMULEX$DISK:[MEADOWS.UNSDL.VMS4-7_H]DTK$ROUTINE */
#ifndef DTK$ROUTINES_H
#define DTK$ROUTINES_H
 
/*** MODULE DTK$ROUTINES ***/
/**************************************************************************** */
/*          *                                                                 */
/*  COPYRIGHT (c) 1986 BY                   *                                 */
/*  DIGITAL EQUIPMENT CORPORATION, MAYNARD, MASSACHUSETTS.          *         */
/*  ALL RIGHTS RESERVED.    *                                                 */
/*          *                                                                 */
/*  THIS SOFTWARE IS FURNISHED UNDER A LICENSE AND MAY BE USED AND COPIED   * */
/*  ONLY IN  ACCORDANCE WITH  THE  TERMS  OF  SUCH  LICENSE  AND WITH THE   * */
/*  INCLUSION OF THE ABOVE COPYRIGHT NOTICE. THIS SOFTWARE OR  ANY  OTHER   * */
/*  COPIES THEREOF MAY NOT BE PROVIDED OR OTHERWISE MADE AVAILABLE TO ANY   * */
/*  OTHER PERSON.  NO TITLE TO AND OWNERSHIP OF  THE  SOFTWARE IS  HEREBY   * */
/*  TRANSFERRED.            *                                                 */
/*          *                                                                 */
/*  THE INFORMATION IN THIS SOFTWARE IS  SUBJECT TO CHANGE WITHOUT NOTICE   * */
/*  AND  SHOULD  NOT  BE  CONSTRUED AS  A COMMITMENT BY DIGITAL EQUIPMENT   * */
/*  CORPORATION.    *                                                         */
/*          *                                                                 */
/*  DIGITAL ASSUMES NO RESPONSIBILITY FOR THE USE  OR  RELIABILITY OF ITS   * */
/*  SOFTWARE ON EQUIPMENT WHICH IS NOT SUPPLIED BY DIGITAL.         *         */
/*          *                                                                 */
/*          *                                                                 */
/**************************************************************************** */
/*+~dtk$answer_phone~+*/
unsigned long int dtk$answer_phone(
    const unsigned long int  *voice_id,
    ...
    /* const long int  *number_of_rings, */
    /* const struct dsc$descriptor *text */
    ) ;
/*~-dtk$answer_phone-~*/
/*+~dtk$dial_phone~+*/
unsigned long int dtk$dial_phone(
    const unsigned long int  *voice_id,
    const struct dsc$descriptor *phone_number,
    ...
    /* const unsigned long int  *dial_mode, */
    /* const struct dsc$descriptor *text, */
    /* const long int  *timeout */
    ) ;
/*~-dtk$dial_phone-~*/
/*+~dtk$hangup_phone~+*/
unsigned long int dtk$hangup_phone(
    const unsigned long int  *voice_id,
    ...
    /* const struct dsc$descriptor *text */
    ) ;
/*~-dtk$hangup_phone-~*/
/*+~dtk$initialize~+*/
unsigned long int dtk$initialize(
    unsigned long int  *voice_id,
    const struct dsc$descriptor *output_device,
    ...
    /* long int  *device_type */
    ) ;
/*~-dtk$initialize-~*/
/*+~dtk$load_dictionary~+*/
unsigned long int dtk$load_dictionary(
    const unsigned long int  *voice_id,
    const struct dsc$descriptor *text,
    const struct dsc$descriptor *substitution
    ) ;
/*~-dtk$load_dictionary-~*/
/*+~dtk$read_keystroke~+*/
unsigned long int dtk$read_keystroke(
    const unsigned long int  *voice_id,
    long int  *key_code,
    ...
    /* const struct dsc$descriptor *prompt_string, */
    /* const long int  *timeout */
    ) ;
/*~-dtk$read_keystroke-~*/
/*+~dtk$read_string~+*/
unsigned long int dtk$read_string(
    const unsigned long int  *voice_id,
    struct dsc$descriptor *resultant_string,
    ...
    /* const struct dsc$descriptor *prompt_string, */
    /* const long int  *timeout, */
    /* long int  *longword_integer_termin_code */
    ) ;
/*~-dtk$read_string-~*/
/*+~dtk$return_last_index~+*/
unsigned long int dtk$return_last_index(
    const unsigned long int  *voice_id,
    long int  *p_index
    ) ;
/*~-dtk$return_last_index-~*/
/*+~dtk$speak_file~+*/
unsigned long int dtk$speak_file(
    const unsigned long int  *voice_id,
    const struct dsc$descriptor *filespec,
    ...
    /* const unsigned long int  *completion_mode */
    ) ;
/*~-dtk$speak_file-~*/
/*+~dtk$speak_phonemic_text~+*/
unsigned long int dtk$speak_phonemic_text(
    const unsigned long int  *voice_id,
    const struct dsc$descriptor *text,
    ...
    /* const unsigned long int  *completion_mode */
    ) ;
/*~-dtk$speak_phonemic_text-~*/
/*+~dtk$speak_text~+*/
unsigned long int dtk$speak_text(
    const unsigned long int  *voice_id,
    const struct dsc$descriptor *text,
    ...
    /* const unsigned long int  *completion_mode */
    ) ;
/*~-dtk$speak_text-~*/
/*+~dtk$set_index~+*/
unsigned long int dtk$set_index(
    const unsigned long int  *voice_id,
    const long int  *p_index
    ) ;
/*~-dtk$set_index-~*/
/*+~dtk$set_keypad_mode~+*/
unsigned long int dtk$set_keypad_mode(
    const unsigned long int  *voice_id,
    const unsigned long int  *keypad_mode
    ) ;
/*~-dtk$set_keypad_mode-~*/
/*+~dtk$set_logging_mode~+*/
unsigned long int dtk$set_logging_mode(
    const unsigned long int  *voice_id,
    ...
    /* const unsigned long int  *new_mode, */
    /* unsigned long int  *old_mode */
    ) ;
/*~-dtk$set_logging_mode-~*/
/*+~dtk$set_mode~+*/
unsigned long int dtk$set_mode(
    const unsigned long int  *voice_id,
    ...
    /* const unsigned long int  *new_mode, */
    /* unsigned long int  *old_mode */
    ) ;
/*~-dtk$set_mode-~*/
/*+~dtk$set_speech_mode~+*/
unsigned long int dtk$set_speech_mode(
    const unsigned long int  *voice_id,
    const unsigned long int  *new_mode,
    ...
    /* unsigned long int  *old_mode */
    ) ;
/*~-dtk$set_speech_mode-~*/
/*+~dtk$set_terminal_mode~+*/
unsigned long int dtk$set_terminal_mode(
    const unsigned long int  *voice_id,
    ...
    /* const unsigned long int  *new_mode, */
    /* unsigned long int  *old_mode */
    ) ;
/*~-dtk$set_terminal_mode-~*/
/*+~dtk$set_voice~+*/
unsigned long int dtk$set_voice(
    const unsigned long int  *voice_id,
    ...
    /* const long int  *new_voice, */
    /* const long int  *speech_rate, */
    /* const unsigned long int  *comma_pause, */
    /* const unsigned long int  *period_pause */
    ) ;
/*~-dtk$set_voice-~*/
/*+~dtk$terminate~+*/
unsigned long int dtk$terminate(
    const unsigned long int  *voice_id
    ) ;
/*~-dtk$terminate-~*/
#endif
