/* Created by SDL V3.0-2     */
/* Source:  8-AUG-1988 09:42:32 EMULEX$DISK:[MEADOWS.UNSDL.VMS4-7_H]SMG$ROUTINE */
#ifndef SMG$ROUTINES_H
#define SMG$ROUTINES_H
 
/*** MODULE SMG$ROUTINES ***/
/**************************************************************************** */
/*          *                                                                 */
/*  COPYRIGHT (c) 1986 BY                   *                                 */
/*  DIGITAL EQUIPMENT CORPORATION, MAYNARD, MASSACHUSETTS.          *         */
/*  ALL RIGHTS RESERVED.    *                                                 */
/*          *                                                                 */
/*  THIS SOFTWARE IS FURNISHED UNDER A LICENSE AND MAY BE USED AND COPIED   * */
/*  ONLY IN  ACCORDANCE WITH  THE  TERMS  OF  SUCH  LICENSE  AND WITH THE   * */
/*  INCLUSION OF THE ABOVE COPYRIGHT NOTICE. THIS SOFTWARE OR  ANY  OTHER   * */
/*  COPIES THEREOF MAY NOT BE PROVIDED OR OTHERWISE MADE AVAILABLE TO ANY   * */
/*  OTHER PERSON.  NO TITLE TO AND OWNERSHIP OF  THE  SOFTWARE IS  HEREBY   * */
/*  TRANSFERRED.            *                                                 */
/*          *                                                                 */
/*  THE INFORMATION IN THIS SOFTWARE IS  SUBJECT TO CHANGE WITHOUT NOTICE   * */
/*  AND  SHOULD  NOT  BE  CONSTRUED AS  A COMMITMENT BY DIGITAL EQUIPMENT   * */
/*  CORPORATION.    *                                                         */
/*          *                                                                 */
/*  DIGITAL ASSUMES NO RESPONSIBILITY FOR THE USE  OR  RELIABILITY OF ITS   * */
/*  SOFTWARE ON EQUIPMENT WHICH IS NOT SUPPLIED BY DIGITAL.         *         */
/*          *                                                                 */
/*          *                                                                 */
/**************************************************************************** */
/*+~smg$add_key_def~+*/
unsigned long int smg$add_key_def(
    const unsigned long int  *key_table_id,
    const struct dsc$descriptor *key_name,
    ...
    /* const struct dsc$descriptor *if_state, */
    /* const unsigned long int  *attributes, */
    /* const struct dsc$descriptor *equivalence_string, */
    /* const struct dsc$descriptor *state_string */
    ) ;
/*~-smg$add_key_def-~*/
/*+~smg$begin_display_update~+*/
unsigned long int smg$begin_display_update(
    const unsigned long int  *display_id
    ) ;
/*~-smg$begin_display_update-~*/
/*+~smg$begin_pasteboard_update~+*/
unsigned long int smg$begin_pasteboard_update(
    const unsigned long int  *pasteboard_id
    ) ;
/*~-smg$begin_pasteboard_update-~*/
/*+~smg$cancel_input~+*/
unsigned long int smg$cancel_input(
    const unsigned long int  *keyboard_id
    ) ;
/*~-smg$cancel_input-~*/
/*+~smg$cursor_column~+*/
unsigned long int smg$cursor_column(
    const unsigned long int  *display_id
    ) ;
/*~-smg$cursor_column-~*/
/*+~smg$check_for_occlusion~+*/
unsigned long int smg$check_for_occlusion(
    const unsigned long int  *display_id,
    const unsigned long int  *pasteboard_id,
    long int  *occlusion_state
    ) ;
/*~-smg$check_for_occlusion-~*/
/*+~smg$create_key_table~+*/
unsigned long int smg$create_key_table(
    unsigned long int  *key_table_id
    ) ;
/*~-smg$create_key_table-~*/
/*+~smg$control_mode~+*/
unsigned long int smg$control_mode(
    const unsigned long int  *pasteboard_id,
    ...
    /* const unsigned long int  *new_mode, */
    /* unsigned long int  *old_mode */
    ) ;
/*~-smg$control_mode-~*/
/*+~smg$copy_virtual_display~+*/
unsigned long int smg$copy_virtual_display(
    const unsigned long int  *current_display_id,
    unsigned long int  *new_display_id
    ) ;
/*~-smg$copy_virtual_display-~*/
/*+~smg$create_pasteboard~+*/
unsigned long int smg$create_pasteboard(
    unsigned long int  *pasteboard_id,
    ...
    /* const struct dsc$descriptor *output_device, */
    /* long int  *number_of_pasteboard_rows, */
    /* long int  *number_of_pasteboard_columns, */
    /* const unsigned long int  *flags */
    ) ;
/*~-smg$create_pasteboard-~*/
/*+~smg$change_pbd_characteristics~+*/
unsigned long int smg$change_pbd_characteristics(
    const unsigned long int  *pasteboard_id,
    ...
    /* const long int  *desired_width, */
    /* long int  *width, */
    /* const long int  *desired_height, */
    /* long int  *height, */
    /* const unsigned long int  *desired_background_color, */
    /* unsigned long int  *background_color */
    ) ;
/*~-smg$change_pbd_characteristics-~*/
/*+~smg$change_rendition~+*/
unsigned long int smg$change_rendition(
    const unsigned long int  *display_id,
    const long int  *start_row,
    const long int  *start_column,
    const long int  *number_of_rows,
    const long int  *number_of_columns,
    ...
    /* const unsigned long int  *rendition_set, */
    /* const unsigned long int  *rendition_complement */
    ) ;
/*~-smg$change_rendition-~*/
/*+~smg$cursor_row~+*/
unsigned long int smg$cursor_row(
    const unsigned long int  *display_id
    ) ;
/*~-smg$cursor_row-~*/
/*+~smg$create_virtual_display~+*/
unsigned long int smg$create_virtual_display(
    const long int  *number_of_rows,
    const long int  *number_of_columns,
    unsigned long int  *display_id,
    ...
    /* const unsigned long int  *display_attributes, */
    /* const unsigned long int  *video_attributes, */
    /* const unsigned long int  *character_set */
    ) ;
/*~-smg$create_virtual_display-~*/
/*+~smg$change_virtual_display~+*/
unsigned long int smg$change_virtual_display(
    const unsigned long int  *display_id,
    const long int  *number_of_rows,
    const long int  *number_of_columns,
    ...
    /* const unsigned long int  *display_attributes, */
    /* const unsigned long int  *video_attributes, */
    /* const unsigned long int  *character_set */
    ) ;
/*~-smg$change_virtual_display-~*/
/*+~smg$create_virtual_keyboard~+*/
unsigned long int smg$create_virtual_keyboard(
    unsigned long int  *keyboard_id,
    ...
    /* const struct dsc$descriptor *filespec, */
    /* const struct dsc$descriptor *default_filespec, */
    /* struct dsc$descriptor *resultant_filespec, */
    /* const unsigned char  *recall_size */
    ) ;
/*~-smg$create_virtual_keyboard-~*/
/*+~smg$delete_chars~+*/
unsigned long int smg$delete_chars(
    const unsigned long int  *display_id,
    const long int  *number_of_characters,
    const long int  *start_row,
    const long int  *start_column
    ) ;
/*~-smg$delete_chars-~*/
/*+~smg$define_key~+*/
unsigned long int smg$define_key(
    const unsigned long int  *key_table_id,
    const struct dsc$descriptor *command_string
    ) ;
/*~-smg$define_key-~*/
/*+~smg$disable_broadcast_trapping~+*/
unsigned long int smg$disable_broadcast_trapping(
    const unsigned long int  *pasteboard_id
    ) ;
/*~-smg$disable_broadcast_trapping-~*/
/*+~smg$disable_unsolicited_input~+*/
unsigned long int smg$disable_unsolicited_input(
    const unsigned long int  *pasteboard_id
    ) ;
/*~-smg$disable_unsolicited_input-~*/
/*+~smg$delete_key_def~+*/
unsigned long int smg$delete_key_def(
    const unsigned long int  *key_table_id,
    const struct dsc$descriptor *key_name,
    ...
    /* const struct dsc$descriptor *if_state */
    ) ;
/*~-smg$delete_key_def-~*/
/*+~smg$delete_line~+*/
unsigned long int smg$delete_line(
    const unsigned long int  *display_id,
    const long int  *start_row,
    ...
    /* const long int  *number_of_rows */
    ) ;
/*~-smg$delete_line-~*/
/*+~smg$delete_pasteboard~+*/
unsigned long int smg$delete_pasteboard(
    const unsigned long int  *pasteboard_id,
    ...
    /* const unsigned long int  *flags */
    ) ;
/*~-smg$delete_pasteboard-~*/
/*+~smg$draw_line~+*/
unsigned long int smg$draw_line(
    const unsigned long int  *display_id,
    const long int  *start_row,
    const long int  *start_column,
    const long int  *end_row,
    const long int  *end_column,
    ...
    /* const unsigned long int  *rendition_set, */
    /* const unsigned long int  *rendition_complement */
    ) ;
/*~-smg$draw_line-~*/
/*+~smg$draw_rectangle~+*/
unsigned long int smg$draw_rectangle(
    const unsigned long int  *display_id,
    const long int  *start_row,
    const long int  *start_column,
    const long int  *end_row,
    const long int  *end_column,
    ...
    /* const unsigned long int  *rendition_set, */
    /* const unsigned long int  *rendition_complement */
    ) ;
/*~-smg$draw_rectangle-~*/
/*+~smg$del_term_table~+*/
unsigned long int smg$del_term_table() ;
/*~-smg$del_term_table-~*/
/*+~smg$delete_virtual_display~+*/
unsigned long int smg$delete_virtual_display(
    const unsigned long int  *display_id
    ) ;
/*~-smg$delete_virtual_display-~*/
/*+~smg$delete_virtual_keyboard~+*/
unsigned long int smg$delete_virtual_keyboard(
    const unsigned long int  *keyboard_id
    ) ;
/*~-smg$delete_virtual_keyboard-~*/
/*+~smg$erase_chars~+*/
unsigned long int smg$erase_chars(
    const unsigned long int  *display_id,
    const long int  *number_of_characters,
    const long int  *start_row,
    const long int  *start_column
    ) ;
/*~-smg$erase_chars-~*/
/*+~smg$end_display_update~+*/
unsigned long int smg$end_display_update(
    const unsigned long int  *display_id
    ) ;
/*~-smg$end_display_update-~*/
/*+~smg$end_pasteboard_update~+*/
unsigned long int smg$end_pasteboard_update(
    const unsigned long int  *pasteboard_id
    ) ;
/*~-smg$end_pasteboard_update-~*/
/*+~smg$enable_unsolicited_input~+*/
unsigned long int smg$enable_unsolicited_input(
    const unsigned long int  *pasteboard_id,
    const int *ast_routine,
    ...
    /* const long int ast_argument */
    ) ;
/*~-smg$enable_unsolicited_input-~*/
/*+~smg$erase_display~+*/
unsigned long int smg$erase_display(
    const unsigned long int  *display_id,
    ...
    /* const long int  *start_row, */
    /* const long int  *start_column, */
    /* const long int  *end_row, */
    /* const long int  *end_column */
    ) ;
/*~-smg$erase_display-~*/
/*+~smg$erase_line~+*/
unsigned long int smg$erase_line(
    const unsigned long int  *display_id,
    ...
    /* const long int  *start_row, */
    /* const long int  *start_column */
    ) ;
/*~-smg$erase_line-~*/
/*+~smg$erase_pasteboard~+*/
unsigned long int smg$erase_pasteboard(
    const unsigned long int  *pasteboard_id
    ) ;
/*~-smg$erase_pasteboard-~*/
/*+~smg$find_cursor_display~+*/
unsigned long int smg$find_cursor_display(
    const unsigned long int  *pasteboard_id,
    unsigned long int  *display_id
    ) ;
/*~-smg$find_cursor_display-~*/
/*+~smg$flush_buffer~+*/
unsigned long int smg$flush_buffer(
    const unsigned long int  *pasteboard_id
    ) ;
/*~-smg$flush_buffer-~*/
/*+~smg$get_broadcast_message~+*/
unsigned long int smg$get_broadcast_message(
    const unsigned long int  *pasteboard_id,
    ...
    /* struct dsc$descriptor *message, */
    /* unsigned short int  *message_length */
    ) ;
/*~-smg$get_broadcast_message-~*/
/*+~smg$get_char_at_physical_cursor~+*/
unsigned long int smg$get_char_at_physical_cursor(
    const unsigned long int  *pasteboard_id,
    unsigned char  *character_code
    ) ;
/*~-smg$get_char_at_physical_cursor-~*/
/*+~smg$get_display_attr~+*/
unsigned long int smg$get_display_attr(
    const unsigned long int  *display_id,
    ...
    /* long int  *height, */
    /* long int  *width, */
    /* unsigned long int  *display_attributes, */
    /* unsigned long int  *video_attributes, */
    /* const unsigned long int  *character_set */
    ) ;
/*~-smg$get_display_attr-~*/
/*+~smg$get_keyboard_attributes~+*/
unsigned long int smg$get_keyboard_attributes(
    const unsigned long int  *keyboard_id,
    int * *p_kit,
    const unsigned long int  *p_kit_size
    ) ;
/*~-smg$get_keyboard_attributes-~*/
/*+~smg$get_key_def~+*/
unsigned long int smg$get_key_def(
    const unsigned long int  *key_table_id,
    const struct dsc$descriptor *key_name,
    ...
    /* const struct dsc$descriptor *if_state, */
    /* unsigned long int  *attributes, */
    /* struct dsc$descriptor *equivalence_string, */
    /* struct dsc$descriptor *state_string */
    ) ;
/*~-smg$get_key_def-~*/
/*+~smg$get_numeric_data~+*/
unsigned long int smg$get_numeric_data(
    const int * *termtable_address,
    const unsigned long int  *request_code,
    int * *buffer_address
    ) ;
/*~-smg$get_numeric_data-~*/
/*+~smg$get_pasting_info~+*/
unsigned long int smg$get_pasting_info(
    const unsigned long int  *display_id,
    const unsigned long int  *pasteboard_id,
    unsigned long int  *flags,
    ...
    /* long int  *pasteboard_row, */
    /* long int  *pasteboard_column */
    ) ;
/*~-smg$get_pasting_info-~*/
/*+~smg$get_pasteboard_attributes~+*/
unsigned long int smg$get_pasteboard_attributes(
    const unsigned long int  *pasteboard_id,
    int  *pasteboard_info_table,
    const unsigned long int  *pasteboard_info_table_size
    ) ;
/*~-smg$get_pasteboard_attributes-~*/
/*+~smg$get_term_data~+*/
unsigned long int smg$get_term_data(
    const int * *termtable_address,
    const unsigned long int  *request_code,
    const long int  *maximum_buffer_length,
    long int  *return_length,
    int * *buffer_address,
    ...
    /* const unsigned long int  *input_argument_vector [1] */
    ) ;
/*~-smg$get_term_data-~*/
/*+~smg$home_cursor~+*/
unsigned long int smg$home_cursor(
    const unsigned long int  *display_id,
    ...
    /* const unsigned long int  *position_code */
    ) ;
/*~-smg$home_cursor-~*/
/*+~smg$init_term_table~+*/
unsigned long int smg$init_term_table(
    const struct dsc$descriptor *terminal_name,
    int * *termtable_address
    ) ;
/*~-smg$init_term_table-~*/
/*+~smg$insert_chars~+*/
unsigned long int smg$insert_chars(
    const unsigned long int  *display_id,
    const struct dsc$descriptor *character_string,
    const long int  *start_row,
    const long int  *start_column,
    ...
    /* const unsigned long int  *rendition_set, */
    /* const unsigned long int  *rendition_complement, */
    /* const unsigned long int  *character_set */
    ) ;
/*~-smg$insert_chars-~*/
/*+~smg$insert_line~+*/
unsigned long int smg$insert_line(
    const unsigned long int  *display_id,
    const long int  *start_row,
    ...
    /* const struct dsc$descriptor *character_string, */
    /* const unsigned long int  *direction, */
    /* const unsigned long int  *rendition_set, */
    /* const unsigned long int  *rendition_complement, */
    /* const unsigned long int  *flags, */
    /* const unsigned long int  *character_set */
    ) ;
/*~-smg$insert_line-~*/
/*+~smg$init_term_table_by_type~+*/
unsigned long int smg$init_term_table_by_type(
    const char  *terminal_type,
    int * *termtable_address,
    ...
    /* struct dsc$descriptor *terminal_name */
    ) ;
/*~-smg$init_term_table_by_type-~*/
/*+~smg$invalidate_display~+*/
unsigned long int smg$invalidate_display(
    const unsigned long int  *display_id
    ) ;
/*~-smg$invalidate_display-~*/
/*+~smg$label_border~+*/
unsigned long int smg$label_border(
    const unsigned long int  *display_id,
    ...
    /* const struct dsc$descriptor *text, */
    /* const unsigned long int  *position_code, */
    /* const long int  *units, */
    /* const unsigned long int  *rendition_set, */
    /* const unsigned long int  *rendition_complement, */
    /* const unsigned long int  *character_set */
    ) ;
/*~-smg$label_border-~*/
/*+~smg$load_key_defs~+*/
unsigned long int smg$load_key_defs(
    const unsigned long int  *key_table_id,
    const struct dsc$descriptor *filespec,
    ...
    /* const struct dsc$descriptor *default_filespec, */
    /* const unsigned long int  *flags */
    ) ;
/*~-smg$load_key_defs-~*/
/*+~smg$list_key_defs~+*/
unsigned long int smg$list_key_defs(
    const unsigned long int  *key_table_id,
    unsigned long int  *context,
    ...
    /* struct dsc$descriptor *key_name, */
    /* struct dsc$descriptor *if_state, */
    /* unsigned long int  *attributes, */
    /* struct dsc$descriptor *equivalence_string, */
    /* struct dsc$descriptor *state_string */
    ) ;
/*~-smg$list_key_defs-~*/
/*+~smg$move_virtual_display~+*/
unsigned long int smg$move_virtual_display(
    const unsigned long int  *display_id,
    const unsigned long int  *pasteboard_id,
    const long int  *pasteboard_row,
    const long int  *pasteboard_column,
    ...
    /* const unsigned long int  *top_display_id */
    ) ;
/*~-smg$move_virtual_display-~*/
/*+~smg$paste_virtual_display~+*/
unsigned long int smg$paste_virtual_display(
    const unsigned long int  *display_id,
    const unsigned long int  *pasteboard_id,
    const long int  *pasteboard_row,
    const long int  *pasteboard_column,
    ...
    /* const unsigned long int  *top_display_id */
    ) ;
/*~-smg$paste_virtual_display-~*/
/*+~smg$put_chars~+*/
unsigned long int smg$put_chars(
    const unsigned long int  *display_id,
    const struct dsc$descriptor *text,
    ...
    /* const long int  *start_row, */
    /* const long int  *start_column, */
    /* const unsigned long int  *flags, */
    /* const unsigned long int  *rendition_set, */
    /* const unsigned long int  *rendition_complement, */
    /* const unsigned long int  *character_set */
    ) ;
/*~-smg$put_chars-~*/
/*+~smg$put_chars_highwide~+*/
unsigned long int smg$put_chars_highwide(
    const unsigned long int  *display_id,
    const struct dsc$descriptor *text,
    ...
    /* const long int  *start_row, */
    /* const long int  *start_column, */
    /* const unsigned long int  *rendition_set, */
    /* const unsigned long int  *rendition_complement, */
    /* const unsigned long int  *character_set */
    ) ;
/*~-smg$put_chars_highwide-~*/
/*+~smg$put_chars_wide~+*/
unsigned long int smg$put_chars_wide(
    const unsigned long int  *display_id,
    const struct dsc$descriptor *text,
    ...
    /* const long int  *start_row, */
    /* const long int  *start_column, */
    /* const unsigned long int  *rendition_set, */
    /* const unsigned long int  *rendition_complement, */
    /* const unsigned long int  *character_set */
    ) ;
/*~-smg$put_chars_wide-~*/
/*+~smg$put_line~+*/
unsigned long int smg$put_line(
    const unsigned long int  *display_id,
    const struct dsc$descriptor *text,
    ...
    /* const long int  *line_advance, */
    /* const unsigned long int  *rendition_set, */
    /* const unsigned long int  *rendition_complement, */
    /* const unsigned long int  *flags, */
    /* const unsigned long int  *character_set, */
    /* const unsigned long int  *direction */
    ) ;
/*~-smg$put_line-~*/
/*+~smg$put_line_highwide~+*/
unsigned long int smg$put_line_highwide(
    const unsigned long int  *display_id,
    const struct dsc$descriptor *text,
    ...
    /* const long int  *line_advance, */
    /* const unsigned long int  *rendition_set, */
    /* const unsigned long int  *rendition_complement, */
    /* const unsigned long int  *flags, */
    /* const unsigned long int  *character_set */
    ) ;
/*~-smg$put_line_highwide-~*/
/*+~smg$put_line_wide~+*/
unsigned long int smg$put_line_wide(
    const unsigned long int  *display_id,
    const struct dsc$descriptor *text,
    ...
    /* const long int  *line_advance, */
    /* const unsigned long int  *rendition_set, */
    /* const unsigned long int  *rendition_complement, */
    /* const unsigned long int  *flags, */
    /* const unsigned long int  *character_set */
    ) ;
/*~-smg$put_line_wide-~*/
/*+~smg$pop_virtual_display~+*/
unsigned long int smg$pop_virtual_display(
    const unsigned long int  *display_id,
    const unsigned long int  *pasteboard_id
    ) ;
/*~-smg$pop_virtual_display-~*/
/*+~smg$put_pasteboard~+*/
unsigned long int smg$put_pasteboard(
    const unsigned long int  *pasteboard_id,
    const int *action_routine,
    const int  *varying_user_argument,
    const unsigned long int  *flags
    ) ;
/*~-smg$put_pasteboard-~*/
/*+~smg$put_virtual_display_encoded~+*/
unsigned long int smg$put_virtual_display_encoded(
    const unsigned long int  *display_id,
    const long int  *encoded_length,
    const int  *encoded_text,
    ...
    /* const long int  *start_row, */
    /* const long int  *start_column, */
    /* const unsigned long int  *placeholder_argument, */
    /* const unsigned long int  *character_set */
    ) ;
/*~-smg$put_virtual_display_encoded-~*/
/*+~smg$ring_bell~+*/
unsigned long int smg$ring_bell(
    const unsigned long int  *display_id,
    ...
    /* const long int  *number_of_times */
    ) ;
/*~-smg$ring_bell-~*/
/*+~smg$read_composed_line~+*/
unsigned long int smg$read_composed_line(
    const unsigned long int  *keyboard_id,
    const unsigned long int  *key_table_id,
    struct dsc$descriptor *resultant_string,
    ...
    /* const struct dsc$descriptor *prompt_string, */
    /* unsigned short int  *resultant_length, */
    /* const unsigned long int  *display_id, */
    /* const unsigned long int  *flags, */
    /* const struct dsc$descriptor *initial_string, */
    /* const long int  *timeout, */
    /* const unsigned long int  *rendition_set, */
    /* const unsigned long int  *rendition_complement, */
    /* unsigned short int  *word_integer_terminator_code */
    ) ;
/*~-smg$read_composed_line-~*/
/*+~smg$replace_input_line~+*/
unsigned long int smg$replace_input_line(
    const unsigned long int  *keyboard_id,
    ...
    /* const struct dsc$descriptor *resultant_string, */
    /* const unsigned char  *line_count */
    ) ;
/*~-smg$replace_input_line-~*/
/*+~smg$return_input_line~+*/
unsigned long int smg$return_input_line(
    const unsigned long int  *keyboard_id,
    struct dsc$descriptor *resultant_string,
    ...
    /* const struct dsc$descriptor *match_string, */
    /* const unsigned char  *byte_integer_line_number, */
    /* unsigned short int  *resultant_length */
    ) ;
/*~-smg$return_input_line-~*/
/*+~smg$read_from_display~+*/
unsigned long int smg$read_from_display(
    const unsigned long int  *display_id,
    struct dsc$descriptor *resultant_string,
    ...
    /* const struct dsc$descriptor *terminator_string, */
    /* const long int  *start_row */
    ) ;
/*~-smg$read_from_display-~*/
/*+~smg$read_keystroke~+*/
unsigned long int smg$read_keystroke(
    const unsigned long int  *keyboard_id,
    unsigned short int  *word_integer_terminator_code,
    ...
    /* const struct dsc$descriptor *prompt_string, */
    /* const long int  *timeout, */
    /* const unsigned long int  *display_id, */
    /* const unsigned long int  *rendition_set, */
    /* const unsigned long int  *rendition_complement */
    ) ;
/*~-smg$read_keystroke-~*/
/*+~smg$repaint_line~+*/
unsigned long int smg$repaint_line(
    const unsigned long int  *pasteboard_id,
    const long int  *start_row,
    ...
    /* const long int  *number_of_lines */
    ) ;
/*~-smg$repaint_line-~*/
/*+~smg$repaint_screen~+*/
unsigned long int smg$repaint_screen(
    const unsigned long int  *pasteboard_id
    ) ;
/*~-smg$repaint_screen-~*/
/*+~smg$repaste_virtual_display~+*/
unsigned long int smg$repaste_virtual_display(
    const unsigned long int  *display_id,
    const unsigned long int  *pasteboard_id,
    const long int  *pasteboard_row,
    const long int  *pasteboard_column,
    ...
    /* const unsigned long int  *top_display_id */
    ) ;
/*~-smg$repaste_virtual_display-~*/
/*+~smg$restore_physical_screen~+*/
unsigned long int smg$restore_physical_screen(
    const unsigned long int  *pasteboard_id,
    const unsigned long int  *display_id
    ) ;
/*~-smg$restore_physical_screen-~*/
/*+~smg$read_string~+*/
unsigned long int smg$read_string(
    const unsigned long int  *keyboard_id,
    struct dsc$descriptor *resultant_string,
    ...
    /* const struct dsc$descriptor *prompt_string, */
    /* const long int  *maximum_length, */
    /* const unsigned long int  *modifiers, */
    /* const long int  *timeout, */
    /* const int  *terminator_set, */
    /* unsigned short int  *resultant_length, */
    /* unsigned short int  *word_integer_terminator_code, */
    /* const unsigned long int  *display_id, */
    /* const struct dsc$descriptor *initial_string, */
    /* const unsigned long int  *rendition_set, */
    /* const unsigned long int  *rendition_complement */
    ) ;
/*~-smg$read_string-~*/
/*+~smg$return_cursor_pos~+*/
unsigned long int smg$return_cursor_pos(
    const unsigned long int  *display_id,
    long int  *start_row,
    long int  *start_column
    ) ;
/*~-smg$return_cursor_pos-~*/
/*+~smg$read_verify~+*/
unsigned long int smg$read_verify(
    const unsigned long int  *keyboard_id,
    struct dsc$descriptor *resultant_string,
    const struct dsc$descriptor *initial_string,
    const struct dsc$descriptor *picture_string,
    const struct dsc$descriptor *fill_character,
    const struct dsc$descriptor *clear_character,
    ...
    /* const struct dsc$descriptor *prompt_string, */
    /* const unsigned long int  *modifiers, */
    /* const long int  *timeout, */
    /* const int  *terminator_set, */
    /* const long int  *initial_offset, */
    /* unsigned short int  *word_integer_terminator_code, */
    /* const unsigned long int  *display_id, */
    /* const struct dsc$descriptor *alternate_echo_string, */
    /* const long int  *alternate_display_id, */
    /* const unsigned long int  *rendition_set, */
    /* const unsigned long int  *rendition_complement */
    ) ;
/*~-smg$read_verify-~*/
/*+~smg$set_broadcast_trapping~+*/
unsigned long int smg$set_broadcast_trapping(
    const unsigned long int  *pasteboard_id,
    ...
    /* const int *ast_routine, */
    /* const unsigned long int ast_argument */
    ) ;
/*~-smg$set_broadcast_trapping-~*/
/*+~smg$scroll_display_area~+*/
unsigned long int smg$scroll_display_area(
    const unsigned long int  *display_id,
    const long int  *start_row,
    const long int  *start_column,
    ...
    /* const long int  *height, */
    /* const long int  *width, */
    /* const unsigned long int  *direction, */
    /* const long int  *count */
    ) ;
/*~-smg$scroll_display_area-~*/
/*+~smg$set_cursor_abs~+*/
unsigned long int smg$set_cursor_abs(
    const unsigned long int  *display_id,
    ...
    /* const long int  *start_row, */
    /* const long int  *start_column */
    ) ;
/*~-smg$set_cursor_abs-~*/
/*+~smg$set_cursor_rel~+*/
unsigned long int smg$set_cursor_rel(
    const unsigned long int  *display_id,
    ...
    /* const long int  *delta_row, */
    /* const long int  *delta_column */
    ) ;
/*~-smg$set_cursor_rel-~*/
/*+~smg$set_display_scroll_region~+*/
unsigned long int smg$set_display_scroll_region(
    const unsigned long int  *display_id,
    ...
    /* const long int  *start_row, */
    /* const long int  *end_row */
    ) ;
/*~-smg$set_display_scroll_region-~*/
/*+~smg$set_cursor_mode~+*/
unsigned long int smg$set_cursor_mode(
    const unsigned long int  *pasteboard_id
    ) ;
/*~-smg$set_cursor_mode-~*/
/*+~smg$set_keypad_mode~+*/
unsigned long int smg$set_keypad_mode(
    const unsigned long int  *keyboard_id,
    const unsigned long int  *flags
    ) ;
/*~-smg$set_keypad_mode-~*/
/*+~smg$snapshot~+*/
unsigned long int smg$snapshot(
    const unsigned long int  *pasteboard_id,
    ...
    /* const unsigned long int  *flags */
    ) ;
/*~-smg$snapshot-~*/
/*+~smg$set_out_of_band_asts~+*/
unsigned long int smg$set_out_of_band_asts(
    const unsigned long int  *pasteboard_id,
    const unsigned long int  *control_character_mask,
    const int *ast_routine,
    ...
    /* const unsigned long int ast_argument */
    ) ;
/*~-smg$set_out_of_band_asts-~*/
/*+~smg$set_physical_cursor~+*/
unsigned long int smg$set_physical_cursor(
    const unsigned long int  *pasteboard_id,
    const long int  *pasteboard_row,
    const long int  *pasteboard_column
    ) ;
/*~-smg$set_physical_cursor-~*/
/*+~smg$set_default_state~+*/
unsigned long int smg$set_default_state(
    const unsigned long int  *key_table_id,
    ...
    /* const struct dsc$descriptor *new_state, */
    /* struct dsc$descriptor *old_state */
    ) ;
/*~-smg$set_default_state-~*/
/*+~smg$save_physical_screen~+*/
unsigned long int smg$save_physical_screen(
    const unsigned long int  *pasteboard_id,
    unsigned long int  *display_id,
    ...
    /* const long int  *desired_start_row, */
    /* const long int  *desired_end_row */
    ) ;
/*~-smg$save_physical_screen-~*/
/*+~smg$unpaste_virtual_display~+*/
unsigned long int smg$unpaste_virtual_display(
    const unsigned long int  *display_id,
    const unsigned long int  *pasteboard_id
    ) ;
/*~-smg$unpaste_virtual_display-~*/
#endif
