/* Created by SDL V3.1-7     */
/* Source:  8-AUG-1988 10:33:04 EMULEX$DISK:[MEADOWS.UNSDL.VMS5-0_H]STARDEFAE.S */
#ifndef $ACCDEF_H
#define $ACCDEF_H
 
/*** MODULE $ACCDEF ***/
#define ACC$K_TERMLEN 84        /* TERMINATION MESSAGE LENGTH                 */
#define ACC$C_TERMLEN 84        /* TERMINATION MESSAGE LENGTH                 */
/* AND ACCOUNTING RECORD FOR NON BATCH JOBS                                   */
#define ACC$K_JOB_LEN 108       /* LENGTH OF BATCH JOB ACCOUNTING RECORD      */
#define ACC$C_JOB_LEN 108       /* LENGTH OF BATCH JOB ACCOUNTING RECORD      */
struct accdef {
    unsigned short int acc$w_msgtyp;    /* MESSAGE TYPE CODE                  */
    unsigned short int acc$w_msgsiz;    /* LENGTH OF DATA MESSAGE (VALID ONLY IN ACCLOG)      */
    unsigned long int acc$l_finalsts;   /* FINAL EXIT STATUS                  */
    unsigned long int acc$l_pid;        /* PROCESS ID                         */
    unsigned long int acc$l_jobid;      /* JOB IDENTIFICATION (VALID ONLY IN ACCLOG)  */
    unsigned int acc$q_termtime [2];    /* TERMINATION TIME (100NS UNITS)     */
    char acc$t_account [8];     /* ACCOUNT NAME STRING (BLANK FILLED)         */
    char acc$t_username [12];   /* USER NAME STRING (BLANK FILLED)            */
    unsigned long int acc$l_cputim;     /* CPUTIM IN 10MS UNITS               */
    unsigned long int acc$l_pageflts;   /* TOTAL PAGE FAULTS                  */
    unsigned long int acc$l_pgflpeak;   /* PEAK PAGING FILE USAGE             */
    unsigned long int acc$l_wspeak;     /* PEAK WORKING SET SIZE              */
    unsigned long int acc$l_biocnt;     /* COUNT OF BUFFERED I/O OPERATIONS   */
    unsigned long int acc$l_diocnt;     /* COUNT OF DIRECT I/O OPERATIONS     */
    unsigned long int acc$l_volumes;    /* COUNT OF VOLUMES MOUNTED           */
    unsigned int acc$q_login [2];       /* LOGIN TIME (100NS UNITS)           */
    unsigned long int acc$l_owner;      /* PID OF SUBPROCESS OWNER            */
/* END OF TERMINATION MESSAGE                                                 */
    char acc$t_job_name [8];    /* JOB NAME (BLANK FILLED)                    */
    char acc$t_job_que [16];    /* QUEUE NAME (.ASCIC)                        */
} ;
#define ACC$K_PRT_LEN 88        /* LENGTH OF PRINT ACCOUNTING RECORD          */
#define ACC$C_PRT_LEN 88        /* LENGTH OF PRINT ACCOUNTING RECORD          */
/*                                                                            */
struct accdef1 {
    char accdef$$_fill_1 [48];
    unsigned long int acc$l_pagcnt;     /* SYMBIONT PAGE COUNT                */
    unsigned long int acc$l_qiocnt;     /* SYMBIONT QIO COUNT                 */
    unsigned long int acc$l_getcnt;     /* SYMBIONT GET COUNT                 */
    unsigned int acc$q_quetime [2];     /* TIME JOB WAS QUEUED                */
    char acc$t_prt_name [8];    /* NAME OF PRINT JOB                          */
    char acc$t_prt_que [12];    /* NAME OF PRINT QUEUE                        */
/* DEFINE USER ACCOUNTING MESSAGE DATA AREA                                   */
/*                                                                            */
} ;
#define ACC$K_INS_LEN 176       /* LENGTH OF INSERT MESSAGE                   */
#define ACC$C_INS_LEN 176       /* LENGTH OF INSERT MESSAGE                   */
/*                                                                            */
#define ACC$K_PRCTRM 1  /* JOB TERMINATION                                    */
#define ACC$K_BATTRM 2  /* BATCH JOB TERMINATION                              */
#define ACC$K_INTTRM 3  /* INTERACTIVE JOB TERMINATION                        */
#define ACC$K_LOGTRM 4  /* LOGIN FAILURE PROCESS TERMINATION                  */
#define ACC$K_IMGTRM 5  /* IMAGE TERMINATION                                  */
#define ACC$K_SUBTRM 6  /* SUBPROCESS TERMINATION                             */
#define ACC$K_DETTRM 7  /* DETACHED PROCESS TERMINATION                       */
#define ACC$K_NETTRM 8  /* NETWORK PROCESS TERMINATION                        */
/* MISC ACCOUNTING RECORDS                                                    */
#define ACC$K_PRTJOB 16 /* PRINT JOB ACCOUNTING                               */
#define ACC$K_INSMSG 17 /* INSERTED MESSAGE                                   */
/*                                                                            */
#define ACC$K_INSMESG 1 /* INSERT MESSAGE INTO ACCOUNTING FILE                */
#define ACC$K_NEWFILE 2 /* CREATE A NEW ACCOUNT FILE                          */
#define ACC$K_ENABACC 3 /* ENABLE ACCOUNTING                                  */
#define ACC$K_DISAACC 4 /* DISABLE ACCOUNTING                                 */
#define ACC$K_ENABSEL 5 /* ENABLE SELECTIVE ACCOUNTING                        */
#define ACC$K_DISASEL 6 /* DISABLE SELECTIVE ACCOUNTING                       */
struct accdef2 {
    char accdef$$_fill_2 [44];
    char acc$t_user_data [132]; /* ALLOW UP TO 132 BYTES OF USER DATA         */
/* ASSIGN RECORD TYPE CODES FOR RECORDS IN THE ACCOUNT LOG FILE               */
/*                                                                            */
/* PROCESS ACCOUNTING RECORDS                                                 */
/* DEFINE ACCOUNTING MANAGER MESSAGE CODES                                    */
/*                                                                            */
/*                                                                            */
} ;
#endif
