/* Created by SDL V3.1-7     */
/* Source:  8-AUG-1988 10:33:04 EMULEX$DISK:[MEADOWS.UNSDL.VMS5-0_H]STARDEFAE.S */
#ifndef $DEVDEF_H
#define $DEVDEF_H
 
/*** MODULE $DEVDEF ***/
/*                                                                            */
/*  THE FOLLOWING BITS DEFINE THE DEVICE CHARACTERISTICS FOR                  */
/*  BOTH THE UCBS AND RMS.                                                    */
/*                                                                            */
#define DEV$M_REC 0x00000001
#define DEV$M_CCL 0x00000002
#define DEV$M_TRM 0x00000004
#define DEV$M_DIR 0x00000008
#define DEV$M_SDI 0x00000010
#define DEV$M_SQD 0x00000020
#define DEV$M_SPL 0x00000040
#define DEV$M_OPR 0x00000080
#define DEV$M_RCT 0x00000100
#define DEV$M_NET 0x00002000
#define DEV$M_FOD 0x00004000
#define DEV$M_DUA 0x00008000
#define DEV$M_SHR 0x00010000
#define DEV$M_GEN 0x00020000
#define DEV$M_AVL 0x00040000
#define DEV$M_MNT 0x00080000
#define DEV$M_MBX 0x00100000
#define DEV$M_DMT 0x00200000
#define DEV$M_ELG 0x00400000
#define DEV$M_ALL 0x00800000
#define DEV$M_FOR 0x01000000
#define DEV$M_SWL 0x02000000
#define DEV$M_IDV 0x04000000
#define DEV$M_ODV 0x08000000
#define DEV$M_RND 0x10000000
#define DEV$M_RTM 0x20000000
#define DEV$M_RCK 0x40000000
#define DEV$M_WCK 0x80000000
#define DEV$M_CLU 0x00000001
#define DEV$M_DET 0x00000002
#define DEV$M_RTT 0x00000004
#define DEV$M_CDP 0x00000008
#define DEV$M_2P 0x00000010
#define DEV$M_MSCP 0x00000020
#define DEV$M_SSM 0x00000040
#define DEV$M_SRV 0x00000080
#define DEV$M_RED 0x00000100
#define DEV$M_NNM 0x00000200
#define DEV$M_WBC 0x00000400
#define DEV$M_WTC 0x00000800
#define DEV$M_HOC 0x00001000
#define DEV$M_LOC 0x00002000
union devdef {
    struct {
        unsigned dev$v_rec : 1; /* DEVICE RECORD ORIENTED                     */
        unsigned dev$v_ccl : 1; /* CARRIAGE CONTROL DEVICE                    */
        unsigned dev$v_trm : 1; /* DEVICE IS A TERMINAL                       */
        unsigned dev$v_dir : 1; /* DEVICE IS DIRECTORY STRUCTURED             */
        unsigned dev$v_sdi : 1; /* DEVICE IS SINGLE DIRECTORY STRUCTURED      */
        unsigned dev$v_sqd : 1; /* SEQUENTIAL BLOCK-ORIENTED DEVICE (I.E., MAGTAPE)   */
        unsigned dev$v_spl : 1; /* DEVICE BEING SPOOLED                       */
        unsigned dev$v_opr : 1; /* DEVICE IS AN OPERATOR                      */
        unsigned dev$v_rct : 1; /* DISK CONTAINS RCT (DEC STANDARD 166 DISK)  */
        unsigned devdef$$_fill_1 : 4;   /* SPARES TO CORRESPOND WITH RSX11M   */
        unsigned dev$v_net : 1; /* NETWORK DEVICE                             */
        unsigned dev$v_fod : 1; /* FILES-ORIENTED DEVICE (I.E., DISK AND MT)  */
        unsigned dev$v_dua : 1; /* DEVICE IS DUAL PORTED                      */
        unsigned dev$v_shr : 1; /* DEVICE SHAREABLE                           */
        unsigned dev$v_gen : 1; /* DEVICE IS A GENERIC DEVICE                 */
        unsigned dev$v_avl : 1; /* DEVICE AVAILABLE FOR USE                   */
        unsigned dev$v_mnt : 1; /* DEVICE IS MOUNTED                          */
        unsigned dev$v_mbx : 1; /* DEVICE IS A MAILBOX                        */
        unsigned dev$v_dmt : 1; /* DEVICE MARKED FOR DISMOUNT                 */
        unsigned dev$v_elg : 1; /* DEVICE HAS ERROR LOGGING ENABLED           */
        unsigned dev$v_all : 1; /* DEVICE IS ALLOCATED                        */
        unsigned dev$v_for : 1; /* DEVICE IS MOUNTED FOREIGN (I.E., NON-FILE STRUCTURED)      */
        unsigned dev$v_swl : 1; /* DEVICE IS SOFTWARE WRITE LOCKED            */
        unsigned dev$v_idv : 1; /* DEVICE CAPABLE OF PROVIDING INPUT          */
        unsigned dev$v_odv : 1; /* DEVICE CAPABLE OF PROVIDING OUTPUT         */
        unsigned dev$v_rnd : 1; /* DEVICE ALLOWS RANDOM ACCESS                */
        unsigned dev$v_rtm : 1; /* DEVICE IS REALTIME IN NATURE               */
        unsigned dev$v_rck : 1; /* DEVICE HAS READ CHECKING ENABLED           */
        unsigned dev$v_wck : 1; /* DEVICE HAS WRITE CHECKING ENABLED          */
        } dev$r_devdef_bits0;
    struct {
        unsigned dev$v_clu : 1; /* DEVICE IS AVAILABLE CLUSTER-WIDE           */
        unsigned dev$v_det : 1; /* DEVICE IS DETACHED TERMINAL                */
        unsigned dev$v_rtt : 1; /* DEVICE HAS REMOTE TERMINAL UCB EXTENSION   */
        unsigned dev$v_cdp : 1; /* DUAL PATH DEVICE WITH 2 UCBs               */
        unsigned dev$v_2p : 1;  /* TWO PATHS ARE KNOWN TO THIS DEVICE         */
        unsigned dev$v_mscp : 1;        /* DEVICE ACCESSED USING MSCP (disk or tape)  */
        unsigned dev$v_ssm : 1; /* DEVICE IS A SHADOW SET MEMBER              */
        unsigned dev$v_srv : 1; /* DEVICE IS SERVED VIA THE MSCP SERVER       */
        unsigned dev$v_red : 1; /* DEVICE IS redirected terminal              */
        unsigned dev$v_nnm : 1; /* DEVICE HAS "node$" PREFIX                  */
        unsigned dev$v_wbc : 1; /* DEVICE SUPPORTS WRITE-BACK CACHING         */
        unsigned dev$v_wtc : 1; /* DEVICE SUPPORTS WRITE-THROUGH CACHING      */
        unsigned dev$v_hoc : 1; /* DEVICE SUPPORTS HOST CACHING               */
        unsigned dev$v_loc : 1; /* DEVICE ACCESSIBLE VIA LOCAL (NON-EMULATED) CONTROLLER      */
        unsigned dev$v_fill_27 : 2;
        } dev$r_devdef_bits1;
} ;
#endif
