/* Created by SDL V3.1-7     */
/* Source:  8-AUG-1988 10:36:21 EMULEX$DISK:[MEADOWS.UNSDL.VMS5-0_H]STARDEFMP.S */
#ifndef $MTDEF_H
#define $MTDEF_H
 
/*** MODULE $MTDEF ***/
/*+                                                                           */
/* MAGTAPE STATUS BITS                                                        */
/*-                                                                           */
#define MT$M_SEREXCP 0x00000001
#define MT$M_ENAUTOPACK 0x00000002
#define MT$M_ENSEREXCP 0x00000004
#define MT$M_PARITY 0x00000008
#define MT$M_FORMAT 0x000000F0
#define MT$M_DENSITY 0x00001F00
#define MT$M_LOGSOFT 0x00004000
#define MT$M_LOGSOFTOG 0x00008000
#define MT$M_BOT 0x00010000
#define MT$M_EOF 0x00020000
#define MT$M_EOT 0x00040000
#define MT$M_HWL 0x00080000
#define MT$M_LOST 0x00100000
#define MT$M_SUP_NRZI 0x00200000
#define MT$M_SUP_PE 0x00400000
#define MT$M_SUP_GCR 0x00800000
#define MT$M_SPEED 0xFF000000
#define MT$K_DEFAULT 0  /* DEFAULT FORMAT                                     */
#define MT$K_NORMAL11 12        /* PDP-11 NORMAL                              */
#define MT$K_CORDMP11 13        /* PDP-11 CORE DUMP                           */
#define MT$K_NORMAL15 14        /* PDP-15 NORMAL                              */
/*                                                                            */
#define MT$K_NRZI_800 3 /* NRZI 800 BPI                                       */
#define MT$K_PE_1600 4  /* PE 1600 BPI                                        */
#define MT$K_GCR_6250 5 /* GCR 6250 BPI                                       */
#define MT$K_WOD_6250 8 /* RV80 6250 BPI EQUIVALENT                           */
#define MT$K_HPC_40K 12 /* HPC 39872 BPI                                      */
#define MT$K_BLK_833 17 /* BLOCK (TK50) 833 BPI                               */
#define MT$K_BLK_1250 18        /* BLOCK (TK70) 1250 BPI                      */
/*                                                                            */
#define MT$K_SPEED_DEF 0        /* DEFAULT SPEED                              */
#define MT$K_SPEED_25 25        /* 25 IPS                                     */
#define MT$K_SPEED_75 75        /* 75 IPS                                     */
union mtdef {
    struct {
        unsigned mt$v_serexcp : 1;      /* SERIOUS EXCEPTION PRESENT          */
        unsigned mt$v_enautopack : 1;   /* ENABLE AUTO PACKACK                */
        unsigned mt$v_enserexcp : 1;    /* ENABLE SERIOUS EXCEPTION MODE      */
        unsigned mt$v_parity : 1;       /* PARITY SELECT (0=ODD, 1=EVEN)      */
        unsigned mt$v_format : 4;       /* RECORDING FORMAT                   */
        unsigned mt$v_density : 5;      /* RECORDING DENSITY AND METHOD       */
        unsigned mtdef$$_fill_2 : 1;    /* SPARE UNUSED BIT                   */
        unsigned mt$v_logsoft : 1;      /* LOG SOFT (TU78) ERRORS (0=NO, 1=YES)       */
        unsigned mt$v_logsoftog : 1;    /* TOGGLE TO REVERSE LOGSOFT STATE BIT        */
        unsigned mt$v_bot : 1;  /* AT BEGINNING OF TAPE                       */
        unsigned mt$v_eof : 1;  /* AT END OF FILE                             */
        unsigned mt$v_eot : 1;  /* AT END OF TAPE                             */
        unsigned mt$v_hwl : 1;  /* TAPE IS HARDWARE WRITELOCKED               */
        unsigned mt$v_lost : 1; /* TAPE POSITION LOST                         */
        unsigned mt$v_sup_nrzi : 1;     /* DRIVE SUPPORTS NRZI (800 BPI)      */
        unsigned mt$v_sup_pe : 1;       /* DRIVE SUPPORTS PE (1600 BPI)       */
        unsigned mt$v_sup_gcr : 1;      /* DRIVE SUPPORTS GCR (6250 BPI)      */
        unsigned mt$v_speed : 8;        /* TAPE SPEED                         */
        } mt$r_mtdef_bits;
/*                                                                            */
/* RECORDING FORMAT DEFINTIONS                                                */
/*                                                                            */
/*                                                                            */
/* RECORDING DENSITY AND METHOD DEFINITIONS                                   */
/*                                                                            */
/*      Default  0                                                            */
/*      9 Track  1 - 7                                                        */
/*      Optical Disk     8 - 11                                               */
/*      High Performance Cartridge      12 - 15                               */
/*      Block Mode      16 - 23                                               */
/*      Reserved24 - 31                                                       */
/*                                                                            */
/*                                                                            */
/*                DEFAULT,0                /* DEFAULT DENSITY (SAME AS ABOVE) */
/* TAPE SPEED VALUE DEFINITIONS                                               */
/*                                                                            */
} ;
#endif
