/* Created by SDL V3.1-7     */
/* Source:  8-AUG-1988 10:36:21 EMULEX$DISK:[MEADOWS.UNSDL.VMS5-0_H]STARDEFMP.S */
#ifndef $PR9CCDEF_H
#define $PR9CCDEF_H
 
/*** MODULE $PR9CCDEF ***/
#define PR9CC$_ICCS 24  /* Interval Clock Control/Status                      */
#define PR9CC$_TODR 27  /* Time of Year Clock                                 */
#define PR9CC$_RXCS 32  /* Console Receiver Control/Status                    */
#define PR9CC$_RXDB 33  /* Console Receiver Data Buffer                       */
#define PR9CC$_TXCS 34  /* Console Transmit Control/Status                    */
#define PR9CC$_TXDB 35  /* Console Transmit Data Buffer                       */
#define PR9CC$_CADR 37  /* Cache Disable Register                             */
#define PR9CC$_MSER 39  /* Memory System Error                                */
#define PR9CC$_SAVPC 42 /* Console SAVED PC                                   */
#define PR9CC$_SAVPSL 43        /* Console SAVED PSL                          */
#define PR9CC$_SID 62   /* System Identification Register                     */
#define PR9CC$M_DIAG 0x00000001
#define PR9CC$M_WRONG_PARITY 0x00000002
#define PR9CC$M_D_STREAM 0x00000010
#define PR9CC$M_I_STREAM 0x00000020
#define PR9CC$M_ENAB_SET1 0x00000040
#define PR9CC$M_ENAB_SET2 0x00000080
#define PR9CC$M_TAG 0x00000001
#define PR9CC$M_DAT 0x00000002
#define PR9CC$M_ST1 0x00000004
#define PR9CC$M_ST2 0x00000008
#define PR9CC$M_MCC 0x00000010
#define PR9CC$M_MCD 0x00000020
#define PR9CC$M_DAL 0x00000040
#define PR9CC$M_HM 0x00000080
union pr9ccdef {
    struct {    /* Cache Disable Register                                     */
        unsigned pr9cc$v_diag : 1;      /* Diagnostic Mode                    */
        unsigned pr9cc$v_wrong_parity : 1;      /* Write Wrong Parity         */
        unsigned pr9cc$$_fill_1 : 2;    /*                                    */
        unsigned pr9cc$v_d_stream : 1;  /* Store D-Stream in cache            */
        unsigned pr9cc$v_i_stream : 1;  /* Store I-Stream in cache            */
        unsigned pr9cc$v_enab_set1 : 1; /* Enable Set 1 of cache              */
        unsigned pr9cc$v_enab_set2 : 1; /* Enable Set 2 of cache              */
        } pr9cc$r_pr9cccadr_bits;
    struct {    /* Memory System Error Register                               */
        unsigned pr9cc$v_tag : 1;       /* Tag Parity Error                   */
        unsigned pr9cc$v_dat : 1;       /* Data Parity Error                  */
        unsigned pr9cc$v_st1 : 1;       /* Set 1 Parity Error                 */
        unsigned pr9cc$v_st2 : 1;       /* Set 2 Parity Error                 */
        unsigned pr9cc$v_mcc : 1;       /* Machine Check/Cache parity         */
        unsigned pr9cc$v_mcd : 1;       /* Machine Check/DAL parity           */
        unsigned pr9cc$v_dal : 1;       /* DAL parity error                   */
        unsigned pr9cc$v_hm : 1;        /* Hit/Miss                           */
        } pr9cc$r_pr9ccmser_bits;
    struct {    /* System Identification Register                             */
        unsigned pr9cc$v_sid_cvaxrev : 8;       /*  CVAX chip microcode revision level        */
        } pr9cc$r_pr9ccsid_bits;
    struct {    /* XSID (SYS_TYPE) Register                                   */
        unsigned pr9cc$v_reserved : 16; /* Bits 15:0 reserved for future use  */
        unsigned pr9cc$v_xsid_xcpfwrev : 8;     /*  XCP firmware revision level       */
        } pr9cc$r_pr9ccxsid_bits;
} ;
#endif
