#ifndef ITMLST_H
/******************************************************************************
*******************************************************************************

   Installation:  Western Michigan University Academic Computer Center

   System:  General Purpose Headers
  
   Header name:  itmlst

   Version=01   Level=01           12/04/86  JoAnne M. Hernandez

   Purpose:  Contains a typedef of a structure tag for item lists.

   Other information:  none

********************************************************************************
*******************************************************************************/

#define ITMLST_H 1			/* to prevent multiple inclusion      */

/******************************************************************************/
/*                                                                            */
/*                        # I N C L U D E   F I L E S                         */
/*                                                                            */
/******************************************************************************/

#ifdef WMUACC
#include utype				/* typedefs for unsigned types	      */
#else
#include "utype.h"
#endif

/******************************************************************************/
/*                                                                            */
/*                             # D E F I N E S                                */
/*                                                                            */
/******************************************************************************/


/******************************************************************************/
/*                                                                            */
/*          S T R U C T U R E S ,   U N I O N S ,   T Y P E D E F S           */
/*                                                                            */
/******************************************************************************/

typedef	 struct	  ITM_TYPE {
	 USHORT	  buf_len,
		  itm_code;
	 char 	  *buf_addr;
	 USHORT	  *ret_len;
} ITM_LST;

/******************************************************************************/
/*                                                                            */
/*   E X T E R N A L   D E F I N I T I O N S   &   D E C L A R A T I O N S    */
/*                                                                            */
/******************************************************************************/


/******************************************************************************/
/*                                                                            */
/*     S T A T I C   D E F I N I T I O N S   &   D E C L A R A T I O N S      */
/*                                                                            */
/******************************************************************************/

#endif
