#ifndef UTYPE_H
/******************************************************************************
*******************************************************************************

   Installation:  Western Michigan University Academic Computer Center

   System:  General Purpose Headers
  
   Header name:  utype

   Version=01   Level=01           12/01/86  Leonard J. Peirce

   Purpose:  Define typedefs for various sundry unsigned data types, ones that
	     C should have built-in but doesn't.

   Other information:  none

********************************************************************************
*******************************************************************************/

#define UTYPE_H 1			/* to prevent multiple inclusion      */

/******************************************************************************/
/*                                                                            */
/*                        # I N C L U D E   F I L E S                         */
/*                                                                            */
/******************************************************************************/


/******************************************************************************/
/*                                                                            */
/*                             # D E F I N E S                                */
/*                                                                            */
/******************************************************************************/


/******************************************************************************/
/*                                                                            */
/*          S T R U C T U R E S ,   U N I O N S ,   T Y P E D E F S           */
/*                                                                            */
/******************************************************************************/

typedef	 unsigned  int   UINT;		/* for unsigned integers	      */
typedef	 unsigned  long  ULONG;		/* for unsigned long integers	      */
typedef	 unsigned  short USHORT;	/* for unsigned short integers	      */
typedef	 unsigned  char  UCHAR;		/* for unsigned characters	      */
typedef	 unsigned  char  TINY;		/* more descriptive for using un-     */
					/* characters as integers	      */

/******************************************************************************/
/*                                                                            */
/*   E X T E R N A L   D E F I N I T I O N S   &   D E C L A R A T I O N S    */
/*                                                                            */
/******************************************************************************/


/******************************************************************************/
/*                                                                            */
/*     S T A T I C   D E F I N I T I O N S   &   D E C L A R A T I O N S      */
/*                                                                            */
/******************************************************************************/

#endif
