$	SAVE_IMAGE_VERIFY = F$ENVIRONMENT("VERIFY_IMAGE")
$	SAVE_PROC_VERIFY = F$VERIFY(0,0)
$!	SET VERIFY
$	FLAG = F$LOCATE("/F",P1)
$	WDTH = F$LENGTH(P1)
$	P1 = F$PARSE(F$EXTRACT(0,FLAG,P1),"*.*;*")
$	IF P1 .NES. "" THEN GOTO HAVFIL
$	WRITE SYS$OUTPUT -
	"%OLD-F-NODEVDIR, non-existent device or directory, or unmounted device"
$	GOTO EXIT
$HAVFIL:FLAG = FLAG .NE. WDTH
$	STAR = ""
$	IF FLAG THEN STAR = "* "
$	NOLD = 0
$	NTOT = 0
$	TOTAL = 0
$	ALLOC = 0
$	ACP = F$GETDVI(F$PARSE(P1,,,"DEVICE"),"ACPTYPE")
$	IF ACP .NES. "F11V2" THEN GOTO NOTODS2
$!
$! ODS-2 version. F$SEARCH returns files in required order.
$!
$	ON CONTROL_Y THEN GOTO DONE2
$	P4 = ""
$LOOK2:	P3 = F$SEARCH(P1)
$	IF P3 .EQS. "" THEN GOTO DONE2
$	NTOT = NTOT+1
$	P2 = F$ELEMENT(0,";",P3)
$	IF P2 .EQS. P4 THEN GOTO OLD2
$	P4 = P2
$	IF .NOT.FLAG THEN GOTO LOOK2
$	MARKER = "  "
$	GOTO SHOW2
$OLD2:	NOLD = NOLD+1
$	MARKER = STAR
$SHOW2:	EOF = F$FILE_ATTRIBUTES(P3,"EOF")
$	TOTAL = TOTAL+EOF
$	ALQ = F$FILE_ATTRIBUTES(P3,"ALQ")
$	ALLOC = ALLOC+ALQ
$	WRITE SYS$OUTPUT F$FAO("!AS!40AS    !6UL/!8<!UL!>!17AS",MARKER, -
		P3,EOF,ALQ,F$FILE_ATTRIBUTES(P3,"CDT"))
$	GOTO LOOK2
$DONE2:	WRITE SYS$OUTPUT F$FAO("!UL old file!%S out of !UL. !UL/!UL block!%S in old files", -
		NOLD,NTOT,TOTAL,ALLOC)
$	GOTO EXIT
$NOTODS2:IF ACP .EQS. "F11V1" .OR. ACP .EQS. "MTA" THEN GOTO ODS1
$	WRITE SYS$OUTPUT -
		"%OLD-F-NOTF11, device is not FILES-11, or is mounted FOREIGN"
$	GOTO EXIT
$!
$! Magtape or ODS-1 version. Files aren't in order -- put them into a file,
$! sort it, and repeat the above, except that filenames are read from file
$! instead of fetched by F$SEARCH directly.
$!
$ODS1:	ON WARNING THEN GOTO EXIT1
$	ON CONTROL_Y THEN GOTO EXIT1
$	TEMPS = 0
$	OPEN/WRITE DIR: SYS$SCRATCH:OLD.TMP
$	TEMPS = 1
$	WIDTH = 0
$GET1:	P2 = F$SEARCH(P1)
$	WDTH = F$LENGTH(P2)
$	IF WDTH .EQ. 0 THEN GOTO ENDG1
$	IF WDTH .GT. WIDTH THEN WIDTH = WDTH
$	SEMIC = F$LOCATE(";",P2)
$	WRITE DIR: F$FAO("!40AS!#* !AS",F$EXTRACT(0,SEMIC+1,P2),7-WDTH+SEMIC, -
		F$EXTRACT(SEMIC+1,6,P2))
$	GOTO GET1
$ENDG1:	CLOSE DIR:
$	P2 = F$PARSE("SYS$SCRATCH:OLD.TMP")
$	SEMIC = F$LOCATE(";",P2)
$	P4 = F$FAO("!40AS!#* !AS",F$EXTRACT(0,SEMIC+1,P2),7-WDTH+SEMIC, -
		F$EXTRACT(SEMIC+1,6,P2))
$	SORT/KEY=(POS:1,SIZ:40)/KEY=(POS:41,SIZ:6,DESC) -
		SYS$SCRATCH:OLD.TMP SYS$SCRATCH:OLD.TMP
$	TEMPS = 2
$	OPEN/READ DIR: SYS$SCRATCH:OLD.TMP
$	P1 = ""
$	IF ACP .EQS. "MTA" THEN GOTO MTAPE
$	P2 = F$PARSE("SYS$SCRATCH:OLD.TMP")
$	SEMIC = F$LOCATE(";",P2)
$	P5 = F$FAO("!40AS!#* !AS",F$EXTRACT(0,SEMIC+1,P2),7-WDTH+SEMIC, -
		F$EXTRACT(SEMIC+1,6,P2))
$	ON CONTROL_Y THEN GOTO DONE1
$LOOK1:	READ/END_OF_FILE=DONE1 DIR: P3
$	IF P3 .EQS. P4 .OR. P3 .EQS. P5 THEN GOTO LOOK1
$	NTOT = NTOT+1
$	P2 = F$ELEMENT(0,";",P3)
$	IF P2 .EQS. P1 THEN GOTO OLD1
$	P1 = P2
$	IF .NOT. FLAG THEN GOTO LOOK1
$	MARKER = "  "
$	GOTO SHOW1
$OLD1:	NOLD = NOLD+1
$	MARKER = STAR
$SHOW1:	EOF = F$FILE_ATTRIBUTES(P3,"EOF")
$	TOTAL = TOTAL+EOF
$	ALQ = F$FILE_ATTRIBUTES(P3,"ALQ")
$	ALLOC = ALLOC+ALQ
$	WRITE SYS$OUTPUT F$FAO("!AS!#AS    !6UL/!8<!UL!>!17AS",MARKER, -
		WIDTH,F$EDIT(P3,"COLLAPSE"),EOF,ALQ,F$FILE_ATTRIBUTES(P3,"CDT"))
$	GOTO LOOK1
$DONE1:	WRITE SYS$OUTPUT F$FAO("!UL old file!%S out of !UL. !UL/!UL block!%S in old files", -
		NOLD,NTOT,TOTAL,ALLOC)
$	GOTO EXIT1
$!
$! Reporting for magtape. As ODS-1, but no file sizes/dates, since this
$! involves re-reading the tape!
$!
$MTAPE:	ON CONTROL_Y THEN GOTO DONEM
$LOOKM:	READ/END_OF_FILE=DONEM DIR: P3
$	NTOT = NTOT+1
$	P2 = F$ELEMENT(0,";",P3)
$	IF P2 .EQS. P1 THEN GOTO OLDM
$	P1 = P2
$	IF .NOT. FLAG THEN GOTO LOOKM
$	MARKER = "  "
$	GOTO SHOWM
$OLDM:	NOLD = NOLD+1
$	MARKER = STAR
$SHOWM:	WRITE SYS$OUTPUT MARKER+F$EDIT(P3,"COLLAPSE")
$	GOTO LOOKM
$DONEM:	WRITE SYS$OUTPUT F$FAO("!UL old file!%S out of !UL",NOLD,NTOT)
$EXIT1:	CLOSE/ERROR=CLEAN DIR:
$CLEAN:	DELETE SYS$SCRATCH:OLD.TMP;0
$	TEMPS = TEMPS-1
$	IF TEMPS.GT.0 THEN GOTO CLEAN
$EXIT:	SAVE_PROC_VERIFY = F$VERIFY(SAVE_PROC_VERIFY,SAVE_IMAGE_VERIFY)
