C*****************************************************************
C
C	DEMO PROGRAM FOR SCREEN ROUTINES
C
C		LINK DEMO,GEN:SCRLIB/LIB
C
C	OR MAKE THE FOLLOWING ASSIGNMENT FOR DEFAULT LIBRARYS
C
C		ASSIGN GEN:SCRLIB.OLB LNK$LIBRARY
C		LINK DEMO		!LINKING WITH DEFAULT LIBRARIES
C
C******************************************************************
	PROGRAM DEMO
	LOGICAL*1 LOGMODE,FLAG,LOGKEY
	CHARACTER*80 CVAL,STRING*10
	COMMON /SCR_SCREEN_VALUE/ IVAL(50),RVAL(50),CVAL(50)
	EQUIVALENCE (RLARGE,RVAL(1))
	EQUIVALENCE (RBIGGEST,RVAL(2))
	EQUIVALENCE (RSMALL,RVAL(3))
	EQUIVALENCE (IBIG,IVAL(1))
	EQUIVALENCE (ISMALL,IVAL(2))
	EQUIVALENCE (STRING,CVAL(1))
	DATA RLARGE,RBIGGEST,RSMALL /100.23,1000.33, 43.7/
	DATA IBIG, ISMALL /500, 100/
	DATA STRING /'CHARACTER'/

C	---- OPEN SCREEN DEFINITION DATA FILE
	OPEN (UNIT=1,NAME='DEMO.DAT',TYPE='OLD',READONLY)
C
C	--- DISPLAY THIS DATA AND GET ANY MODIFICATIONS
	LOGMODE = .FALSE. 	! Enable insert mode
	LOGKEY  = .TRUE.	! Enable applications keypad
	ISEC    = 1		! First time, use screen section 1
	IUNIT   = 1
1	CALL SCR_SCRIN(ISEC, IUNIT, FLAG, LOGMODE, LOGKEY)
	IF (FLAG) STOP 'FATAL ERROR'
	CLOSE(UNIT=1)		! Other times, use the current section
	ISEC = -1		! This saves reading screen definition file

C	---- DO SOMETHING WITH THE DATA AND PROMPT FOR MORE DATA
	TYPE 5, RLARGE,RBIGGEST,RSMALL, IBIG, ISMALL, STRING
5	FORMAT(/////,1X'RLARGE: ',F12.3/
     &		1X,'RBIGGEST: ',F12.3/
     &		1X,'RSMALL: ',F12.3/
     &		1X,'IBIG: ',I8/
     &		1X,'ISMALL ',I8/
     &		1X,'STRING: ',A)


	TYPE 10
10	FORMAT(/1X,'*** SCREEN UTILITY DEMO PROGRAM ***',
     &		/1X,'INPUT REAL NUMBER (F10.3): ',$)
	READ *, RLARGE

	TYPE 20
20	FORMAT(/1X,'INPUT REAL NUMBER (F10.0): ',$)
	READ *, RBIGGEST

	TYPE 30
30	FORMAT(/1X,'INPUT REAL NUMBER (F8.2): ',$)
	READ *, RSMALL

	TYPE 40
40	FORMAT(/1X,'INPUT INTEGER NUMBER (I5): ',$)
	READ *, IBIG

	TYPE 50
50	FORMAT(/1X,'INPUT INTEGER NUMBER (I3): ',$)
	READ *,ISMALL

	TYPE 60
60	FORMAT(/1X,'INPUT CHARACTER (A10): ',$)
	READ 65,STRING
65	FORMAT(A)
	GOTO 1
	END
