$ SET PROCESS/PRIV=ALL
$ SET NOON
$!
$! This command file creates the Distribution kit for the
$! MA_Q software.
$!
$!
$! FAC=MAQ
$!  VV=VERSION
$!   U=UPDATE NUMBER
$!
$ FAC="MAQ"
$ VV="01"
$ U="0"
$!
$ INQ:
$ INQUIRE VV "Enter release number (default=1)"
$ IF VV .EQS. "" THEN VV="01"
$ IL=F$LENGTH(VV)
$ IF IL .GT 2 THEN GOTO INQ
$ IF IL .EQ. 2 THEN GOTO VER
$ VV="0" + VV
$!
$ VER:
$ INQUIRE U "Enter update version number (default=0)  "
$ IF U .EQS. "" THEN U="0"
$!
$ KITID= FAC+VV+U
$!
$ INQUIRE CREATE "Do you wish me to libr. update/assemble/compile first?"
$ IF CREATE .NES. "Y" THEN GOTO BLDKIT
$!
$! ASSEMBLE AND COMPILE EVERYTHING FOR THE DISTRIBUTION KIT
$!
$!
$ 	SET DEF SYS$LOGIN
$	SET DEF [.SUBROUTINES]
$	@SUBR.COM
$!
$ 	SET DEF SYS$LOGIN
$	SET DEF [.DEF]
$	@LBRUPDATE	! UPDATE THE MACRO AND TEXT LIBRARIES
$!
$ 	SET DEF SYS$LOGIN
$	SET DEF [.SYSSERV]
$	@SSDISP A
$	@MENU CAM
$!
$ 	SET DEF SYS$LOGIN
$	SET DEF [.CRUPD]
$	@QUEUE_CHKR CAM
$	@Q_UTL CAM
$	@SHUTDOWN_QUEUE CAM
$!
$ 	SET DEF SYS$LOGIN
$	SET DEF [.ROUTE]
$	@MA_ROUTER CAMV
$	@RTIN CAM
$	@RTOUT CAM
$	@NRBDMP CAM
$	@NETMSG CAM
$	@FIND_SERVICE CAM
$!
$ 	SET DEF SYS$LOGIN
$	SET DEF [.KIT]
$!
$! ACTUALLY BUILD THE KIT
$!
$ BLDKIT:
$ INQUIRE DEVICE "Enter target kit device (default MA_Q:[KIT.SAVESET]) "
$ IF DEVICE .EQS. "" THEN DEVICE= "MA_Q:[KIT.SAVESET]"
$ AVAIL=F$GETDVI(DEVICE,"AVL")
$ IF AVAIL .EQS. "FALSE" THEN GOTO NOGOOD
$!
$! PURGE ALL DIRECTORIES
$!
$ TYPE SYS$INPUT
	PURGING ALL DIRECTORIES AND DELETEING
	ALL: .LIS, .MAP, .MEM  FILES
$ SET DEFAULT MA_Q$PROD:
$ DELETE [...]*.LIS;*,*.MAP;*,*.MEM;*
$ PURGE [...]*.*/KEEP=1
$!
$ TYPE SYS$INPUT

	Copy files objects, macro/text definitions, and command
	files to this directory so can create a backup set.
$!
$!
$ SET DEF [MA_Q.KIT]
$ DELETE-
	/EXCLUDE=(SPKITBLD.COM,BLDMA_QKIT.COM,KITINSTAL.COM,*.SAV,*.DIR) -
	 *.*;*
$ DELETE [MA_Q.KIT.SAVESET]*.*;*
$!
$ COPY MA_Q$PROD:*.DAT;,*.COM; MA_Q:[KIT]
$ COPY MA_Q:[CRUPD]*.COM;,*.FOR;,*.INC;,*.MSG;,*.OBJ; MA_Q:[KIT]
$ COPY MA_Q:[DEF]*.COM;,*.MAR;,*.TXT;,*.TLB;,*.MLB;,*.MSG;,*.PL1; MA_Q:[KIT]
$ COPY MA_Q:[DOCUMENTATION]*.RNO;*,*.COM; MA_Q:[KIT]
$ COPY MA_Q:[ROUTE]*.FOR;,*.INC;,*.MSG;,*.COM;,*.OBJ;,*.MAR; MA_Q:[KIT]
$ COPY MA_Q:[SUBROUTINES]*.OLB MA_Q:[KIT]
$ COPY MA_Q:[SYSSERV]*.MAR;,*.COM;,*.FOR;,*.OBJ; MA_Q:[KIT]
$ COPY MA_Q:[DBS]*.EXE,*.FLB MA_Q:[KIT]
$ PURGE MA_Q:[KIT]*.*/KEEP=1
$!
$!
$ TYPE SYS$INPUT
	Creating the actual backup set on the device
	via the SPKITBLD command file.  
$!
$! NOW LETS CREATE THE BACKUP SET
$!
$ @MA_Q:[KIT]SPKITBLD 'KITID' 'DEVICE'  [MA_Q.KIT]*.*;
$!
$ TYPE SYS$INPUT
	DONE
$EXIT
$ NOGOOD:
$ TYPE SYS$INPUT
	The device name entered is not available for use.
$EXIT
