	integer*4 function AT_ADD(ADDRESS)
C.begin.doc ************************** begin.doc
C  
C .c ;MODULE
C .c ;^&AT_ADD\&
C .nf
C .x AT_ADD>Defined
C Source:AT_ADD.MOD
C Designer           :EARL LAKIA
C Author             :EARL LAKIA
C 	      Inland Steel
C             Process Automation Department
C             3210 Watling St.  MS 2-465
C             East Chicago, IN  46312
C  
C Date of last update:30-JUN-1986 12:20:10.97
C Revision level     :1.0
C  
C .C ;Formal Parameter List
C Receives:
C  
C  
C    ADDRESS                    INTEGER*4
C                               Contains address of element to be returned
C  
C Returns:
C  
C    AT_ADD                   INTEGER*4                                         
C                             RETURNS THE VALUE at the address
C  
C Accesses common(s):
C  
C Accesses file(s):
C  
C Other modules referenced:
C .SK
C .fill
C .SK
C Description:
C .sk    
C 	This is a simple subroutine to return the next value from
C the address passed.  In this application, the following is
C used:
C        SYS_STATUS=AT_ADD(%VAL(ROUTE_DBS(1)+4))
C 	This will return the second long word of the
c at the address contained in route_dbs.
c  
C end.doc ****************************** end.doc  

	integer*4 address	! nrb list
c
	AT_ADD=address
	RETURN
	END
