	SUBROUTINE CLRBIT(BITARY,IBIT)
C.begin.doc ************************** begin.doc
C  
C .c ;MODULE
C .c ;^&CLRBIT\&
C .nf
C .x CLRBIT>Defined
C Source:CLRBIT.MOD
C Designer           :EARL LAKIA
C Author             :EARL LAKIA
C             Inland Steel
C             Process Automation Department
C             3210 Watling St.  MS 2-465
C             East Chicago, IN  46312
C  
C Date of last update: 3/26/87
C Revision level     :1.0
C  
C .C ;Formal Parameter List
C Receives:
C 
C BITARY                        BYTE
C                               Array of bits
c 
c IBIT                          INTEGER*4
C                               Desired bit to clear within array.
C  
C Returns:
C 
C  
C .SK
C .fill
C .SK
C Description:
C .sk    
C 	This subroutine is responsible for clearing a bit within a bit
c array to one.  The calling sequence is:
c .nofill
c .sk
c 	INTEGER*4 BITARY(100)	! BIT ARRAY
C 	INTEGER*4 IBIT		! BIT TO SET STARTING WITH ZERO
C 	CALL CLRBIT(BITARY,IBIT)
C 
C end.doc ****************************** end.doc  

	BYTE BYTMSK(0:7)	! SINGLE BYTE MASK
	BYTE BITARY(0:*)	! BIT ARRAY FROM USER
	INTEGER*4 IBIT	! BIT TO TEST
	INTEGER*4 IR	! REMAINDER BIT
	INTEGER*4 IB	! BYTE BIT IS IN
C
	DATA BYTMSK/'1'X,'2'X,'4'X,'8'X,'10'X,'20'X,'40'X,'80'X/
C
C	
	IB=IBIT/8		! GET BYTE THAT CONTAINS BIT
	IR= IBIT- (IB*8)	! GET BIT WITHIN BYTE
C
	BITARY(IB)=BITARY(IB) .AND. (.NOT.(BYTMSK(IR))) ! SET THE BIT
	RETURN
	END
