/* This header file was created by Joe Meadows, and is not copyrighted
   in any way. No guarantee is made as to the accuracy of the contents
   of this header file. This header file was last modified on Sep. 8th,
   1987. */
#define HM2$C_LEVEL1	257
#define HM2$C_LEVEL2	512
#define HM2$M_READCHECK	1
#define HM2$M_WRITCHECK	2
#define HM2$M_ERASE	4
#define HM2$M_NOHIGHWATER	8
#define HM2$M_CLASS_PROT	16
#define HM2$S_HM2DEF	512
#define HM2$S_CREDATE	8
#define HM2$S_RETAINMIN	8
#define HM2$S_RETAINMAX	8
#define HM2$S_REVDATE	8
#define HM2$S_MIN_CLASS	20
#define HM2$S_MAX_CLASS	20
#define HM2$S_STRUCNAME	12
#define HM2$S_VOLNAME	12
#define HM2$S_OWNERNAME	12
#define HM2$S_FORMAT	12
#define DATE {unsigned : 32; unsigned : 32;}

struct hm2def {
  unsigned long int hm2$l_homelbn;
  unsigned long int hm2$l_alhomelbn;
  unsigned long int hm2$l_altidxlbn;
  variant_union {
    unsigned short int hm2$w_struclev;
    variant_struct {
      unsigned char hm2$b_strucver;
      unsigned char hm2$b_struclev;
    } hm2$dummy_w_struclev_struct;
  } hm2$dummy_w_struclev_union;
  unsigned short int hm2$w_cluster;
  unsigned short int hm2$w_homevbn;
  unsigned short int hm2$w_alhomevbn;
  unsigned short int hm2$w_altidxvbn;
  unsigned short int hm2$w_ibmapvbn;
  unsigned long int hm2$l_ibmaplbn;
  unsigned long int hm2$l_maxfiles;
  unsigned short int hm2$w_ibmapsize;
  unsigned short int hm2$w_resfiles;
  unsigned short int hm2$w_devtype;
  unsigned short int hm2$w_rvn;
  unsigned short int hm2$w_setcount;
  variant_union {
    unsigned short int hm2$w_volchar;
    variant_struct {
      unsigned hm2$v_readcheck : 1;
      unsigned hm2$v_writcheck : 1;
      unsigned hm2$v_erase : 1;
      unsigned hm2$v_nohighwater : 1;
      unsigned hm2$v_class_prot : 1;
    } hm2$dummy_w_volchar_struct;
  } hm2$dummy_w_volchar_union;
  unsigned long int hm2$l_volowner;
  unsigned long int hm2$l_sec_mask;
  unsigned short int hm2$w_protect;
  unsigned short int hm2$w_fileprot;
  unsigned short int hm2$w_recprot;
  unsigned short int hm2$w_checksum1;
  struct DATE hm2$q_credate;
  unsigned char hm2$b_window;
  unsigned char hm2$b_lru_lim;
  unsigned short int hm2$w_extend;
  struct DATE hm2$q_retainmin;
  struct DATE hm2$q_retainmax;
  struct DATE hm2$q_revdate;
  unsigned char hm2$r_min_class[HM2$S_MIN_CLASS];
  unsigned char hm2$r_max_class[HM2$S_MAX_CLASS];
  unsigned char hm2$fill_0[320];
  unsigned long int hm2$l_serialnum;
  unsigned char hm2$t_strucname[HM2$S_STRUCNAME];
  unsigned char hm2$t_volname[HM2$S_VOLNAME];
  unsigned char hm2$t_ownername[HM2$S_OWNERNAME];
  unsigned char hm2$t_format[HM2$S_FORMAT];
  unsigned char hm2$fill_1[2];
  unsigned short int hm2$w_checksum2;
};
