#include descrip

#include "status.h"
extern int (*init[])();
extern int (*format[])();
extern struct node keywords[];

build_select(jpi, syi, list, vals, index, fmt, susp, max)
  struct itmlst jpi[], syi[];
  int list[];
  char *vals[];
  int *index;
  int (*fmt[])();
  char susp[];
  int max;
{
  static char *listname = "select";
  char buff[40];
  struct dsc$descriptor str={sizeof(buff), DSC$K_DTYPE_T, DSC$K_CLASS_S, buff};
  int keyword;
  char *ptr;
  int len, i;

  if (!(cli_present(listname) & 1)) return;
  while (cli_next_qual(listname) & 1) {
    str.dsc$w_length = sizeof(buff);
    while (cli_get_value(listname,&str) & 1) {
      if (*index >= max) {
        printf("No memory left for more keywords!\n");
        printf("%.*s will not be used\n", str.dsc$w_length, buff);
        return;
      };
      for (i=0; i<str.dsc$w_length; i++) {
        buff[i] = toupper(buff[i]);
        if ((buff[i] == ':') || (buff[i] == '=')) {
          /* allocate space for string, save pointer in val[index] */
          len = str.dsc$w_length - i - 1;
          ptr = 0;
          lib$get_vm(&len, &ptr);
          buff[i++] = '\0'; /* change '=' or ':' to '\0' */
          if (vals[*index] = ptr) { /* set vals[] equal to ptr, and copy it */
            for (;i<str.dsc$w_length; i++)
              *ptr++ = buff[i];
          }
          else
            printf("Unable to allocate memory for select clause\n");
        };
      };
      buff[i] = '\0';
      keyword = search_keywords(buff);
      if (keyword < 0) {
        printf("%.*s is %s%\n", str.dsc$w_length, buff,
               (keyword == -1)?"unknown":"ambiguous");
        if (vals[*index]) /* free this memory! */
          lib$free_vm(&len,&vals[*index]);
      }
      else {
        fmt[*index] = keywords[keyword].fmt_ptr;
        (*init[keywords[keyword].ini_ptr])(keywords[keyword].ini_data,
                jpi, syi, list, susp, index);
      };
      str.dsc$w_length = sizeof(buff);
    };
  };
}
