#include descrip
#include dcdef

#define MAXDEVICES 128
#define DEVICENAMESIZE 128
static struct DevInfo{
  long int pid;
  short int len;
  char name[DEVICENAMESIZE];
} device_array[MAXDEVICES];
static int elemntsize = sizeof(struct DevInfo);

static struct {
  long int duetim;
  long int pid;
  short int rtt_link;
  short int nameindex;
} terminfo[MAXDEVICES];

static int maxdevices = MAXDEVICES;

main()
{
  static struct dsc$descriptor dev = {0,DSC$K_DTYPE_T,DSC$K_CLASS_S,0};
  int pid;
  int class;
  int status;
  int i,j;

  class = -1;
  pid = 0;
  status = devices(&class,&pid,&maxdevices,&elemntsize,device_array);
  if ((status & 1) == 0) return(status);
  i = 0;
  while (device_array[i].len) {
    printf("%.*s\n",device_array[i].len,device_array[i].name);
    device_array[i].len = 0;	/* clear it out */
    ++i;
  };
  printf("\n");
  printf("\n");

  class = -1;
  pid = -1;
  status = devices(&class,&pid,&maxdevices,&elemntsize,device_array);
  if ((status & 1) == 0) return(status);
  i = 0;
  while (device_array[i].len) {
    printf("%.*s - %08X\n",
		device_array[i].len,
		device_array[i].name,
		device_array[i].pid);
    device_array[i].len = 0;	/* clear it out */
    ++i;
  };
  printf("\n");
  printf("\n");

  class = DC$_TERM;
  pid = -1;
  status = devices(&class,&pid,&maxdevices,&elemntsize,device_array);
  if ((status & 1) == 0) return(status);
  i = 0;
  j = 0;
  while (device_array[i].len) {
    printf("%.*s",device_array[i].len,device_array[i].name);
    dev.dsc$w_length = device_array[i].len;
    dev.dsc$a_pointer = device_array[i].name;
    status = term_info(&dev,&terminfo[j]);
    if ((status & 1) == 0)
      printf(", invalid operation\n");
    else
      printf(", pid = %08X, due = %d, rtt_link = %d\n",
		terminfo[j].pid,terminfo[j].duetim,terminfo[j].rtt_link);
    ++i;
  };
}
