#include jpidef

#include "status.h"

init$dummy(item,jpilist,syilist,listptr,susp,index)
  unsigned int item;
  struct itmlst jpilist[], syilist[];
  int listptr[];
  char susp[];
  int *index;
{                     
  susp[*index] = 0;
  *index += 1;
}

init$global_value(item,jpilist,syilist,listptr,susp,index)
  unsigned int item;
  struct itmlst jpilist[], syilist[];
  int listptr[];
  char susp[];
  int *index;
{                     
  susp[*index] = 0;
  listptr[*index] = item;
  *index += 1;
}

init$jpi(item,jpilist,syilist,listptr,susp,index)
  unsigned int item;
  struct itmlst jpilist[], syilist[];
  int listptr[];
  char susp[];
  int *index;
{                     
  int i = 0;

  while ((jpilist[i].cod_len != 0) && (jpilist[i].cod_len != item))
    ++i;

  jpilist[i].cod_len = item;
  listptr[*index] = &jpilist[i];

  susp[*index] = jpilist[i].code >> 8;
  switch (susp[*index]) {
    case JPI$C_JIBTYPE:
    case JPI$C_PCBFLDTYPE:
    case JPI$C_PCBTYPE:
      susp[*index] = 0;
      break;
    case JPI$C_PHDTYPE:
    case JPI$C_PHDFLDTYPE:
      switch (jpilist[i].code) {
        case JPI$_PRCLM:
        case JPI$_PGFLQUOTA:
        case JPI$_PAGFILCNT:
        case JPI$_FILLM:
        case JPI$_TQLM:
          susp[*index] = 0;
          break;
        default:
          susp[*index] = 1;
          break;
      };
      break;
    default:
      switch (jpilist[i].code) {
        case JPI$_USERNAME:
        case JPI$_ACCOUNT:
        case JPI$_MAXDETACH:
        case JPI$_MAXJOBS:
        case JPI$_SHRFILLM:
          susp[*index] = 0;
          break;
        default:
          susp[*index] = 2;
          break;
      }
      break;
  };
  *index += 1;
}

init$syi(item,jpilist,syilist,listptr,susp,index)
  unsigned int item;
  struct itmlst jpilist[], syilist[];
  int listptr[];
  char susp[];
  int *index;
{
  int i = 0;

  while ((syilist[i].cod_len != 0) && (syilist[i].cod_len != item))
    ++i;

  syilist[i].cod_len = item;
  listptr[*index] = &syilist[i];
  susp[*index] = 0;
  *index += 1;
}

init$pages(item,jpilist,syilist,listptr,susp,index)
  unsigned int item;
  struct itmlst jpilist[], syilist[];
  int listptr[];
  char susp[];
  int *index;
{
  int i = 0;

  init$jpi((JPI$_GPGCNT<<16)+4, jpilist, syilist, listptr, susp, index);
  init$jpi((JPI$_PPGCNT<<16)+4, jpilist, syilist, listptr, susp, index);
}

init$type(item,jpilist,syilist,listptr,susp,index)
  unsigned int item;
  struct itmlst jpilist[], syilist[];
  int listptr[];
  char susp[];
  int *index;
{
  int i = 0;

  init$jpi((JPI$_JOBTYPE<<16)+4, jpilist, syilist, listptr, susp, index);
  init$jpi((JPI$_MODE<<16)+4, jpilist, syilist, listptr, susp, index);
  init$jpi((JPI$_OWNER<<16)+4, jpilist, syilist, listptr, susp, index);
}

init$literal(item,jpilist,syilist,listptr,susp,index)
  unsigned int item;
  struct itmlst jpilist[], syilist[];
  int listptr[];
  char susp[];
  int *index;
{                     
  listptr[*index] = -1;
  susp[*index] = 0;
  *index += 1;
}
