/* Created by SDL V3.0-2     */
/* Source:  8-AUG-1988 09:44:43 EMULEX$DISK:[MEADOWS.UNSDL.VMS4-7_H]STARDEFAE.S */
#ifndef $CHPDEF_H
#define $CHPDEF_H
 
/*** MODULE $CHPDEF ***/
/*+                                                                           */
/*                                                                            */
/* Item definitions for the $CHKPRO (check protection) service.               */
/*                                                                            */
/*-                                                                           */
#define CHP$_END 0      /* list end                                           */
#define CHP$_ACCESS 1   /* intended access                                    */
#define CHP$_FLAGS 2    /* read / write flags                                 */
#define CHP$_PRIV 3     /* privilege mask                                     */
#define CHP$_ACMODE 4   /* accessor access mode                               */
#define CHP$_ACCLASS 5  /* accessor security classification                   */
#define CHP$_RIGHTS 6   /* rights list                                        */
#define CHP$_ADDRIGHTS 7        /* additional rights list segments            */
#define CHP$_MODE 8     /* simple access mode                                 */
#define CHP$_MODES 9    /* per action access mode                             */
#define CHP$_MINCLASS 10        /* minimum security classification            */
#define CHP$_MAXCLASS 11        /* maximum security classification            */
#define CHP$_OWNER 12   /* object owner UIC                                   */
#define CHP$_PROT 13    /* protection mask                                    */
#define CHP$_ACL 14     /* access control list segment                        */
#define CHP$_AUDITNAME 15       /* security audit name                        */
#define CHP$_ALARMNAME 16       /* security alarm name                        */
#define CHP$_MATCHEDACE 17      /* address of matching ACE                    */
#define CHP$_PRIVUSED 18        /* mask of privileges used                    */
#define CHP$_MAX_CODE 19        /* highest CHP$ item code                     */
#define CHP$M_SYSPRV 0x00000001
#define CHP$M_BYPASS 0x00000002
#define CHP$M_UPGRADE 0x00000004
#define CHP$M_DOWNGRADE 0x00000008
#define CHP$M_GRPPRV 0x00000010
#define CHP$M_READALL 0x00000020
struct privs_used_bits {
    unsigned chp$v_sysprv : 1;  /* access via SYSPRV privilege                */
    unsigned chp$v_bypass : 1;  /* access via BYPASS privilege                */
    unsigned chp$v_upgrade : 1; /* access via UPGRADE privilege               */
    unsigned chp$v_downgrade : 1;       /* access via DOWNGRADE privilege     */
    unsigned chp$v_grpprv : 1;  /* access via GRPPRV privilege                */
    unsigned chp$v_readall : 1; /* access via READALL privilege               */
    unsigned chp$v_fill_10 : 2;
} ;
#define CHP$M_READ 0x00000001
#define CHP$M_WRITE 0x00000002
#define CHP$M_USEREADALL 0x00000004
struct flag_bits {
    unsigned chp$v_read : 1;    /* non-discretionary read access              */
    unsigned chp$v_write : 1;   /* non-discretionary write access             */
    unsigned chp$v_usereadall : 1;      /* READALL privilege applies          */
    unsigned chp$v_fill_11 : 5;
} ;
#endif
