/* Created by SDL V3.0-2     */
/* Source:  8-AUG-1988 09:45:49 EMULEX$DISK:[MEADOWS.UNSDL.VMS4-7_H]STARDEFFL.S */
#ifndef $KGBDEF_H
#define $KGBDEF_H
 
/*** MODULE $KGBDEF ***/
/*++                                                                          */
/* Key Grant Block definitions: Format of records in the rights database      */
/* file. These records (1) associate identifier codes with names, and         */
/* (2) list the holders of all identifiers in the system.                     */
/*--                                                                          */
#define KGB$M_RESOURCE 0x00000001
#define KGB$M_DYNAMIC 0x00000002
#define KGB$M_ACCESS 0x00000004
#define KGB$K_HOLD_RECORD 16    /* End of holder record                       */
#define KGB$K_IDENT_RECORD 48   /* End of identifier record                   */
#define KGB$K_LEVEL1 257        /* Version 1 structure level                  */
#define KGB$K_MAINT_RECORD 64   /* End of maintenance record                  */
struct kgbdef {
    unsigned long int kgb$l_identifier; /* Binary identifier code             */
    union {
        unsigned long int kgb$l_attributes;     /* Attribute bit definitions  */
        struct {
            unsigned kgb$v_resource : 1;        /* Resource use allowed       */
            unsigned kgb$v_dynamic : 1; /* Identifier may be enabled or disabled      */
            unsigned kgb$v_access : 1;  /* Identifier used in protection checks       */
            unsigned kgb$v_fill_33 : 5;
            } kgb$r_fill_32;
        } kgb$r_fill_31;
    unsigned int kgb$q_holder [2];      /* Holder identifier                  */
    char kgb$t_name [32];       /* Identifier name (blank filled string)      */
    unsigned short int kgb$w_level;     /* File structure level               */
    short int kgb$$$_fill_1;
    unsigned int kgb$q_sys_id [2];      /* System identifier                  */
    unsigned long int kgb$l_next_id;    /* Next available identifier          */
} ;
/*++                                                                          */
/* Define the environmental rights ID values                                  */
/*--                                                                          */
#define KGB$K_BATCH_ID -2147483647      /* Batch ID value                     */
#define KGB$K_DIALUP_ID -2147483646     /* Dialup ID value                    */
#define KGB$K_INTERACTIVE_ID -2147483645        /* Interactive ID value       */
#define KGB$K_LOCAL_ID -2147483644      /* Local ID value                     */
#define KGB$K_NETWORK_ID -2147483643    /* Network ID value                   */
#define KGB$K_REMOTE_ID -2147483642     /* Remote ID value                    */
#endif
