/* Created by SDL V3.0-2     */
/* Source:  8-AUG-1988 09:45:49 EMULEX$DISK:[MEADOWS.UNSDL.VMS4-7_H]STARDEFFL.S */
#ifndef $LADEF_H
#define $LADEF_H
 
/*** MODULE $LADEF ***/
/*+                                                                           */
/*                                                                            */
/* LPA-11 CHARACTERISTICS DEFINITIONS                                         */
/*                                                                            */
/*-                                                                           */
/*MICROCODE TYPE VALUES                                                       */
#define LA$K_MRMCODE 1  /* MULTIREQUEST MICROCODE                             */
#define LA$K_ADMCODE 2  /* DEDICATED A/D MICROCODE                            */
#define LA$K_DAMCODE 3  /* DEDICATED D/A MICROCODE                            */
#define LA$M_MCVALID 0x00000001
#define LA$M_CLOCKA 0x00000008
#define LA$M_CLOCKB 0x00000010
#define LA$M_AD1 0x00000020
#define LA$M_AD2 0x00000040
#define LA$M_DA 0x00000080
#define LA$M_DIO1 0x00000100
#define LA$M_DIO2 0x00000200
#define LA$M_DIO3 0x00000400
#define LA$M_DIO4 0x00000800
#define LA$M_DIO5 0x00001000
#define LA$M_BFROVRN 0x00800000
union ladef {
    struct {
        unsigned la$v_mcvalid : 1;      /* MICROCODE VALID                    */
        unsigned la$v_mctype : 2;       /* MICROCODE TYPE                     */
        unsigned la$v_config : 10;      /* DEVICE CONFIGURATION BITS          */
        unsigned la$v_rate : 3; /* CLOCK RATE                                 */
        unsigned la$v_preset : 16;      /* CLOCK PRESET                       */
        } la$r_ladef_bits0;
    struct {
        unsigned ladef$$_fill_1 : 3;    /* SKIP OVER MICROCODE VALID AND TYPE */
        unsigned la$v_clocka : 1;       /* CLOCK A                            */
        unsigned la$v_clockb : 1;       /* CLOCK B                            */
        unsigned la$v_ad1 : 1;  /* A/D ! 1                                    */
        unsigned la$v_ad2 : 1;  /* A/D ! 2                                    */
        unsigned la$v_da : 1;   /* D/A                                        */
        unsigned la$v_dio1 : 1; /* DIGITAL I/O ! 1                            */
        unsigned la$v_dio2 : 1; /* DIGITAL I/O ! 2                            */
        unsigned la$v_dio3 : 1; /* DIGITAL I/O ! 3                            */
        unsigned la$v_dio4 : 1; /* DIGITAL I/O ! 4                            */
        unsigned la$v_dio5 : 1; /* DIGITAL I/O ! 5                            */
        unsigned la$v_fill_34 : 3;
        } la$r_ladef_bits1;
    struct {
        unsigned ladef$$_fill_2 : 23;   /*(IN USER'S COMMAND TABLE)           */
        unsigned la$v_bfrovrn : 1;      /* BUFFER OVERRUN NON-FATAL BIT       */
        } la$r_ladef_bits2;
} ;
#endif
