/* Created by SDL V3.0-2     */
/* Source:  8-AUG-1988 09:46:33 EMULEX$DISK:[MEADOWS.UNSDL.VMS4-7_H]STARDEFMP.S */
#ifndef $MSGDEF_H
#define $MSGDEF_H
 
/*** MODULE $MSGDEF ***/
/*+                                                                           */
/*                                                                            */
/* SYSTEM WIDE MAILBOX MESSAGE TYPES                                          */
/*                                                                            */
/*-                                                                           */
/* DEFINE CODES AS CONSTANTS                                                  */
#define MSG$_TRMUNSOLIC 1       /* UNSOLICITED TERMINAL DATA                  */
#define MSG$_CRUNSOLIC 2        /* UNSOLICTED CARD READER DATA                */
#define MSG$_DELPROC 3  /* DELETE PROCESS                                     */
#define MSG$_SNDSMB 4   /* SEND TO SYMBIONT MANAGER                           */
#define MSG$_DEVOFFLIN 5        /* DEVICE OFFLINE                             */
#define MSG$_TRMHANGUP 6        /* TERMINAL HANG UP                           */
#define MSG$_DEVONLIN 7 /* DEVICE ONLINE                                      */
#define MSG$_OPRQST 8   /* OPERATOR REQUEST *** OVERLAPPED CODE ***           */
#define MSG$_OPREPLY 9  /* OPERATOR REPLY *** OVERLAPPED CODE ***             */
/* DEFINE SYMBIONT RESPONSE MESSAGES                                          */
#define MSG$_SMBINI 8   /* SYMBIONT HAS INITED                                */
#define MSG$_SMBDON 9   /* SYMBIONT FINISHED                                  */
#define MSG$_SNDACC 10  /* SEND MESSAGE TO ACCOUNTING MANAGER                 */
#define MSG$_PURPROC 11 /* PURGE PROCESS *** OVERLAPPED CODE ***              */
#define MSG$_DELIMAG 12 /* DELETE IMAGE *** OVERLAPPED CODE ***               */
#define MSG$_PURIMAG 13 /* PURGE IMAGE *** OVERLAPPED CODE ***                */
#define MSG$_SYSFUNC 14 /* SYSTEM FUNCTION *** OVERLAPPED CODE ***            */
#define MSG$_SNDJBC 15  /* Send message to job controller                     */
#define MSG$_GETQUI 16  /* Get queue information (from job controller)        */
/* DEFINE DMC MESSAGES                                                        */
#define MSG$_XM_DATAVL 11       /* DMC UNSOLICITED DATA                       */
#define MSG$_XM_SHUTDN 12       /* DMC LINE DOWN                              */
#define MSG$_XM_ATTN 13 /* DMC ATTENTION MESSAGE                              */
/* SYMBIONT COMMAND MESSAGES                                                  */
#define MSG$_INIOPR 16  /* INITIATE PRINTING A FILE                           */
#define MSG$_ABOOPR 17  /* ABORT PRINTING A FILE                              */
#define MSG$_SUSOPR 18  /* PAUSE PRINTING THE FILE                            */
#define MSG$_RESOPR 19  /* RESUME PRINTING THE FILE                           */
#define MSG$_DELSMB 20  /* SYMBIONT SHOULD DELETE ITSELF                      */
#define MSG$_REQUE 21   /* REQUEUE A FILE FOR PRINTING                        */
/*                                                                            */
#define MSG$_SMBRSP 32  /* SYMBIONT MANAGER RESPONSE                          */
#define MSG$_ACCRSP 33  /* ACCOUNTING MANAGER RESPONSE                        */
/* FILE ACP MESSAGES                                                          */
#define MSG$_SCANBAD 40 /* SCAN FILE FOR BAD BLOCKS                           */
#define MSG$_SCANRSP 41 /* RESPONSE FROM FILE SCANNER                         */
/* NETWORK ATTENTION CODES                                                    */
#define MSG$_ABORT 48   /* PARTNER ABORTED LINK                               */
#define MSG$_CONFIRM 49 /* CONNECT CONFIRM                                    */
#define MSG$_CONNECT 50 /* INBOUND CONNECT INITIATE                           */
#define MSG$_DISCON 51  /* PARTNER DISCONNECTED - HANGUP                      */
#define MSG$_EXIT 52    /* PARTNER EXITED PREMATURELY                         */
#define MSG$_INTMSG 53  /* INTERRUPT MESSAGE - UNSOLICITED DATA               */
#define MSG$_PATHLOST 54        /* NFW - PATH LOST TO PARTNER                 */
#define MSG$_PROTOCOL 55        /* PROTOCOL ERROR                             */
#define MSG$_REJECT 56  /* CONNECT REJECT                                     */
#define MSG$_THIRDPARTY 57      /* THIRD PARTY DISCONNECT                     */
#define MSG$_TIMEOUT 58 /* CONNECT TIMEOUT                                    */
#define MSG$_NETSHUT 59 /* Network shutting down                              */
#define MSG$_NODEACC 60 /* Node has become accessible                         */
#define MSG$_NODEINACC 61       /* Node has become inaccessible               */
#define MSG$_EVTAVL 62  /* Events are available to EVL                        */
#define MSG$_EVTRCVCHG 63       /* Event receiver database change             */
#define MSG$_INCDAT 64  /* X25 INCOMING DATA                                  */
#define MSG$_RESET 65   /* X25 CIRCUIT RESET                                  */
#define MSG$_LINUP 66   /* X25 PVC LINE UP                                    */
#define MSG$_LINDWN 67  /* X25 PVC LINE DOWN                                  */
#define MSG$_EVTXMTCHG 68       /* Event transmitter database change          */
/* MOUNT VERIFICATION MESSAGES                                                */
#define MSG$_DEVOFFLINX 80      /* DEVICE OFFLINE                             */
#define MSG$_WRONGVOL 81        /* WRONG VOLUME IN DEVICE                     */
#define MSG$_DEVWRTLCK 82       /* DEVICE HAS BEEN WRITE LOCKED               */
#define MSG$_TRMBRDCST 83       /* TERMINAL BROADCAST                         */
#define MSG$_MVCOMPLETE 84      /* MOUNT VERIFICATION COMPLETED               */
#define MSG$_MVABORTED 85       /* MOUNT VERIFICATION ABORTED                 */
#define MSG$_DISMOUNTED 86      /* VOLUME DISMOUNTED                          */
#define MSG$_UDA50MVER 87       /* UDA50 MICORCODE NOT UPTO REV               */
#define MSG$_DUPUNITNO 88       /* MSCP CONTROLLER - DUPLICATE UNIT !         */
#define MSG$_CLUMBX 89  /* CNXMGR to OPCOM messages                           */
#define MSG$_TM78MVER 90        /* TM78 Microcode not up to rev level         */
#define MSG$_SHAMEMFAL 91       /* Member failed out of shadow set            */
#define MSG$_SHARDUCED 92       /* Shadow set reduced                         */
#define MSG$_RC25MVER 93        /* RC25 MICORCODE NOT UPTO REV                */
#define MSG$_RDRXMVER 94        /* RDRX MICORCODE NOT UPTO REV                */
#define MSG$_TU81MVER 95        /* TU81 MICORCODE NOT UPTO REV                */
#define MSG$_MAYAMVER 96        /* MAYA MICORCODE NOT UPTO REV                */
#define MSG$_SHACHASTA 97       /* Shadow set has changed state               */
#define MSG$_SHACOPCOM 98       /* Shadow copy operation has completed        */
#define MSG$_SHAREDZER 99       /* Shadow set reduced to zero members         */
#define MSG$_SHAPOSMEM 100      /* Possible shadow set member                 */
#define MSG$_SHAALLCOM 101      /* All shadow set copy operations completed   */
#define MSG$_SHACOPBEG 102      /* Shadow copy operation begun                */
#define MSG$_SHAWROMEM 103      /* Shadow member contains wrong volume        */
#define MSG$_SHAORGMEM 104      /* Shadow system disk missing VMB R3 member   */
#define MSG$_TRMLOSE_KB 105     /* terminal lost physical KB                  */
#define MSG$_TRMGAIN_KB 106     /* terminal gained physical KB                */
#define MSG$_TRMSHRINK 107      /* terminal window shrunk to icon             */
#define MSG$_TRMEXPAND 108      /* terminal window icon expanded              */
#define MSG$_TRMRESIZE 109      /* terminal window resized                    */
#define MSG$_TRMMOVE 110        /* terminal window moved                      */
#endif
