/* Created by SDL V3.0-2     */
/* Source:  8-AUG-1988 09:33:03 EMULEX$DISK:[MEADOWS.UNSDL.VMS4-7_H]LIB$ROUTINE */
#ifndef LIB$ROUTINES_H
#define LIB$ROUTINES_H
 
/*** MODULE LIB$ROUTINES ***/
/**************************************************************************** */
/*          *                                                                 */
/*  COPYRIGHT (c) 1986 BY                   *                                 */
/*  DIGITAL EQUIPMENT CORPORATION, MAYNARD, MASSACHUSETTS.          *         */
/*  ALL RIGHTS RESERVED.    *                                                 */
/*          *                                                                 */
/*  THIS SOFTWARE IS FURNISHED UNDER A LICENSE AND MAY BE USED AND COPIED   * */
/*  ONLY IN  ACCORDANCE WITH  THE  TERMS  OF  SUCH  LICENSE  AND WITH THE   * */
/*  INCLUSION OF THE ABOVE COPYRIGHT NOTICE. THIS SOFTWARE OR  ANY  OTHER   * */
/*  COPIES THEREOF MAY NOT BE PROVIDED OR OTHERWISE MADE AVAILABLE TO ANY   * */
/*  OTHER PERSON.  NO TITLE TO AND OWNERSHIP OF  THE  SOFTWARE IS  HEREBY   * */
/*  TRANSFERRED.            *                                                 */
/*          *                                                                 */
/*  THE INFORMATION IN THIS SOFTWARE IS  SUBJECT TO CHANGE WITHOUT NOTICE   * */
/*  AND  SHOULD  NOT  BE  CONSTRUED AS  A COMMITMENT BY DIGITAL EQUIPMENT   * */
/*  CORPORATION.    *                                                         */
/*          *                                                                 */
/*  DIGITAL ASSUMES NO RESPONSIBILITY FOR THE USE  OR  RELIABILITY OF ITS   * */
/*  SOFTWARE ON EQUIPMENT WHICH IS NOT SUPPLIED BY DIGITAL.         *         */
/*          *                                                                 */
/*          *                                                                 */
/**************************************************************************** */
/*+~lib$addx~+*/
unsigned long int lib$addx(
    const int  *addend_array,
    const int  *augend_array,
    int  *resultant_array,
    ...
    /* const long int  *array_length */
    ) ;
/*~-lib$addx-~*/
/*+~lib$analyze_sdesc~+*/
unsigned long int lib$analyze_sdesc(
    const struct dsc$descriptor *input_descriptor,
    unsigned short int  *data_length,
    int * *data_address
    ) ;
/*~-lib$analyze_sdesc-~*/
/*+~lib$asn_wth_mbx~+*/
unsigned long int lib$asn_wth_mbx(
    const struct dsc$descriptor *device_name,
    const long int  *maximum_message_size,
    const long int  *buffer_quota,
    unsigned short int  *device_channel,
    unsigned short int  *mailbox_channel
    ) ;
/*~-lib$asn_wth_mbx-~*/
/*+~lib$ast_in_prog~+*/
char lib$ast_in_prog() ;
/*~-lib$ast_in_prog-~*/
/*+~lib$attach~+*/
unsigned long int lib$attach(
    const unsigned long int  *process_id
    ) ;
/*~-lib$attach-~*/
/*+~lib$bbcci~+*/
unsigned long int lib$bbcci(
    const long int  *position,
    const int * *bit_zero_address
    ) ;
/*~-lib$bbcci-~*/
/*+~lib$bbssi~+*/
unsigned long int lib$bbssi(
    const long int  *position,
    const int * *bit_zero_address
    ) ;
/*~-lib$bbssi-~*/
/*+~lib$callg~+*/
unsigned long int lib$callg(
    const int  *argument_list,
    const int *user_procedure
    ) ;
/*~-lib$callg-~*/
/*+~lib$create_dir~+*/
unsigned long int lib$create_dir(
    const struct dsc$descriptor *device_directory_spec,
    ...
    /* const unsigned long int  *owner_uic, */
    /* const unsigned short int  *protection_enable, */
    /* const unsigned short int  *protection_value, */
    /* const unsigned short int  *maximum_versions, */
    /* const unsigned short int  *relative_volume_number */
    ) ;
/*~-lib$create_dir-~*/
/*+~lib$char~+*/
unsigned long int lib$char(
    struct dsc$descriptor *one_character_string,
    const unsigned char  *ascii_code
    ) ;
/*~-lib$char-~*/
/*+~lib$crc~+*/
unsigned long int lib$crc(
    const long int  *crc_table [1],
    const long int  *initial_crc,
    const struct dsc$descriptor *stream
    ) ;
/*~-lib$crc-~*/
/*+~lib$crc_table~+*/
int lib$crc_table(
    const unsigned long int  *polynomial_coefficient,
    long int  *crc_table [1]
    ) ;
/*~-lib$crc_table-~*/
/*+~lib$crf_ins_key~+*/
int lib$crf_ins_key(
    const long int  *control_table [1],
    const struct dsc$descriptor *key_string,
    const long int  *symbol_value,
    const unsigned long int  *flags
    ) ;
/*~-lib$crf_ins_key-~*/
/*+~lib$crf_ins_ref~+*/
int lib$crf_ins_ref(
    const long int  *control_table [1],
    const long int  *longword_integer_key,
    const struct dsc$descriptor *reference_string,
    long int  *longword_integer_reference,
    const long int  *ref_definition_indicator
    ) ;
/*~-lib$crf_ins_ref-~*/
/*+~lib$crf_output~+*/
int lib$crf_output(
    const long int  *control_table [1],
    const long int  *output_line_width,
    const long int  *page1,
    const long int  *page2,
    const long int  *mode_indicator,
    const long int  *delete_save_indicator
    ) ;
/*~-lib$crf_output-~*/
/*+~lib$currency~+*/
unsigned long int lib$currency(
    struct dsc$descriptor *currency_string,
    ...
    /* unsigned short int  *resultant_length */
    ) ;
/*~-lib$currency-~*/
/*+~lib$create_user_vm_zone~+*/
unsigned long int lib$create_user_vm_zone(
    unsigned long int  *zone_id,
    ...
    /* const unsigned long int  *user_argument, */
    /* const int *user_allocation_routine, */
    /* const int *user_deallocation_routine, */
    /* const int *user_reset_routine, */
    /* const int *user_delete_routine */
    ) ;
/*~-lib$create_user_vm_zone-~*/
/*+~lib$cvt_dx_dx~+*/
unsigned long int lib$cvt_dx_dx(
    const int  *source_item,
    int  *destination_item,
    ...
    /* unsigned short int  *word_integer_dest_length */
    ) ;
/*~-lib$cvt_dx_dx-~*/
/*+~lib$cvt_dtb~+*/
unsigned long int lib$cvt_dtb(
    const long int byte_count,
    const char  *numeric_string,
    long int  *result
    ) ;
/*~-lib$cvt_dtb-~*/
/*+~lib$cvt_htb~+*/
unsigned long int lib$cvt_htb(
    const long int byte_count,
    const char  *numeric_string,
    long int  *result
    ) ;
/*~-lib$cvt_htb-~*/
/*+~lib$cvt_otb~+*/
unsigned long int lib$cvt_otb(
    const long int byte_count,
    const char  *numeric_string,
    long int  *result
    ) ;
/*~-lib$cvt_otb-~*/
/*+~lib$create_vm_zone~+*/
unsigned long int lib$create_vm_zone(
    unsigned long int  *zone_id,
    ...
    /* const long int  *algorithm, */
    /* const long int  *algorithm_argument, */
    /* const unsigned long int  *flags, */
    /* const long int  *extend_size, */
    /* const long int  *initial_size, */
    /* const long int  *block_size, */
    /* const long int  *alignment, */
    /* const long int  *page_limit, */
    /* const long int  *smallest_block_size */
    ) ;
/*~-lib$create_vm_zone-~*/
/*+~lib$date_time~+*/
unsigned long int lib$date_time(
    struct dsc$descriptor *date_time_string
    ) ;
/*~-lib$date_time-~*/
/*+~lib$day~+*/
unsigned long int lib$day(
    long int  *number_of_days,
    ...
    /* const unsigned int  *user_time [2], */
    /* long int  *day_time */
    ) ;
/*~-lib$day-~*/
/*+~lib$day_of_week~+*/
unsigned long int lib$day_of_week(
    const unsigned int  *user_time [2],
    unsigned long int  *day_number
    ) ;
/*~-lib$day_of_week-~*/
/*+~lib$dec_over~+*/
unsigned long int lib$dec_over(
    const unsigned long int  *new_setting
    ) ;
/*~-lib$dec_over-~*/
/*+~lib$decode_fault~+*/
unsigned long int lib$decode_fault(
    const int  *signal_arguments,
    const int  *mechanism_arguments,
    const struct dsc$descriptor *user_routine,
    ...
    /* const int  *unspecified_user_argument, */
    /* const unsigned char  *instruction_definitions [1] */
    ) ;
/*~-lib$decode_fault-~*/
/*+~lib$delete_file~+*/
unsigned long int lib$delete_file(
    const struct dsc$descriptor *filespec,
    ...
    /* const struct dsc$descriptor *default_filespec, */
    /* const struct dsc$descriptor *related_filespec, */
    /* const int *user_success_routine, */
    /* const int *user_error_routine, */
    /* const int *user_confirm_routine, */
    /* const int  *user_specified_argument, */
    /* struct dsc$descriptor *resultant_name, */
    /* unsigned long int  *file_scan_context */
    ) ;
/*~-lib$delete_file-~*/
/*+~lib$digit_sep~+*/
unsigned long int lib$digit_sep(
    struct dsc$descriptor *digit_separator_string,
    ...
    /* unsigned short int  *resultant_length */
    ) ;
/*~-lib$digit_sep-~*/
/*+~lib$disable_ctrl~+*/
unsigned long int lib$disable_ctrl(
    const unsigned long int  *disable_mask,
    ...
    /* unsigned long int  *old_mask */
    ) ;
/*~-lib$disable_ctrl-~*/
/*+~lib$delete_logical~+*/
unsigned long int lib$delete_logical(
    const struct dsc$descriptor *logical_name,
    ...
    /* const struct dsc$descriptor *table_name */
    ) ;
/*~-lib$delete_logical-~*/
/*+~lib$do_command~+*/
unsigned long int lib$do_command(
    const struct dsc$descriptor *command_string
    ) ;
/*~-lib$do_command-~*/
/*+~lib$delete_symbol~+*/
unsigned long int lib$delete_symbol(
    const struct dsc$descriptor *symbol,
    ...
    /* const long int  *table_type_indicator */
    ) ;
/*~-lib$delete_symbol-~*/
/*+~lib$delete_vm_zone~+*/
unsigned long int lib$delete_vm_zone(
    const unsigned long int  *zone_id
    ) ;
/*~-lib$delete_vm_zone-~*/
/*+~lib$ediv~+*/
unsigned long int lib$ediv(
    const long int  *longword_integer_divisor,
    const int  *quadword_integer_dividend [2],
    long int  *longword_integer_quotient,
    long int  *remainder
    ) ;
/*~-lib$ediv-~*/
/*+~lib$emodf~+*/
unsigned long int lib$emodf(
    const float  *floating_point_multiplier,
    const unsigned char  *multiplier_extension,
    const float  *floating_point_multiplicand,
    long int  *integer_portion,
    float  *fractional_portion
    ) ;
/*~-lib$emodf-~*/
/*+~lib$emodd~+*/
unsigned long int lib$emodd(
    const double float  *floating_point_multiplier,
    const unsigned char  *multiplier_extension,
    const double float  *floating_point_multiplicand,
    long int  *integer_portion,
    double float  *fractional_portion
    ) ;
/*~-lib$emodd-~*/
/*+~lib$emodg~+*/
unsigned long int lib$emodg(
    const double float  *floating_point_multiplier,
    const unsigned short int  *multiplier_extension,
    const double float  *floating_point_multiplicand,
    long int  *integer_portion,
    double float  *fractional_portion
    ) ;
/*~-lib$emodg-~*/
/*+~lib$emodh~+*/
unsigned long int lib$emodh(
    const struct {int floating$$ret_0_ [4];}  *floating_point_multiplier,
    const unsigned short int  *multiplier_extension,
    const struct {int floating$$ret_1_ [4];}  *floating_point_multiplicand,
    long int  *integer_portion,
    struct {int fraction$$ret_0_ [4];}  *fractional_portion
    ) ;
/*~-lib$emodh-~*/
/*+~lib$emul~+*/
unsigned long int lib$emul(
    const long int  *longword_integer_multiplier,
    const long int  *longword_integer_multiplicand,
    const long int  *addend,
    int  *product [2]
    ) ;
/*~-lib$emul-~*/
/*+~lib$enable_ctrl~+*/
unsigned long int lib$enable_ctrl(
    const unsigned long int  *enable_mask,
    ...
    /* unsigned long int  *old_mask */
    ) ;
/*~-lib$enable_ctrl-~*/
/*+~lib$establish~+*/
int *lib$establish(
    const int *new_handler
    ) ;
/*~-lib$establish-~*/
/*+~lib$extv~+*/
long int lib$extv(
    const long int  *position,
    const unsigned char  *size,
    const int *base_value
    ) ;
/*~-lib$extv-~*/
/*+~lib$extzv~+*/
long int lib$extzv(
    const long int  *position,
    const unsigned char  *size,
    const int *base_value
    ) ;
/*~-lib$extzv-~*/
/*+~lib$free_ef~+*/
unsigned long int lib$free_ef(
    const unsigned long int  *event_flag_number
    ) ;
/*~-lib$free_ef-~*/
/*+~lib$find_file_end~+*/
unsigned long int lib$find_file_end(
    const unsigned long int  *context
    ) ;
/*~-lib$find_file_end-~*/
/*+~lib$find_file~+*/
unsigned long int lib$find_file(
    const struct dsc$descriptor *filespec,
    struct dsc$descriptor *resultant_filespec,
    unsigned long int  *context,
    ...
    /* const struct dsc$descriptor *default_filespec, */
    /* const struct dsc$descriptor *related_filespec, */
    /* unsigned long int  *status_value, */
    /* const unsigned long int  *flags */
    ) ;
/*~-lib$find_file-~*/
/*+~lib$ffc~+*/
unsigned long int lib$ffc(
    const long int  *position,
    const unsigned char  *size,
    const int * *base,
    long int  *find_position
    ) ;
/*~-lib$ffc-~*/
/*+~lib$ffs~+*/
unsigned long int lib$ffs(
    const long int  *position,
    const unsigned char  *size,
    const int * *base,
    long int  *find_position
    ) ;
/*~-lib$ffs-~*/
/*+~lib$find_image_symbol~+*/
unsigned long int lib$find_image_symbol(
    const struct dsc$descriptor *filename,
    const struct dsc$descriptor *symbol,
    long int  *symbol_value
    ) ;
/*~-lib$find_image_symbol-~*/
/*+~lib$fixup_flt~+*/
unsigned long int lib$fixup_flt(
    const int  *signal_arguments,
    const int  *mechanism_arguments,
    ...
    /* const float  *new_operand */
    ) ;
/*~-lib$fixup_flt-~*/
/*+~lib$flt_under~+*/
unsigned long int lib$flt_under(
    const unsigned long int  *new_setting
    ) ;
/*~-lib$flt_under-~*/
/*+~lib$free_lun~+*/
unsigned long int lib$free_lun(
    const long int  *logical_unit_number
    ) ;
/*~-lib$free_lun-~*/
/*+~lib$free_vm_page~+*/
unsigned long int lib$free_vm_page(
    const long int  *number_of_pages,
    const int * *base_address
    ) ;
/*~-lib$free_vm_page-~*/
/*+~lib$file_scan~+*/
unsigned long int lib$file_scan(
    const int  *fab,
    const int *user_success_routine,
    const int *user_error_routine,
    ...
    /* unsigned long int  *context */
    ) ;
/*~-lib$file_scan-~*/
/*+~lib$file_scan_end~+*/
unsigned long int lib$file_scan_end(
    int  *fab,
    ...
    /* unsigned long int  *context */
    ) ;
/*~-lib$file_scan_end-~*/
/*+~lib$free_timer~+*/
unsigned long int lib$free_timer(
    int * *handle_address
    ) ;
/*~-lib$free_timer-~*/
/*+~lib$free_vm~+*/
unsigned long int lib$free_vm(
    const long int  *number_of_bytes,
    const int * *base_address,
    ...
    /* const unsigned long int  *zone_id */
    ) ;
/*~-lib$free_vm-~*/
/*+~lib$get_command~+*/
unsigned long int lib$get_command(
    struct dsc$descriptor *resultant_string,
    ...
    /* const struct dsc$descriptor *prompt_string, */
    /* unsigned short int  *resultant_length */
    ) ;
/*~-lib$get_command-~*/
/*+~lib$get_common~+*/
unsigned long int lib$get_common(
    struct dsc$descriptor *resultant_string,
    ...
    /* unsigned short int  *resultant_length */
    ) ;
/*~-lib$get_common-~*/
/*+~lib$getdvi~+*/
unsigned long int lib$getdvi(
    /* const unsigned short int  *channel, */
    /* const struct dsc$descriptor *device_name, */
    /* long int  *longword_integer_value, */
    /* struct dsc$descriptor *resultant_string, */
    /* unsigned short int  *resultant_length */
    ) ;
/*~-lib$getdvi-~*/
/*+~lib$get_ef~+*/
unsigned long int lib$get_ef(
    unsigned long int  *event_flag_number
    ) ;
/*~-lib$get_ef-~*/
/*+~lib$get_foreign~+*/
unsigned long int lib$get_foreign(
    struct dsc$descriptor *resultant_string,
    ...
    /* const struct dsc$descriptor *prompt_string, */
    /* unsigned short int  *resultant_length, */
    /* unsigned long int  *flags */
    ) ;
/*~-lib$get_foreign-~*/
/*+~lib$get_input~+*/
unsigned long int lib$get_input(
    struct dsc$descriptor *resultant_string,
    ...
    /* const struct dsc$descriptor *prompt_string, */
    /* unsigned short int  *resultant_length */
    ) ;
/*~-lib$get_input-~*/
/*+~lib$getjpi~+*/
unsigned long int lib$getjpi(
    /* unsigned long int  *process_id, */
    /* const struct dsc$descriptor *process_name, */
    /* int  *resultant_value, */
    /* struct dsc$descriptor *resultant_string, */
    /* unsigned short int  *resultant_length */
    ) ;
/*~-lib$getjpi-~*/
/*+~lib$get_lun~+*/
unsigned long int lib$get_lun(
    long int  *logical_unit_number
    ) ;
/*~-lib$get_lun-~*/
/*+~lib$get_vm_page~+*/
unsigned long int lib$get_vm_page(
    const long int  *number_of_pages,
    int * *base_address
    ) ;
/*~-lib$get_vm_page-~*/
/*+~lib$getsyi~+*/
unsigned long int lib$getsyi(
    /* int  *resultant_value, */
    /* struct dsc$descriptor *resultant_string, */
    /* unsigned short int  *resultant_length, */
    /* unsigned long int  *cluster_system_id, */
    /* const struct dsc$descriptor *node_name */
    ) ;
/*~-lib$getsyi-~*/
/*+~lib$get_symbol~+*/
unsigned long int lib$get_symbol(
    const struct dsc$descriptor *symbol,
    struct dsc$descriptor *resultant_string,
    ...
    /* unsigned short int  *resultant_length, */
    /* long int  *table_type_indicator */
    ) ;
/*~-lib$get_symbol-~*/
/*+~lib$get_vm~+*/
unsigned long int lib$get_vm(
    const long int  *number_of_bytes,
    int * *base_address,
    ...
    /* const unsigned long int  *zone_id */
    ) ;
/*~-lib$get_vm-~*/
/*+~lib$ichar~+*/
unsigned long int lib$ichar(
    const struct dsc$descriptor *source_string
    ) ;
/*~-lib$ichar-~*/
/*+~lib$index~+*/
unsigned long int lib$index(
    const struct dsc$descriptor *source_string,
    const struct dsc$descriptor *sub_string
    ) ;
/*~-lib$index-~*/
/*+~lib$init_timer~+*/
unsigned long int lib$init_timer(
    /* int * *handle_address */
    ) ;
/*~-lib$init_timer-~*/
/*+~lib$insert_tree~+*/
long int lib$insert_tree(
    unsigned long int  *treehead,
    const struct dsc$descriptor *symbol,
    const unsigned long int  *flags,
    const int *user_compare_routine,
    const int *user_allocation_routine,
    int * *new_node,
    ...
    /* int  *user_data */
    ) ;
/*~-lib$insert_tree-~*/
/*+~lib$insqhi~+*/
unsigned long int lib$insqhi(
    int  *entry,
    int  *header [2],
    ...
    /* const unsigned long int  *retry_count */
    ) ;
/*~-lib$insqhi-~*/
/*+~lib$insqti~+*/
unsigned long int lib$insqti(
    int  *entry,
    int  *header [2],
    ...
    /* const unsigned long int  *retry_count */
    ) ;
/*~-lib$insqti-~*/
/*+~lib$insv~+*/
int lib$insv(
    const long int  *longword_integer_source,
    const long int  *position,
    const unsigned char  *size,
    int * *base_field
    ) ;
/*~-lib$insv-~*/
/*+~lib$int_over~+*/
unsigned long int lib$int_over(
    const unsigned long int  *new_setting
    ) ;
/*~-lib$int_over-~*/
/*+~lib$len~+*/
unsigned short int lib$len(
    const struct dsc$descriptor *source_string
    ) ;
/*~-lib$len-~*/
/*+~lib$locc~+*/
unsigned long int lib$locc(
    const struct dsc$descriptor *character_string,
    const struct dsc$descriptor *source_string
    ) ;
/*~-lib$locc-~*/
/*+~lib$lookup_key~+*/
unsigned long int lib$lookup_key(
    const struct dsc$descriptor *search_string,
    const unsigned long int  *key_table_array [1],
    ...
    /* unsigned long int  *key_value, */
    /* struct dsc$descriptor *keyword_string, */
    /* unsigned short int  *resultant_length */
    ) ;
/*~-lib$lookup_key-~*/
/*+~lib$lookup_tree~+*/
unsigned long int lib$lookup_tree(
    const unsigned long int  *treehead,
    const struct dsc$descriptor *symbol,
    const int *user_compare_routine,
    unsigned long int  *new_node
    ) ;
/*~-lib$lookup_tree-~*/
/*+~lib$lp_lines~+*/
long int lib$lp_lines() ;
/*~-lib$lp_lines-~*/
/*+~lib$matchc~+*/
unsigned long int lib$matchc(
    const struct dsc$descriptor *sub_string,
    const struct dsc$descriptor *source_string
    ) ;
/*~-lib$matchc-~*/
/*+~lib$movc3~+*/
int lib$movc3(
    const unsigned short int  *word_integer_length,
    const int  *source,
    int  *destination
    ) ;
/*~-lib$movc3-~*/
/*+~lib$movc5~+*/
int lib$movc5(
    const unsigned short int  *word_integer_source_length,
    const int  *source,
    const char  *fill,
    const unsigned short int  *word_integer_destination_length,
    int  *destination
    ) ;
/*~-lib$movc5-~*/
/*+~lib$movtc~+*/
unsigned long int lib$movtc(
    const struct dsc$descriptor *source_string,
    const struct dsc$descriptor *fill_character,
    const struct dsc$descriptor *translation_table,
    struct dsc$descriptor *destination_string
    ) ;
/*~-lib$movtc-~*/
/*+~lib$movtuc~+*/
unsigned long int lib$movtuc(
    const struct dsc$descriptor *source_string,
    const struct dsc$descriptor *stop_character,
    const struct dsc$descriptor *translation_table,
    struct dsc$descriptor *destination_string,
    ...
    /* const struct dsc$descriptor *fill_character */
    ) ;
/*~-lib$movtuc-~*/
/*+~lib$pause~+*/
unsigned long int lib$pause() ;
/*~-lib$pause-~*/
/*+~lib$polyf~+*/
unsigned long int lib$polyf(
    const float  *polynomial_argument,
    const short int  *degree,
    const float  *coefficient [1],
    float  *floating_point_result
    ) ;
/*~-lib$polyf-~*/
/*+~lib$polyd~+*/
unsigned long int lib$polyd(
    const double float  *polynomial_argument,
    const short int  *degree,
    const double float  *coefficient [1],
    double float  *floating_point_result
    ) ;
/*~-lib$polyd-~*/
/*+~lib$polyg~+*/
unsigned long int lib$polyg(
    const double float  *polynomial_argument,
    const short int  *degree,
    const double float  *coefficient [1],
    double float  *floating_point_result
    ) ;
/*~-lib$polyg-~*/
/*+~lib$polyh~+*/
unsigned long int lib$polyh(
    const struct {int polynomi$$ret_0_ [4];}  *polynomial_argument,
    const short int  *degree,
    const struct {int coeffici$$ret_0_ [4];}  *coefficient [1],
    struct {int floating$$ret_0_ [4];}  *floating_point_result
    ) ;
/*~-lib$polyh-~*/
/*+~lib$put_common~+*/
unsigned long int lib$put_common(
    const struct dsc$descriptor *source_string,
    ...
    /* unsigned short int  *resultant_length */
    ) ;
/*~-lib$put_common-~*/
/*+~lib$put_output~+*/
unsigned long int lib$put_output(
    const struct dsc$descriptor *message_string
    ) ;
/*~-lib$put_output-~*/
/*+~lib$radix_point~+*/
unsigned long int lib$radix_point(
    struct dsc$descriptor *radix_point_string,
    ...
    /* unsigned short int  *resultant_length */
    ) ;
/*~-lib$radix_point-~*/
/*+~lib$remqhi~+*/
unsigned long int lib$remqhi(
    int  *header [2],
    int * *remque_address,
    ...
    /* const unsigned long int  *retry_count */
    ) ;
/*~-lib$remqhi-~*/
/*+~lib$remqti~+*/
unsigned long int lib$remqti(
    int  *header [2],
    int * *remque_address,
    ...
    /* const unsigned long int  *retry_count */
    ) ;
/*~-lib$remqti-~*/
/*+~lib$rename_file~+*/
unsigned long int lib$rename_file(
    const struct dsc$descriptor *old_filespec,
    const struct dsc$descriptor *new_filespec,
    ...
    /* const struct dsc$descriptor *default_filespec, */
    /* const struct dsc$descriptor *related_filespec, */
    /* const unsigned long int  *flags, */
    /* const int *user_success_routine, */
    /* const int *user_error_routine, */
    /* const int *user_confirm_routine, */
    /* const int  *user_specified_argument, */
    /* struct dsc$descriptor *old_resultant_name, */
    /* struct dsc$descriptor *new_resultant_name, */
    /* unsigned long int  *file_scan_context */
    ) ;
/*~-lib$rename_file-~*/
/*+~lib$reserve_ef~+*/
unsigned long int lib$reserve_ef(
    const unsigned long int  *event_flag_number
    ) ;
/*~-lib$reserve_ef-~*/
/*+~lib$reset_vm_zone~+*/
unsigned long int lib$reset_vm_zone(
    const unsigned long int  *zone_id
    ) ;
/*~-lib$reset_vm_zone-~*/
/*+~lib$revert~+*/
int *lib$revert() ;
/*~-lib$revert-~*/
/*+~lib$run_program~+*/
unsigned long int lib$run_program(
    const struct dsc$descriptor *program_name
    ) ;
/*~-lib$run_program-~*/
/*+~lib$sys_asctim~+*/
unsigned long int lib$sys_asctim(
    unsigned short int  *resultant_length,
    struct dsc$descriptor *time_string,
    ...
    /* const unsigned int  *user_time [2], */
    /* const unsigned long int  *flags */
    ) ;
/*~-lib$sys_asctim-~*/
/*+~lib$scanc~+*/
unsigned long int lib$scanc(
    const struct dsc$descriptor *source_string,
    const unsigned char  *table_array [1],
    const unsigned char  *byte_integer_mask
    ) ;
/*~-lib$scanc-~*/
/*+~lib$scopy_dxdx~+*/
unsigned long int lib$scopy_dxdx(
    const struct dsc$descriptor *source_string,
    struct dsc$descriptor *destination_string
    ) ;
/*~-lib$scopy_dxdx-~*/
/*+~lib$scopy_r_dx~+*/
unsigned long int lib$scopy_r_dx(
    const unsigned short int  *word_integer_source_length,
    const char  *source_string_address,
    const struct dsc$descriptor *destination_string
    ) ;
/*~-lib$scopy_r_dx-~*/
/*+~lib$set_logical~+*/
unsigned long int lib$set_logical(
    const struct dsc$descriptor *logical_name,
    ...
    /* const struct dsc$descriptor *value_string, */
    /* const struct dsc$descriptor *table, */
    /* const unsigned long int  *attributes, */
    /* const unsigned long int  *item_list [1] */
    ) ;
/*~-lib$set_logical-~*/
/*+~lib$set_symbol~+*/
unsigned long int lib$set_symbol(
    const struct dsc$descriptor *symbol,
    const struct dsc$descriptor *value_string,
    ...
    /* const long int  *table_type_indicator */
    ) ;
/*~-lib$set_symbol-~*/
/*+~lib$sfree1_dd~+*/
unsigned long int lib$sfree1_dd(
    unsigned int  *descriptor_address [2]
    ) ;
/*~-lib$sfree1_dd-~*/
/*+~lib$sfreen_dd~+*/
unsigned long int lib$sfreen_dd(
    const unsigned long int  *number_of_descriptors,
    unsigned int  *first_descriptor_array [2] [1]
    ) ;
/*~-lib$sfreen_dd-~*/
/*+~lib$sget1_dd~+*/
unsigned long int lib$sget1_dd(
    const unsigned short int  *word_integer_length,
    unsigned int  *descriptor_part [2]
    ) ;
/*~-lib$sget1_dd-~*/
/*+~lib$sys_getmsg~+*/
unsigned long int lib$sys_getmsg(
    const unsigned long int  *message_id,
    unsigned short int  *message_length,
    struct dsc$descriptor *destination_string,
    ...
    /* const unsigned long int  *flags, */
    /* unsigned long int  *unsigned_resultant_array [1] */
    ) ;
/*~-lib$sys_getmsg-~*/
/*+~lib$show_timer~+*/
unsigned long int lib$show_timer(
    /* const int * *handle_address, */
    /* const long int  *code, */
    /* const int *user_action_routine, */
    /* const int user_argument_value */
    ) ;
/*~-lib$show_timer-~*/
/*+~lib$show_vm~+*/
unsigned long int lib$show_vm(
    /* const long int  *code, */
    /* const int *user_action_routine, */
    /* const int  *user_specified_argument */
    ) ;
/*~-lib$show_vm-~*/
/*+~lib$sig_to_ret~+*/
unsigned long int lib$sig_to_ret(
    const int  *signal_arguments,
    const int  *mechanism_arguments
    ) ;
/*~-lib$sig_to_ret-~*/
/*+~lib$sig_to_stop~+*/
unsigned long int lib$sig_to_stop(
    int  *signal_arguments,
    const int  *mechanism_arguments
    ) ;
/*~-lib$sig_to_stop-~*/
/*+~lib$sim_trap~+*/
unsigned long int lib$sim_trap(
    int  *signal_arguments,
    const int  *mechanism_arguments
    ) ;
/*~-lib$sim_trap-~*/
/*+~lib$skpc~+*/
unsigned long int lib$skpc(
    const struct dsc$descriptor *character_string,
    const struct dsc$descriptor *source_string
    ) ;
/*~-lib$skpc-~*/
/*+~lib$spanc~+*/
unsigned long int lib$spanc(
    const struct dsc$descriptor *source_string,
    const unsigned char  *table_array [1],
    const unsigned char  *byte_integer_mask
    ) ;
/*~-lib$spanc-~*/
/*+~lib$spawn~+*/
unsigned long int lib$spawn(
    /* const struct dsc$descriptor *command_string, */
    /* const struct dsc$descriptor *input_file, */
    /* const struct dsc$descriptor *output_file, */
    /* const unsigned long int  *flags, */
    /* const struct dsc$descriptor *process_name, */
    /* unsigned long int  *process_id, */
    /* unsigned long int  *completion_status, */
    /* const unsigned char  *byte_integer_event_flag_num, */
    /* const int *ast_address, */
    /* const int  *varying_ast_argument, */
    /* const struct dsc$descriptor *prompt_string, */
    /* const struct dsc$descriptor *cli */
    ) ;
/*~-lib$spawn-~*/
/*+~lib$stat_timer~+*/
unsigned long int lib$stat_timer(
    const long int  *code,
    int  *value_argument,
    ...
    /* const int * *handle_address */
    ) ;
/*~-lib$stat_timer-~*/
/*+~lib$stat_vm~+*/
unsigned long int lib$stat_vm(
    const long int  *code,
    int  *value_argument
    ) ;
/*~-lib$stat_vm-~*/
/*+~lib$subx~+*/
unsigned long int lib$subx(
    const int  *minuend_array,
    const int  *subtrahend_array,
    int  *difference_array,
    ...
    /* const long int  *array_length */
    ) ;
/*~-lib$subx-~*/
/*+~lib$tparse~+*/
unsigned long int lib$tparse(
    int * *argument_block,
    const int * *state_table,
    const int * *key_table
    ) ;
/*~-lib$tparse-~*/
/*+~lib$tra_asc_ebc~+*/
unsigned long int lib$tra_asc_ebc(
    const struct dsc$descriptor *source_string,
    struct dsc$descriptor *byte_integer_dest_string
    ) ;
/*~-lib$tra_asc_ebc-~*/
/*+~lib$tra_ebc_asc~+*/
unsigned long int lib$tra_ebc_asc(
    const struct dsc$descriptor *byte_integer_source_string,
    struct dsc$descriptor *destination_string
    ) ;
/*~-lib$tra_ebc_asc-~*/
/*+~lib$traverse_tree~+*/
unsigned long int lib$traverse_tree(
    const unsigned long int  *treehead,
    const int *user_action_routine,
    ...
    /* const int  *user_data_address */
    ) ;
/*~-lib$traverse_tree-~*/
/*+~lib$trim_filespec~+*/
unsigned long int lib$trim_filespec(
    const struct dsc$descriptor *old_filespec,
    struct dsc$descriptor *new_filespec,
    ...
    /* const unsigned short int  *word_integer_width, */
    /* unsigned short int  *resultant_length */
    ) ;
/*~-lib$trim_filespec-~*/
/*+~lib$wait~+*/
unsigned long int lib$wait(
    const float  *seconds
    ) ;
/*~-lib$wait-~*/
#endif
