/* Created by SDL V3.1-7     */
/* Source:  8-AUG-1988 10:33:04 EMULEX$DISK:[MEADOWS.UNSDL.VMS5-0_H]STARDEFAE.S */
#ifndef $CLSDEF_H
#define $CLSDEF_H
 
/*** MODULE $CLSDEF ***/
/*+                                                                           */
/*                                                                            */
/* Security classification mask block. Contains security and integrity        */
/* level and categories for non-discretionary access controls.                */
/*                                                                            */
/*-                                                                           */
struct clsdef {
    unsigned char cls$b_secur_lev;      /* Security level                     */
    unsigned char cls$b_integ_lev;      /* Integrity level                    */
    short int cls$w_fill_1;     /* Reserved                                   */
    int cls$q_secur_cat [2];    /* Security category mask                     */
    int cls$q_integ_cat [2];    /* Integrity category mask                    */
} ;
#define CLS$_SECSTR 1   /* Textual secrecy/security string                    */
#define CLS$_INTSTR 2   /* Textual integrity string                           */
#define CLS$_CLSBLK 3   /* Simple classification block                        */
#define CLS$_MINCLSBLK 4        /* Minimum classification block               */
#define CLS$_MAXCLSBLK 5        /* Maximum classification block               */
#define CLS$_WIDTH 6    /* Width of display for $FORMAT_CLASS                 */
#define CLS$_TRMDSC 7   /* Line terminator for $FORMAT_CLASS                  */
#define CLS$_INDENT 8   /* Line indenting for $FORMAT_CLASS                   */
#define CLS$_OLDCLSBLK 9        /* Previous classification block              */
#define CLS$_OLDMINCLS 10       /* Previous minimum class block               */
#define CLS$_OLDMAXCLS 11       /* Previous maximum class block               */
/* ADD ITEM-CODES BEFORE THIS COMMENT                                         */
#endif
