/* Created by SDL V3.1-7     */
/* Source:  8-AUG-1988 10:33:04 EMULEX$DISK:[MEADOWS.UNSDL.VMS5-0_H]STARDEFAE.S */
#ifndef $DCDEF_H
#define $DCDEF_H
 
/*** MODULE $DCDEF ***/
/*                                                                            */
/* DEVICE ADAPTER, CLASS, AND TYPE DEFINITIONS                                */
/*                                                                            */
/*                                                                            */
/* DEFINE ADAPTER TYPES                                                       */
/*                                                                            */
/*DEFINE ADAPTER TYPES                                                        */
#define AT$_MBA 0       /* MASSBUS ADAPTER                                    */
#define AT$_UBA 1       /* UNIBUS ADAPTER                                     */
#define AT$_DR 2        /* DR32 ADAPTER                                       */
#define AT$_MPM 3       /* MULTI-PORT MEMORY                                  */
#define AT$_CI 4        /* CI BUS                                             */
#define AT$_NULL 5      /* NULL (SOFTWARE) ADAPTER                            */
#define AT$_BDA 6       /* BI DISK ADAPTER(KDB50)                             */
#define AT$_DMB32 7     /* DMB32 ADAPTER                                      */
#define AT$_DRB32 8     /* DRB32 ADAPTER                                      */
#define AT$_BVP 9       /* BVP GENERIC ADAPTER                                */
#define AT$_BVP_SSP 10  /* BVP STORAGE SYSTEMS PORT                           */
#define AT$_BVP_NIP 11  /* BVP NI PORT                                        */
#define AT$_KA410 12    /* VAXstar system                                     */
#define AT$_GENBI 13    /* Generic BI device                                  */
#define AT$_NBI 14      /* NBIB on BI.                                        */
#define AT$_DISK9 15
#define AT$_XBI 16
#define AT$_TERM9 17
#define AT$_TAPE9 18
#define AT$_PRTR9 19
#define AT$_SFUN9 20
#define AT$_USER9 21
#define AT$_MBUSIO 22
#define AT$_MBUSGFX 23
#define AT$_KA640 24
/*                                                                            */
/* DEFINE DEVICE CLASSES                                                      */
/*                                                                            */
/*DEFINE DEVICE CLASSES                                                       */
#define DC$_DISK 1      /* DISK                                               */
#define DC$_TAPE 2      /* TAPES                                              */
#define DC$_SCOM 32     /* SYNCHRONOUS COMMUNICATIONS DEVICES                 */
#define DC$_CARD 65     /* CARD READER                                        */
#define DC$_TERM 66     /* TERMINAL                                           */
#define DC$_LP 67       /* LINE PRINTER                                       */
#define DC$_WORKSTATION 70      /* WORKSTATIONS                               */
#define DC$_REALTIME 96 /* REAL-TIME                                          */
#define DC$_BUS 128     /* BUSES, E.G, CI                                     */
#define DC$_MAILBOX 160 /* MAILBOX                                            */
#define DC$_MISC 200    /* MISCELLANEOUS DEVICES                              */
/*                                                                            */
/* DEFINE DEVICE TYPES                                                        */
/*                                                                            */
/*                                                                            */
/* DISK DEVICES                                                               */
/*                                                                            */
#define DT$_RK06 1      /*RK06 DISK                                           */
#define DT$_RK07 2      /*RK07 DISK                                           */
#define DT$_RP04 3      /*RP04 DISK                                           */
#define DT$_RP05 4      /*RP05 DISK                                           */
#define DT$_RP06 5      /*RP06 DISK                                           */
#define DT$_RM03 6      /*RM03 DISK                                           */
#define DT$_RP07 7      /*RP07 DISK                                           */
#define DT$_RP07HT 8    /*RP07 DISK WITH HEAD/TRACK                           */
#define DT$_RL01 9      /*RL01 DISK                                           */
#define DT$_RL02 10     /*RL02 DISK                                           */
#define DT$_RX02 11     /*RX02 DISK                                           */
#define DT$_RX04 12     /*RX04 DISK                                           */
#define DT$_RM80 13     /*RM80 DISK                                           */
#define DT$_TU58 14     /*TU58                                                */
#define DT$_RM05 15     /*RM05 DISK                                           */
#define DT$_RX01 16     /*RX01 DISK                                           */
#define DT$_ML11 17     /*ML11 disk                                           */
#define DT$_RB02 18     /*R02 ON RB730                                        */
#define DT$_RB80 19     /*R80 ON RB730                                        */
#define DT$_RA80 20     /*R80 ON INTELLIGENT CONTROLLER                       */
#define DT$_RA81 21     /*R81 ON INTELLIGENT CONTROLLER                       */
#define DT$_RA60 22     /*PINON ON INTELLIGENT CONTROLLER                     */
#define DT$_RZ01 23     /*AZTEC REMOVABLE (Old name)                          */
#define DT$_RC25 23     /*AZTEC REMOVABLE (New name)                          */
#define DT$_RZF01 24    /*AZTEC FIXED (Old name)                              */
#define DT$_RCF25 24    /*AZTEC FIXED (New name)                              */
#define DT$_RD51 25     /*RD51 FIXED DISK DRIVE                               */
#define DT$_RX50 26     /*RX50 FLOPPY DISK DRIVE                              */
#define DT$_RD52 27     /*RD52 FIXED DISK DRIVE                               */
#define DT$_RD53 28     /*RD53 FIXED DISK DRIVE                               */
#define DT$_RD26 29     /*RD26 FIXED DISK DRIVE                               */
#define DT$_RA82 30     /*RA82 FIXED DISK DRIVE                               */
#define DT$_RD31 31     /*RD31 FIXED DISK DRIVE                               */
#define DT$_RD54 32     /*RD54 FIXED DISK DRIVE                               */
#define DT$_CRX50 33    /*Console RX50                                        */
#define DT$_RRD50 34    /*RRD50                                               */
#define DT$_GENERIC_DU 35       /*Brand X Disk                                */
#define DT$_RX33 36     /*RX33 DISKETTE DRIVE                                 */
#define DT$_RX18 37     /*RX18                                                */
#define DT$_RA70 38
#define DT$_RA90 39
#define DT$_RD32 40
#define DT$_DISK9 41
#define DT$_RX35 42
#define DT$_RF30 43
#define DT$_RF70 44
#define DT$_RF71 44
#define DT$_RD33 45
#define DT$_ESE20 46
#define DT$_TU56 47
#define DT$_FD1 129     /*FOREIGN DISK TYPE 1                                 */
#define DT$_FD2 130     /*FOREIGN DISK TYPE 2                                 */
#define DT$_FD3 131     /*FOREIGN DISK TYPE 3                                 */
#define DT$_FD4 132     /*FOREIGN DISK TYPE 4                                 */
#define DT$_FD5 133     /*FOREIGN DISK TYPE 5                                 */
#define DT$_FD6 134     /*FOREIGN DISK TYPE 6                                 */
#define DT$_FD7 135     /*FOREIGN DISK TYPE 7                                 */
#define DT$_FD8 136     /*FOREIGN DISK TYPE 8                                 */
/*                                                                            */
/* TAPE DEVICES                                                               */
/*                                                                            */
#define DT$_TE16 1      /*TE16 MAGTAPE                                        */
#define DT$_TU45 2      /*TU45 MAGTAPE                                        */
#define DT$_TU77 3      /*TU77 MAGTAPE                                        */
#define DT$_TS11 4      /*TS11 MAGTAPE                                        */
#define DT$_TU78 5      /*TU78 MAGTAPE                                        */
#define DT$_TA78 6      /*TA78 MAGTAPE                                        */
#define DT$_TU80 7      /*TU80 MAGTAPE                                        */
#define DT$_TU81 8      /*TU81 MAGTAPE                                        */
#define DT$_TA81 9
#define DT$_TK50 10     /*TK50 CARTRIDGE TAPE                                 */
#define DT$_MR_TU70 11  /*TU70 STC TAPE (DX20)                                */
#define DT$_MR_TU72 12  /*TU72 STC TAPE                                       */
#define DT$_MW_TSU05 13 /*TSU05 TAPE (CSS)                                    */
#define DT$_MW_TSV05 14 /*TSV05 TAPE (CSS)                                    */
#define DT$_TK70 15     /*TK70 CARTRIDGE TAPE                                 */
#define DT$_RV20 16
#define DT$_RV80 16
#define DT$_TK60 17     /*TK60 CARTRIDGE TAPE                                 */
#define DT$_GENERIC_TU 18       /*Brand X Tape                                */
#define DT$_TA79 19     /*TA79                                                */
#define DT$_TAPE9 20
#define DT$_TA90 21
#define DT$_TF30 22
#define DT$_TF70 23
#define DT$_RV60 24
/*                                                                            */
/* TERMINAL DEVICE TYPES                                                      */
/*                                                                            */
/* new definitions for terminal types should be placed in $ttdef only         */
/* this table remains around for compatibility only                           */
/*                                                                            */
/* **** MATCHES $TTDEF *****                                                  */
#define DT$_TTYUNKN 0   /* UNKNOWN TERMINAL                                   */
#define DT$_VT05 1      /* VT05                                               */
#define DT$_FT1 16      /* FOREIGN TERMINAL TYPES                             */
#define DT$_FT2 17
#define DT$_FT3 18
#define DT$_FT4 19
#define DT$_FT5 20
#define DT$_FT6 21
#define DT$_FT7 22
#define DT$_FT8 23      /* END OF FOREIGN TYPES                               */
/* RESERVE REST UP TO 32 FOR EXTENSIONS                                       */
#define DT$_LAX 32      /* LA TYPE TERMINAL                                   */
#define DT$_LA36 32     /* LA36                                               */
#define DT$_LA120 33
#define DT$_VT5X 64     /* VT5X TYPE                                          */
#define DT$_VT52 64     /* VT52                                               */
#define DT$_VT55 65     /* VT55                                               */
#define DT$_TQ_BTS 4    /* TQ_BTS                                             */
#define DT$_TEK401X 10  /* TEK401X series                                     */
#define DT$_VT100 96    /* VT100                                              */
#define DT$_VK100 2
#define DT$_VT173 3
#define DT$_LA34 34
#define DT$_LA38 35
#define DT$_LA12 36
#define DT$_LA24 37
#define DT$_LA100 37
#define DT$_LQP02 38
#define DT$_VT101 97
#define DT$_VT102 98
#define DT$_VT105 99
#define DT$_VT125 100
#define DT$_VT131 101
#define DT$_VT132 102
#define DT$_DZ11 66     /* DZ11 CONTROLLER                                    */
#define DT$_DZ32 67     /* DZ32 CONTROLLER                                    */
#define DT$_DZ730 68    /* DZ730 (COMBO) CONTROLLER                           */
#define DT$_DMZ32 69    /* DMZ32 CONTROLLER                                   */
#define DT$_DHV 70      /* DHV CONTROLLER                                     */
#define DT$_DHU 71      /* DHU CONTROLLER                                     */
#define DT$_SLU 72      /* Onboard Serial Line Unit                           */
#define DT$_TERM9 73    /*Terminal on 009                                     */
#define DT$_LAT 74      /* LAT terminals                                      */
/*                                                                            */
/* Terminal WORKSTATIONS                                                      */
/*                                                                            */
#define DT$_VS100 1     /* VAXstation 100                                     */
#define DT$_VS125 2     /* VAXstation 125                                     */
#define DT$_VL_VS8200 3 /* VAXstation 8200 (Lynx)                             */
#define DT$_VD 4        /* VAXstation Vir. Device                             */
#define DT$_DECW_OUTPUT 5
#define DT$_DECW_INPUT 6
/*                                                                            */
/* SYNCHRONOUS COMMUNICATIONS DEVICE TYPES                                    */
/*                                                                            */
#define DT$_DMC11 1     /* DMC11                                              */
#define DT$_DMR11 2     /* DMR11                                              */
#define DT$_XK_3271 3   /* DUP-11 FOR 3271 PROTOCOL EMULATOR                  */
#define DT$_XJ_2780 4   /* DUP-11 FOR 2780 " "                                */
#define DT$_NW_X25 5    /* X25 PROTOCOL EMULATOR                              */
#define DT$_NV_X29 6    /* X29 " "                                            */
#define DT$_SB_ISB11 7  /* ISB-11 DEC dataway                                 */
#define DT$_MX_MUX200 8 /* MUX-200 PROTOCOL EMULATOR                          */
#define DT$_DMP11 9     /* DMP11                                              */
#define DT$_DMF32 10    /* DMF32                                              */
#define DT$_XV_3271 11  /* DV-11 3271 PROTOCOL EMULATOR                       */
#define DT$_CI 12       /* CI - Computer Interconnect                         */
#define DT$_NI 13       /* NI - Network Interconnect                          */
#define DT$_UNA11 14    /* UNIBUS to NI adapter                               */
#define DT$_DEUNA 14    /* UNIBUS to NI adapter                               */
#define DT$_YN_X25 15   /* KMS11 X.25 P. E.                                   */
#define DT$_YO_X25 16   /* " " "                                              */
#define DT$_YP_ADCCP 17 /* " ADCCP P.E.                                       */
#define DT$_YQ_3271 18  /* " " "                                              */
#define DT$_YR_DDCMP 19 /* " DDCMP                                            */
#define DT$_YS_SDLC 20  /* " SDLC                                             */
#define DT$_UK_KTC32 21 /* " KTC32                                            */
#define DT$_DEQNA 22    /* Q-BUS to NI adapter                                */
#define DT$_DMV11 23    /* DMV11                                              */
#define DT$_ES_LANCE 24 /* SCORPIO to NI adapter                              */
#define DT$_DELUA 25    /* LSI version of DEUNA                               */
#define DT$_NQ_3271 26  /* DHCF                                               */
#define DT$_DMB32 27    /* DMB32 (BICombo)                                    */
#define DT$_YI_KMS11K 28        /* not a product, used by field service       */
#define DT$_ET_DEBNT 29 /* DEBNT (DEBNA grandpa)                              */
#define DT$_ET_DEBNA 29 /* DEBNA (BI-NI adapter)                              */
#define DT$_SJ_DSV11 30 /* DSV11 Q-BUS sync adapter                           */
#define DT$_SL_DSB32 31 /* DSB32 BI sync adaptor                              */
#define DT$_ZS_DST32 32 /* DST32, X25                                         */
#define DT$_XQ_DELQA 33 /* DELQA - Q-BUS to NI adaptor                        */
/*                                                                            */
/* LINE PRINTER AND CARD READER DEVICE TYPES                                  */
/*                                                                            */
#define DT$_LP11 1      /* LP11                                               */
#define DT$_LA11 2      /* LA11                                               */
#define DT$_LA180 3     /* LA180                                              */
#define DT$_LC_DMF32 4  /* DMF32                                              */
#define DT$_LI_DMB32 5  /* DMB32                                              */
#define DT$_PRTR9 6     /*Printer on 009                                      */
#define DT$_CR11 1      /* CR11 CARD READER                                   */
/*                                                                            */
/* MAILBOX DEVICE TYPES                                                       */
/*                                                                            */
#define DT$_MBX 1       /* LOCAL MEMORY MAILBOX                               */
#define DT$_SHRMBX 2    /* SHARED MEMORY MAILBOX                              */
#define DT$_NULL 3      /* The NULL DEVICE                                    */
/*                                                                            */
/* REALTIME DEVICE TYPES                                                      */
/*                                                                            */
#define DT$_LPA11 1     /* LPA-11                                             */
#define DT$_DR780 2     /* DR780                                              */
#define DT$_DR750 3     /* DR750                                              */
#define DT$_DR11W 4     /* DR11W                                              */
#define DT$_PCL11R 5    /* PCL11 RECEIVER (CSS)                               */
#define DT$_PCL11T 6    /* PCL11 TRANSMTTER (CSS)                             */
#define DT$_DR11C 7     /* DR11C PARALLEL INTERFACE                           */
#define DT$_BS_DT07 8   /* UNIBUS SWITCH                                      */
#define DT$_XP_PCL11B 9 /* PCL-11B (DECNET and NONDECNET mode CSS)            */
#define DT$_IX_IEX11 10 /* IEEE-488 to UNIBUS INTERFACE                       */
#define DT$_FP_FEPCM 11 /* FEPCM CSS frontend processor                       */
#define DT$_TK_FCM 12   /* FEPCM CSS frontend processor                       */
#define DT$_XI_DR11C 13 /* PARALLEL INTERFACE ON DMF-32                       */
#define DT$_XA_DRV11WA 14       /* DMA Parallel Interface                     */
#define DT$_DRB32 15    /* DRB32 (or MFA)                                     */
#define DT$_HX_DRQ3B 16 /* DRQ3B PARALLEL INTERFACE                           */
/*                                                                            */
/* BUS CLASS DEVICES                                                          */
/*                                                                            */
#define DT$_CI780 1     /* CI780                                              */
#define DT$_CI750 2     /* CI750                                              */
#define DT$_UQPORT 3    /* UQPORT is generic UDA                              */
#define DT$_UDA50 3     /* UDA50                                              */
#define DT$_UDA50A 4    /* UDA50A                                             */
#define DT$_LESI 5      /* Low end storage                                    */
#define DT$_TU81P 6     /* TU81 port                                          */
#define DT$_RDRX 7      /* RDRX port                                          */
#define DT$_TK50P 8     /* TK50 port                                          */
#define DT$_RUX50P 9    /* RUX50 port                                         */
#define DT$_RC26P 10    /* RC26P port                                         */
#define DT$_QDA50 11    /* KDA50 port (old name)                              */
#define DT$_KDA50 11    /* KDA50 port                                         */
#define DT$_BDA50 12    /* KDB50 port (old name)                              */
#define DT$_KDB50 12    /* KDB50 port (alias BDA50)                           */
#define DT$_RRD50P 13   /* RRD50 port                                         */
#define DT$_QDA25 14    /* KDA25 port (old name)                              */
#define DT$_KDA25 14    /* KDA25 port                                         */
#define DT$_BCI750 15   /* BI-CI750 port                                      */
#define DT$_BCA 16      /* BI-CI port                                         */
#define DT$_RQDX3 17    /* RQDX3 port                                         */
#define DT$_NISCA 18    /* NI-SCA port                                        */
#define DT$_AIO 19      /* BVP SSP port                                       */
#define DT$_KFBTA 19    /* BVP SSP port                                       */
#define DT$_AIE 20      /* BVP multi-port                                     */
#define DT$_DEBNT 20    /* BVP multi-port                                     */
#define DT$_BSA 21
#define DT$_KSB50 21
#define DT$_TK70P 22    /* TK70 port                                          */
#define DT$_RV20P 23
#define DT$_RV80P 23
#define DT$_TK60P 24    /* TK60 port                                          */
#define DT$_SII 25
#define DT$_KFSQSA 26
#define DT$_SHAC 27
#define DT$_CIXCA 28
#define DT$_CIXCB 29
/*                                                                            */
/* MISCELLANEOUS DEVICES                                                      */
/*                                                                            */
#define DT$_DN11 1      /* AUTODIALER                                         */
#define DT$_PV 2        /* Pseudo keyboard                                    */
#define DT$_SFUN9 3
#define DT$_USER9 4
#endif
