/* Created by SDL V3.1-7     */
/* Source:  8-AUG-1988 10:34:47 EMULEX$DISK:[MEADOWS.UNSDL.VMS5-0_H]STARDEFFL.S */
#ifndef $IODEF_H
#define $IODEF_H
 
/*** MODULE $IODEF ***/
/*+                                                                           */
/* I/O FUNCTION CODE DEFINITIONS                                              */
/*-                                                                           */
/*                                                                            */
/* *** START PHYSICAL I/O FUNCTION CODES ***                                  */
/*                                                                            */
#define IO$_NOP 0       /*NO OPERATION                                        */
#define IO$_UNLOAD 1    /*UNLOAD DRIVE                                        */
#define IO$_LOADMCODE 1 /*LOAD MICROCODE                                      */
#define IO$_SEEK 2      /*SEEK CYLINDER                                       */
#define IO$_SPACEFILE 2 /*SPACE FILES                                         */
#define IO$_STARTMPROC 2        /*START MICROPROCESSOR                        */
#define IO$_RECAL 3     /*RECALIBRATE DRIVE                                   */
#define IO$_STOP 3      /*STOP                                                */
#define IO$_DRVCLR 4    /*DRIVE CLEAR                                         */
#define IO$_INITIALIZE 4        /*INITIALIZE                                  */
#define IO$_RELEASE 5   /*RELEASE PORT                                        */
#define IO$_SETCLOCKP 5 /*SET CLOCK (PHYSICAL)                                */
#define IO$_OFFSET 6    /*OFFSET READ HEADS                                   */
#define IO$_ERASETAPE 6 /*ERASE TAPE                                          */
#define IO$_STARTDATAP 6        /*START DATA TRANSFER (PHYSICAL)              */
#define IO$_RETCENTER 7 /*RETURN TO CENTERLINE                                */
#define IO$_QSTOP 7     /*QUEUE STOP REQUEST                                  */
#define IO$_PACKACK 8   /*PACK ACKNOWLEDGE                                    */
#define IO$_SEARCH 9    /*SEARCH FOR SECTOR                                   */
#define IO$_SPACERECORD 9       /*SPACE RECORDS                               */
#define IO$_READRCT 9   /*READ REPLACEMENT & CACHING TABLE                    */
#define IO$_WRITECHECK 10       /*WRITE CHECK DATA                            */
#define IO$_WRITEPBLK 11        /*WRITE PHYSICAL BLOCK                        */
#define IO$_READPBLK 12 /*READ PHYSICAL BLOCK                                 */
#define IO$_WRITEHEAD 13        /*WRITE HEADER AND DATA                       */
#define IO$_RDSTATS 13  /*READ STATISTICS                                     */
#define IO$_CRESHAD 13  /*CREATE A SHADOW SET                                 */
#define IO$_READHEAD 14 /*READ HEADER AND DATA                                */
#define IO$_ADDSHAD 14  /*ADD MEMBER TO SHADOW SET                            */
#define IO$_WRITETRACKD 15      /*WRITE TRACK DATA                            */
#define IO$_COPYSHAD 15 /*PERFORM SHADOW SET COPY OPERATIONS                  */
#define IO$_READTRACKD 16       /*READ TRACK DATA                             */
#define IO$_REMSHAD 16  /*REMOVE MEMBER FROM SHADOW SET                       */
#define IO$_AVAILABLE 17        /*AVAILABLE (DISK AND TAPE CLASS)             */
#define IO$_SETPRFPATH 18       /*SET PREFERRED PATH                          */
#define IO$_DSE 21      /*DATA SECURITY ERASE (AND REWIND)                    */
#define IO$_REREADN 22  /*REREAD NEXT                                         */
#define IO$_REREADP 23  /*REREAD PREVIOUS                                     */
#define IO$_WRITERET 24 /*WRITE RETRY                                         */
#define IO$_WRITECHECKH 24      /*WRITE CHECK HEADER AND DATA                 */
#define IO$_READPRESET 25       /*READIN PRESET                               */
#define IO$_STARTSPNDL 25       /*START SPINDLE                               */
#define IO$_SETCHAR 26  /*SET CHARACTERISTICS                                 */
#define IO$_SENSECHAR 27        /*SENSE TAPE CHARACTERISTICS                  */
#define IO$_WRITEMARK 28        /*WRITE TAPE MARK                             */
#define IO$_WRTTMKR 29  /*WRITE TAPE MARK RETRY                               */
#define IO$_DIAGNOSE 29 /*DIAGNOSE                                            */
#define IO$_SHADMV 29   /*PREFORM MOUNT VER. ON SHADOW SET                    */
#define IO$_FORMAT 30   /*FORMAT                                              */
#define IO$_CLEAN 30    /*CLEAN TAPE                                          */
#define IO$_PHYSICAL 31 /*HIGHEST PHYSICAL I/O FUNCTION CODE                  */
/*                                                                            */
/* *** START LOGICAL I/O FUNCTION CODES ***                                   */
/*                                                                            */
#define IO$_WRITELBLK 32        /*WRITE LOGICAL BLOCK                         */
#define IO$_READLBLK 33 /*READ LOGICAL BLOCK                                  */
#define IO$_REWINDOFF 34        /*REWIND AND SET OFFLINE                      */
#define IO$_READRCTL 34 /*READ RCT SECTOR ZERO                                */
#define IO$_SETMODE 35  /*SET MODE                                            */
#define IO$_REWIND 36   /*REWIND TAPE                                         */
#define IO$_SKIPFILE 37 /*SKIP FILES                                          */
#define IO$_SKIPRECORD 38       /*SKIP RECORDS                                */
#define IO$_SENSEMODE 39        /*SENSE TAPE MODE                             */
#define IO$_WRITEOF 40  /*WRITE END OF FILE                                   */
#define IO$_TTY_PORT 41 /*TERMINAL PORT FDT ROUTINE                           */
#define IO$_FREECAP 41  /*RETURN FREE CAPACITY                                */
#define IO$_FLUSH 42    /*FLUSH CONTROLLER CACHE                              */
#define IO$_LOGICAL 47  /*HIGHEST LOGICAL I/O FUNCTION CODE                   */
/*                                                                            */
/* *** START VIRTUAL I/O FUNCTION CODES                                       */
/*                                                                            */
#define IO$_WRITEVBLK 48        /*WRITE VIRTUAL BLOCK                         */
#define IO$_READVBLK 49 /*READ VIRTUAL BLOCK                                  */
#define IO$_ACCESS 50   /*ACCESS FILE                                         */
#define IO$_CREATE 51   /*CREATE FILE                                         */
#define IO$_DEACCESS 52 /*DEACCESS FILE                                       */
#define IO$_DELETE 53   /*DELETE FILE                                         */
#define IO$_MODIFY 54   /*MODIFY FILE                                         */
#define IO$_NETCONTROL 54       /*X25 NETWORK CONTROL FUNCTION                */
#define IO$_READPROMPT 55       /*READ TERMINAL WITH PROMPT                   */
#define IO$_SETCLOCK 55 /*SET CLOCK                                           */
#define IO$_ACPCONTROL 56       /*MISCELLANEOUS ACP CONTROL                   */
#define IO$_STARTDATA 56        /*START DATA                                  */
#define IO$_MOUNT 57    /*MOUNT VOLUME                                        */
#define IO$_TTYREADALL 58       /* TERMINAL READ PASSALL                      */
#define IO$_TTYREADPALL 59      /* TERM READ W/PROMPT PASSALL                 */
#define IO$_CONINTREAD 60       /* Connect to interrupt readonly              */
#define IO$_CONINTWRITE 61      /* Connect to interrupt with write            */
#define IO$_VIRTUAL 63  /*HIGHEST VIRTUAL I/O FUNCTION                        */
/*                                                                            */
/* FUNCTION MODIFIER BIT DEFINITIONS                                          */
/*                                                                            */
#define IO$M_FCODE 0x0000003F
#define IO$M_FMODIFIERS 0x0000FFC0
#define IO$M_INHERLOG 0x00000800
#define IO$M_ERASE 0x00000400
#define IO$M_ENCRYPT 0x00002000
#define IO$M_DATACHECK 0x00004000
#define IO$M_INHRETRY 0x00008000
#define IO$M_INHSEEK 0x00001000
#define IO$M_REVERSE 0x00000040
#define IO$M_NOWAIT 0x00000080
#define IO$M_INHEXTGAP 0x00001000
#define IO$M_MSCPMODIFS 0x00000100
#define IO$M_SHADOW 0x00000040
#define IO$M_LOCATE 0x00000080
#define IO$M_MSCP_FORMAT 0x00000040
#define IO$M_ALLHOSTS 0x00000040
#define IO$M_DISSOLVE 0x00000080
#define IO$M_NOCLEANUP 0x00000100
#define IO$M_SPINDOWN 0x00000040
#define IO$M_FORCEPATH 0x00000040
#define IO$M_COMMOD 0x00000040
#define IO$M_MOVETRACKD 0x00000080
#define IO$M_DIAGNOSTIC 0x00000100
#define IO$M_SKPSECINH 0x00000200
#define IO$M_DELDATA 0x00000040
#define IO$M_NOMRSP 0x00000040
#define IO$M_SWAP 0x00000100
#define IO$M_OPPOSITE 0x00000200
#define IO$M_CLSEREXCP 0x00000200
#define IO$M_ACCESS 0x00000040
#define IO$M_CREATE 0x00000080
#define IO$M_DELETE 0x00000100
#define IO$M_MOUNT 0x00000200
#define IO$M_DMOUNT 0x00000400
#define IO$M_REMOUNT 0x00000800
#define IO$M_BINARY 0x00000040
#define IO$M_PACKED 0x00000080
#define IO$M_NOW 0x00000040
#define IO$M_READATTN 0x00000080
#define IO$M_WRTATTN 0x00000100
#define IO$M_SETPROT 0x00000200
#define IO$M_NORSWAIT 0x00000400
#define IO$M_NOECHO 0x00000040
#define IO$M_TIMED 0x00000080
#define IO$M_CVTLOW 0x00000100
#define IO$M_NOFILTR 0x00000200
#define IO$M_DSABLMBX 0x00000400
#define IO$M_PURGE 0x00000800
#define IO$M_TRMNOECHO 0x00001000
#define IO$M_REFRESH 0x00002000
#define IO$M_ESCAPE 0x00004000
#define IO$M_EXTEND 0x00008000
#define IO$M_CANCTRLO 0x00000040
#define IO$M_ENABLMBX 0x00000080
#define IO$M_NOFORMAT 0x00000100
#define IO$M_BREAKTHRU 0x00000200
#define IO$M_NEWLINE 0x00000400
#define IO$M_TYPEAHDCNT 0x00000040
#define IO$M_MAINT 0x00000040
#define IO$M_CTRLYAST 0x00000080
#define IO$M_CTRLCAST 0x00000100
#define IO$M_HANGUP 0x00000200
#define IO$M_OUTBAND 0x00000400
#define IO$M_TT_CONNECT 0x00000800
#define IO$M_TT_DISCON 0x00001000
#define IO$M_TT_PROCESS 0x00002000
#define IO$M_BRDCST 0x00004000
#define IO$M_LOOP 0x00000080
#define IO$M_UNLOOP 0x00000100
#define IO$M_LINE_OFF 0x00000200
#define IO$M_SET_MODEM 0x00000400
#define IO$M_LINE_ON 0x00000800
#define IO$M_LOOP_EXT 0x00001000
#define IO$M_AUTXOF_ENA 0x00002000
#define IO$M_AUTXOF_DIS 0x00004000
#define IO$M_INCLUDE 0x00000800
#define IO$M_TT_ABORT 0x00001000
#define IO$M_INTERRUPT 0x00000040
#define IO$M_MULTIPLE 0x00000080
#define IO$M_LOCKBUF 0x00000100
#define IO$M_NOBLOCK 0x00000200
#define IO$M_ABORT 0x00000100
#define IO$M_SYNCH 0x00000200
#define IO$M_RESPONSE 0x00000040
#define IO$M_STARTUP 0x00000040
#define IO$M_SHUTDOWN 0x00000080
#define IO$M_ATTNAST 0x00000100
#define IO$M_CTRL 0x00000200
#define IO$M_RD_MEM 0x00000040
#define IO$M_RD_MODEM 0x00000080
#define IO$M_RD_COUNT 0x00000100
#define IO$M_CLR_COUNT 0x00000400
#define IO$K_SRRUNOUT 0 /* Send or rcv until cnt runout                       */
#define IO$K_PTPBSC 8192        /* Point to point BSC control                 */
#define IO$K_LOOPTEST 57344     /* Loop test                                  */
/* X25 driver WRITEBLK function modifier bits.                                */
#define IO$M_MORE 0x00000040
#define IO$M_QUALIFIED 0x00000080
#define IO$M_REDIRECT 0x00000040
#define IO$M_ACCEPT 0x00000080
#define IO$M_SETEVF 0x00000040
#define IO$M_WORD 0x00000040
#define IO$M_SETFNCT 0x00000200
#define IO$M_DATAPATH 0x00000400
#define IO$M_CYCLE 0x00001000
#define IO$M_RESET 0x00002000
#define IO$M_SETCUADR 0x00000100
#define IO$M_SETBSIZE 0x00000200
#define IO$M_SETPOOLSZ 0x00000400
#define IO$M_SETENQCNT 0x00000800
#define IO$M_CLEAR 0x00001000
#define IO$M_LPBEXT 0x00002000
#define IO$M_LPBINT 0x00004000
#define IO$M_READCSR 0x00008000
#define IO$M_NOCTSWAIT 0x00000040
#define IO$M_SLAVLOOP 0x00000080
#define IO$M_NODSRWAIT 0x00000100
#define IO$M_MAINTLOOP 0x00000200
#define IO$M_LASTBLOCK 0x00000400
#define IO$M_INTCLOCK 0x00001000
#define IO$M_LT_CONNECT 0x00000040
#define IO$M_LT_DISCON 0x00000080
#define IO$M_LT_READPORT 0x00000100
#define IO$M_LT_MAP_PORT 0x00000200
#define IO$M_LT_RATING 0x00000400
#define IO$M_LT_SOL_INFO 0x00000800
#define IO$M_LT_RCV_INFO 0x00001000
#define IO$M_LT_MAP_FILLER 0x00000001
#define IO$M_LT_MAP_NODNAM 0x00000002
#define IO$M_LT_MAP_PORNAM 0x00000004
#define IO$M_LT_MAP_SRVNAM 0x00000008
#define IO$M_LT_MAP_LNKNAM 0x00000010
#define IO$M_LT_MAP_NETADR 0x00000020
union iodef {
/* Basic I/O function code/modifiers structure                                */
    struct {
        unsigned io$v_fcode : 6;        /* Function Code Field                */
        unsigned io$v_fmodifiers : 10;  /* Function Modifiers Field           */
        } io$r_fcode_structure;
/* Function modifiers common to all drivers which do error logging            */
    struct {
        unsigned io$v_fcode_fill : 6;
        unsigned io$v_filler : 5;
        unsigned io$v_inherlog : 1;     /* Inhibit error logging              */
        unsigned io$v_fill_6 : 4;
        } io$r_errlog_modifiers;
/* General disk and tape function code modifiers                              */
    struct {
        unsigned io$v_fcode_fill : 6;
        unsigned io$v_reserved_for_device_dependent : 4;
        unsigned io$v_erase : 1;        /* Erase data                         */
        unsigned io$v_filler : 1;       /* IO$M_INHERLOG                      */
        unsigned io$v_reserved_for_device_dependent : 1;
        unsigned io$v_encrypt : 1;      /* Encryption                         */
        unsigned io$v_datacheck : 1;    /* Write check data after transfer    */
        unsigned io$v_inhretry : 1;     /* Inhibit error retry                */
        } io$r_disk_tape_modifiers;
/* General disk function code modifiers                                       */
    struct {
        unsigned io$v_fcode_fill : 6;
        unsigned io$v_reserved_for_device_dependent : 6;
        unsigned io$v_inhseek : 1;      /* Inhibit implied seek on physical functions */
        unsigned io$v_fill_7 : 3;
        } io$r_disk_modifiers;
/* General tape function code modifiers                                       */
    struct {
        unsigned io$v_fcode_fill : 6;
        unsigned io$v_reverse : 1;      /* Reverse operation                  */
        unsigned io$v_nowait : 1;       /* No wait for rewind to complete     */
        unsigned io$v_reserved_for_device_dependent : 4;
        unsigned io$v_inhextgap : 1;    /* Inhibit extended inter-record gap  */
        unsigned io$v_fill_8 : 3;
        } io$r_tape_modifiers;
/* DU  & TU, disk & tape class driver transfer function modifier bits         */
    struct {
        unsigned io$v_fcode_fill : 6;
        unsigned io$v_dutux_reserved : 2;
        unsigned io$v_mscpmodifs : 1;   /* Use MSCP modifiers in P5           */
        unsigned io$v_fill_9 : 7;
        } io$r_dutu_xfer_modifiers;
    struct {
        unsigned io$v_fcode_fill : 6;
        unsigned io$v_shadow : 1;       /* Shadowing SENSECHAR                */
        unsigned io$v_locate : 1;       /* Shadowing Locate function          */
        } io$r_du_sense_modifiers;
    struct {
        unsigned io$v_fcode_fill : 6;
        unsigned io$v_mscp_format : 1;  /* PACKACK media for formatting       */
        unsigned io$v_fill_10 : 1;
        } io$r_du_packack_modifiers;
    struct {
        unsigned io$v_fcode_fill : 6;
        unsigned io$v_allhosts : 1;     /* Do available as for all class drivers      */
        unsigned io$v_dissolve : 1;     /* Dissolve shadow set                */
        unsigned io$v_nocleanup : 1;    /* Normal shadow set cleanup not necessary    */
        unsigned io$v_fill_11 : 7;
        } io$r_du_avail_modifiers;
    struct {
        unsigned io$v_fcode_fill : 6;
        unsigned io$v_spindown : 1;     /* Spin down removed member           */
        unsigned io$v_fill_12 : 1;
        } io$r_du_remshad_modifiers;
    struct {
        unsigned io$v_fcode_fill : 6;
        unsigned io$v_forcepath : 1;    /* Make path change happen            */
        unsigned io$v_fill_13 : 1;
        } io$r_du_prfpath_modifiers;
/* DR driver function modifier bits.                                          */
    struct {
        unsigned io$v_fcode_fill : 6;
        unsigned io$v_commod : 1;       /* Diagnostic command                 */
        unsigned io$v_movetrackd : 1;   /* Move track descriptor              */
        unsigned io$v_diagnostic : 1;   /* Diagnostic function                */
        unsigned io$v_skpsecinh : 1;    /* Skip sector inhibit                */
        unsigned io$v_fill_14 : 6;
        } io$r_dr_modifiers;
/* DY driver function modifier bits.                                          */
    struct {
        unsigned io$v_fcode_fill : 6;
        unsigned io$v_deldata : 1;      /* Write deleted data mark            */
        unsigned io$v_fill_15 : 1;
        } io$r_dy_modifiers;
/* DD driver (TU58) function modifier bits.                                   */
    struct {
        unsigned io$v_fcode_fill : 6;
        unsigned io$v_nomrsp : 1;       /* Do not use MRSP for this operation */
        unsigned io$v_fill_16 : 1;
        } io$r_dd_modifiers;
/* Magnetic tape I/O function modifier bits for the TS11.                     */
    struct {
        unsigned io$v_fcode_fill : 6;
        unsigned io$v_reserved_for_device_dependent : 2;
        unsigned io$v_swap : 1; /* Swap byte (TS11)                           */
        unsigned io$v_opposite : 1;     /* Opposite bit for rereads (TS11)    */
        unsigned io$v_fill_17 : 6;
        } io$r_ts11_modifiers;
/* TU driver function modifier bits                                           */
    struct {
        unsigned io$v_fcode_fill : 6;
        unsigned io$v_reserved_for_device_dependent : 3;
        unsigned io$v_clserexcp : 1;    /* Clear serious exception condition  */
        unsigned io$v_fill_18 : 6;
        } io$r_tu_modifiers;
/* ACP function modifier bits.                                                */
    struct {
        unsigned io$v_fcode_fill : 6;
        unsigned io$v_access : 1;       /* Access file                        */
        unsigned io$v_create : 1;       /* Create file                        */
        unsigned io$v_delete : 1;       /* Delete file                        */
        unsigned io$v_mount : 1;        /* Mount volume                       */
        unsigned io$v_dmount : 1;       /* Dismount volume                    */
        unsigned io$v_remount : 1;      /* Remount volume                     */
        unsigned io$v_fill_19 : 4;
        } io$r_acp_modifiers;
/* CR (card reader) driver function modifier bits.                            */
    struct {
        unsigned io$v_fcode_fill : 6;
        unsigned io$v_binary : 1;       /* Binary read                        */
        unsigned io$v_packed : 1;       /* Packed read                        */
        } io$r_cr_modifiers;
/* MB (mailbox) driver function modifier bits.                                */
    struct {
        unsigned io$v_fcode_fill : 6;
        unsigned io$v_now : 1;  /* Do not wait for operation complete         */
        unsigned io$v_readattn : 1;     /* Request ast on waiting reader      */
        unsigned io$v_wrtattn : 1;      /* Request ast on waiting writer      */
        unsigned io$v_setprot : 1;      /* Set volume protection              */
        unsigned io$v_norswait : 1;     /* Do not allow resource waits        */
        unsigned io$v_fill_20 : 5;
        } io$r_mb_modifiers;
/* TT driver READ function modifier bits.                                     */
    struct {
        unsigned io$v_fcode_fill : 6;
        unsigned io$v_noecho : 1;       /* Noecho                             */
        unsigned io$v_timed : 1;        /* Timed                              */
        unsigned io$v_cvtlow : 1;       /* Convert lower case                 */
        unsigned io$v_nofiltr : 1;      /* No filter                          */
        unsigned io$v_dsablmbx : 1;     /* Disable mailbox                    */
        unsigned io$v_purge : 1;        /* Purge typeahead                    */
        unsigned io$v_trmnoecho : 1;    /* Terminators are not echoed         */
        unsigned io$v_refresh : 1;      /* Control-R interrupted read         */
        unsigned io$v_escape : 1;       /* Terminate read on escape sequence  */
        unsigned io$v_extend : 1;       /* Used by alternate class drivers    */
        } io$r_tt_read_modifiers;
/* TT driver WRITE function modifier bits.                                    */
    struct {
        unsigned io$v_fcode_fill : 6;
        unsigned io$v_canctrlo : 1;     /* Cancel control O                   */
        unsigned io$v_enablmbx : 1;     /* Enable mailbox                     */
        unsigned io$v_noformat : 1;     /* Do not format output               */
        unsigned io$v_breakthru : 1;    /* Broadcast I/O                      */
        unsigned io$v_newline : 1;      /* Output a newline                   */
        unsigned io$v_fill_21 : 5;
        } io$r_tt_write_modifiers;
/* TT driver SENSEMODE function modifier bits.                                */
    struct {
        unsigned io$v_fcode_fill : 6;
        unsigned io$v_typeahdcnt : 1;   /* Sense typeahead information        */
        unsigned io$v_reserve_rd_modem : 1;
        } io$r_tt_sensemode_modifiers;
/* TT driver SETMODE subfunction modifier bits.                               */
    struct {
        unsigned io$v_fcode_fill : 6;
        unsigned io$v_maint : 1;        /* Enable maint sub modifiers         */
        unsigned io$v_ctrlyast : 1;     /* Set control Y AST                  */
        unsigned io$v_ctrlcast : 1;     /* Set Control C                      */
        unsigned io$v_hangup : 1;       /* Set mode and hang up line          */
        unsigned io$v_outband : 1;      /* Set out of band AST                */
        unsigned io$v_tt_connect : 1;   /* Connect to detached terminal       */
        unsigned io$v_tt_discon : 1;    /* Disconnect detached terminal       */
        unsigned io$v_tt_process : 1;   /* Define controlling process         */
        unsigned io$v_brdcst : 1;       /* Define broadcast mask              */
        unsigned io$v_fill_22 : 1;
        } io$r_tt_setmode_modifiers;
/* TT driver MAINTIANCE subfunction submodifier bits.                         */
    struct {
        unsigned io$v_fcode_fill : 6;
        unsigned io$v_reserve_maint_escape : 1;
        unsigned io$v_loop : 1; /* Diagnostic loopback                        */
        unsigned io$v_unloop : 1;       /* Diagnostic reset loopback          */
        unsigned io$v_line_off : 1;     /* Disable line                       */
        unsigned io$v_set_modem : 1;    /* Diagnostic modem control           */
        unsigned io$v_line_on : 1;      /* Enable line                        */
        unsigned io$v_loop_ext : 1;     /* Diagnostic external loopback       */
        unsigned io$v_autxof_ena : 1;   /* Enable auto XOFF                   */
        unsigned io$v_autxof_dis : 1;   /* Disable auto XOFF                  */
        unsigned io$v_reserve_int_disable : 1;
        } io$r_tt_maint_modifiers;
/* TT driver out-of-band modifier bits.                                       */
    struct {
        unsigned io$v_fcode_fill : 6;
        unsigned io$v_reserve_maint_escape : 5;
        unsigned io$v_include : 1;      /* Include character in stream        */
        unsigned io$v_tt_abort : 1;     /* Abort current I/O                  */
        unsigned io$v_fill_23 : 3;
        } io$r_tt_outofband_modifiers;
/* Network WRITE and READ VIRTUAL function modifier bits.                     */
    struct {
        unsigned io$v_fcode_fill : 6;
        unsigned io$v_interrupt : 1;    /* Interrupt message                  */
        unsigned io$v_multiple : 1;     /* Multiple write/read request        */
        unsigned io$v_lockbuf : 1;      /* Direct I/O request                 */
        unsigned io$v_noblock : 1;      /* Segment message w/o blocking       */
        unsigned io$v_fill_24 : 6;
        } io$r_net_write_read_modifiers;
/* Network ACCESS/DEACCESS function modifier bits.                            */
    struct {
        unsigned io$v_fcode_fill : 6;
        unsigned io$v_reserved : 2;
        unsigned io$v_abort : 1;        /* Disconnect abort/connect reject    */
        unsigned io$v_synch : 1;        /* Synchronous disconnect             */
        unsigned io$v_fill_25 : 6;
        } io$r_net_accdea_modifiers;
/* DATALINK driver WRITE subfunction modifier bits.                           */
    struct {
        unsigned io$v_fcode_fill : 6;
        unsigned io$v_response : 1;     /* Transmit this packet as a response */
        unsigned io$v_fill_26 : 1;
        } io$r_dlink_write_modifiers;
/* DATALINK driver SETMODE subfunction modifier bits.                         */
    struct {
        unsigned io$v_fcode_fill : 6;
        unsigned io$v_startup : 1;      /* Start protocol                     */
        unsigned io$v_shutdown : 1;     /* Stop protocol                      */
        unsigned io$v_attnast : 1;      /* Attention AST                      */
        unsigned io$v_ctrl : 1; /* Controller (ie. not station) function      */
        unsigned io$v_reserve_set_modem : 1;
        unsigned io$v_fill_27 : 5;
        } io$r_dlink_setmode_modifiers;
/* DATALINK driver SENSEMODE subfunction modifier bits.                       */
    struct {
        unsigned io$v_fcode_fill : 6;
        unsigned io$v_rd_mem : 1;       /* Read device memory                 */
        unsigned io$v_rd_modem : 1;     /* Read modem status                  */
        unsigned io$v_rd_count : 1;     /* Read counters                      */
        unsigned io$v_reserve_ctrl : 1;
        unsigned io$v_clr_count : 1;    /* Clear counters                     */
        unsigned io$v_fill_28 : 5;
        } io$r_dlink_sensemode_modifiers;
    struct {
        unsigned io$v_fcode_fill : 6;
        unsigned io$v_more : 1; /* More data follows (M-bit)                  */
        unsigned io$v_qualified : 1;    /* Use qualified sub-channel (Q-bit)  */
        } io$r_x25_write_modifiers;
/* X25 driver ACCESS function modifier bits.                                  */
    struct {
        unsigned io$v_fcode_fill : 6;
        unsigned io$v_redirect : 1;     /* Redirect virtual call              */
        unsigned io$v_accept : 1;       /* Accept virtual call                */
        } io$r_x25_access_modifiers;
/* LPA-11 driver STARTDATA modifier bits.                                     */
    struct {
        unsigned io$v_fcode_fill : 6;
        unsigned io$v_setevf : 1;       /* Set event flag                     */
        unsigned io$v_fill_29 : 1;
        } io$r_lpa_start_modifiers;
/* XA (DR11-W) driver function modifier bits.                                 */
    struct {
        unsigned io$v_fcode_fill : 6;
        unsigned io$v_word : 1; /* Word (interrupt)/block (DMA) mode specifier*/
        unsigned io$v_filler : 1;       /* IO$M_TIMED                         */
        unsigned io$v_filler : 1;       /* IO$M_ATTNAST, IO$M_DIAGNOSTIC      */
        unsigned io$v_setfnct : 1;      /* Set "FNCT" bits in device CSR      */
        unsigned io$v_datapath : 1;     /* Change UBA datapath (direct/buffered)      */
        unsigned io$v_filler : 1;       /* IO$M_INHERLOG (former def'n for RESET)     */
        unsigned io$v_cycle : 1;        /* Set "cycle" bit in device CSR      */
        unsigned io$v_reset : 1;        /* Device reset specifier             */
        unsigned io$v_fill_30 : 2;
        } io$r_xa_modifiers;
/* 3271 driver function modifier bits.                                        */
    struct {
        unsigned io$v_fcode_fill : 6;
        unsigned io$v_filler : 2;
        unsigned io$v_setcuadr : 1;     /* Set a new CU address               */
        unsigned io$v_setbsize : 1;     /* Set a new maximum buffer size      */
        unsigned io$v_setpoolsz : 1;    /* Set a new pool size                */
        unsigned io$v_setenqcnt : 1;    /* Set a new ENQ threshold            */
        unsigned io$v_clear : 1;        /* Zero status counters               */
        unsigned io$v_lpbext : 1;       /* Loopback is external loopback      */
        unsigned io$v_lpbint : 1;       /* Loopback is internal loopback (DUP11)      */
        unsigned io$v_readcsr : 1;      /* Read CSRs on DUP11                 */
        } io$r_ibm3271_modifiers;
/* XW driver function modifier bits.                                          */
    struct {
        unsigned io$v_fcode_fill : 6;
        unsigned io$v_noctswait : 1;    /* Diagnostic function                */
        unsigned io$v_slavloop : 1;     /* Diagnostic function                */
        unsigned io$v_nodsrwait : 1;    /* Do not wait for DSR (diag)         */
        unsigned io$v_maintloop : 1;    /* Internal maint loop                */
        unsigned io$v_lastblock : 1;    /* Last block of message              */
        unsigned io$v_filler : 1;
        unsigned io$v_intclock : 1;     /* Internal clock                     */
        unsigned io$v_fill_31 : 3;
        } io$r_xw_modifiers;
/* LAT driver function modifier bits.                                         */
    struct {
        unsigned io$v_fcode_fill : 6;
        unsigned io$v_lt_connect : 1;   /* Solicit connection to remote LAT device    */
        unsigned io$v_lt_discon : 1;    /* Disconnect LAT session             */
        unsigned io$v_lt_readport : 1;  /* Read LAT device info               */
        unsigned io$v_lt_map_port : 1;  /* Map application port               */
        unsigned io$v_lt_rating : 1;    /* Set service rating                 */
        unsigned io$v_lt_sol_info : 1;  /* Request solicit info               */
        unsigned io$v_lt_rcv_info : 1;  /* Setup to recive reply              */
        unsigned io$v_fill_32 : 3;
        } io$r_lt_modifiers;
/* LAT item list definitions for MAP_PORT                                     */
    struct {
        unsigned io$v_lt_map_filler : 1;        /* Item 0 not used            */
        unsigned io$v_lt_map_nodnam : 1;        /* Server node name           */
        unsigned io$v_lt_map_pornam : 1;        /* Server port name           */
        unsigned io$v_lt_map_srvnam : 1;        /* Server service name        */
        unsigned io$v_lt_map_lnknam : 1;        /* Link name                  */
        unsigned io$v_lt_map_netadr : 1;        /* Server Ethernet Add.       */
        unsigned io$v_fill_33 : 2;
        } io$r_lt_mapitem;
} ;
#endif
