/* Created by SDL V3.1-7     */
/* Source:  8-AUG-1988 10:38:12 EMULEX$DISK:[MEADOWS.UNSDL.VMS5-0_H]STARDEFQZ.S */
#ifndef $SMRDEF_H
#define $SMRDEF_H
 
/*** MODULE $SMRDEF ***/
/*                                                                            */
/* DEFINE SYMBIONT MANAGER REQUEST CODES                                      */
/*                                                                            */
/* SYMBIONT MANAGER REQUEST CODES                                             */
#define SMR$K_INITIAL 0 /* INITIALIZE A QUEUE                                 */
#define SMR$K_DELETE 1  /* DELETE THE QUEUE                                   */
#define SMR$K_START 2   /* ACTIVATE OR RESUME PRINTING                        */
#define SMR$K_PAUSE 3   /* SUSPEND PRINTING FOR A WHILE                       */
#define SMR$K_MERGE 4   /* MOVE FILES FORM ONE QUEUE INTO ANOTHER             */
#define SMR$K_REDIRECT 5        /* ASSIGNMENT OF ONE QUEUE TO ANOTHER         */
#define SMR$K_JUSTIFY 6 /* JUSTIFY PRINT FORMS(IE: ISSUE FF)                  */
#define SMR$K_STOP 7    /* DISABLE FURTHER DE-QUEING                          */
#define SMR$K_ENTER 8   /* ADD A FILE TO A QUEUE                              */
#define SMR$K_CREJOB 9  /* CREATE A PRINT JOB                                 */
#define SMR$K_ADDFIL 10 /* ADD A FILE TO EXISTING JOB                         */
#define SMR$K_CLSJOB 11 /* CLOSE OPEN JOB                                     */
#define SMR$K_RMVJOB 12 /* REMOVE JOB FROM QUEUE                              */
#define SMR$K_ALTER 13  /* CHANGE A FILES CHARACTERISTICS                     */
#define SMR$K_ABORT 14  /* ABORT CURRENT JOB, START NEXT                      */
#define SMR$K_RELEASE 15        /* RELEASE JOB FROM HOLD LIST                 */
#define SMR$K_DETINIT 16        /* DETACHED JOB HAS INITIATED                 */
#define SMR$K_SYNCJOB 17        /* SYNCRONIZE WITH A BATCH JOB                */
#define SMR$K_ASKQNAM 18        /* GET NAME OF QUEUE FOR LOG FILE             */
/*                                                                            */
/* ASSIGN SYMBIONT MANAGER PRINT JOB/RECORD OPTION CODES                      */
/*                                                                            */
/*                                                                            */
/* JOB FILE OPTIONS                                                           */
#define SMO$K_DELETE 1  /* DELETE THE FILE AFTER PRINTING                     */
#define SMO$K_BRSTPAG 2 /* CREATE A BURST PAGE                                */
#define SMO$K_NOBRSTPAG 3       /* INHIBIT BURST PAGE                         */
#define SMO$K_FLAGPAG 4 /* PRINT A FLAG PAGE                                  */
#define SMO$K_NOFLAGPAG 5       /* INHIBIT A FLAG PAGE                        */
#define SMO$K_PAGHDR 6  /* PRINT FILENAME AS PAGE HEADER                      */
#define SMO$K_DOUBLE 7  /* DOUBLE SPACE THE LISTING                           */
#define SMO$K_NOFEED 8  /* INHIBIT FORM FEED GENERATION                       */
#define SMO$K_PAGCNT 9  /* SPECIFY PAGE COUNT TO PRINT                        */
#define SMO$K_COPIES 10 /* NUMBER OF COPIES TO PRINT                          */
#define SMO$K_FILESIZ 11        /* FILE SIZE                                  */
#define SMO$K_DESTQUE 12        /* DESTINATION QUEUE                          */
/* OPTIONS FOR CREATE JOB                                                     */
#define SMO$K_RLSTIM 32 /* TIME TO HOLD UNTIL QUEUEING                        */
#define SMO$K_HOLD 33   /* HOLD THE JOB                                       */
#define SMO$K_JOBPRI 34 /* SPECIFY PRINT JOB/DETACHED JOB PRIOITY             */
#define SMO$K_JOBCOPY 35        /* NUMBER OF COPIES OF ENTIRE JOB             */
#define SMO$K_FORMTYPE 36       /* FORM TYPE TO USED WHEN PRINTED             */
#define SMO$K_LOWER 37  /* UPPER/LOWER CASE PRINTER ONLY                      */
#define SMO$K_PARAMS 38 /* SUPPLY JOB PARAMETERS                              */
#define SMO$K_JOBNAME 39        /* SUPPLY A NAME TO THE JOB                   */
#define SMO$K_NOLOWER 40        /* CLEAR LOWER CASE REQUIRED                  */
#define SMO$K_CPULIM 41 /* CPU TIME LIMIT                                     */
#define SMO$K_NOCPULM 42        /* NO CPU TIME LIMIT                          */
#define SMO$K_WSQUOTA 43        /* WORKING SET QUOTA                          */
#define SMO$K_NOWSQUO 44        /* NO WORKING SET QUOTA                       */
#define SMO$K_WSDEFLT 45        /* WORKING SET DEFAULT                        */
#define SMO$K_NOWSDFT 46        /* NO WORKING SET DEFAULT                     */
#define SMO$K_DQCHAR 47 /* CHAR. TO BE USED WHEN PRINTED                      */
#define SMO$K_LOGFNAM 48        /* LOG FILE SPEC.                             */
#define SMO$K_LOGQNAM 49        /* QUEUE NAME FOR LOG FILE                    */
#define SMO$K_KEEPLOG 50        /* KEEP LOG FILE                              */
#define SMO$K_NOSPOOL 51        /* DON'T SPOOL LOG FILE                       */
#define SMO$K_NOKEEPLOG 52      /* DELETE LOG FILE                            */
#define SMO$K_NOLOG 53  /* CREATE LOG ON NULL DEVICE                          */
#define SMO$K_NOTIFY 54 /* NOTIFY WHEN JOB COMPLETES                          */
#define SMO$K_NONOTFY 55        /* NO NOTIFY                                  */
#define SMO$K_WSEXTNT 56        /* WS EXTENT                                  */
#define SMO$K_NOWSEXTNT 57      /* NO WS EXTENT                               */
/* OPTIONS FOR INIT OR START A QUEUE                                          */
#define SMO$K_CURFORM 64        /* CURRENT FORMS MOUNTED ON DEVICE            */
#define SMO$K_GENPRT 65 /* ALLOW GENERIC PRINTING                             */
#define SMO$K_NOGENPRT 66       /* DISALLOW GENERIC PRINTING                  */
#define SMO$K_DETJOB 67 /* QUEUE IS FOR DETACHED JOB QUEUING                  */
#define SMO$K_GENDEV 68 /* QUEUE IS GENERIC DEVICE QUEUE                      */
#define SMO$K_NOGENDEV 69       /* NOT A GENERIC DEVICE                       */
#define SMO$K_DEFBRST 70        /* QUEUE HAS BURST PAGE BY DEFAULT            */
#define SMO$K_NODEFBRST 71      /* NO DEFAULT BURST PAGE                      */
#define SMO$K_DEFFLAG 72        /* QUEUE HAS FLAG PAGE BY DEFAULT             */
#define SMO$K_NODEFFLAG 73      /* NO DEFAULT FLAG                            */
#define SMO$K_TRMDEV 74 /* DEVICE IS A TERMINAL                               */
#define SMO$K_NOTRMDEV 75       /* DEVICE IS NOT A TERMINAL                   */
#define SMO$K_JOBLIM 76 /* JOB LIMIT FOR BATCH JOBS                           */
#define SMO$K_INIPRI 77 /* JOB INITIAL PRIORITY                               */
#define SMO$K_DISWAP 78 /* DISABLE SWAPING                                    */
#define SMO$K_MCPULM 79 /* MAX CPU TIME LIMIT                                 */
#define SMO$K_NOMCPULM 80       /* NO MAX CPU TIME LIMIT                      */
#define SMO$K_DCPULM 81 /* DEFAULT CPU TIME LIMIT                             */
#define SMO$K_NODCPULM 82       /* NO DEFAULT CPU TIME LIMIT                  */
#define SMO$K_WSQUTA 83 /* WORKING SET QUOTA                                  */
#define SMO$K_NOWSQUTA 84       /* NO WORKING SET QUOTA                       */
#define SMO$K_WSDFLT 85 /* WORKING SET DEFAULT                                */
#define SMO$K_NOWSDFLT 86       /* NO WORKING SET DEFAULT                     */
#define SMO$K_CURDQCHAR 87      /* CURRENT CHAR. OF THE QUEUE                 */
#define SMO$K_SMBNAME 88        /* SYMBIONT NAME FOR QUEUE                    */
#define SMO$K_WSXTANT 89        /* WS EXTENT                                  */
#define SMO$K_NOWSXTNT 90       /* NO WS EXTENT                               */
#define SMO$K_NODISWAP 91       /* ENABLE SWAPPING                            */
/* OPTIONS FOR RESTART                                                        */
#define SMO$K_NEXTJOB 96        /* RESTART AT END BEGINNING OF NEXT JOB       */
#define SMO$K_TOPOFILE 97       /* RESTART JOB AT TOP-OF-FILE                 */
#define SMO$K_SPCCNT 98 /* SPECIFY PAGES TO SPACE OVER                        */
/* OPTIONS FOR ABORT                                                          */
#define SMO$K_REQUEUE 112       /* REQUEUE THE FILE                           */
#define SMO$K_REQDEST 113       /* SPECIFY NEW QUEUE DESTINATION              */
#define SMO$K_REQPRIO 114       /* SPECIFY PRIORITY ON REQUEUE                */
#endif
