/* Created by SDL V3.1-7     */
/* Source:  8-AUG-1988 10:38:12 EMULEX$DISK:[MEADOWS.UNSDL.VMS5-0_H]STARDEFQZ.S */
#ifndef $XWDEF_H
#define $XWDEF_H
 
/*** MODULE $XWDEF ***/
/*++                                                                          */
/*                                                                            */
/* XWDEF - System definitions for software DDCMP                              */
/*                                                                            */
/*--                                                                          */
#define XW$M_CHA_FDX 0x00000001
#define XW$M_CHA_XPR 0x00000002
#define XW$M_CHA_DSR 0x00000004
#define XW$M_FAT_STAT 0x000003FF
#define XW$M_INFO_STAT 0x0000FC00
#define XW$M_EOT 0x00000001
#define XW$M_DATACK 0x00000002
#define XW$M_NODSR 0x00000004
#define XW$M_DISCON 0x00000008
#define XW$M_TRABINTMO 0x00000010
#define XW$M_PIPE_MARK 0x00000020
#define XW$M_BADCHAIN 0x00000040
#define XW$M_ILLMOD 0x00000080
#define XW$M_RVI 0x00000400
#define XW$M_CONACK 0x00000800
#define XW$M_XPR 0x00001000
#define XW$M_ETXEND 0x00002000
#define XW$M_PUNCH 0x00010000
#define XW$M_HOR_FOR 0x00020000
#define XW$M_IOMOD 0x0000E000
union xwdef {
    struct {
        unsigned xw$v_cha_fdx : 1;      /* Full duplex line                   */
        unsigned xw$v_cha_xpr : 1;      /* Transparency                       */
        unsigned xw$v_cha_dsr : 1;      /* Data Set Ready set                 */
        unsigned xw$v_fill_11 : 5;
        } xw$r_xwdef_bits0;
/*                                                                            */
/* Device dependent status                                                    */
/*                                                                            */
    struct {
        unsigned xw$v_fat_stat : 10;    /* Beginning of fatal stat flags      */
        unsigned xw$v_info_stat : 6;    /* Start of informational status      */
        } xw$r_xwdef_bits1;
/*                                                                            */
/* Bit definitions for fatal and informational status fields                  */
/*                                                                            */
    struct {
        unsigned xw$v_eot : 1;  /* EOT received                               */
        unsigned xw$v_datack : 1;       /* Retry threshold exceeded           */
        unsigned xw$v_nodsr : 1;        /* Line not connected                 */
        unsigned xw$v_discon : 1;       /* Disconnect (DLE, EOT) rcvd         */
        unsigned xw$v_trabintmo : 1;    /* Binary transmit timeout            */
        unsigned xw$v_pipe_mark : 1;    /* Aborted because of pipe mark       */
        unsigned xw$v_badchain : 1;     /* Bad record list                    */
        unsigned xw$v_illmod : 1;       /* Illegal QIO modifier               */
        unsigned xwdef$$_fill_1 : 2;
        unsigned xw$v_rvi : 1;  /* Buffer ACKed with RVI                      */
        unsigned xw$v_conack : 1;       /* Buffer ACKed with conver resp      */
        unsigned xw$v_xpr : 1;  /* Buffer rcvd with transparency              */
        unsigned xw$v_etxend : 1;       /* Rcvd block ended with ETX          */
        unsigned xwdef$$_fill_2 : 2;
        unsigned xw$v_punch : 1;        /* Punch select found                 */
        unsigned xw$v_hor_for : 1;      /* Horizontal forms record rcvd       */
        unsigned xw$v_fill_12 : 6;
        } xw$r_xwdef_bits2;
/*                                                                            */
/* Read/Write function modifier definition                                    */
/*                                                                            */
    struct {
        unsigned xwdef$$_fill_3 : 13;
        unsigned xw$v_iomod : 3;        /* I/O modifier field start           */
        } xw$r_xwdef_bits3;
} ;
#endif
