/* Created by SDL V3.1-7     */
/* Source:  8-AUG-1988 10:16:21 EMULEX$DISK:[MEADOWS.UNSDL.VMS5-0_H]MTH$ROUTINE */
#ifndef MTH$ROUTINES_H
#define MTH$ROUTINES_H
 
/*** MODULE MTH$ROUTINES ***/
/**************************************************************************** */
/*          *                                                                 */
/*  COPYRIGHT (c) 1988 BY                   *                                 */
/*  DIGITAL EQUIPMENT CORPORATION, MAYNARD, MASSACHUSETTS.          *         */
/*  ALL RIGHTS RESERVED.    *                                                 */
/*          *                                                                 */
/*  THIS SOFTWARE IS FURNISHED UNDER A LICENSE AND MAY BE USED AND COPIED   * */
/*  ONLY IN  ACCORDANCE WITH  THE  TERMS  OF  SUCH  LICENSE  AND WITH THE   * */
/*  INCLUSION OF THE ABOVE COPYRIGHT NOTICE. THIS SOFTWARE OR  ANY  OTHER   * */
/*  COPIES THEREOF MAY NOT BE PROVIDED OR OTHERWISE MADE AVAILABLE TO ANY   * */
/*  OTHER PERSON.  NO TITLE TO AND OWNERSHIP OF  THE  SOFTWARE IS  HEREBY   * */
/*  TRANSFERRED.            *                                                 */
/*          *                                                                 */
/*  THE INFORMATION IN THIS SOFTWARE IS  SUBJECT TO CHANGE WITHOUT NOTICE   * */
/*  AND  SHOULD  NOT  BE  CONSTRUED AS  A COMMITMENT BY DIGITAL EQUIPMENT   * */
/*  CORPORATION.    *                                                         */
/*          *                                                                 */
/*  DIGITAL ASSUMES NO RESPONSIBILITY FOR THE USE  OR  RELIABILITY OF ITS   * */
/*  SOFTWARE ON EQUIPMENT WHICH IS NOT SUPPLIED BY DIGITAL.         *         */
/*          *                                                                 */
/*          *                                                                 */
/**************************************************************************** */
/*    MTH$ACOS                                                                */
/*                                                                            */
/*    Arc Cosine of Angle Expressed in Radians                                */
/*                                                                            */
/*    Given the cosine of an angle, the Arc Cosine of Angle Expressed in Radians      */
/*    routine returns that angle                                              */
/*    (in radians).                                                           */
/*                                                                            */
/*+~mth$acos~+*/
float mth$acos(
    const float  *cosine
    ) ;
/*~-mth$acos-~*/
/*    MTH$DACOS                                                               */
/*                                                                            */
/*    Arc Cosine of Angle Expressed in Radians                                */
/*                                                                            */
/*    Given the cosine of an angle, the Arc Cosine of Angle Expressed in Radians      */
/*    routine returns that angle                                              */
/*    (in radians).                                                           */
/*                                                                            */
/*+~mth$dacos~+*/
double float mth$dacos(
    const double float  *cosine
    ) ;
/*~-mth$dacos-~*/
/*    MTH$GACOS                                                               */
/*                                                                            */
/*    Arc Cosine of Angle Expressed in Radians                                */
/*                                                                            */
/*    Given the cosine of an angle, the Arc Cosine of Angle Expressed in Radians      */
/*    routine returns that angle                                              */
/*    (in radians).                                                           */
/*                                                                            */
/*+~mth$gacos~+*/
double float mth$gacos(
    const double float  *cosine
    ) ;
/*~-mth$gacos-~*/
/*    MTH$ACOSD                                                               */
/*                                                                            */
/*    Arc Cosine of Angle Expressed in Degrees                                */
/*                                                                            */
/*    Given the cosine of an angle, the Arc Cosine of Angle Expressed in Degrees      */
/*    routine returns that                                                    */
/*    angle (in degrees).                                                     */
/*                                                                            */
/*+~mth$acosd~+*/
float mth$acosd(
    const float  *cosine
    ) ;
/*~-mth$acosd-~*/
/*    MTH$DACOSD                                                              */
/*                                                                            */
/*    Arc Cosine of Angle Expressed in Degrees                                */
/*                                                                            */
/*    Given the cosine of an angle, the Arc Cosine of Angle Expressed in Degrees      */
/*    routine returns that                                                    */
/*    angle (in degrees).                                                     */
/*                                                                            */
/*+~mth$dacosd~+*/
double float mth$dacosd(
    const double float  *cosine
    ) ;
/*~-mth$dacosd-~*/
/*    MTH$GACOSD                                                              */
/*                                                                            */
/*    Arc Cosine of Angle Expressed in Degrees                                */
/*                                                                            */
/*    Given the cosine of an angle, the Arc Cosine of Angle Expressed in Degrees      */
/*    routine returns that                                                    */
/*    angle (in degrees).                                                     */
/*                                                                            */
/*+~mth$gacosd~+*/
double float mth$gacosd(
    const double float  *cosine
    ) ;
/*~-mth$gacosd-~*/
/*    MTH$ASIN                                                                */
/*                                                                            */
/*    Arc Sine in Radians                                                     */
/*                                                                            */
/*    Given the sine of an angle, the Arc Sine in Radians                     */
/*    routine returns that angle                                              */
/*    (in radians).                                                           */
/*                                                                            */
/*+~mth$asin~+*/
float mth$asin(
    const float  *sine
    ) ;
/*~-mth$asin-~*/
/*    MTH$DASIN                                                               */
/*                                                                            */
/*    Arc Sine in Radians                                                     */
/*                                                                            */
/*    Given the sine of an angle, the Arc Sine in Radians                     */
/*    routine returns that angle                                              */
/*    (in radians).                                                           */
/*                                                                            */
/*+~mth$dasin~+*/
double float mth$dasin(
    const double float  *sine
    ) ;
/*~-mth$dasin-~*/
/*    MTH$GASIN                                                               */
/*                                                                            */
/*    Arc Sine in Radians                                                     */
/*                                                                            */
/*    Given the sine of an angle, the Arc Sine in Radians                     */
/*    routine returns that angle                                              */
/*    (in radians).                                                           */
/*                                                                            */
/*+~mth$gasin~+*/
double float mth$gasin(
    const double float  *sine
    ) ;
/*~-mth$gasin-~*/
/*    MTH$ASIND                                                               */
/*                                                                            */
/*    Arc Sine in Degrees                                                     */
/*                                                                            */
/*    Given the sine of an angle, the Arc Sine in Degrees                     */
/*    routine returns that angle                                              */
/*    (in degrees).                                                           */
/*                                                                            */
/*+~mth$asind~+*/
float mth$asind(
    const float  *sine
    ) ;
/*~-mth$asind-~*/
/*    MTH$DASIND                                                              */
/*                                                                            */
/*    Arc Sine in Degrees                                                     */
/*                                                                            */
/*    Given the sine of an angle, the Arc Sine in Degrees                     */
/*    routine returns that angle                                              */
/*    (in degrees).                                                           */
/*                                                                            */
/*+~mth$dasind~+*/
double float mth$dasind(
    const double float  *sine
    ) ;
/*~-mth$dasind-~*/
/*    MTH$GASIND                                                              */
/*                                                                            */
/*    Arc Sine in Degrees                                                     */
/*                                                                            */
/*    Given the sine of an angle, the Arc Sine in Degrees                     */
/*    routine returns that angle                                              */
/*    (in degrees).                                                           */
/*                                                                            */
/*+~mth$gasind~+*/
double float mth$gasind(
    const double float  *sine
    ) ;
/*~-mth$gasind-~*/
/*    MTH$ATAN                                                                */
/*                                                                            */
/*    Arc Tangent in Radians                                                  */
/*                                                                            */
/*    Given the tangent of an angle, the Arc Tangent in Radians               */
/*    routine returns that angle (in radians).                                */
/*                                                                            */
/*+~mth$atan~+*/
float mth$atan(
    const float  *tangent
    ) ;
/*~-mth$atan-~*/
/*    MTH$DATAN                                                               */
/*                                                                            */
/*    Arc Tangent in Radians                                                  */
/*                                                                            */
/*    Given the tangent of an angle, the Arc Tangent in Radians               */
/*    routine returns that angle (in radians).                                */
/*                                                                            */
/*+~mth$datan~+*/
double float mth$datan(
    const double float  *tangent
    ) ;
/*~-mth$datan-~*/
/*    MTH$GATAN                                                               */
/*                                                                            */
/*    Arc Tangent in Radians                                                  */
/*                                                                            */
/*    Given the tangent of an angle, the Arc Tangent in Radians               */
/*    routine returns that angle (in radians).                                */
/*                                                                            */
/*+~mth$gatan~+*/
double float mth$gatan(
    const double float  *tangent
    ) ;
/*~-mth$gatan-~*/
/*    MTH$ATAN2                                                               */
/*                                                                            */
/*    Arc Tangent in Radians with Two Arguments                               */
/*                                                                            */
/*    Given cosine and cosine, the Arc Tangent in                             */
/*    Radians with Two Arguments                                              */
/*    routine returns the angle (in radians)                                  */
/*    whose tangent is given by the quotient of cosine and cosine,            */
/*    cosine/cosine.                                                          */
/*                                                                            */
/*+~mth$atan2~+*/
float mth$atan2(
    const float  *sine,
    const float  *cosine
    ) ;
/*~-mth$atan2-~*/
/*    MTH$DATAN2                                                              */
/*                                                                            */
/*    Arc Tangent in Radians with Two Arguments                               */
/*                                                                            */
/*    Given cosine and cosine, the Arc Tangent in                             */
/*    Radians with Two Arguments                                              */
/*    routine returns the angle (in radians)                                  */
/*    whose tangent is given by the quotient of cosine and cosine,            */
/*    cosine/cosine.                                                          */
/*                                                                            */
/*+~mth$datan2~+*/
double float mth$datan2(
    const double float  *sine,
    const double float  *cosine
    ) ;
/*~-mth$datan2-~*/
/*    MTH$GATAN2                                                              */
/*                                                                            */
/*    Arc Tangent in Radians with Two Arguments                               */
/*                                                                            */
/*    Given cosine and cosine, the Arc Tangent in                             */
/*    Radians with Two Arguments                                              */
/*    routine returns the angle (in radians)                                  */
/*    whose tangent is given by the quotient of cosine and cosine,            */
/*    cosine/cosine.                                                          */
/*                                                                            */
/*+~mth$gatan2~+*/
double float mth$gatan2(
    const double float  *sine,
    const double float  *cosine
    ) ;
/*~-mth$gatan2-~*/
/*    MTH$ATAND                                                               */
/*                                                                            */
/*    Arc Tangent in Degrees                                                  */
/*                                                                            */
/*    Given the tangent of an angle, the Arc Tangent in Degrees               */
/*    routine returns that angle (in degrees).                                */
/*                                                                            */
/*+~mth$atand~+*/
float mth$atand(
    const float  *tangent
    ) ;
/*~-mth$atand-~*/
/*    MTH$DATAND                                                              */
/*                                                                            */
/*    Arc Tangent in Degrees                                                  */
/*                                                                            */
/*    Given the tangent of an angle, the Arc Tangent in Degrees               */
/*    routine returns that angle (in degrees).                                */
/*                                                                            */
/*+~mth$datand~+*/
double float mth$datand(
    const double float  *tangent
    ) ;
/*~-mth$datand-~*/
/*    MTH$GATAND                                                              */
/*                                                                            */
/*    Arc Tangent in Degrees                                                  */
/*                                                                            */
/*    Given the tangent of an angle, the Arc Tangent in Degrees               */
/*    routine returns that angle (in degrees).                                */
/*                                                                            */
/*+~mth$gatand~+*/
double float mth$gatand(
    const double float  *tangent
    ) ;
/*~-mth$gatand-~*/
/*    MTH$ATANH                                                               */
/*                                                                            */
/*    Hyperbolic Arc Tangent                                                  */
/*                                                                            */
/*    Given the hyperbolic tangent of an angle, the Hyperbolic Arc Tangent    */
/*    routine returns                                                         */
/*    the hyperbolic arc tangent of that angle.                               */
/*                                                                            */
/*+~mth$atanh~+*/
float mth$atanh(
    const float  *hyperbolic_tangent
    ) ;
/*~-mth$atanh-~*/
/*    MTH$DATANH                                                              */
/*                                                                            */
/*    Hyperbolic Arc Tangent                                                  */
/*                                                                            */
/*    Given the hyperbolic tangent of an angle, the Hyperbolic Arc Tangent    */
/*    routine returns                                                         */
/*    the hyperbolic arc tangent of that angle.                               */
/*                                                                            */
/*+~mth$datanh~+*/
double float mth$datanh(
    const double float  *hyperbolic_tangent
    ) ;
/*~-mth$datanh-~*/
/*    MTH$GATANH                                                              */
/*                                                                            */
/*    Hyperbolic Arc Tangent                                                  */
/*                                                                            */
/*    Given the hyperbolic tangent of an angle, the Hyperbolic Arc Tangent    */
/*    routine returns                                                         */
/*    the hyperbolic arc tangent of that angle.                               */
/*                                                                            */
/*+~mth$gatanh~+*/
double float mth$gatanh(
    const double float  *hyperbolic_tangent
    ) ;
/*~-mth$gatanh-~*/
/*    MTH$ATAND2                                                              */
/*                                                                            */
/*    Arc Tangent in Degrees with Two Arguments                               */
/*                                                                            */
/*    Given cosine and cosine, the Arc Tangent in                             */
/*    Degrees with Two Arguments                                              */
/*    routine returns                                                         */
/*    the angle (in degrees) whose tangent                                    */
/*    is given by the quotient of cosine and cosine,                          */
/*    cosine/cosine.                                                          */
/*                                                                            */
/*+~mth$atand2~+*/
float mth$atand2(
    const float  *sine,
    const float  *cosine
    ) ;
/*~-mth$atand2-~*/
/*    MTH$DATAND2                                                             */
/*                                                                            */
/*    Arc Tangent in Degrees with Two Arguments                               */
/*                                                                            */
/*    Given cosine and cosine, the Arc Tangent in                             */
/*    Degrees with Two Arguments                                              */
/*    routine returns                                                         */
/*    the angle (in degrees) whose tangent                                    */
/*    is given by the quotient of cosine and cosine,                          */
/*    cosine/cosine.                                                          */
/*                                                                            */
/*+~mth$datand2~+*/
double float mth$datand2(
    const double float  *sine,
    const double float  *cosine
    ) ;
/*~-mth$datand2-~*/
/*    MTH$GATAND2                                                             */
/*                                                                            */
/*    Arc Tangent in Degrees with Two Arguments                               */
/*                                                                            */
/*    Given cosine and cosine, the Arc Tangent in                             */
/*    Degrees with Two Arguments                                              */
/*    routine returns                                                         */
/*    the angle (in degrees) whose tangent                                    */
/*    is given by the quotient of cosine and cosine,                          */
/*    cosine/cosine.                                                          */
/*                                                                            */
/*+~mth$gatand2~+*/
double float mth$gatand2(
    const double float  *sine,
    const double float  *cosine
    ) ;
/*~-mth$gatand2-~*/
/*    MTH$CABS                                                                */
/*                                                                            */
/*    Complex Absolute Value                                                  */
/*                                                                            */
/*    The Complex Absolute Value routine                                      */
/*    returns the absolute value of a complex number (r,i).                   */
/*                                                                            */
/*+~mth$cabs~+*/
float mth$cabs(
    const FFLOAT_COMPLEX *complex_number
    ) ;
/*~-mth$cabs-~*/
/*    MTH$CDABS                                                               */
/*                                                                            */
/*    Complex Absolute Value                                                  */
/*                                                                            */
/*    The Complex Absolute Value routine                                      */
/*    returns the absolute value of a complex number (r,i).                   */
/*                                                                            */
/*+~mth$cdabs~+*/
double float mth$cdabs(
    const DFLOAT_COMPLEX *complex_number
    ) ;
/*~-mth$cdabs-~*/
/*    MTH$CGABS                                                               */
/*                                                                            */
/*    Complex Absolute Value                                                  */
/*                                                                            */
/*    The Complex Absolute Value routine                                      */
/*    returns the absolute value of a complex number (r,i).                   */
/*                                                                            */
/*+~mth$cgabs~+*/
double float mth$cgabs(
    const GFLOAT_COMPLEX *complex_number
    ) ;
/*~-mth$cgabs-~*/
/*    MTH$CCOS                                                                */
/*                                                                            */
/*    Cosine of a Complex Number (F-floating Value)                           */
/*                                                                            */
/*    The Cosine of a Complex Number (F-floating Value)                       */
/*    routine returns the cosine of a complex number as an                    */
/*    F-floating value.                                                       */
/*                                                                            */
/*+~mth$ccos~+*/
FFLOAT_COMPLEXmth$ccos(
    const FFLOAT_COMPLEX *complex_number
    ) ;
/*~-mth$ccos-~*/
/*    MTH$CEXP                                                                */
/*                                                                            */
/*    Complex Exponential (F-floating Value)                                  */
/*                                                                            */
/*    The Complex Exponential (F-floating Value)                              */
/*    routine returns the complex exponential of a                            */
/*    complex number as an F-floating value.                                  */
/*                                                                            */
/*+~mth$cexp~+*/
FFLOAT_COMPLEXmth$cexp(
    const FFLOAT_COMPLEX *complex_number
    ) ;
/*~-mth$cexp-~*/
/*    MTH$CLOG                                                                */
/*                                                                            */
/*    Complex Natural Logarithm (F-floating Value)                            */
/*                                                                            */
/*    The Complex Natural Logarithm (F-floating Value)                        */
/*    routine returns the complex natural logarithm of a complex number as    */
/*    an F-floating value.                                                    */
/*                                                                            */
/*+~mth$clog~+*/
FFLOAT_COMPLEXmth$clog(
    const FFLOAT_COMPLEX *complex_number
    ) ;
/*~-mth$clog-~*/
/*    MTH$CMPLX                                                               */
/*                                                                            */
/*    Complex Number Made from F-floating-Point                               */
/*                                                                            */
/*    The Complex Number Made from F-floating-Point                           */
/*    routine returns a complex number from two floating-point input values.  */
/*                                                                            */
/*+~mth$cmplx~+*/
FFLOAT_COMPLEXmth$cmplx(
    const float  *real_part,
    const float  *imaginary_part
    ) ;
/*~-mth$cmplx-~*/
/*    MTH$DCMPLX                                                              */
/*                                                                            */
/*    Complex Number Made from D- or G-floating-Point                         */
/*                                                                            */
/*    The Complex Number Made from                                            */
/*    D- or G-floating-Point                                                  */
/*    routine returns a complex number from two D- or G-floating input values.        */
/*                                                                            */
/*+~mth$dcmplx~+*/
int mth$dcmplx(
    DFLOAT_COMPLEX *complx,
    const double float  *real_part,
    const double float  *imaginary_part
    ) ;
/*~-mth$dcmplx-~*/
/*    MTH$GCMPLX                                                              */
/*                                                                            */
/*    Complex Number Made from D- or G-floating-Point                         */
/*                                                                            */
/*    The Complex Number Made from                                            */
/*    D- or G-floating-Point                                                  */
/*    routine returns a complex number from two D- or G-floating input values.        */
/*                                                                            */
/*+~mth$gcmplx~+*/
int mth$gcmplx(
    GFLOAT_COMPLEX *complx,
    const double float  *real_part,
    const double float  *imaginary_part
    ) ;
/*~-mth$gcmplx-~*/
/*    MTH$CONJG                                                               */
/*                                                                            */
/*    Conjugate of a Complex Number (F-floating Value)                        */
/*                                                                            */
/*    The Conjugate of a Complex Number (F-floating                           */
/*    Value)                                                                  */
/*    routine returns the complex conjugate (r,-i) of a complex number        */
/*    (r,i) as an F-floating value.                                           */
/*                                                                            */
/*+~mth$conjg~+*/
FFLOAT_COMPLEXmth$conjg(
    const FFLOAT_COMPLEX *complex_number
    ) ;
/*~-mth$conjg-~*/
/*    MTH$DCONJG                                                              */
/*                                                                            */
/*    Conjugate of a Complex Number                                           */
/*                                                                            */
/*    The Conjugate of a Complex Number                                       */
/*    routine returns the complex conjugate (r,-i) of a complex number (r,i). */
/*                                                                            */
/*+~mth$dconjg~+*/
int mth$dconjg(
    DFLOAT_COMPLEX *complex_conjugate,
    const DFLOAT_COMPLEX *complex_number
    ) ;
/*~-mth$dconjg-~*/
/*    MTH$GCONJG                                                              */
/*                                                                            */
/*    Conjugate of a Complex Number                                           */
/*                                                                            */
/*    The Conjugate of a Complex Number                                       */
/*    routine returns the complex conjugate (r,-i) of a complex number (r,i). */
/*                                                                            */
/*+~mth$gconjg~+*/
int mth$gconjg(
    GFLOAT_COMPLEX *complex_conjugate,
    const GFLOAT_COMPLEX *complex_number
    ) ;
/*~-mth$gconjg-~*/
/*    MTH$COS                                                                 */
/*                                                                            */
/*    Cosine of Angle Expressed in Radians                                    */
/*                                                                            */
/*    The Cosine of Angle Expressed in Radians                                */
/*    routine returns the cosine of a given angle (in radians).               */
/*                                                                            */
/*+~mth$cos~+*/
float mth$cos(
    const float  *angle_in_radians
    ) ;
/*~-mth$cos-~*/
/*    MTH$DCOS                                                                */
/*                                                                            */
/*    Cosine of Angle Expressed in Radians                                    */
/*                                                                            */
/*    The Cosine of Angle Expressed in Radians                                */
/*    routine returns the cosine of a given angle (in radians).               */
/*                                                                            */
/*+~mth$dcos~+*/
double float mth$dcos(
    const double float  *angle_in_radians
    ) ;
/*~-mth$dcos-~*/
/*    MTH$GCOS                                                                */
/*                                                                            */
/*    Cosine of Angle Expressed in Radians                                    */
/*                                                                            */
/*    The Cosine of Angle Expressed in Radians                                */
/*    routine returns the cosine of a given angle (in radians).               */
/*                                                                            */
/*+~mth$gcos~+*/
double float mth$gcos(
    const double float  *angle_in_radians
    ) ;
/*~-mth$gcos-~*/
/*    MTH$COSD                                                                */
/*                                                                            */
/*    Cosine of Angle Expressed in Degrees                                    */
/*                                                                            */
/*    The Cosine of Angle Expressed in Degrees                                */
/*    routine returns the cosine of a given angle (in degrees).               */
/*                                                                            */
/*+~mth$cosd~+*/
float mth$cosd(
    const float  *angle_in_degrees
    ) ;
/*~-mth$cosd-~*/
/*    MTH$DCOSD                                                               */
/*                                                                            */
/*    Cosine of Angle Expressed in Degrees                                    */
/*                                                                            */
/*    The Cosine of Angle Expressed in Degrees                                */
/*    routine returns the cosine of a given angle (in degrees).               */
/*                                                                            */
/*+~mth$dcosd~+*/
double float mth$dcosd(
    const double float  *angle_in_degrees
    ) ;
/*~-mth$dcosd-~*/
/*    MTH$GCOSD                                                               */
/*                                                                            */
/*    Cosine of Angle Expressed in Degrees                                    */
/*                                                                            */
/*    The Cosine of Angle Expressed in Degrees                                */
/*    routine returns the cosine of a given angle (in degrees).               */
/*                                                                            */
/*+~mth$gcosd~+*/
double float mth$gcosd(
    const double float  *angle_in_degrees
    ) ;
/*~-mth$gcosd-~*/
/*    MTH$COSH                                                                */
/*                                                                            */
/*    Hyperbolic Cosine                                                       */
/*                                                                            */
/*    The Hyperbolic Cosine                                                   */
/*    routine returns the hyperbolic cosine of                                */
/*    the input value.                                                        */
/*                                                                            */
/*+~mth$cosh~+*/
float mth$cosh(
    const float  *floating_point_input_value
    ) ;
/*~-mth$cosh-~*/
/*    MTH$DCOSH                                                               */
/*                                                                            */
/*    Hyperbolic Cosine                                                       */
/*                                                                            */
/*    The Hyperbolic Cosine                                                   */
/*    routine returns the hyperbolic cosine of                                */
/*    the input value.                                                        */
/*                                                                            */
/*+~mth$dcosh~+*/
double float mth$dcosh(
    const double float  *floating_point_input_value
    ) ;
/*~-mth$dcosh-~*/
/*    MTH$GCOSH                                                               */
/*                                                                            */
/*    Hyperbolic Cosine                                                       */
/*                                                                            */
/*    The Hyperbolic Cosine                                                   */
/*    routine returns the hyperbolic cosine of                                */
/*    the input value.                                                        */
/*                                                                            */
/*+~mth$gcosh~+*/
double float mth$gcosh(
    const double float  *floating_point_input_value
    ) ;
/*~-mth$gcosh-~*/
/*    MTH$CSIN                                                                */
/*                                                                            */
/*    Sine of Complex Number (F-floating Value)                               */
/*                                                                            */
/*    The Sine of Complex Number (F-floating                                  */
/*    Value)                                                                  */
/*    routine returns the sine of a complex number (r,i) as an                */
/*    F-floating value.                                                       */
/*                                                                            */
/*+~mth$csin~+*/
FFLOAT_COMPLEXmth$csin(
    const FFLOAT_COMPLEX *complex_number
    ) ;
/*~-mth$csin-~*/
/*    MTH$CSQRT                                                               */
/*                                                                            */
/*    Complex Square Root (F-floating Value)                                  */
/*                                                                            */
/*    The Complex Square Root (F-floating Value) routine                      */
/*    returns the complex square root of a complex number (r,i).              */
/*                                                                            */
/*+~mth$csqrt~+*/
FFLOAT_COMPLEXmth$csqrt(
    const FFLOAT_COMPLEX *complex_number
    ) ;
/*~-mth$csqrt-~*/
/*    MTH$CVT_D_G                                                             */
/*                                                                            */
/*    Convert One Double-Precision Value                                      */
/*                                                                            */
/*    The Convert One Double-Precision Value routines                         */
/*    convert one double-precision value to the                               */
/*    destination data type and return the result as a function value.        */
/*    MTH$CVT_D_G converts a D_floating value to G_floating and               */
/*    MTH$CVT_G_D converts a G_floating value to a D_floating value.          */
/*                                                                            */
/*+~mth$cvt_d_g~+*/
double float mth$cvt_d_g(
    const double float  *floating_point_input_val
    ) ;
/*~-mth$cvt_d_g-~*/
/*    MTH$CVT_G_D                                                             */
/*                                                                            */
/*    Convert One Double-Precision Value                                      */
/*                                                                            */
/*    The Convert One Double-Precision Value routines                         */
/*    convert one double-precision value to the                               */
/*    destination data type and return the result as a function value.        */
/*    MTH$CVT_D_G converts a D_floating value to G_floating and               */
/*    MTH$CVT_G_D converts a G_floating value to a D_floating value.          */
/*                                                                            */
/*+~mth$cvt_g_d~+*/
double float mth$cvt_g_d(
    const double float  *floating_point_input_val
    ) ;
/*~-mth$cvt_g_d-~*/
/*    MTH$CVT_DA_GA                                                           */
/*                                                                            */
/*    Convert an Array of Double-Precision Values                             */
/*                                                                            */
/*    The Convert an Array of                                                 */
/*    Double-Precision Values                                                 */
/*    routines convert a contiguous array of                                  */
/*    double-precision values to the destination data type and return the results     */
/*    as an array. MTH$CVT_DA_GA converts D_floating values to G_floating and */
/*    MTH$CVT_GA_DA converts G_floating values to D_floating.                 */
/*                                                                            */
/*+~mth$cvt_da_ga~+*/
int mth$cvt_da_ga(
    const double float  *floating_point_input_array [1],
    double float  *floating_point_dest_array [1],
    ...
    /* const long int  *array_size */
    ) ;
/*~-mth$cvt_da_ga-~*/
/*    MTH$CVT_GA_DA                                                           */
/*                                                                            */
/*    Convert an Array of Double-Precision Values                             */
/*                                                                            */
/*    The Convert an Array of                                                 */
/*    Double-Precision Values                                                 */
/*    routines convert a contiguous array of                                  */
/*    double-precision values to the destination data type and return the results     */
/*    as an array. MTH$CVT_DA_GA converts D_floating values to G_floating and */
/*    MTH$CVT_GA_DA converts G_floating values to D_floating.                 */
/*                                                                            */
/*+~mth$cvt_ga_da~+*/
int mth$cvt_ga_da(
    const double float  *floating_point_input_array [1],
    double float  *floating_point_dest_array [1],
    ...
    /* const long int  *array_size */
    ) ;
/*~-mth$cvt_ga_da-~*/
/*    MTH$CDCOS                                                               */
/*                                                                            */
/*    Cosine of a Complex Number                                              */
/*                                                                            */
/*    The Cosine of a Complex Number                                          */
/*    routine returns the cosine of a complex number.                         */
/*                                                                            */
/*+~mth$cdcos~+*/
int mth$cdcos(
    DFLOAT_COMPLEX *complex_cosine,
    const DFLOAT_COMPLEX *complex_number
    ) ;
/*~-mth$cdcos-~*/
/*    MTH$CGCOS                                                               */
/*                                                                            */
/*    Cosine of a Complex Number                                              */
/*                                                                            */
/*    The Cosine of a Complex Number                                          */
/*    routine returns the cosine of a complex number.                         */
/*                                                                            */
/*+~mth$cgcos~+*/
int mth$cgcos(
    GFLOAT_COMPLEX *complex_cosine,
    const GFLOAT_COMPLEX *complex_number
    ) ;
/*~-mth$cgcos-~*/
/*    MTH$CDEXP                                                               */
/*                                                                            */
/*    Complex Exponential                                                     */
/*                                                                            */
/*    The Complex Exponential                                                 */
/*    routine returns the complex exponential of a                            */
/*    complex number.                                                         */
/*                                                                            */
/*+~mth$cdexp~+*/
int mth$cdexp(
    DFLOAT_COMPLEX *complex_exponent,
    const DFLOAT_COMPLEX *complex_number
    ) ;
/*~-mth$cdexp-~*/
/*    MTH$CGEXP                                                               */
/*                                                                            */
/*    Complex Exponential                                                     */
/*                                                                            */
/*    The Complex Exponential                                                 */
/*    routine returns the complex exponential of a                            */
/*    complex number.                                                         */
/*                                                                            */
/*+~mth$cgexp~+*/
int mth$cgexp(
    GFLOAT_COMPLEX *complex_exponent,
    const GFLOAT_COMPLEX *complex_number
    ) ;
/*~-mth$cgexp-~*/
/*    MTH$CDLOG                                                               */
/*                                                                            */
/*    Complex Natural Logarithm                                               */
/*                                                                            */
/*    The Complex Natural Logarithm                                           */
/*    routine returns the complex natural logarithm of a complex number.      */
/*                                                                            */
/*+~mth$cdlog~+*/
int mth$cdlog(
    DFLOAT_COMPLEX *complex_natural_log,
    const DFLOAT_COMPLEX *complex_number
    ) ;
/*~-mth$cdlog-~*/
/*    MTH$CGLOG                                                               */
/*                                                                            */
/*    Complex Natural Logarithm                                               */
/*                                                                            */
/*    The Complex Natural Logarithm                                           */
/*    routine returns the complex natural logarithm of a complex number.      */
/*                                                                            */
/*+~mth$cglog~+*/
int mth$cglog(
    GFLOAT_COMPLEX *complex_natural_log,
    const GFLOAT_COMPLEX *complex_number
    ) ;
/*~-mth$cglog-~*/
/*    MTH$CDSIN                                                               */
/*                                                                            */
/*    Sine of Complex Number                                                  */
/*                                                                            */
/*    The Sine of Complex Number                                              */
/*    routine returns the sine of a complex number (r,i).                     */
/*                                                                            */
/*+~mth$cdsin~+*/
int mth$cdsin(
    DFLOAT_COMPLEX *complex_sine,
    const DFLOAT_COMPLEX *complex_number
    ) ;
/*~-mth$cdsin-~*/
/*    MTH$CGSIN                                                               */
/*                                                                            */
/*    Sine of Complex Number                                                  */
/*                                                                            */
/*    The Sine of Complex Number                                              */
/*    routine returns the sine of a complex number (r,i).                     */
/*                                                                            */
/*+~mth$cgsin~+*/
int mth$cgsin(
    GFLOAT_COMPLEX *complex_sine,
    const GFLOAT_COMPLEX *complex_number
    ) ;
/*~-mth$cgsin-~*/
/*    MTH$CDSQRT                                                              */
/*                                                                            */
/*    Complex Square Root                                                     */
/*                                                                            */
/*    The Complex Square Root routine                                         */
/*    returns the complex square root of a complex number (r,i).              */
/*                                                                            */
/*+~mth$cdsqrt~+*/
int mth$cdsqrt(
    DFLOAT_COMPLEX *complex_square_root,
    const DFLOAT_COMPLEX *complex_number
    ) ;
/*~-mth$cdsqrt-~*/
/*    MTH$CGSQRT                                                              */
/*                                                                            */
/*    Complex Square Root                                                     */
/*                                                                            */
/*    The Complex Square Root routine                                         */
/*    returns the complex square root of a complex number (r,i).              */
/*                                                                            */
/*+~mth$cgsqrt~+*/
int mth$cgsqrt(
    GFLOAT_COMPLEX *complex_square_root,
    const GFLOAT_COMPLEX *complex_number
    ) ;
/*~-mth$cgsqrt-~*/
/*    MTH$EXP                                                                 */
/*                                                                            */
/*    Exponential                                                             */
/*                                                                            */
/*    The Exponential                                                         */
/*    routine returns the exponential of the input value.                     */
/*                                                                            */
/*+~mth$exp~+*/
float mth$exp(
    const float  *floating_point_input_value
    ) ;
/*~-mth$exp-~*/
/*    MTH$DEXP                                                                */
/*                                                                            */
/*    Exponential                                                             */
/*                                                                            */
/*    The Exponential                                                         */
/*    routine returns the exponential of the input value.                     */
/*                                                                            */
/*+~mth$dexp~+*/
double float mth$dexp(
    const double float  *floating_point_input_value
    ) ;
/*~-mth$dexp-~*/
/*    MTH$GEXP                                                                */
/*                                                                            */
/*    Exponential                                                             */
/*                                                                            */
/*    The Exponential                                                         */
/*    routine returns the exponential of the input value.                     */
/*                                                                            */
/*+~mth$gexp~+*/
double float mth$gexp(
    const double float  *floating_point_input_value
    ) ;
/*~-mth$gexp-~*/
/*    MTH$HACOS                                                               */
/*                                                                            */
/*    Arc Cosine of Angle Expressed in Radians (H-floating Value)             */
/*                                                                            */
/*    Given the cosine of an angle, the Arc Cosine of Angle Expressed in      */
/*    Radians (H-floating Value) routine returns that angle (in radians) in   */
/*    H-floating-point precision.                                             */
/*                                                                            */
/*+~mth$hacos~+*/
int mth$hacos(
    struct {int h_radian$$ret_0_ [4];}  *h_radians,
    const struct {int cosine$$ret_0_ [4];}  *cosine
    ) ;
/*~-mth$hacos-~*/
/*    MTH$HACOSD                                                              */
/*                                                                            */
/*    Arc Cosine of Angle Expressed in Degrees (H-Floating Value)             */
/*                                                                            */
/*    Given the cosine of an angle, the Arc Cosine of Angle Expressed in      */
/*    Degrees (H-Floating Value)                                              */
/*    routine returns that                                                    */
/*    angle (in degrees) as an H-floating value.                              */
/*                                                                            */
/*+~mth$hacosd~+*/
int mth$hacosd(
    struct {int h_degree$$ret_0_ [4];}  *h_degrees,
    const struct {int cosine$$ret_0_ [4];}  *cosine
    ) ;
/*~-mth$hacosd-~*/
/*    MTH$HASIN                                                               */
/*                                                                            */
/*    Arc Sine in Radians (H-floating Value)                                  */
/*                                                                            */
/*    Given the sine of an angle, the Arc Sine in Radians (H-floating Value)  */
/*    routine returns that angle                                              */
/*    (in radians) as an H-floating value.                                    */
/*                                                                            */
/*+~mth$hasin~+*/
int mth$hasin(
    struct {int h_radian$$ret_0_ [4];}  *h_radians,
    const struct {int sine$$ret_0_ [4];}  *sine
    ) ;
/*~-mth$hasin-~*/
/*    MTH$HASIND                                                              */
/*                                                                            */
/*    Arc Sine in Degrees (H-Floating Value)                                  */
/*                                                                            */
/*    Given the sine of an angle, the Arc Sine in Degrees (H-Floating Value)  */
/*    routine returns that angle                                              */
/*    (in degrees) as an H-floating value.                                    */
/*                                                                            */
/*+~mth$hasind~+*/
int mth$hasind(
    struct {int h_degree$$ret_0_ [4];}  *h_degrees,
    const struct {int sine$$ret_0_ [4];}  *sine
    ) ;
/*~-mth$hasind-~*/
/*    MTH$HATAN                                                               */
/*                                                                            */
/*    Arc Tangent in Radians (H-floating Value)                               */
/*                                                                            */
/*    Given the tangent of an angle, the Arc Tangent in Radians (H-floating Value)    */
/*    routine returns that angle (in radians)                                 */
/*    as an H-floating value.                                                 */
/*                                                                            */
/*+~mth$hatan~+*/
int mth$hatan(
    struct {int h_radian$$ret_0_ [4];}  *h_radians,
    const struct {int tangent$$ret_0_ [4];}  *tangent
    ) ;
/*~-mth$hatan-~*/
/*    MTH$HATAN2                                                              */
/*                                                                            */
/*    Arc Tangent in Radians (H-floating Value) with Two Arguments            */
/*                                                                            */
/*    Given cosine and cosine, the Arc Tangent in                             */
/*    Radians (H-floating Value) with Two Arguments routine returns the       */
/*    angle (in radians) as an H-floating value whose tangent is given by     */
/*    the quotient of cosine and cosine,                                      */
/*    cosine/cosine.                                                          */
/*                                                                            */
/*+~mth$hatan2~+*/
int mth$hatan2(
    struct {int h_radian$$ret_0_ [4];}  *h_radians,
    const struct {int sine$$ret_0_ [4];}  *sine,
    const struct {int cosine$$ret_0_ [4];}  *cosine
    ) ;
/*~-mth$hatan2-~*/
/*    MTH$HATAND                                                              */
/*                                                                            */
/*    Arc Tangent in Degrees (H-floating Value)                               */
/*                                                                            */
/*    Given the tangent of an angle, the Arc Tangent in Degrees (H-floating Value)    */
/*    routine returns that angle (in degrees)                                 */
/*    as an H-floating point value.                                           */
/*                                                                            */
/*+~mth$hatand~+*/
int mth$hatand(
    struct {int h_degree$$ret_0_ [4];}  *h_degrees,
    const struct {int tangent$$ret_0_ [4];}  *tangent
    ) ;
/*~-mth$hatand-~*/
/*    MTH$HATANH                                                              */
/*                                                                            */
/*    Hyperbolic Arc Tangent (H-floating Value)                               */
/*                                                                            */
/*    Given the hyperbolic tangent of an angle, the Hyperbolic Arc            */
/*    Tangent (H-floating Value)                                              */
/*    routine returns                                                         */
/*    the hyperbolic arc tangent (as an H-floating value) of that angle.      */
/*                                                                            */
/*+~mth$hatanh~+*/
int mth$hatanh(
    struct {int h_atanh$$ret_0_ [4];}  *h_atanh,
    const struct {int hyperbol$$ret_0_ [4];}  *hyperbolic_tangent
    ) ;
/*~-mth$hatanh-~*/
/*    MTH$HCOS                                                                */
/*                                                                            */
/*    Cosine of Angle Expressed in Radians (H-floating Value)                 */
/*                                                                            */
/*    The Cosine of Angle Expressed in Radians                                */
/*    (H-floating Value)                                                      */
/*    routine returns the cosine of a given angle (in radians) as an          */
/*    H-floating value.                                                       */
/*                                                                            */
/*+~mth$hcos~+*/
int mth$hcos(
    struct {int h_cosine$$ret_0_ [4];}  *h_cosine,
    const struct {int angle_in$$ret_0_ [4];}  *angle_in_radians
    ) ;
/*~-mth$hcos-~*/
/*    MTH$HCOSD                                                               */
/*                                                                            */
/*    Cosine of Angle Expressed in Degrees (H-floating Value)                 */
/*                                                                            */
/*    The Cosine of Angle Expressed in Degrees                                */
/*    (H-floating Value)                                                      */
/*    routine returns the cosine of a given angle (in degrees) as an          */
/*    H-floating value.                                                       */
/*                                                                            */
/*+~mth$hcosd~+*/
int mth$hcosd(
    struct {int h_cosine$$ret_0_ [4];}  *h_cosine,
    const struct {int angle_in$$ret_0_ [4];}  *angle_in_degrees
    ) ;
/*~-mth$hcosd-~*/
/*    MTH$HCOSH                                                               */
/*                                                                            */
/*    Hyperbolic Cosine (H-floating Value)                                    */
/*                                                                            */
/*    The Hyperbolic Cosine                                                   */
/*    routine returns the hyperbolic cosine of                                */
/*    the input value as an H-floating value.                                 */
/*                                                                            */
/*+~mth$hcosh~+*/
int mth$hcosh(
    struct {int h_cosh$$ret_0_ [4];}  *h_cosh,
    const struct {int floating$$ret_0_ [4];}  *floating_point_input_value
    ) ;
/*~-mth$hcosh-~*/
/*    MTH$HEXP                                                                */
/*                                                                            */
/*    Exponential (H-floating Value)                                          */
/*                                                                            */
/*    The Exponential                                                         */
/*    routine returns the exponential of the input value as an H-floating     */
/*    value.                                                                  */
/*                                                                            */
/*+~mth$hexp~+*/
int mth$hexp(
    struct {int h_exp$$ret_0_ [4];}  *h_exp,
    const struct {int floating$$ret_0_ [4];}  *floating_point_input_value
    ) ;
/*~-mth$hexp-~*/
/*    MTH$HLOG10                                                              */
/*                                                                            */
/*    Common Logarithm (H-floating Value)                                     */
/*                                                                            */
/*    The Common Logarithm (H-floating Value)                                 */
/*    routine returns the common (base 10) logarithm of                       */
/*    the input argument as an H-floating value.                              */
/*                                                                            */
/*+~mth$hlog10~+*/
int mth$hlog10(
    struct {int h_log10$$ret_0_ [4];}  *h_log10,
    const struct {int floating$$ret_0_ [4];}  *floating_point_input_value
    ) ;
/*~-mth$hlog10-~*/
/*    MTH$HLOG                                                                */
/*                                                                            */
/*    Natural Logarithm (H-floating Value)                                    */
/*                                                                            */
/*    The Natural Logarithm (H-floating Value)                                */
/*    routine returns the natural (base e) logarithm of                       */
/*    the input argument as an H-floating value.                              */
/*                                                                            */
/*+~mth$hlog~+*/
int mth$hlog(
    struct {int h_natlog$$ret_0_ [4];}  *h_natlog,
    const struct {int floating$$ret_0_ [4];}  *floating_point_input_value
    ) ;
/*~-mth$hlog-~*/
/*    MTH$HLOG2                                                               */
/*                                                                            */
/*    Base 2 Logarithm (H-floating Value)                                     */
/*                                                                            */
/*    The Base 2 Logarithm (H-floating Value)                                 */
/*    routine returns the base 2 logarithm of the input value                 */
/*    specified by floating-point-input-value as an H-floating                */
/*    value.                                                                  */
/*                                                                            */
/*+~mth$hlog2~+*/
int mth$hlog2(
    struct {int h_log2$$ret_0_ [4];}  *h_log2,
    const struct {int floating$$ret_0_ [4];}  *floating_point_input_value
    ) ;
/*~-mth$hlog2-~*/
/*    MTH$HSIN                                                                */
/*                                                                            */
/*    Sine of Angle Expressed in Radians (H-floating Value)                   */
/*                                                                            */
/*    The Sine of Angle Expressed in Radians (H-floating                      */
/*    Value)                                                                  */
/*    routine returns the sine of a given angle (in radians) as an            */
/*    H-floating value.                                                       */
/*                                                                            */
/*+~mth$hsin~+*/
int mth$hsin(
    struct {int h_sine$$ret_0_ [4];}  *h_sine,
    const struct {int angle_in$$ret_0_ [4];}  *angle_in_radians
    ) ;
/*~-mth$hsin-~*/
/*    MTH$HSIND                                                               */
/*                                                                            */
/*    Sine of Angle Expressed in Degrees (H-floating Value)                   */
/*                                                                            */
/*    The Sine of Angle Expressed in Degrees (H-floating                      */
/*    Value)                                                                  */
/*    routine returns the sine of a given angle (in degrees) as an            */
/*    H-floating value.                                                       */
/*                                                                            */
/*+~mth$hsind~+*/
int mth$hsind(
    struct {int h_sine$$ret_0_ [4];}  *h_sine,
    const struct {int angle_in$$ret_0_ [4];}  *angle_in_degrees
    ) ;
/*~-mth$hsind-~*/
/*    MTH$HSINH                                                               */
/*                                                                            */
/*    Hyperbolic Sine (H-floating Value)                                      */
/*                                                                            */
/*    The Hyperbolic Sine (H-floating Value)                                  */
/*    routine returns the hyperbolic sine of the input                        */
/*    value specified by floating-point-input-value as an                     */
/*    H-floating value.                                                       */
/*                                                                            */
/*+~mth$hsinh~+*/
int mth$hsinh(
    struct {int h_sinh$$ret_0_ [4];}  *h_sinh,
    const struct {int floating$$ret_0_ [4];}  *floating_point_input_value
    ) ;
/*~-mth$hsinh-~*/
/*    MTH$HSQRT                                                               */
/*                                                                            */
/*    Square Root (H-floating Value)                                          */
/*                                                                            */
/*    The Square Root (H-floating Value)                                      */
/*    routine returns the square root of the input value                      */
/*    floating-point-input-value as an H-floating value.                      */
/*                                                                            */
/*+~mth$hsqrt~+*/
int mth$hsqrt(
    struct {int h_sqrt$$ret_0_ [4];}  *h_sqrt,
    const struct {int floating$$ret_0_ [4];}  *floating_point_input_value
    ) ;
/*~-mth$hsqrt-~*/
/*    MTH$HTAN                                                                */
/*                                                                            */
/*    Tangent of Angle Expressed in Radians (H-floating Value)                */
/*                                                                            */
/*    The Tangent of Angle Expressed in Radians                               */
/*    (H-floating Value)                                                      */
/*    routine returns the tangent of a given angle (in radians) as an         */
/*    H-floating value.                                                       */
/*                                                                            */
/*+~mth$htan~+*/
int mth$htan(
    struct {int h_tan$$ret_0_ [4];}  *h_tan,
    const struct {int angle_in$$ret_0_ [4];}  *angle_in_radians
    ) ;
/*~-mth$htan-~*/
/*    MTH$HTAND                                                               */
/*                                                                            */
/*    Tangent of Angle Expressed in Degrees (H-floating Value)                */
/*                                                                            */
/*    The Tangent of Angle Expressed in Degrees                               */
/*    (H-floating Value)                                                      */
/*    routine returns the tangent of a given angle (in degrees) as an         */
/*    H-floating value.                                                       */
/*                                                                            */
/*+~mth$htand~+*/
int mth$htand(
    struct {int h_tan$$ret_0_ [4];}  *h_tan,
    const struct {int angle_in$$ret_0_ [4];}  *angle_in_degrees
    ) ;
/*~-mth$htand-~*/
/*    MTH$HTANH                                                               */
/*                                                                            */
/*    Compute the Hyperbolic Tangent (H-floating Value)                       */
/*                                                                            */
/*    The Compute the Hyperbolic Tangent (H-floating                          */
/*    Value)                                                                  */
/*    routine returns the hyperbolic tangent                                  */
/*    of the input value as an H-floating value.                              */
/*                                                                            */
/*+~mth$htanh~+*/
int mth$htanh(
    struct {int h_tanh$$ret_0_ [4];}  *h_tanh,
    const struct {int floating$$ret_0_ [4];}  *floating_point_input_value
    ) ;
/*~-mth$htanh-~*/
/*    MTH$HATAND2                                                             */
/*                                                                            */
/*    Arc Tangent in Degrees (H-floating Value) with Two Arguments            */
/*                                                                            */
/*    Given cosine and cosine, MTH$xHTAND2 returns                            */
/*    the angle (in degrees) whose tangent                                    */
/*    is given by the quotient of cosine and cosine,                          */
/*    cosine/cosine.                                                          */
/*                                                                            */
/*+~mth$hatand2~+*/
int mth$hatand2(
    struct {int h_degree$$ret_0_ [4];}  *h_degrees,
    const struct {int sine$$ret_0_ [4];}  *sine,
    const struct {int cosine$$ret_0_ [4];}  *cosine
    ) ;
/*~-mth$hatand2-~*/
/*    MTH$AIMAG                                                               */
/*                                                                            */
/*    Imaginary Part of a Complex Number                                      */
/*                                                                            */
/*    The Imaginary Part of a Complex Number                                  */
/*    routine returns the imaginary part of a complex number.                 */
/*                                                                            */
/*+~mth$aimag~+*/
float mth$aimag(
    const FFLOAT_COMPLEX *complex_number
    ) ;
/*~-mth$aimag-~*/
/*    MTH$DIMAG                                                               */
/*                                                                            */
/*    Imaginary Part of a Complex Number                                      */
/*                                                                            */
/*    The Imaginary Part of a Complex Number                                  */
/*    routine returns the imaginary part of a complex number.                 */
/*                                                                            */
/*+~mth$dimag~+*/
double float mth$dimag(
    const DFLOAT_COMPLEX *complex_number
    ) ;
/*~-mth$dimag-~*/
/*    MTH$GIMAG                                                               */
/*                                                                            */
/*    Imaginary Part of a Complex Number                                      */
/*                                                                            */
/*    The Imaginary Part of a Complex Number                                  */
/*    routine returns the imaginary part of a complex number.                 */
/*                                                                            */
/*+~mth$gimag~+*/
double float mth$gimag(
    const GFLOAT_COMPLEX *complex_number
    ) ;
/*~-mth$gimag-~*/
/*    MTH$ALOG                                                                */
/*                                                                            */
/*    Natural Logarithm                                                       */
/*                                                                            */
/*    The Natural Logarithm                                                   */
/*    routine returns the natural (base e) logarithm of                       */
/*    the input argument.                                                     */
/*                                                                            */
/*+~mth$alog~+*/
float mth$alog(
    const float  *floating_point_input_value
    ) ;
/*~-mth$alog-~*/
/*    MTH$DLOG                                                                */
/*                                                                            */
/*    Natural Logarithm                                                       */
/*                                                                            */
/*    The Natural Logarithm                                                   */
/*    routine returns the natural (base e) logarithm of                       */
/*    the input argument.                                                     */
/*                                                                            */
/*+~mth$dlog~+*/
double float mth$dlog(
    const double float  *floating_point_input_value
    ) ;
/*~-mth$dlog-~*/
/*    MTH$GLOG                                                                */
/*                                                                            */
/*    Natural Logarithm                                                       */
/*                                                                            */
/*    The Natural Logarithm                                                   */
/*    routine returns the natural (base e) logarithm of                       */
/*    the input argument.                                                     */
/*                                                                            */
/*+~mth$glog~+*/
double float mth$glog(
    const double float  *floating_point_input_value
    ) ;
/*~-mth$glog-~*/
/*    MTH$ALOG10                                                              */
/*                                                                            */
/*    Common Logarithm                                                        */
/*                                                                            */
/*    The Common Logarithm                                                    */
/*    routine returns the common (base 10) logarithm of                       */
/*    the input argument.                                                     */
/*                                                                            */
/*+~mth$alog10~+*/
float mth$alog10(
    const float  *floating_point_input_value
    ) ;
/*~-mth$alog10-~*/
/*    MTH$DLOG10                                                              */
/*                                                                            */
/*    Common Logarithm                                                        */
/*                                                                            */
/*    The Common Logarithm                                                    */
/*    routine returns the common (base 10) logarithm of                       */
/*    the input argument.                                                     */
/*                                                                            */
/*+~mth$dlog10~+*/
double float mth$dlog10(
    const double float  *floating_point_input_value
    ) ;
/*~-mth$dlog10-~*/
/*    MTH$GLOG10                                                              */
/*                                                                            */
/*    Common Logarithm                                                        */
/*                                                                            */
/*    The Common Logarithm                                                    */
/*    routine returns the common (base 10) logarithm of                       */
/*    the input argument.                                                     */
/*                                                                            */
/*+~mth$glog10~+*/
double float mth$glog10(
    const double float  *floating_point_input_value
    ) ;
/*~-mth$glog10-~*/
/*    MTH$ALOG2                                                               */
/*                                                                            */
/*    Base 2 Logarithm                                                        */
/*                                                                            */
/*    The Base 2 Logarithm                                                    */
/*    routine returns the base 2 logarithm of the input value                 */
/*    specified by floating-point-input-value.                                */
/*                                                                            */
/*+~mth$alog2~+*/
float mth$alog2(
    const float  *floating_point_input_value
    ) ;
/*~-mth$alog2-~*/
/*    MTH$DLOG2                                                               */
/*                                                                            */
/*    Base 2 Logarithm                                                        */
/*                                                                            */
/*    The Base 2 Logarithm                                                    */
/*    routine returns the base 2 logarithm of the input value                 */
/*    specified by floating-point-input-value.                                */
/*                                                                            */
/*+~mth$dlog2~+*/
double float mth$dlog2(
    const double float  *floating_point_input_value
    ) ;
/*~-mth$dlog2-~*/
/*    MTH$GLOG2                                                               */
/*                                                                            */
/*    Base 2 Logarithm                                                        */
/*                                                                            */
/*    The Base 2 Logarithm                                                    */
/*    routine returns the base 2 logarithm of the input value                 */
/*    specified by floating-point-input-value.                                */
/*                                                                            */
/*+~mth$glog2~+*/
double float mth$glog2(
    const double float  *floating_point_input_value
    ) ;
/*~-mth$glog2-~*/
/*    MTH$RANDOM                                                              */
/*                                                                            */
/*    Random-Number Generator, Uniformly Distributed                          */
/*                                                                            */
/*    The Random-Number Generator, Uniformly Distributed                      */
/*    routine is a general random-number generator.                           */
/*                                                                            */
/*+~mth$random~+*/
float mth$random(
    unsigned long int  *seed
    ) ;
/*~-mth$random-~*/
/*    MTH$REAL                                                                */
/*                                                                            */
/*    Real Part of a Complex Number                                           */
/*                                                                            */
/*    The Real Part of a Complex Number                                       */
/*    routine returns the real part of a complex number.                      */
/*                                                                            */
/*+~mth$real~+*/
float mth$real(
    const FFLOAT_COMPLEX *complex_number
    ) ;
/*~-mth$real-~*/
/*    MTH$DREAL                                                               */
/*                                                                            */
/*    Real Part of a Complex Number                                           */
/*                                                                            */
/*    The Real Part of a Complex Number                                       */
/*    routine returns the real part of a complex number.                      */
/*                                                                            */
/*+~mth$dreal~+*/
double float mth$dreal(
    const DFLOAT_COMPLEX *complex_number
    ) ;
/*~-mth$dreal-~*/
/*    MTH$GREAL                                                               */
/*                                                                            */
/*    Real Part of a Complex Number                                           */
/*                                                                            */
/*    The Real Part of a Complex Number                                       */
/*    routine returns the real part of a complex number.                      */
/*                                                                            */
/*+~mth$greal~+*/
double float mth$greal(
    const GFLOAT_COMPLEX *complex_number
    ) ;
/*~-mth$greal-~*/
/*    MTH$SIN                                                                 */
/*                                                                            */
/*    Sine of Angle Expressed in Radians                                      */
/*                                                                            */
/*    The Sine of Angle Expressed in Radians                                  */
/*    routine returns the sine of a given angle (in radians).                 */
/*                                                                            */
/*+~mth$sin~+*/
float mth$sin(
    const float  *angle_in_radians
    ) ;
/*~-mth$sin-~*/
/*    MTH$DSIN                                                                */
/*                                                                            */
/*    Sine of Angle Expressed in Radians                                      */
/*                                                                            */
/*    The Sine of Angle Expressed in Radians                                  */
/*    routine returns the sine of a given angle (in radians).                 */
/*                                                                            */
/*+~mth$dsin~+*/
double float mth$dsin(
    const double float  *angle_in_radians
    ) ;
/*~-mth$dsin-~*/
/*    MTH$GSIN                                                                */
/*                                                                            */
/*    Sine of Angle Expressed in Radians                                      */
/*                                                                            */
/*    The Sine of Angle Expressed in Radians                                  */
/*    routine returns the sine of a given angle (in radians).                 */
/*                                                                            */
/*+~mth$gsin~+*/
double float mth$gsin(
    const double float  *angle_in_radians
    ) ;
/*~-mth$gsin-~*/
/*    MTH$SIND                                                                */
/*                                                                            */
/*    Sine of Angle Expressed in Degrees                                      */
/*                                                                            */
/*    The Sine of Angle Expressed in Degrees                                  */
/*    routine returns the sine of a given angle (in degrees).                 */
/*                                                                            */
/*+~mth$sind~+*/
float mth$sind(
    const float  *angle_in_degrees
    ) ;
/*~-mth$sind-~*/
/*    MTH$DSIND                                                               */
/*                                                                            */
/*    Sine of Angle Expressed in Degrees                                      */
/*                                                                            */
/*    The Sine of Angle Expressed in Degrees                                  */
/*    routine returns the sine of a given angle (in degrees).                 */
/*                                                                            */
/*+~mth$dsind~+*/
double float mth$dsind(
    const double float  *angle_in_degrees
    ) ;
/*~-mth$dsind-~*/
/*    MTH$GSIND                                                               */
/*                                                                            */
/*    Sine of Angle Expressed in Degrees                                      */
/*                                                                            */
/*    The Sine of Angle Expressed in Degrees                                  */
/*    routine returns the sine of a given angle (in degrees).                 */
/*                                                                            */
/*+~mth$gsind~+*/
double float mth$gsind(
    const double float  *angle_in_degrees
    ) ;
/*~-mth$gsind-~*/
/*    MTH$SINH                                                                */
/*                                                                            */
/*    Hyperbolic Sine                                                         */
/*                                                                            */
/*    The Hyperbolic Sine                                                     */
/*    routine returns the hyperbolic sine of the input                        */
/*    value specified by floating-point-input-value.                          */
/*                                                                            */
/*+~mth$sinh~+*/
float mth$sinh(
    const float  *floating_point_input_value
    ) ;
/*~-mth$sinh-~*/
/*    MTH$DSINH                                                               */
/*                                                                            */
/*    Hyperbolic Sine                                                         */
/*                                                                            */
/*    The Hyperbolic Sine                                                     */
/*    routine returns the hyperbolic sine of the input                        */
/*    value specified by floating-point-input-value.                          */
/*                                                                            */
/*+~mth$dsinh~+*/
double float mth$dsinh(
    const double float  *floating_point_input_value
    ) ;
/*~-mth$dsinh-~*/
/*    MTH$GSINH                                                               */
/*                                                                            */
/*    Hyperbolic Sine                                                         */
/*                                                                            */
/*    The Hyperbolic Sine                                                     */
/*    routine returns the hyperbolic sine of the input                        */
/*    value specified by floating-point-input-value.                          */
/*                                                                            */
/*+~mth$gsinh~+*/
double float mth$gsinh(
    const double float  *floating_point_input_value
    ) ;
/*~-mth$gsinh-~*/
/*    MTH$SINCOS                                                              */
/*                                                                            */
/*    Sine and Cosine of Angle Expressed in Radians                           */
/*                                                                            */
/*    The Sine and Cosine of Angle Expressed in Radians                       */
/*    routine returns the sine                                                */
/*    and the cosine of a given angle (in radians).                           */
/*                                                                            */
/*+~mth$sincos~+*/
int mth$sincos(
    const float  *angle_in_radians,
    float  *sine,
    float  *cosine
    ) ;
/*~-mth$sincos-~*/
/*    MTH$DSINCOS                                                             */
/*                                                                            */
/*    Sine and Cosine of Angle Expressed in Radians                           */
/*                                                                            */
/*    The Sine and Cosine of Angle Expressed in Radians                       */
/*    routine returns the sine                                                */
/*    and the cosine of a given angle (in radians).                           */
/*                                                                            */
/*+~mth$dsincos~+*/
int mth$dsincos(
    const double float  *angle_in_radians,
    double float  *sine,
    double float  *cosine
    ) ;
/*~-mth$dsincos-~*/
/*    MTH$GSINCOS                                                             */
/*                                                                            */
/*    Sine and Cosine of Angle Expressed in Radians                           */
/*                                                                            */
/*    The Sine and Cosine of Angle Expressed in Radians                       */
/*    routine returns the sine                                                */
/*    and the cosine of a given angle (in radians).                           */
/*                                                                            */
/*+~mth$gsincos~+*/
int mth$gsincos(
    const double float  *angle_in_radians,
    double float  *sine,
    double float  *cosine
    ) ;
/*~-mth$gsincos-~*/
/*    MTH$HSINCOS                                                             */
/*                                                                            */
/*    Sine and Cosine of Angle Expressed in Radians                           */
/*                                                                            */
/*    The Sine and Cosine of Angle Expressed in Radians                       */
/*    routine returns the sine                                                */
/*    and the cosine of a given angle (in radians).                           */
/*                                                                            */
/*+~mth$hsincos~+*/
int mth$hsincos(
    const struct {int angle_in$$ret_0_ [4];}  *angle_in_radians,
    struct {int sine$$ret_0_ [4];}  *sine,
    struct {int cosine$$ret_0_ [4];}  *cosine
    ) ;
/*~-mth$hsincos-~*/
/*    MTH$SINCOSD                                                             */
/*                                                                            */
/*    Sine and Cosine of Angle Expressed in Degrees                           */
/*                                                                            */
/*    The Sine and Cosine of Angle Expressed in Degrees                       */
/*    routine returns the sine and cosine of a given angle (in degrees).      */
/*                                                                            */
/*+~mth$sincosd~+*/
int mth$sincosd(
    const float  *angle_in_degrees,
    float  *sine,
    float  *cosine
    ) ;
/*~-mth$sincosd-~*/
/*    MTH$DSINCOSD                                                            */
/*                                                                            */
/*    Sine and Cosine of Angle Expressed in Degrees                           */
/*                                                                            */
/*    The Sine and Cosine of Angle Expressed in Degrees                       */
/*    routine returns the sine and cosine of a given angle (in degrees).      */
/*                                                                            */
/*+~mth$dsincosd~+*/
int mth$dsincosd(
    const double float  *angle_in_degrees,
    double float  *sine,
    double float  *cosine
    ) ;
/*~-mth$dsincosd-~*/
/*    MTH$GSINCOSD                                                            */
/*                                                                            */
/*    Sine and Cosine of Angle Expressed in Degrees                           */
/*                                                                            */
/*    The Sine and Cosine of Angle Expressed in Degrees                       */
/*    routine returns the sine and cosine of a given angle (in degrees).      */
/*                                                                            */
/*+~mth$gsincosd~+*/
int mth$gsincosd(
    const double float  *angle_in_degrees,
    double float  *sine,
    double float  *cosine
    ) ;
/*~-mth$gsincosd-~*/
/*    MTH$HSINCOSD                                                            */
/*                                                                            */
/*    Sine and Cosine of Angle Expressed in Degrees                           */
/*                                                                            */
/*    The Sine and Cosine of Angle Expressed in Degrees                       */
/*    routine returns the sine and cosine of a given angle (in degrees).      */
/*                                                                            */
/*+~mth$hsincosd~+*/
int mth$hsincosd(
    const struct {int angle_in$$ret_0_ [4];}  *angle_in_degrees,
    struct {int sine$$ret_0_ [4];}  *sine,
    struct {int cosine$$ret_0_ [4];}  *cosine
    ) ;
/*~-mth$hsincosd-~*/
/*    MTH$SQRT                                                                */
/*                                                                            */
/*    Square Root                                                             */
/*                                                                            */
/*    The Square Root                                                         */
/*    routine returns the square root of the input value                      */
/*    floating-point-input-value.                                             */
/*                                                                            */
/*+~mth$sqrt~+*/
float mth$sqrt(
    const float  *floating_point_input_value
    ) ;
/*~-mth$sqrt-~*/
/*    MTH$DSQRT                                                               */
/*                                                                            */
/*    Square Root                                                             */
/*                                                                            */
/*    The Square Root                                                         */
/*    routine returns the square root of the input value                      */
/*    floating-point-input-value.                                             */
/*                                                                            */
/*+~mth$dsqrt~+*/
double float mth$dsqrt(
    const double float  *floating_point_input_value
    ) ;
/*~-mth$dsqrt-~*/
/*    MTH$GSQRT                                                               */
/*                                                                            */
/*    Square Root                                                             */
/*                                                                            */
/*    The Square Root                                                         */
/*    routine returns the square root of the input value                      */
/*    floating-point-input-value.                                             */
/*                                                                            */
/*+~mth$gsqrt~+*/
double float mth$gsqrt(
    const double float  *floating_point_input_value
    ) ;
/*~-mth$gsqrt-~*/
/*    MTH$TAN                                                                 */
/*                                                                            */
/*    Tangent of Angle Expressed in Radians                                   */
/*                                                                            */
/*    The Tangent of Angle Expressed in Radians                               */
/*    routine returns the tangent of a given angle (in radians).              */
/*                                                                            */
/*+~mth$tan~+*/
float mth$tan(
    const float  *angle_in_radians
    ) ;
/*~-mth$tan-~*/
/*    MTH$DTAN                                                                */
/*                                                                            */
/*    Tangent of Angle Expressed in Radians                                   */
/*                                                                            */
/*    The Tangent of Angle Expressed in Radians                               */
/*    routine returns the tangent of a given angle (in radians).              */
/*                                                                            */
/*+~mth$dtan~+*/
double float mth$dtan(
    const double float  *angle_in_radians
    ) ;
/*~-mth$dtan-~*/
/*    MTH$GTAN                                                                */
/*                                                                            */
/*    Tangent of Angle Expressed in Radians                                   */
/*                                                                            */
/*    The Tangent of Angle Expressed in Radians                               */
/*    routine returns the tangent of a given angle (in radians).              */
/*                                                                            */
/*+~mth$gtan~+*/
double float mth$gtan(
    const double float  *angle_in_radians
    ) ;
/*~-mth$gtan-~*/
/*    MTH$TAND                                                                */
/*                                                                            */
/*    Tangent of Angle Expressed in Degrees                                   */
/*                                                                            */
/*    The Tangent of Angle Expressed in Degrees                               */
/*    routine returns the tangent of a given angle (in degrees).              */
/*                                                                            */
/*+~mth$tand~+*/
float mth$tand(
    const float  *angle_in_degrees
    ) ;
/*~-mth$tand-~*/
/*    MTH$DTAND                                                               */
/*                                                                            */
/*    Tangent of Angle Expressed in Degrees                                   */
/*                                                                            */
/*    The Tangent of Angle Expressed in Degrees                               */
/*    routine returns the tangent of a given angle (in degrees).              */
/*                                                                            */
/*+~mth$dtand~+*/
double float mth$dtand(
    const double float  *angle_in_degrees
    ) ;
/*~-mth$dtand-~*/
/*    MTH$GTAND                                                               */
/*                                                                            */
/*    Tangent of Angle Expressed in Degrees                                   */
/*                                                                            */
/*    The Tangent of Angle Expressed in Degrees                               */
/*    routine returns the tangent of a given angle (in degrees).              */
/*                                                                            */
/*+~mth$gtand~+*/
double float mth$gtand(
    const double float  *angle_in_degrees
    ) ;
/*~-mth$gtand-~*/
/*    MTH$TANH                                                                */
/*                                                                            */
/*    Compute the Hyperbolic Tangent                                          */
/*                                                                            */
/*    The Compute the Hyperbolic Tangent                                      */
/*    routine returns the hyperbolic tangent                                  */
/*    of the input value.                                                     */
/*                                                                            */
/*+~mth$tanh~+*/
float mth$tanh(
    const float  *floating_point_input_value
    ) ;
/*~-mth$tanh-~*/
/*    MTH$DTANH                                                               */
/*                                                                            */
/*    Compute the Hyperbolic Tangent                                          */
/*                                                                            */
/*    The Compute the Hyperbolic Tangent                                      */
/*    routine returns the hyperbolic tangent                                  */
/*    of the input value.                                                     */
/*                                                                            */
/*+~mth$dtanh~+*/
double float mth$dtanh(
    const double float  *floating_point_input_value
    ) ;
/*~-mth$dtanh-~*/
/*    MTH$GTANH                                                               */
/*                                                                            */
/*    Compute the Hyperbolic Tangent                                          */
/*                                                                            */
/*    The Compute the Hyperbolic Tangent                                      */
/*    routine returns the hyperbolic tangent                                  */
/*    of the input value.                                                     */
/*                                                                            */
/*+~mth$gtanh~+*/
double float mth$gtanh(
    const double float  *floating_point_input_value
    ) ;
/*~-mth$gtanh-~*/
/*    MTH$UMAX                                                                */
/*                                                                            */
/*    Compute Unsigned Maximum                                                */
/*                                                                            */
/*    The Compute Unsigned Maximum                                            */
/*    routine computes the unsigned longword maximum of n unsigned longword   */
/*    arguments, where n is greater than or equal to 1.                       */
/*                                                                            */
/*+~mth$umax~+*/
unsigned long int mth$umax(
    const unsigned long int  *argument
    ) ;
/*~-mth$umax-~*/
/*    MTH$UMIN                                                                */
/*                                                                            */
/*    Compute Unsigned Minimum                                                */
/*                                                                            */
/*    The Compute Unsigned Minimum                                            */
/*    routine computes the unsigned longword minimum of n unsigned longword   */
/*    arguments, where n is greater than or                                   */
/*    equal to 1.                                                             */
/*                                                                            */
/*+~mth$umin~+*/
unsigned long int mth$umin(
    const unsigned long int  *argument
    ) ;
/*~-mth$umin-~*/
/*    MTH$ABS                                                                 */
/*                                                                            */
/*    F_floating Absolute Value Routine                                       */
/*                                                                            */
/*+~mth$abs~+*/
float mth$abs(
    const float  *f_floating
    ) ;
/*~-mth$abs-~*/
/*    MTH$DABS                                                                */
/*                                                                            */
/*    D_floating Absolute Value Routine                                       */
/*                                                                            */
/*+~mth$dabs~+*/
double float mth$dabs(
    const double float  *d_floating
    ) ;
/*~-mth$dabs-~*/
/*    MTH$GABS                                                                */
/*                                                                            */
/*    G_floating Absolute Value Routine                                       */
/*                                                                            */
/*+~mth$gabs~+*/
double float mth$gabs(
    const double float  *g_floating
    ) ;
/*~-mth$gabs-~*/
/*    MTH$HABS                                                                */
/*                                                                            */
/*    H_floating Absolute Value Routine                                       */
/*                                                                            */
/*+~mth$habs~+*/
int mth$habs(
    struct {int h_abs_va$$ret_0_ [4];}  *h_abs_val,
    const struct {int h_floati$$ret_0_ [4];}  *h_floating
    ) ;
/*~-mth$habs-~*/
/*    MTH$IIABS                                                               */
/*                                                                            */
/*    Word Absolute Value Routine                                             */
/*                                                                            */
/*+~mth$iiabs~+*/
short int mth$iiabs(
    const short int  *word
    ) ;
/*~-mth$iiabs-~*/
/*    MTH$JIABS                                                               */
/*                                                                            */
/*    Longword Absolute Value Routine                                         */
/*                                                                            */
/*+~mth$jiabs~+*/
long int mth$jiabs(
    const long int  *longword
    ) ;
/*~-mth$jiabs-~*/
/*    MTH$IIAND                                                               */
/*                                                                            */
/*    Bitwise AND of Two Word Parameters Routine                              */
/*                                                                            */
/*+~mth$iiand~+*/
unsigned short int mth$iiand(
    const unsigned short int  *word1,
    const unsigned short int  *word2
    ) ;
/*~-mth$iiand-~*/
/*    MTH$JIAND                                                               */
/*                                                                            */
/*    Bitwise AND of Two Longword Parameters Routine                          */
/*                                                                            */
/*+~mth$jiand~+*/
unsigned long int mth$jiand(
    const unsigned long int  *longword1,
    const unsigned long int  *longword2
    ) ;
/*~-mth$jiand-~*/
/*    MTH$DBLE                                                                */
/*                                                                            */
/*    Convert F_floating to D_floating (Exact) Routine                        */
/*                                                                            */
/*+~mth$dble~+*/
double float mth$dble(
    const float  *f_floating
    ) ;
/*~-mth$dble-~*/
/*    MTH$GDBLE                                                               */
/*                                                                            */
/*    Convert F_floating to G_floating (Exact) Routine                        */
/*                                                                            */
/*+~mth$gdble~+*/
double float mth$gdble(
    const float  *f_floating
    ) ;
/*~-mth$gdble-~*/
/*    MTH$DIM                                                                 */
/*                                                                            */
/*    Positive Difference of Two F_floating Parameters Routine                */
/*                                                                            */
/*+~mth$dim~+*/
float mth$dim(
    const float  *f_floating1,
    const float  *f_floating2
    ) ;
/*~-mth$dim-~*/
/*    MTH$DDIM                                                                */
/*                                                                            */
/*    Positive Difference of Two D_floating Parameters Routine                */
/*                                                                            */
/*+~mth$ddim~+*/
double float mth$ddim(
    const double float  *d_floating1,
    const double float  *d_floating2
    ) ;
/*~-mth$ddim-~*/
/*    MTH$GDIM                                                                */
/*                                                                            */
/*    Positive Difference of Two D_floating Parameters Routine                */
/*                                                                            */
/*+~mth$gdim~+*/
double float mth$gdim(
    const double float  *g_floating1,
    const double float  *g_floating2
    ) ;
/*~-mth$gdim-~*/
/*    MTH$HDIM                                                                */
/*                                                                            */
/*    Positive Difference of Two D_floating Parameters Routine                */
/*                                                                            */
/*+~mth$hdim~+*/
int mth$hdim(
    struct {int h_floati$$ret_1_ [4];}  *h_floating,
    const struct {int h_floati$$ret_2_ [4];}  *h_floating1,
    const struct {int h_floati$$ret_3_ [4];}  *h_floating2
    ) ;
/*~-mth$hdim-~*/
/*    MTH$IIDIM                                                               */
/*                                                                            */
/*    Positive Difference of Two Word Parameters Routine                      */
/*                                                                            */
/*+~mth$iidim~+*/
short int mth$iidim(
    const short int  *word1,
    const short int  *word2
    ) ;
/*~-mth$iidim-~*/
/*    MTH$JIDIM                                                               */
/*                                                                            */
/*    Positive Difference of Two Longword Parameters Routine                  */
/*                                                                            */
/*+~mth$jidim~+*/
long int mth$jidim(
    const long int  *longword1,
    const long int  *longword2
    ) ;
/*~-mth$jidim-~*/
/*    MTH$IIEOR                                                               */
/*                                                                            */
/*    Bitwise Exclusive OR of Two Word Parameters Routine                     */
/*                                                                            */
/*+~mth$iieor~+*/
unsigned short int mth$iieor(
    const unsigned short int  *word1,
    const unsigned short int  *word2
    ) ;
/*~-mth$iieor-~*/
/*    MTH$JIEOR                                                               */
/*                                                                            */
/*    Bitwise Exclusive OR of Two Longword Parameters Routine                 */
/*                                                                            */
/*+~mth$jieor~+*/
unsigned long int mth$jieor(
    const unsigned long int  *longword1,
    const unsigned long int  *longword2
    ) ;
/*~-mth$jieor-~*/
/*    MTH$IIFIX                                                               */
/*                                                                            */
/*    Convert F_floating to Word (Truncated) Routine                          */
/*                                                                            */
/*+~mth$iifix~+*/
short int mth$iifix(
    const float  *f_floating
    ) ;
/*~-mth$iifix-~*/
/*    MTH$JIFIX                                                               */
/*                                                                            */
/*    Convert F_floating to Longword (Truncated) Routine                      */
/*                                                                            */
/*+~mth$jifix~+*/
long int mth$jifix(
    const float  *f_floating
    ) ;
/*~-mth$jifix-~*/
/*    MTH$FLOATI                                                              */
/*                                                                            */
/*    Convert Word to F_floating (Exact) Routine                              */
/*                                                                            */
/*+~mth$floati~+*/
float mth$floati(
    const short int  *word
    ) ;
/*~-mth$floati-~*/
/*    MTH$DFLOTI                                                              */
/*                                                                            */
/*    Convert Word to D_floating (Exact) Routine                              */
/*                                                                            */
/*+~mth$dfloti~+*/
double float mth$dfloti(
    const short int  *word
    ) ;
/*~-mth$dfloti-~*/
/*    MTH$GFLOTI                                                              */
/*                                                                            */
/*    Convert Word to G_floating (Exact) Routine                              */
/*                                                                            */
/*+~mth$gfloti~+*/
double float mth$gfloti(
    const short int  *word
    ) ;
/*~-mth$gfloti-~*/
/*    MTH$FLOATJ                                                              */
/*                                                                            */
/*    Convert Longword to F_floating (Exact) Routine                          */
/*                                                                            */
/*+~mth$floatj~+*/
float mth$floatj(
    const long int  *longword
    ) ;
/*~-mth$floatj-~*/
/*    MTH$DFLOTJ                                                              */
/*                                                                            */
/*    Convert Longword to D_floating (Exact) Routine                          */
/*                                                                            */
/*+~mth$dflotj~+*/
double float mth$dflotj(
    const long int  *longword
    ) ;
/*~-mth$dflotj-~*/
/*    MTH$GFLOTJ                                                              */
/*                                                                            */
/*    Convert Longword to G_floating (Exact) Routine                          */
/*                                                                            */
/*+~mth$gflotj~+*/
double float mth$gflotj(
    const long int  *longword
    ) ;
/*~-mth$gflotj-~*/
/*    MTH$FLOOR                                                               */
/*                                                                            */
/*    Convert F_floating to Greatest F_floating Integer Routine               */
/*                                                                            */
/*+~mth$floor~+*/
float mth$floor(
    const float  *f_floating
    ) ;
/*~-mth$floor-~*/
/*    MTH$DFLOOR                                                              */
/*                                                                            */
/*    Convert D_floating to Greatest D_floating Integer Routine               */
/*                                                                            */
/*+~mth$dfloor~+*/
double float mth$dfloor(
    const double float  *d_floating
    ) ;
/*~-mth$dfloor-~*/
/*    MTH$GFLOOR                                                              */
/*                                                                            */
/*    Convert G_floating to Greatest G_floating Integer Routine               */
/*                                                                            */
/*+~mth$gfloor~+*/
double float mth$gfloor(
    const double float  *g_floating
    ) ;
/*~-mth$gfloor-~*/
/*    MTH$HFLOOR                                                              */
/*                                                                            */
/*    Convert H_floating to Greatest H_floating Integer Routine               */
/*                                                                            */
/*+~mth$hfloor~+*/
int mth$hfloor(
    struct {int max_h_fl$$ret_0_ [4];}  *max_h_float,
    const struct {int h_floati$$ret_0_ [4];}  *h_floating
    ) ;
/*~-mth$hfloor-~*/
/*    MTH$AINT                                                                */
/*                                                                            */
/*    Convert F_floating to Truncated F_floating Routine                      */
/*                                                                            */
/*+~mth$aint~+*/
float mth$aint(
    const float  *f_floating
    ) ;
/*~-mth$aint-~*/
/*    MTH$DINT                                                                */
/*                                                                            */
/*    Convert D_floating to Truncated D_floating Routine                      */
/*                                                                            */
/*+~mth$dint~+*/
double float mth$dint(
    const double float  *d_floating
    ) ;
/*~-mth$dint-~*/
/*    MTH$IIDINT                                                              */
/*                                                                            */
/*    Convert D_floating to Word (Truncated) Routine                          */
/*                                                                            */
/*+~mth$iidint~+*/
short int mth$iidint(
    const double float  *d_floating
    ) ;
/*~-mth$iidint-~*/
/*    MTH$JIDINT                                                              */
/*                                                                            */
/*    Convert D_floating to Longword (Truncated) Routine                      */
/*                                                                            */
/*+~mth$jidint~+*/
long int mth$jidint(
    const double float  *d_floating
    ) ;
/*~-mth$jidint-~*/
/*    MTH$GINT                                                                */
/*                                                                            */
/*    Convert G_floating to G_floating (Truncated) Routine                    */
/*                                                                            */
/*+~mth$gint~+*/
double float mth$gint(
    const double float  *g_floating
    ) ;
/*~-mth$gint-~*/
/*    MTH$IIGINT                                                              */
/*                                                                            */
/*    Convert G_floating to Word (Truncated) Routine                          */
/*                                                                            */
/*+~mth$iigint~+*/
short int mth$iigint(
    const double float  *g_floating
    ) ;
/*~-mth$iigint-~*/
/*    MTH$JIGINT                                                              */
/*                                                                            */
/*    Convert G_floating to Longword (Truncated) Routine                      */
/*                                                                            */
/*+~mth$jigint~+*/
long int mth$jigint(
    const double float  *g_floating
    ) ;
/*~-mth$jigint-~*/
/*    MTH$HINT                                                                */
/*                                                                            */
/*    Convert H_floating to H_floating (Truncated) Routine                    */
/*                                                                            */
/*+~mth$hint~+*/
int mth$hint(
    struct {int trunc_h_$$ret_0_ [4];}  *trunc_h_flt,
    const struct {int h_floati$$ret_0_ [4];}  *h_floating
    ) ;
/*~-mth$hint-~*/
/*    MTH$IIHINT                                                              */
/*                                                                            */
/*    Convert H_floating to Truncated Word Routine                            */
/*                                                                            */
/*+~mth$iihint~+*/
short int mth$iihint(
    const struct {int h_floati$$ret_1_ [4];}  *h_floating
    ) ;
/*~-mth$iihint-~*/
/*    MTH$JIHINT                                                              */
/*                                                                            */
/*    Convert H_floating to Truncated Longword Routine                        */
/*                                                                            */
/*+~mth$jihint~+*/
long int mth$jihint(
    const struct {int h_floati$$ret_2_ [4];}  *h_floating
    ) ;
/*~-mth$jihint-~*/
/*    MTH$IINT                                                                */
/*                                                                            */
/*    Convert F_floating to Word (Truncated) Routine                          */
/*                                                                            */
/*+~mth$iint~+*/
short int mth$iint(
    const float  *f_floating
    ) ;
/*~-mth$iint-~*/
/*    MTH$JINT                                                                */
/*                                                                            */
/*    Convert F_floating to Longword (Truncated) Routine                      */
/*                                                                            */
/*+~mth$jint~+*/
long int mth$jint(
    const float  *f_floating
    ) ;
/*~-mth$jint-~*/
/*    MTH$IIOR                                                                */
/*                                                                            */
/*    Bitwise Inclusive OR of Two Word Parameters Routine                     */
/*                                                                            */
/*+~mth$iior~+*/
unsigned short int mth$iior(
    const unsigned short int  *word1,
    const unsigned short int  *word2
    ) ;
/*~-mth$iior-~*/
/*    MTH$JIOR                                                                */
/*                                                                            */
/*    Bitwise Inclusive OR of Two Longword Parameters Routine                 */
/*                                                                            */
/*+~mth$jior~+*/
unsigned long int mth$jior(
    const unsigned long int  *longword1,
    const unsigned long int  *longword2
    ) ;
/*~-mth$jior-~*/
/*    MTH$AIMAX0                                                              */
/*                                                                            */
/*    F_floating Maximum of N WordParameters Routine                          */
/*                                                                            */
/*+~mth$aimax0~+*/
float mth$aimax0(
    const short int  *word
    ) ;
/*~-mth$aimax0-~*/
/*    MTH$AJMAX0                                                              */
/*                                                                            */
/*    F_floating Maximum of N Longword Parameters Routine                     */
/*                                                                            */
/*+~mth$ajmax0~+*/
float mth$ajmax0(
    const long int  *longword
    ) ;
/*~-mth$ajmax0-~*/
/*    MTH$IMAX0                                                               */
/*                                                                            */
/*    Word Maximum of N Word Parameters Routine                               */
/*                                                                            */
/*+~mth$imax0~+*/
short int mth$imax0(
    const short int  *word
    ) ;
/*~-mth$imax0-~*/
/*    MTH$JMAX0                                                               */
/*                                                                            */
/*    Longword Maximum of N Longword Parameters Routine                       */
/*                                                                            */
/*+~mth$jmax0~+*/
long int mth$jmax0(
    const long int  *longword
    ) ;
/*~-mth$jmax0-~*/
/*    MTH$AMAX1                                                               */
/*                                                                            */
/*    F_floating Maximum of N F_floating Parameters Routine                   */
/*                                                                            */
/*+~mth$amax1~+*/
float mth$amax1(
    const float  *f_floating
    ) ;
/*~-mth$amax1-~*/
/*    MTH$DMAX1                                                               */
/*                                                                            */
/*    D_floating Maximum of N D_floating Parameters Routine                   */
/*                                                                            */
/*+~mth$dmax1~+*/
double float mth$dmax1(
    const double float  *d_floating
    ) ;
/*~-mth$dmax1-~*/
/*    MTH$GMAX1                                                               */
/*                                                                            */
/*    G_floating Maximum of N G_floating Parameters Routine                   */
/*                                                                            */
/*+~mth$gmax1~+*/
double float mth$gmax1(
    const double float  *g_floating
    ) ;
/*~-mth$gmax1-~*/
/*    MTH$HMAX1                                                               */
/*                                                                            */
/*    H_floating Maximum of N H_floating Parameters Routine                   */
/*                                                                            */
/*+~mth$hmax1~+*/
int mth$hmax1(
    struct {int h_float_$$ret_0_ [4];}  *h_float_max,
    const struct {int h_floati$$ret_0_ [4];}  *h_floating
    ) ;
/*~-mth$hmax1-~*/
/*    MTH$IMAX1                                                               */
/*                                                                            */
/*    Word Maximum of N F_floating Parameters Routine                         */
/*                                                                            */
/*+~mth$imax1~+*/
short int mth$imax1(
    const float  *f_floating
    ) ;
/*~-mth$imax1-~*/
/*    MTH$JMAX1                                                               */
/*                                                                            */
/*    Longword Maximum of N F_floating Parameters Routine                     */
/*                                                                            */
/*+~mth$jmax1~+*/
long int mth$jmax1(
    const float  *f_floating
    ) ;
/*~-mth$jmax1-~*/
/*    MTH$AIMIN0                                                              */
/*                                                                            */
/*    F_floating Minimum of N Word Parameters Routine                         */
/*                                                                            */
/*+~mth$aimin0~+*/
float mth$aimin0(
    const short int  *word
    ) ;
/*~-mth$aimin0-~*/
/*    MTH$AJMIN0                                                              */
/*                                                                            */
/*    F_floating Minimum of N Longword Parameters Routine                     */
/*                                                                            */
/*+~mth$ajmin0~+*/
float mth$ajmin0(
    const long int  *longword
    ) ;
/*~-mth$ajmin0-~*/
/*    MTH$IMIN0                                                               */
/*                                                                            */
/*    Word Minimum of N Word Parameters Routine                               */
/*                                                                            */
/*+~mth$imin0~+*/
short int mth$imin0(
    const short int  *word
    ) ;
/*~-mth$imin0-~*/
/*    MTH$JMIN0                                                               */
/*                                                                            */
/*    Longword Minimum of N Longword Parameters Routine                       */
/*                                                                            */
/*+~mth$jmin0~+*/
long int mth$jmin0(
    const long int  *longword
    ) ;
/*~-mth$jmin0-~*/
/*    MTH$AMIN1                                                               */
/*                                                                            */
/*    F_floating Minimum of N F_floating Parameters Routine                   */
/*                                                                            */
/*+~mth$amin1~+*/
float mth$amin1(
    const float  *f_floating
    ) ;
/*~-mth$amin1-~*/
/*    MTH$DMIN1                                                               */
/*                                                                            */
/*    D_floating Minimum of N D_floating Parameters Routine                   */
/*                                                                            */
/*+~mth$dmin1~+*/
double float mth$dmin1(
    const double float  *d_floating
    ) ;
/*~-mth$dmin1-~*/
/*    MTH$GMIN1                                                               */
/*                                                                            */
/*    G_floating Minimum of N G_floating Parameters Routine                   */
/*                                                                            */
/*+~mth$gmin1~+*/
double float mth$gmin1(
    const double float  *g_floating
    ) ;
/*~-mth$gmin1-~*/
/*    MTH$HMIN1                                                               */
/*                                                                            */
/*    H_floating Minimum of N H_floating Parameters Routine                   */
/*                                                                            */
/*+~mth$hmin1~+*/
int mth$hmin1(
    struct {int h_float_$$ret_0_ [4];}  *h_float_max,
    const struct {int h_floati$$ret_0_ [4];}  *h_floating
    ) ;
/*~-mth$hmin1-~*/
/*    MTH$IMIN1                                                               */
/*                                                                            */
/*    Word Minimum of N F_floating Parameters Routine                         */
/*                                                                            */
/*+~mth$imin1~+*/
short int mth$imin1(
    const float  *f_floating
    ) ;
/*~-mth$imin1-~*/
/*    MTH$JMIN1                                                               */
/*                                                                            */
/*    Longword Minimum of N F_floating Parameters Routine                     */
/*                                                                            */
/*+~mth$jmin1~+*/
long int mth$jmin1(
    const float  *f_floating
    ) ;
/*~-mth$jmin1-~*/
/*    MTH$AMOD                                                                */
/*                                                                            */
/*    Remainder of Two F_floating Parameters Routine                          */
/*                                                                            */
/*+~mth$amod~+*/
float mth$amod(
    const float  *dividend,
    const float  *divisor
    ) ;
/*~-mth$amod-~*/
/*    MTH$DMOD                                                                */
/*                                                                            */
/*    Remainder of Two D_floating Parameters Routine                          */
/*                                                                            */
/*+~mth$dmod~+*/
double float mth$dmod(
    const double float  *dividend,
    const double float  *divisor
    ) ;
/*~-mth$dmod-~*/
/*    MTH$GMOD                                                                */
/*                                                                            */
/*    Remainder of Two G_floating Parameters Routine                          */
/*                                                                            */
/*+~mth$gmod~+*/
double float mth$gmod(
    const double float  *dividend,
    const double float  *divisor
    ) ;
/*~-mth$gmod-~*/
/*    MTH$HMOD                                                                */
/*                                                                            */
/*    Remainder of Two H_floating Parameters Routine                          */
/*                                                                            */
/*+~mth$hmod~+*/
int mth$hmod(
    struct {int h_mod$$ret_0_ [4];}  *h_mod,
    const struct {int dividend$$ret_0_ [4];}  *dividend,
    const struct {int divisor$$ret_0_ [4];}  *divisor
    ) ;
/*~-mth$hmod-~*/
/*    MTH$IMOD                                                                */
/*                                                                            */
/*    Remainder of Two Word Parameters Routine                                */
/*                                                                            */
/*+~mth$imod~+*/
short int mth$imod(
    const short int  *dividend,
    const short int  *divisor
    ) ;
/*~-mth$imod-~*/
/*    MTH$JMOD                                                                */
/*                                                                            */
/*    Remainder of Two Longword Parameters Routine                            */
/*                                                                            */
/*+~mth$jmod~+*/
long int mth$jmod(
    const long int  *dividend,
    const long int  *divisor
    ) ;
/*~-mth$jmod-~*/
/*    MTH$ANINT                                                               */
/*                                                                            */
/*    Convert F_floating to Nearest F_floating Integer Routine                */
/*                                                                            */
/*+~mth$anint~+*/
float mth$anint(
    const float  *f_floating
    ) ;
/*~-mth$anint-~*/
/*    MTH$DNINT                                                               */
/*                                                                            */
/*    Convert D_floating to Nearest D_floating Integer Routine                */
/*                                                                            */
/*+~mth$dnint~+*/
double float mth$dnint(
    const double float  *d_floating
    ) ;
/*~-mth$dnint-~*/
/*    MTH$IIDNNT                                                              */
/*                                                                            */
/*    Convert D_floating to Word Integer Routine                              */
/*                                                                            */
/*+~mth$iidnnt~+*/
short int mth$iidnnt(
    const double float  *d_floating
    ) ;
/*~-mth$iidnnt-~*/
/*    MTH$JIDNNT                                                              */
/*                                                                            */
/*    Convert D_floating to Nearest Longword Integer Routine                  */
/*                                                                            */
/*+~mth$jidnnt~+*/
long int mth$jidnnt(
    const double float  *d_floating
    ) ;
/*~-mth$jidnnt-~*/
/*    MTH$GNINT                                                               */
/*                                                                            */
/*    Convert G_floating to Nearest G_floating Integer Routine                */
/*                                                                            */
/*+~mth$gnint~+*/
double float mth$gnint(
    const double float  *g_floating
    ) ;
/*~-mth$gnint-~*/
/*    MTH$IIGNNT                                                              */
/*                                                                            */
/*    Convert T_floating to Nearest G_floating Integer Routine                */
/*                                                                            */
/*+~mth$iignnt~+*/
short int mth$iignnt(
    const double float  *g_floating
    ) ;
/*~-mth$iignnt-~*/
/*    MTH$JIGNNT                                                              */
/*                                                                            */
/*    Convert G_floating to Nearest Longword Integer Routine                  */
/*                                                                            */
/*+~mth$jignnt~+*/
long int mth$jignnt(
    const double float  *g_floating
    ) ;
/*~-mth$jignnt-~*/
/*    MTH$HNINT                                                               */
/*                                                                            */
/*    Convert H_floating to Nearest H_floating Integer Routine                */
/*                                                                            */
/*+~mth$hnint~+*/
int mth$hnint(
    struct {int nearst_h$$ret_0_ [4];}  *nearst_h_flt,
    const struct {int h_floati$$ret_0_ [4];}  *h_floating
    ) ;
/*~-mth$hnint-~*/
/*    MTH$IIHNNT                                                              */
/*                                                                            */
/*    Convert H_floating to Nearest Word Integer Routine                      */
/*                                                                            */
/*+~mth$iihnnt~+*/
short int mth$iihnnt(
    const struct {int h_floati$$ret_1_ [4];}  *h_floating
    ) ;
/*~-mth$iihnnt-~*/
/*    MTH$JIHNNT                                                              */
/*                                                                            */
/*    Convert H_floating to Nearest Longword Integer Routine                  */
/*                                                                            */
/*+~mth$jihnnt~+*/
long int mth$jihnnt(
    const struct {int h_floati$$ret_2_ [4];}  *h_floating
    ) ;
/*~-mth$jihnnt-~*/
/*    MTH$ININT                                                               */
/*                                                                            */
/*    Convert F_floating to Nearest Word Integer Routine                      */
/*                                                                            */
/*+~mth$inint~+*/
short int mth$inint(
    const float  *f_floating
    ) ;
/*~-mth$inint-~*/
/*    MTH$JNINT                                                               */
/*                                                                            */
/*    Convert F_floating to Nearest Longword Integer Routine                  */
/*                                                                            */
/*+~mth$jnint~+*/
long int mth$jnint(
    const float  *f_floating
    ) ;
/*~-mth$jnint-~*/
/*    MTH$INOT                                                                */
/*                                                                            */
/*    Bitwise Complement of Word Parameter Routine                            */
/*                                                                            */
/*+~mth$inot~+*/
unsigned short int mth$inot(
    const unsigned short int  *word
    ) ;
/*~-mth$inot-~*/
/*    MTH$JNOT                                                                */
/*                                                                            */
/*    Bitwise Complement of Longword Parameter Routine                        */
/*                                                                            */
/*+~mth$jnot~+*/
unsigned long int mth$jnot(
    const unsigned long int  *longword
    ) ;
/*~-mth$jnot-~*/
/*    MTH$DPROD                                                               */
/*                                                                            */
/*    D_floating Product of Two F_floating Parameters Routine                 */
/*                                                                            */
/*+~mth$dprod~+*/
double float mth$dprod(
    const float  *f_floating1,
    const float  *f_floating2
    ) ;
/*~-mth$dprod-~*/
/*    MTH$GPROD                                                               */
/*                                                                            */
/*    G_floating Product of Two F_floating Parameters Routine                 */
/*                                                                            */
/*+~mth$gprod~+*/
double float mth$gprod(
    const float  *f_floating1,
    const float  *f_floating2
    ) ;
/*~-mth$gprod-~*/
/*    MTH$SGN                                                                 */
/*                                                                            */
/*    F_floating Sign Function                                                */
/*                                                                            */
/*+~mth$sgn~+*/
long int mth$sgn(
    const int  *f_or_d_floating
    ) ;
/*~-mth$sgn-~*/
/*    MTH$IISHFT                                                              */
/*                                                                            */
/*    Bitwise Shift of Word Routine                                           */
/*                                                                            */
/*+~mth$iishft~+*/
unsigned short int mth$iishft(
    const unsigned short int  *word,
    const short int  *shift_cnt
    ) ;
/*~-mth$iishft-~*/
/*    MTH$JISHFT                                                              */
/*                                                                            */
/*    Bitwise Shift of Longword Routine                                       */
/*                                                                            */
/*+~mth$jishft~+*/
unsigned long int mth$jishft(
    const unsigned long int  *longword,
    const long int  *shift_cnt
    ) ;
/*~-mth$jishft-~*/
/*    MTH$SIGN                                                                */
/*                                                                            */
/*    F_floating Transfer of Sign of Y to Sign of X Routine                   */
/*                                                                            */
/*+~mth$sign~+*/
float mth$sign(
    const float  *f_float_x,
    const float  *f_float_y
    ) ;
/*~-mth$sign-~*/
/*    MTH$DSIGN                                                               */
/*                                                                            */
/*    D_floating Transfer of Sign of Y to Sign of X Routine                   */
/*                                                                            */
/*+~mth$dsign~+*/
double float mth$dsign(
    const double float  *d_float_x,
    const double float  *d_float_y
    ) ;
/*~-mth$dsign-~*/
/*    MTH$GSIGN                                                               */
/*                                                                            */
/*    G_floating Transfer of Sign of X to Sign of X Routine                   */
/*                                                                            */
/*+~mth$gsign~+*/
double float mth$gsign(
    const double float  *g_float_x,
    const double float  *g_float_y
    ) ;
/*~-mth$gsign-~*/
/*    MTH$HSIGN                                                               */
/*                                                                            */
/*    H_floating Transfer of Sign of Y to Sign of X Routine                   */
/*                                                                            */
/*+~mth$hsign~+*/
int mth$hsign(
    struct {int h_result$$ret_0_ [4];}  *h_result,
    const struct {int h_float_$$ret_0_ [4];}  *h_float_x,
    const struct {int h_float_$$ret_1_ [4];}  *h_float_y
    ) ;
/*~-mth$hsign-~*/
/*    MTH$IISIGN                                                              */
/*                                                                            */
/*    Word Transfer of Sign of Y to Sign of X Routine                         */
/*                                                                            */
/*+~mth$iisign~+*/
short int mth$iisign(
    const short int  *word_x,
    const short int  *word_y
    ) ;
/*~-mth$iisign-~*/
/*    MTH$JISIGN                                                              */
/*                                                                            */
/*    Longword Transfer of Sign of Y to Sign of X Routine                     */
/*                                                                            */
/*+~mth$jisign~+*/
long int mth$jisign(
    const long int  *longwrd_x,
    const long int  *longwrd_y
    ) ;
/*~-mth$jisign-~*/
/*    MTH$SNGL                                                                */
/*                                                                            */
/*    Convert D_floating to F_floating (Rounded) Routine                      */
/*                                                                            */
/*+~mth$sngl~+*/
float mth$sngl(
    const double float  *d_floating
    ) ;
/*~-mth$sngl-~*/
/*    MTH$SNGLG                                                               */
/*                                                                            */
/*    Convert G_floating to F_floating (Rounded) Routine                      */
/*                                                                            */
/*+~mth$snglg~+*/
float mth$snglg(
    const double float  *g_floating
    ) ;
/*~-mth$snglg-~*/
#endif
