/* Created by SDL V3.1-7     */
/* Source:  8-AUG-1988 10:24:32 EMULEX$DISK:[MEADOWS.UNSDL.VMS5-0_H]PPL$DEF.SDI */
#ifndef PPL$DEF_H
#define PPL$DEF_H
 
/*** MODULE PPL$DEF ***/
/* Definitions for RTL Parallel Processing Facility - PPL                     */
/*                                                                            */
/* Pre-defined event ids.                                                     */
/*                                                                            */
#define PPL$K_ABNORMAL_EXIT -2  /* abnormal participant termination           */
#define PPL$K_NORMAL_EXIT -1    /* normal participant termination             */
/*                                                                            */
/* Shared memory options flags.                                               */
/*                                                                            */
#define PPL$M_NOZERO 0x00000001
#define PPL$M_NOWRT 0x00000002
#define PPL$M_FLUSH 0x00000004
#define PPL$M_NOUNI 0x00000008
#define PPL$M_MOPT_SPARE 0xFFFFFFF0
struct mem_options {
    unsigned ppl$v_nozero : 1;  /* not demand-zero                            */
    unsigned ppl$v_nowrt : 1;   /* read-only                                  */
    unsigned ppl$v_flush : 1;   /* write to disk                              */
    unsigned ppl$v_nouni : 1;   /* non-unique name not requested              */
    unsigned ppl$v_mopt_spare : 28;     /* extra bits                         */
} ;
/*                                                                            */
/* Processing options flags.                                                  */
/*                                                                            */
#define PPL$M_INIT_SYNCH 0x00000001
#define PPL$M_NODEBUG 0x00000002
#define PPL$M_STOP_CHILDREN 0x00000004
#define PPL$M_NON_BLOCKING 0x00000008
#define PPL$M_NOTIFY_ONE 0x00000010
#define PPL$M_SPIN_WAIT 0x00000020
#define PPL$M_POPT_SPARE 0xFFFFFFC0
struct proc_options {
    unsigned ppl$v_init_synch : 1;      /* parent blocks until children init  */
    unsigned ppl$v_nodebug : 1; /* disable DEBUG                              */
    unsigned ppl$v_stop_children : 1;   /* stop children of terminating process       */
    unsigned ppl$v_non_blocking : 1;    /* don't block if semaphore unavailable       */
    unsigned ppl$v_notify_one : 1;      /* notify only one enabler for event  */
    unsigned ppl$v_spin_wait : 1;       /* spin rather than $HIBER            */
    unsigned ppl$v_popt_spare : 26;     /* extra bits                         */
} ;
#endif
