$	SAVE_IMAGE_VERIFY = F$ENVIRONMENT("VERIFY_IMAGE")
$	SAVE_PROC_VERIFY = F$VERIFY(0,0)
$!	SET VERIFY
$! Based on "The Multi-tasker" Dec 1983 pp 4-5.
$!
$	ON CONTROL_Y THEN GOTO E
$	INTERACTIVE = F$MODE().EQS."INTERACTIVE"
$	NULL = ""
$	$L = 0
$	$R = 0
$	$C = 0
$	$E = 1
$	$X = 1
$	$Y = 1
$	STATI0 = 0
$	STATI1 = 0
$	STATI2 = 0
$	STATI3 = 0
$	STATI4 = 0
$	STATI5 = 0
$	STATI6 = 0
$	STATI7 = 0
$	N = 1
$	MAKFIL := F
$	DELFIL := F
$	CMDFIL := F
$	CMDNAM := TMP.COM
$	DIRFIL := SYS$SCRATCH:OPS.TMP
$	HASHIF = ""
$!
$!  If no DIR selection, take one
$!
$	NOSEL = P1 .EQS. ""
$	DELFIL = .NOT.NOSEL
$	IF DELFIL THEN DIRECTORY/COLUMNS=1/NOHEAD/NOTRAIL/OUT='DIRFIL' 'P1'
$	INLINE = P2 .NES. ""
$	IF INLINE THEN GOTO STRIN
$	IF INTERACTIVE THEN GOTO INTER
$		WRITE SYS$OUTPUT -
			"%OPS-F-NOTBATCH, Only inline form may be used from BATCH"
$		GOTO E3
$INTER:	INQUIRE/NOPUNCT MAKFIL -
		"Generate command procedure file only (without executing it) [N]? "
$	IF .NOT.MAKFIL THEN GOTO SWORD
$	HASHIF = ", begin data line with #"
$	INQUIRE CMDNAM "File name"
$	IF F$LOCATE(".",CMDNAM).EQ.F$LENGTH(CMDNAM) THEN CMDNAM = CMDNAM+".COM"
$SWORD:
$	IF .NOT.NOSEL THEN GOTO CMDS
$	TYPE SYS$INPUT

Give DIR file selection:-
	CR			none -- execute command(s) [n times] only
	*			all files/versions
	@filename.typ [.LIS]	use existing list of files
					in DIR/COLUMNS=1/NOHEAD/NOTRAIL format

$	INQUIRE P1 "DIRECTORY selection"
$	NOSEL = P1.EQS.""
$	INQUIRE/NOPUNCT P3 "No of times to repeat each set of command lines [1] = "
$	IF P3 .EQS. "" THEN P3 = 1
$	IF NOSEL THEN GOTO CMDS
$	IF F$LOCATE("@",P1) .NE. 0 THEN GOTO DO_DIR
$! @filename means use existing DIRECTORY file (possibly edited)
$	DIRFIL = P1-"@"
$	IF F$LOCATE(".",DIRFIL).EQ.F$LENGTH(DIRFIL) THEN DIRFIL = DIRFIL+".LIS"
$	GOTO CMDS
$DO_DIR: DIRECTORY/COLUMNS=1/NOHEAD/NOTRAIL/OUT='DIRFIL' 'P1'
$	DELFIL := T
$!
$! If not on command line, loop and read strings
$!
$CMDS:	TYPE SYS$INPUT

Enter prototype command lines, using substitution directives:-

!W = whole name	 !N = node::	!D = ddcn:	 !O = [directory]
!F = filename    !T = .type	!V = ;version	 !L = cmd line no
!E = cmds exec   !C = cmds sel	!S = sub dir no	 !R = rpt count
!X = exit status !Y = severity
!/ = CR+LF	 !_ = tab	!^ = form feed	 !! = !

@filename = take remaining commands from file (default type .OPS).

$CMDL:
$	IF .NOT.CMDFIL THEN GOTO ISTRIN
$RSTRIN: READ/END=EOFCMD CMD P2
$	GOTO STRIN
$EOFCMD: CLOSE/ERROR=SORT CMD
$	CMDFIL := F
$	GOTO SORT
$ISTRIN: IF .NOT.CMDFIL THEN READ/END=SORT-
		/PROMPT="Command line ''N' (ctrl/Z if no more''HASHIF')
: " -
		SYS$COMMAND P2
$	IF P2 .EQS. "?" THEN GOTO CMDS
$STRIN:	IF F$LOCATE("@",P2).NE.0 THEN GOTO NOCMF
$!
$!	Chain to file (NOT nested) if command starts @
$!
$	IF CMDFIL THEN CLOSE/ERROR=E CMD
$	TEMP = F$EXTRACT(1,F$LENGTH(P2)-1,P2)
$	IF F$LOCATE(".",TEMP).EQ.F$LENGTH(TEMP) THEN TEMP = TEMP+".OPS"
$	OPEN/READ/ERR=CMDL CMD 'TEMP'
$	CMDFIL := T
$	INLINE := F
$	GOTO RSTRIN
$NOCMF:
$! Pre-parse command line for later use. Creates:
$!	CTRL'N' = F$FAO control string
$!	PARS'N' = F$FAO arguments
$!
$	PARS'N' = ""
$	CTRL'N' = ""
$	L = F$LENGTH(P2)
$	QUERY'N' = F$EXTRACT(0,1,P2).EQS."?" .AND. INTERACTIVE
$	IF QUERY'N' THEN P2 = F$EXTRACT(1,L,P2)
$	QUIT'N' := F
$	$S = 0
$	NP=0
$PIECE:
$	I = F$LOCATE("!",P2)
$	CTRL'N' = CTRL'N'+F$EXTRACT(0,I,P2)
$	I=I+1
$	TEMP = F$EXTRACT(I,1,P2)
$	I=I+1
$	L = L-I
$! Ignore ! as very last character (error?)
$	IF L.LT.0 THEN GOTO PARSED
$	P2 = F$EXTRACT(I,L,P2)
$! Found "!", see what follows.
$	$S = $S+1
$	IF F$LOCATE(TEMP,"!/_^").EQ.4 THEN GOTO NOTCC
$! !, /, _, and ^ are F$FAO specials (!, CRLF, tab, and FF):
$	CTRL'N' = CTRL'N'+"!"+TEMP
$	GOTO PIECE
$NOTCC:	IF F$LOCATE(TEMP,"WwNnDdFfTtVvEeRrCcPpSsLlXyYy").NE.28 THEN GOTO SUB'TEMP'
$! Unknown, just copy char:
$OTHER:	CTRL'N' = CTRL'N'+TEMP
$	GOTO PIECE
$! Run time string substitutions:
$SUBW:
$SUBN:
$SUBD:
$SUBF:
$SUBT:
$SUBV:	CTRL'N' = CTRL'N'+"!AS"
$	GOTO ADDP
$! Run time numeric substitutions:
$SUBX:	IF MAKFIL THEN GOTO MAKEX
$SUBY:	IF MAKFIL THEN GOTO MAKEY
$SUBE:
$SUBR:
$SUBC:	CTRL'N' = CTRL'N'+"!UL"
$ADDP:	PARS'N' = PARS'N'+",$"+TEMP
$	NP = NP+1
$	IF NP.LE.15 THEN GOTO PIECE
$	WRITE SYS$OUTPUT "%OPS-F-TOOMANYSUBS, too many substitutions on line:
$	WRITE SYS$OUTPUT "-OPS-F-TOOMANYSUBS, ",CMD'N'
$	GOTO E
$! If making a command file, $SEVERITY and $STATUS must be put in as such.
$MAKEX:	CTRL'N' = CTRL'N'+"$STATUS"
$	GOTO PIECE
$MAKEY:	CTRL'N' = CTRL'N'+"$SEVERITY"
$	GOTO PIECE
$! Compile time numeric substitutions:
$SUBS:	CTRL'N' = CTRL'N'+F$STRING($S-1)
$	GOTO PIECE
$SUBL:	CTRL'N' = CTRL'N'+F$STRING(N)
$	GOTO PIECE
$PARSED:
$	N = N+1
$	IF .NOT.INLINE THEN GOTO CMDL
$!
$! Make DIRECTORY selection to temp file and open for read
$!
$SORT:	N = N-1
$	IF N .EQ. 0 THEN GOTO E
$	IF NOSEL THEN GOTO NOSORT
$	OPEN/READ/END=E/ERR=E INP 'DIRFIL'
$NOSORT: IF MAKFIL THEN OPEN/WRITE OUT 'CMDNAM'
$!
$! Read DIRECTORY list file and select filename.
$!
$LOOP:
$	$W = ""
$	$N = ""
$	$D = ""
$	$O = ""
$	$F = ""
$	$T = ""
$	$V = ""
$	IF NOSEL THEN GOTO NOLIN
$	READ/END=E INP $W
$	$N = F$PARSE($W,,,"NODE")
$	$D = F$PARSE($W,,,"DEVICE")
$	$O = F$PARSE($W,,,"DIRECTORY")
$	$F = F$PARSE($W,,,"NAME")
$	$T = F$PARSE($W,,,"TYPE")
$	$V = F$PARSE($W,,,"VERSION")
$	$W = $N+$D+$O+$F+$T+$V
$NOLIN:
$	$R = 1
$!
$! Execute commands and/or build command file for each line.
$RPT:
$	$L = 1
$MAKE:
$	IF $L .GT. N THEN GOTO ENDCOM
$	IF QUIT'$L' THEN GOTO NEXT
$	$C = $C+1
$	TEMP = PARS'$L'
$	COMAND = F$FAO(CTRL'$L''TEMP')
$	IF .NOT.QUERY'$L' THEN GOTO Y
$	IF COMAND .EQS. "" THEN GOTO NEXT
$GETCOM:INQUIRE TEMP "''COMAND' ?	(Yes/No/Go/Quit/Exit) [N]"
$	IF TEMP .EQS. "" THEN GOTO N
$	TEMP = F$EXTRACT(0,1,TEMP)
$	IF F$LOCATE(TEMP,"YNGQE").EQ.5 THEN GOTO GETCOM
$	GOTO 'TEMP'
$Q:	IF $L.EQ.N THEN GOTO QUITN
$	QUIT'$L' := T
$	GOTO N
$! Quit last, see if it is last of all, in which case stop now.
$QUITN:	N=N-1
$	IF N.LE.0 THEN GOTO E
$	IF QUIT'N' THEN GOTO QUITN
$	GOTO N
$G:
$	QUERY'$L' := F
$Y:
$	$E = $E+1
$	IF .NOT.MAKFIL THEN GOTO DOCOM
$	IF F$EXTRACT(0,1,COMAND).EQS."#" THEN GOTO WRTDAT
$	WRITE OUT "$	",COMAND
$	GOTO NEXT
$WRTDAT: WRITE OUT F$EXTRACT(1,F$LENGTH(COMAND)-1,COMAND)
$	GOTO NEXT
$DOCOM:	SET NOON
$	WRITE SYS$OUTPUT "$ ",COMAND
$	IF INTERACTIVE THEN DEFINE/USER/NOLOG SYS$INPUT SYS$COMMAND
$	'COMAND'
$	$X = $STATUS
$	$Y = $X.AND.7
$	STATI'$Y' = STATI'$Y'+1
$	SET ON
$	GOTO NEXT
$N:	
$	$X = 0
$	$Y = 0
$NEXT:
$	$L = $L+1
$	GOTO MAKE
$ENDCOM:
$	$R = $R+1
$	IF $R .LE. P3 THEN GOTO RPT
$	IF MAKFIL THEN WRITE OUT "$!"
$	IF .NOT.NOSEL THEN GOTO LOOP
$E:	IF .NOT.NOSEL THEN CLOSE/ERROR=E1 INP
$E1:	IF MAKFIL THEN CLOSE/ERROR=E2 OUT
$E2:	IF CMDFIL THEN CLOSE/ERROR=E3 CMD
$E3:	IF DELFIL THEN DELETE 'DIRFIL';0
$	IF MAKFIL THEN GOTO EMAKE
$	WRITE SYS$OUTPUT -
	F$FAO("!UL command!%S selected, !UL executed.!/!UL success!%S, !UL warning!%S, !UL error!%S, !UL severe error!%S, !UL unknown.", -
	$C,$E-1,STATI1+STATI3,STATI0,STATI2,STATI4,STATI5+STATI6+STATI7)
$	GOTO EXIT
$EMAKE:	WRITE SYS$OUTPUT F$FAO("!UL command!%S selected.",$C)
$EXIT:
$	SAVE_PROC_VERIFY = F$VERIFY(SAVE_PROC_VERIFY,SAVE_IMAGE_VERIFY)
$	EXIT
