	SUBROUTINE SCR_DECVAL
C	---- DECODE ARRAYS CVAL, IVAL, AND RVAL FROM THE CHARACTER SCREEN
	CHARACTER*80 I_LINE,ERRMES,VTYPE*7
	INTEGER*4 SAVED_ID
	INCLUDE '($TRMDEF)'
	INCLUDE 'SCREEN.FOR'
C
	IROW=0
	DO 100 I=1,INUM_FIELDS

	IF (IROW.NE.LINE(I)) THEN
		IROW = LINE(I)
		CALL SMG$READ_FROM_DISPLAY(DISPLAY_ID,I_LINE,,IROW)
	ENDIF
	ISTART = BCOL(I)
	IEND = ECOL(I)
	LENGTHI = IEND-ISTART+1
	IP = IPOSITION(I)	!GET POSITION IN IVAL, RVAL, OR CVAL

 10	IF(TYPE(I)) 20,30,40
C
C	---- TYPE(I)<0 IS CHARACTER
 20	CVAL(IP)(1:LENGTHI)= I_LINE(ISTART:IEND)
	GOTO 100
C
C	---- TYPE(I)=0 IS INTEGER
 30	IF (I_LINE(ISTART:IEND).EQ.' ') THEN		! ALL BLANK = 0
		IVAL(IP)=0				! (* FORMAT DOESN'T DO THAT)
	ELSE
		READ (I_LINE(ISTART:IEND), *, ERR=50) IVAL(IP)
	ENDIF
	GOTO 100
C
C	---- TYPE(I)>0 IS REAL, WITH TYPE(I)-1 DECIMAL PLACES
 40	IF (I_LINE(ISTART:IEND).EQ.' ') THEN
		RVAL(IP)=0.
	ELSE
		READ (I_LINE(ISTART:IEND), *, ERR=60) RVAL(IP)
C		---- MAKE SURE THE VALUE WILL FIT WHEN ENCODED BACK
		IF (ABS(RVAL(IP)).GE.10.**(LENGTHI-TYPE(I)-2)) GOTO 60
	ENDIF
	GOTO 100

C	---- INTEGER DECODE ERRORS
50	LEN = 1
	IF (LENGTHI.GT.9) LEN = 2
	WRITE(ERRMES,55) I, IP, I_LINE(ISTART:IEND), LENGTHI
55	FORMAT('ERROR DECODING FIELD No ',I2,' INTEGER FIELD No ',I2,
     &		' FROM ''',A,''' WITH FORMAT I',I<LEN>)
	VTYPE='INTEGER'
	LENV=7
	GOTO 70

C	---- REAL DECODE ERRORS
60	LEN = 1
	IF (LENGTHI.GT.9) LEN = 2
	WRITE(ERRMES,65) I,IP, I_LINE(ISTART:IEND),
     &		LENGTHI, TYPE(I)-1
65	FORMAT('ERROR DECODING FIELD No ',I2,' REAL FIELD No ',I2,
     &		' FROM ''',A,''' WITH FORMAT F',I<LEN>,'.',I1)
	VTYPE='REAL'
	LENV=4
70	CALL SMG$SAVE_PHYSICAL_SCREEN(PASTEBOARD_ID,SAVED_ID,22)
	CALL SMG$SET_CURSOR_ABS(SAVED_ID,2,1)
	CALL SMG$PUT_LINE(SAVED_ID,ERRMES)
	CALL SMG$RING_BELL(SAVED_ID)
	CALL SMG$READ_STRING(KEYBOARD_ID,I_LINE(ISTART:IEND),
     &		'PLEASE INPUT PROPER '//VTYPE(:LENV)//' VALUE: ',
     &		LENGTHI,TRM$M_TM_TRMNOECHO,,,,,SAVED_ID,,IBOLD)
	CALL SMG$ERASE_DISPLAY(SAVED_ID)
	CALL SMG$RESTORE_PHYSICAL_SCREEN(PASTEBOARD_ID,SAVED_ID)
	CALL SMG$PUT_CHARS(DISPLAY_ID,I_LINE(ISTART:IEND),IROW,ISTART,
     &		,IBOLD)
	GOTO 10
C
100	CONTINUE
	CALL SMG$SET_CURSOR_ABS(DISPLAY_ID,ILIN,ICOL)
	RETURN
	END
